.H 1 "HARDWARE INVOLVED"
At that time, the only usable disk for bulk storage was the 9332 400Mb
which was extremely expensive compared to the disks available at the
"pirate" market.  It was then decided to buy nine Maxtor XT-4380S
~380Mb 5 1/2 inch winchesters.  The nine 4380's were mounted together
into what we call a "Disk Hotel" with 5 disks and 1 tape in an 19"
case. Two of these hotels were put together and mounted in an old PDP11
rack. We decided to try using these disks and tapes with the Adaptec
AHA-1540 host adapter which we bought for just peanuts.
.H 2 "Problems and fixes to the hardware"
When the first prototype of the driver was first tested, nothing worked.
.br
The error codes sent from the host adapter (HA) were totally weird. A
newly delivered logic analyzer (thanks TEK!) was plugged into the
AT-bus of the computer and we found that the HA, when reading data from
the system memory just didn't care if valid data was present or not.
The cause for this stupid behaviour was that the HA didn't honor the
signal on the AT-bus called I/O CH RDY.
.br
The specification for the AT-bus says:
.DS 1 1
.S -1
.ll -10n
I/O Channel Ready (normally high) is pulled low by a selected device to
lengthen the current I/O or memory cycle. Any slow device using this
line should drive it low when a valid select is decoded and a read or
write command is active. Once the device has stored data during a write
operation or it has gated valid data onto the data bus during a read
operation, it should then drive 'I/O CH RDY' high to indicate that the
controller may end the current operation.
.ll +10n
.S
.DE
The RT did that.
.br
The AHA-1540 just didn't care.
.br
On an ordinary AT, the fact that the HA didn't look at this signal
wouldn't cause any trouble, since the AT's memory is directly connected
to the AT-bus and memory nowadays are always fast enough.  However, on
the RT, memory is on a special system bus with the I/O channel
controller in between. In this setup, considerable delay will sometimes
occur, and I/O CH RDY is used to signal that no valid data is present.
.H 2 "How to fix the AHA-1540 host adapter"
When the trouble above was encountered and analyzed, I decided to fight
the elephant and rewrite the HA dependent parts of the driver for the
IBM SCSI card instead. Fortunately, one of the daring hardware guys at
the department asked if we could do a hardware patch to the card to see
if we could make it wait for the relevant data. I asked if he had
anything particular in mind and the answer was simply:
.I "\- Yes, we just stop its clock!"
And so we did. When we finally got it free from spikes and races the
card worked fairly well.  Appendix A contains a detailed description of
the patch.
.P
One of the earlier versions of the HW patch also stopped a clock signal from the AT-bus. When we
received our second HA this part of the patch was mistakingly omitted. The card worked better than
the old one which had problems reading short records from the tape. Credit for the better
functionality was first put on the fact that that the new card had a later revision of the firmware,
but after moving the PROM's from the new card to the old card the problems persisted. A close
examination of the patch revealed the mistake and the new card was ''fixed'' to be equal to the old
card and voila, the problems shoved up on the new card too!
We decided to leave out that part of the patch.
.P
Many months later, Adaptec came out with another card, AHA1542 with all of the DMA logic integrated
into a big chip. This version worked OK without any patches and seems to be a much more mature
product in other respects too. It can even be used in SCSI target mode, but we haven't found any use
for this yet, maybe we'll run TCP/IP on the SCSI bus...
