.H 1 "BRIEF DESCRIPTION OF THE DRIVER"
This section deals with the gross structure of the code, process flows and hardware relationships.
Other software that required changes is also described.
.H 2 "Building blocks"
The driver consists of essentially three building blocks. Two of them
are device drivers in its normal sense and one is an interface between
the device driver and the host adapter, much like the Massbus or Unibus
drivers on the VAX. The blocks are designed so that no block will have
to know anything about what block is at the other end or how it
operates.  This design makes it possible to exchange device drivers or
the interface block independently.  However, the interface between the
various blocks have to be thoroughly specified.  This is done in
chapter 5.  The figure below show the interrelationship between the
blocks, the hardware and the top half of the UNIX kernel.
.PS
.SP 40
.FG "Relationship between the various blocks and hardware"
.PE
.SK
.SP
The model is expandable for accomodating more SCSI buses and host
adapter models:
.PS
.SP 35
.FG "Expanded model of the driver system"
.PE
.SP
In order to make this structure possible, modifications were made to
the autoconfig code in the UNIX kernel and the config(8) program. Other
changes were made to the syntax of /sys/conf/devices file in order to
make more than 8 disk partitions possible. The minidisk(8) program
needed a small patch in order to recognise these SCSI disks as being
such. Code were also added to /dev/MAKEDEV and to /etc/mkfs, the last
one should be regarded as a bug fix.
.H 2 "What the blocks are allowed to know about their environment"
The device driver blocks have no relationship to other device driver
blocks. A device driver block is allowed to know things about the type
of device it controls. E.g. SCSI command codes, sense information and
the operation of the device. It is
.I not
allowed to know anything about the host adapter to which the device is
connected. It is not allowed to control the HA directly, nor is it
allowed to use any codes specific to the interface block.  Complete
SCSI commands may be sent to the interface block since SCSI commands
are sent transparently to the SCSI bus.
.P
The interface block must not know anything about the devices that is
connected to the SCSI bus, nor should it know anything about how the
device driver block works apart from what is specified below.  The
interface block must not export any hardware specific code to other
blocks. Any SCSI commands sent from the device drivers should be
accepted and sent to the SCSI device. Any information derived from that
SCSI command should be specified in the ANSI SCSI specification, vendor
unique information may not be used in the interface block.
