#include "dk.h"

dk_reassign( char *disk, int dkfd)
{
    long	reblock=1;

    close(dkfd); /* close it since we want it exclusively */

    if ((dkfd = open(disk, O_RDWR  | O_EXCL)) < 0)
    {
	perror(disk);
	exit(1);
    }
    printf("%s exclusively opened\n",disk);

	
    do
    {
	printf("Enter absolute block to be reassigned:");

	scanf("%d",&reblock);
	if(reblock)
	    dk_doreassign(dkfd,reblock);
    } while(reblock);
    close(dkfd);
}

dk_doreassign(dkfd,block)
{
	struct scsi_reass_blks
	{
		u_char	sc_op;
		u_char	sc_lun:3;
		u_char	sc_resv1:5;
		u_char	sc_resv2[3];
		sccb	sc_control;
	} cdb, *cdbp = &cdb;
	struct scsi_def_list_hdr
	{
		u_char dlh_resv;
		u_short	dlh_length;
	};
	struct scsi_def_data
	{
		struct scsi_def_list_hdr	dlh;
		u_long	dlh_blocks[1];
	} defdata;

	bzero(cdbp,6);
	bzero(&defdata,sizeof defdata);

	cdbp->sc_op = SC0_REASSIGN_BLOCKS;

	ioctl(dkfd, DKIOCSSCSI, (char *) cdbp);

	defdata.dlh.dlh_length = 4;
	defdata.dlh_blocks[0] = block;

	if(write(dkfd, &defdata, sizeof defdata) != sizeof defdata)
	{
		struct scsi_esense esense;
		printf("Write reassign %X", block);
		perror("");
		if(ioctl(dkfd, DKIOCGSCSISENSE, (char *) &esense) < 0 )
		{
			perror("Ioctl esense");
		}
		xxhdump(&esense,sizeof esense);
		printf("Key=%x, code=%x, esense length=%d\n",esense.es_key, esense.es_scode,sizeof esense);
	}
}
