#include "dk.h"

#define VERBLKSI 1024

dk_verify( char *disk, int dkfd)
{
    long	verblock=1, versize=0;

    close(dkfd); /* close it since we want it exclusively */

    if ((dkfd = open(disk, O_RDWR  | O_EXCL)) < 0)
    {
	perror(disk);
	exit(1);
    }

    /* dk_posterror(dkfd,1); */
	
    do
    {
	printf("\nEnter start block  and size to be verified:");

	scanf("%d %d",&verblock, &versize);
	if(versize)
        {
	    while(versize >= VERBLKSI)
	    {
		int badblk;

		if(badblk=dk_doblkverify(dkfd,verblock,VERBLKSI))
		{
			if(badblk < 0) 
				break;
			dk_doverify(dkfd,badblk-10,20,16);
			continue; /* Check it again */
		}
		verblock += VERBLKSI;
	        versize -= VERBLKSI;
	    }	
	    dk_doverify(dkfd,verblock,versize,2);
	}
    } while(versize);
    dk_posterror(dkfd,0);
    close(dkfd);
}


dk_doblkverify(dkfd,verblock,versize)
{
	struct scsi_verify_blks
	{
		u_char	sc_op;
                u_char  sc_lun:3;
                u_char  sc_resv1:5;
		u_char	sc_block[4];
		u_char	sc_resv2;
		u_char	sc_bcount[2];
		sccb	sc_control;
	} cdb, *cdbp = &cdb;
	char dummy;

	int	i;

	bzero(cdbp, sizeof *cdbp);

	cdbp->sc_op= SC1_VERIFY;
	printf("B:%07d\r",verblock);
	fflush(stdout);

	for(i=0; i<1; i++)
	{
	    cdbp->sc_block[0] = (verblock >> 24) & 0xFF;
	    cdbp->sc_block[1] = (verblock >> 16) & 0xFF;
	    cdbp->sc_block[2] = (verblock >>  8) & 0xFF;
	    cdbp->sc_block[3] = (verblock >>  0) & 0xFF;

	    cdbp->sc_bcount[0] = (versize >> 8) & 0xFF;
	    cdbp->sc_bcount[1] = (versize >> 0) & 0xFF;

	    ioctl(dkfd, DKIOCSSCSI, (char *) cdbp);
	    
	    if(read(dkfd,&dummy,1) < 0)
	    {
	        struct scsi_esense esense;
		long badblk = -1;

		if((ioctl(dkfd, DKIOCGSCSISENSE, (char *) &esense)) < 0)
	        {
                    perror("Ioctl esense");
                }
		printf("\n");
                xxhdump(&esense,sizeof esense);
		switch(esense.es_key)
                    {
                        case 3:
			badblk = esense.es_info[0];
			badblk = 256 * badblk + esense.es_info[1];
			badblk = 256 * badblk + esense.es_info[2];
			badblk = 256 * badblk + esense.es_info[3];
				
			if(esense.es_scode == 0x21)
			{
				printf("Illegal block address\n");
				return -1;
			}
			printf("Block %d is bad ?\n",badblk);
			break;
			case 5:
			printf("Unit attention verify quits\n");
			return -1;
                        default:
                            printf("Sense key=%d, continuing\n",esense.es_key);
			    continue;
                    }
		return badblk;
	    }
	}
	return 0;
}
int autoyes=0;
dk_doverify(dkfd,verblock,versize,repeats)
{
	struct scsi_verify_blks
	{
	    u_char	sc_op;
	    u_char  sc_lun:3;
	    u_char  sc_resv1:5;
	    u_char	sc_block[4];
	    u_char	sc_resv2;
	    u_char	sc_bcount[2];
	    sccb	sc_control;
	} cdb, *cdbp = &cdb;
	char dummy;

	bzero(cdbp, sizeof *cdbp);

	cdbp->sc_op= SC1_VERIFY;

	while(versize)
	{
	    int	i;

	    printf("F:%07d\r",verblock);
	    fflush(stdout);

	    for(i=0; i<repeats; i++)
	    {
		cdbp->sc_block[0] = (verblock >> 24) & 0xFF;
		cdbp->sc_block[1] = (verblock >> 16) & 0xFF;
		cdbp->sc_block[2] = (verblock >>  8) & 0xFF;
		cdbp->sc_block[3] = (verblock >>  0) & 0xFF;

		cdbp->sc_bcount[0] = 0;
		cdbp->sc_bcount[1] = 1;

		ioctl(dkfd, DKIOCSSCSI, (char *) cdbp);
		
		if(read(dkfd,&dummy,1) < 0)
		{
		    char reply[80];
		    struct scsi_esense esense;

		    if((ioctl(dkfd, DKIOCGSCSISENSE, (char *) &esense)) < 0)
		    {
			perror("Ioctl esense");
		    }
		    printf("\n");
		    xxhdump(&esense,sizeof esense);
		    switch(esense.es_key)
		    {
			case 3:
			    if(esense.es_scode == 0x21)
			    {
				printf("Illegal block address\n");
				return ;
			    }
			    if(!autoyes)
			    {
				printf("Block %d is bad, reassign ?\n", verblock);
				scanf("%s",&reply);
				if(reply[0] == 'Y' || reply[0] == 'A')
				{
				    dk_doreassign(dkfd,verblock);
				}
				if(reply[0] == 'A') autoyes++;
			    }
			    else
			    {
				printf("Block %d is bad, reassigned\n",verblock);
				dk_doreassign(dkfd,verblock);
			    }
			    break;
			case 5:
			printf("Unit attention verify quits\n");
			return ;
			default:
			    printf("Sense key=%d, continuing\n",esense.es_key);
		    }
		
		}
		    
	    }
	    versize--;
	    verblock++;
    }
}
