#include "dk.h"

dk_readdefects(char *disk, int dkfd)
{
	struct scsi_rdd_cdb 
	{
		u_char	sc_op;
                u_char  sc_lun:3;
                u_char  sc_resv1:5;
		u_char	sc_resv2:3;
		u_char	sc_p:1;
		u_char	sc_g:1;
		u_char	sc_dlfmt:3;
		u_char	sc_resv3[4];
		u_char	sc_allen[2];
		sccb	sc_control;
	} cdb, *cdbp=&cdb;
	struct scsi_defhd
	{
		u_char	resvd;
		u_char  resvd2:3;
		u_char	p:1;
		u_char	g:1;
		u_char	dlfmt:3;
		u_short	dllen;
	};
	struct defdesc
	{
		u_long	cylno:24;
		u_long	headno:8;
		u_long	bytesno;
	};

	struct deflist
	{
		struct scsi_defhd	defhd;
		struct defdesc          defbuf[8191];
	} deflist;
	struct defdesc *defp;
	int	length;
	int	i;

	close(dkfd); /* close it since we want it exclusively */

	if ((dkfd = open(disk, O_RDWR  | O_EXCL)) < 0)
	{
	    perror(disk);
	    exit(1);
 	}

	bzero(cdbp,sizeof cdb);
	bzero(deflist, sizeof deflist);

	cdbp->sc_op=0x37;
	cdbp->sc_dlfmt=0x4;
	cdbp->sc_allen[0] = sizeof(deflist) >> 8 & 0xFF;
	cdbp->sc_allen[1] = sizeof(deflist) &0xFF;

	cdbp->sc_p = 1;

	if(ioctl(dkfd, DKIOCSSCSI, (char *) cdbp) < 0)
	{
		perror("Ioctl readdefects");
		exit(1);
	}

	if(read(dkfd, &deflist, sizeof deflist) < 0 )
	{
		perror("Read readdefects");
	}

	printf("Primary: ");
	length=deflist.defhd.dllen;
	printf("length=%d containing %d defects\n",length, length/sizeof (struct defdesc));
	length -= sizeof (struct scsi_defhd);
	printf("No.	Cyl	Hd	Bytes\n");

	for(i=1,defp=deflist.defbuf; length > 0; i++,defp++)
	{
		printf("%d.	%d	%d	%d\n",i,
			defp->cylno,defp->headno,defp->bytesno);
		length -= sizeof (struct defdesc);
	}

	bzero(cdbp,sizeof cdb);
	bzero(deflist, sizeof deflist);

	cdbp->sc_op=0x37;
	cdbp->sc_dlfmt=0x4;
	cdbp->sc_allen[0] = sizeof(deflist) >> 8 & 0xFF;
	cdbp->sc_allen[1] = sizeof(deflist) &0xFF;

	cdbp->sc_g = 1;

	if(ioctl(dkfd, DKIOCSSCSI, (char *) cdbp) < 0)
	{
		perror("Ioctl readdefects");
		exit(1);
	}

	if(read(dkfd, &deflist, sizeof deflist) < 0 )
	{
		perror("Read readdefects");
	}

	printf("Grown: ");
        length=deflist.defhd.dllen;
        printf("length=%d containing %d defects\n",length, length/sizeof (struct defdesc));
        length -= sizeof (struct scsi_defhd);
        printf("No.     Cyl     Hd      Bytes\n");

        for(i=1,defp=deflist.defbuf; length > 0; i++,defp++)
        {
                printf("%d.     %d      %d      %d\n",i,
                        defp->cylno,defp->headno,defp->bytesno);
                length -= sizeof (struct defdesc);
        }

}

