#include "dk.h"

print_modesense_pages(struct scsi_ms *p)
{
	if(p->sms_hd.sm_length >0) print_modesense(&p->sms_hd);
	if(p->sms_erp.erp_plen >0) print_mserppage(&p->sms_erp);
	if(p->sms_cop.cop_plen >0) print_msconnpage(&p->sms_cop);
	if(p->sms_daf.daf_plen >0) print_msdadfpage(&p->sms_daf);
	if(p->sms_rdg.rdg_plen >0) print_msrigidpage(&p->sms_rdg);
	if(p->sms_csh.csh_plen >0) print_mscachepage(&p->sms_csh);
	if(p->sms_rac.rac_plen >0) print_msracache(&p->sms_rac);
	if(p->sms_rtc.rtc_plen >0) print_msrtcpage(&p->sms_rtc);
	if(p->sms_aer.aer_plen >0) print_msaerpage(&p->sms_aer);
	if(p->sms_atc.atc_plen >0) print_msatcpage(&p->sms_atc);
	if(p->sms_ver.ver_plen >0) print_msverpage(&p->sms_ver);
}

print_modesense(struct scsi_modesense *p) 
{
printf("Mode Sense, Sense data length 		%d\n",p->sm_length);  
printf("Mode Sense, Medium type 		%d\n",p->sm_mtype);   
printf("Mode Sense, Write-protect 		%x\n",p->sm_wp);    
printf("Mode Sense, Maxtor Buffered mode 	%x\n",p->sm_bufmode);
printf("Mode Sense, Maxtor Speed code 		%x\n",p->sm_speed); 
printf("Mode Sense, Block descriptor length 	%d\n",p->sm_bdl);     
printf("Mode Sense Block descriptor, density code 	%d\n",
	p->sm_bdarr[0].sbd_density);     
printf("Mode Sense Block descriptor, Number of blocks 	%d\n",
	p->sm_bdarr[0].sbd_nblocks);     
printf("Mode Sense Block descriptor, Block length 	%d\n\n",
	p->sm_bdarr[0].sbd_blklen);     

};
print_mserppage(struct scsi_mserppage *p) 
{ 
	char pname[] = "Error recovery page,";

	if( p->erp_plen > 0 ) printf("%s parameter savable		%x\n", pname, p->erp_ps);
	if( p->erp_plen > 0 ) printf("%s Page code			%x\n", pname, p->erp_pcode);
	if( p->erp_plen > 0 ) printf("%s Page length		%d\n", pname, p->erp_plen);
	if( p->erp_plen > 0 ) printf("%s Automatic write reallocation enable	%x\n", pname, p->erp_awre);
	if( p->erp_plen > 0 ) printf("%s Automatic read reallocation enable		%x\n", pname, p->erp_arre);
	if( p->erp_plen > 0 ) printf("%s Transfer block with error	%x\n", pname, p->erp_tb);
	if( p->erp_plen > 0 ) printf("%s Read continous		%x\n", pname, p->erp_rc);
	if( p->erp_plen > 0 ) printf("%s Enable early correction	%x\n", pname, p->erp_eec);
	if( p->erp_plen > 0 ) printf("%s Post error			%x\n", pname, p->erp_per);
	if( p->erp_plen > 0 ) printf("%s Disable transfer on error	%x\n", pname, p->erp_dte);
	if( p->erp_plen > 0 ) printf("%s Disable correction		%x\n", pname, p->erp_dcr);
	if( p->erp_plen > 1 ) printf("%s Read retry count		%d\n", pname, p->erp_rrtcnt);
	if( p->erp_plen > 2 ) printf("%s Correction span		%d\n", pname, p->erp_cspan);
	if( p->erp_plen > 3 ) printf("%s Head offset count		%d\n", pname, p->erp_hoffset);
	if( p->erp_plen > 4 ) printf("%s Data strobe offset count	%d\n", pname, p->erp_dsoffset);
	if( p->erp_plen > 5 ) printf("%s Recovery time limit	%d\n", pname, p->erp_rtl);
	if( p->erp_plen > 6 ) printf("%s Write retry count	%d\n", pname, p->erp_wrtcnt);
	if( p->erp_plen > 0 ) printf("\n");

};
print_msconnpage(struct scsi_msconnpage *p) 
{
	if( p->cop_plen > 0) printf("Connect Page , parameter savable	%x\n", p->cop_ps);
	if( p->cop_plen > 0) printf("Connect Page , Page code		%x\n", p->cop_pcode);
	if( p->cop_plen > 0) printf("Connect Page , Page length		%d\n", p->cop_plen);
	if( p->cop_plen > 0) printf("Connect Page , Buffer full ratio	%d\n", p->cop_bfr);
	if( p->cop_plen > 1) printf("Connect Page , Buffer empty ratio	%d\n", p->cop_ber);
	if( p->cop_plen > 3) printf("Connect Page , Bus inactivity limit	%d\n", p->cop_bil);
	if( p->cop_plen > 5) printf("Connect Page , Disconnect time limit	%d\n", p->cop_dtl);
	if( p->cop_plen > 7) printf("Connect Page , Connect time limit	%d\n\n", p->cop_ctl);

};
print_msdadfpage(struct scsi_msdadfpage *p) 
{ 
   	if( p->daf_plen > 0) printf("Format Page, Parameter Savable		%x \n",p->daf_ps); 
   	if( p->daf_plen > 0) printf("Format Page, Page code			%x \n",p->daf_pcode); 
   	if( p->daf_plen > 0) printf("Format Page, Page length			%d \n",p->daf_plen);    
   	if( p->daf_plen > 1) printf("Format Page, Tracks per zone			%d \n",p->daf_tpz);     
   	if( p->daf_plen > 3) printf("Format Page, Alternate sectors per zone	%d \n",p->daf_altspz);  
   	if( p->daf_plen > 5) printf("Format Page, Alternate tracks per zone	%d \n",p->daf_atttpz);  
   	if( p->daf_plen > 7) printf("Format Page, Alternate tracks per volume	%d \n",p->daf_alttpv);  
   	if( p->daf_plen > 9) printf("Format Page, Sectors per track		%d \n",p->daf_spt);     
   	if( p->daf_plen > 11) printf("Format Page, No of bytes per sector		%d \n",p->daf_nbps);    
   	if( p->daf_plen > 13) printf("Format Page, Interleave factor		%d \n",p->daf_intrlve); 
   	if( p->daf_plen > 15) printf("Format Page, Track skew			%d \n",p->daf_tskew);   
   	if( p->daf_plen > 17) printf("Format Page, Cylinder skew			%d \n",p->daf_cskew);   
   	if( p->daf_plen > 18) printf("Format Page, Soft sector format		%x \n",p->daf_ssec);  
   	if( p->daf_plen > 18) printf("Format Page, Hard sector format		%x \n",p->daf_hsec);  
   	if( p->daf_plen > 18) printf("Format Page, Removable media			%x \n",p->daf_rmb);   
   	if( p->daf_plen > 18) printf("Format Page, Format by surface		%x \n",p->daf_surf);  
   	if( p->daf_plen > 18) printf("Format Page, Inhibit Save			%x \n\n",p->daf_ins);   

};
print_msrigidpage(struct scsi_msrigidpage *p) 
{ 
 printf("Rigid page,  parameter savable            %x \n",p->rdg_ps);      
 printf("Rigid page,  Page code                    %x \n",p->rdg_pcode);   
 printf("Rigid page,  Page length                  %d \n",p->rdg_plen);      
 printf("Rigid page,  Maximum no of cylinders      %d \n",
	(p->rdg_maxcyl[0]<<16) |
	(p->rdg_maxcyl[1]<<8 ) |
	(p->rdg_maxcyl[2] )
	); 
 printf("Rigid page,  Maximum no of heads          %d \n\n",p->rdg_hmaxheads); 
};
print_mscachepage(struct scsi_mscachepage *p) 
{
	printf("Wren Cache Parameter Savable:	%s\n",
	       p->csh_ps ? "Yes" : "No" );
	printf("Wren Cache page code:		%x\n", p->csh_pcode);
	printf("Wren Cache page length:		%d\n",p->csh_plen);
	printf("Wren Write Index enabled :	%s\n",
	       p->csh_wie ? "Yes" : "No" );
	printf("Wren Caching enabled :		%s\n",
	       p->csh_ce ? "Yes" : "No" );
	printf("Wren Cache table size:		%d\n",p->csh_cts);
	printf("Wren Cache Prefetch Threshold:	%x\n\n",
                        p->csh_pt);
}
print_msracache(struct scsi_msracache *p) 
{
	printf("Cache Parameter Savable:	%s\n",
	       p->rac_ps ? "Yes" : "No" );
	printf("Cache page code:		%x\n", p->rac_pcode);
	printf("Cache page length:		%d\n",p->rac_plen);
	printf("Cache Multiple:	       		%s\n", p->rac_ms ? "Yes":"No" );
	printf("Read Cache disabled :		%s\n", p->rac_rcd ? "Yes":"No");
	printf("Cache Suppression :		%x\n", p->rac_suppr );
	printf("Cache Min prefetch :		%d\n", p->rac_min_pre );
	printf("Cache Max prefetch :		%d\n", p->rac_max_pre );
	printf("Cache Max prefetch restriction :%d\n", p->rac_max_pre_restr );
}

print_msrtcpage(struct scsi_rtcpage *p) 
{
	printf("RC timing Parameter Savable:	%s\n",
	       p->rtc_ps ? "Yes" : "No" );
	printf("RC timing page code:		%x\n", p->rtc_pcode);
	printf("RC timing page length:		%d\n",p->rtc_plen);
	printf("RC timing reserved byte 1:	%d\n",p->rtc_resv1);
	printf("RC timing reserved byte 2:	%d\n",p->rtc_resv2);
}

print_msaerpage(struct scsi_msaerpage *p) 
{
	printf("Addl err rec Parameter Savable:	%s\n",
	       p->aer_ps ? "Yes" : "No" );
	printf("Addl err rec page code:		%x\n", p->aer_pcode);
	printf("Addl err rec page length:		%d\n",p->aer_plen);
	printf("Addl err rec cmd exec delay:	%sabled\n",p->aer_dced?"Dis":"En");
	printf("Addl err rec Post SCSI err:	%sabled\n",p->aer_pser?"En":"Dis");
	printf("Addl err rec Seek retry cnt:	%d\n",p->aer_srtc);
}

print_msverpage(struct scsi_msverpage *p) 
{
	printf("Vfy err rec Parameter Savable:	%s\n",
	       p->ver_ps ? "Yes" : "No" );
	printf("Vfy err rec page code:		%x\n", p->ver_pcode);
	printf("Vfy err rec page length:		%d\n",p->ver_plen);
	printf("Vfy err rec Early recovery:	%sabled\n",p->ver_eer?"En":"Dis");
	printf("Vfy err rec Post SCSI err:	%sabled\n",p->ver_per?"En":"Dis");
	printf("Vfy err rec Xfer on error:	%sabled\n",p->ver_dte?"Dis":"En");
	printf("Vfy err rec Error correction:	%sabled\n",p->ver_dcr?"Dis":"En");
	printf("Vfy err rec Retry count:	%d\n",p->ver_vrtc);
	printf("Vfy err rec Correctable bit len:%d\n",p->ver_cbl);
}

print_msatcpage(struct scsi_msatconnpage *p) 
{
	printf("Adaptec conn Parameter Savable:	%s\n",
	       p->atc_ps ? "Yes" : "No" );
	printf("Adaptec conn page code:		%x\n", p->atc_pcode);
	printf("Adaptec conn page length:		%d\n",p->atc_plen);
	printf("Adaptec conn Host rec overhead:	%d uS\n",p->atc_hroh*100);
	printf("Adaptec conn Buffer pre-fill:	%d bytes\n",p->atc_bpfill*256);
	printf("Adaptec conn Modify data ptr:	%sabled\n",p->atc_mdp?"En":"Dis");
}
