#include "dk.h"

struct commands com[] = 
{
	{ "start",			DKSTART,	0 },
	{ "stop",			DKSTOP,		0 },
	{ "autospin",			DKAS,		0 },
	{ "noautospin",			DKNAS,		0 },
        { "cacheenable",		DKCE,           0 },
        { "cachedisable",		DKCD,           0 },
        { "modesense",			DKMS,           0 },
        { "partition",			DKPART,         0 },
        { "help",			DKHELP,         0 },
	{ "format",			DKFORMAT,	0 },
	{ "mtsetdens [den] [blklen]",	MTSETDENS,	0 },
	{ "reassign",			DKREASSIGN,	0 },
	{ "verify",			DKVERIFY,	0 },
	{ "readdefects",		DKREADDEFECTS,	0 },
	{ 0 }
};

int dkfd,ret;
char *disk;
struct commands *comp;

char *progname;
struct dkpart dk;
char msbuf[127];
struct scsi_ms ms;
struct scsi_msc msc;
struct scsi_modesense mtms;


main(argc, argv)
	char **argv;
{
	char *getenv();
	register char *cp;
	register struct commands *comp;

	progname = argv[0];

	if (argc > 2 && (equal(argv[1], "-t") || equal(argv[1], "-f"))) {
		argc -= 2;
		disk = argv[2];
		argv += 2;
	} else
		if ((disk = getenv("DISK")) == NULL)
			disk = DEFDISK;
	if (argc < 2) {
		fprintf(stderr, "usage: %s [ -f device ] command [ count ]\n",progname);
		exit(1);
	}
	cp = argv[1];
	for (comp = com; comp->c_name != NULL; comp++)
		if (strncmp(cp, comp->c_name, strlen(cp)) == 0)
			break;
	if (comp->c_name == NULL) {
		fprintf(stderr, "%s: doesn't understand \"%s\"\n",progname, cp);
		exit(1);
	}
	if ((dkfd = open(disk, comp->c_ronly ? 0 : 2)) < 0) {
		perror(disk);
		exit(1);
	}
	switch(comp->c_code)
	{
	case DKSTART:
		if (ioctl(dkfd, DKIOCSTART) < 0) {
			fprintf(stderr, "%s %s", disk, comp->c_name);
			perror("failed ");
			exit(2);
		}
		break;
		
	case DKSTOP:
		if (ioctl(dkfd, DKIOCSTOP) < 0) {
			fprintf(stderr, "%s %s", disk, comp->c_name);
			perror("failed ");
			exit(2);
		}
		break;
	case DKAS:
		if (ioctl(dkfd, DKIOCSAUTOSPIN) < 0) {
			fprintf(stderr, "%s %s", disk, comp->c_name);
			perror("failed ");
			exit(2);
		}
		break;
	case DKNAS:
		if (ioctl(dkfd, DKIOCSNOAUTOSPIN) < 0) {
			fprintf(stderr, "%s %s", disk, comp->c_name);
			perror("failed ");
			exit(2);
		}
		break;
        case DKCE:
                cache_onoff(1);
                break;
        case DKCD:
                cache_onoff(0);
                break;
        case DKMS:
		printf("Sizeof ms = %d\n",sizeof ms);
                ret = ioctl(dkfd, DKIOCSMODESENSE,&msbuf);
                if (ret < 0) {
                        fprintf(stderr, "%s %s", disk, comp->c_name);
                        perror(" failed ");
                        exit(2);
                }
		xxfillmspages(&msbuf,&ms);
                print_modesense_pages(&ms);
                break;
        case DKPART:
                ret = ioctl(dkfd, DKIOCGPART,&dk) ;
                if (ret  < 0) {
                        fprintf(stderr, "ioctl returned %d for %s %s ",
                                ret,disk, comp->c_name);
                        perror(" failed ");
                        exit(2);
                }
                if( ret !=0 ) printf("Return code = %d\n", ret );
                printf("partition       size    blksize start   ncyl    ntrack	nsector name\n");

                printf("%s:     %d      %d      %d      %d      %d      %d	 %s\n",
                        disk,
                        dk.dk_size,
                        dk.dk_blocksize,
                        dk.dk_start,
                        dk.dk_ncyl,
                        dk.dk_ntrack,
                        dk.dk_nsector,
                        dk.dk_name );

                break;
        case DKHELP:
                int i;
                for (i=0 ; *com[i].c_name != 0 ; i++){
                        printf("        %s\n",com[i].c_name);
                }
                break;

	case DKNOP:
		break;
	case DKFORMAT:
	        dk_format(disk, dkfd);
	        break;
	case DKREASSIGN:
		dk_reassign(disk,dkfd);
		break;
	case DKVERIFY:
		dk_verify(disk,dkfd);
		break;
	case DKREADDEFECTS:
		dk_readdefects(disk,dkfd);
		break;
	case MTSETDENS:
		mt_setdens(atoi(argv[2]), atoi(argv[3]));
                break;
	}
	close(dkfd);
}
