#include "dk.h"


#define MIN(x,y) ((x) < (y) ? (x) : (y))

			
xxfillmspages(u_char *from, struct scsi_ms *to)
{
        u_char *fromstart = from;
        struct scsi_mspghd *pghdp;
        int bavail = 0;

        bcopy(from,(char *) to, 4); /* Copy header, beleived to be constant */
        from += 4;

        /* Copy one Block descriptor */
        bcopy(from, (char *) to->sms_hd.sm_bdarr,
                MIN(to->sms_hd.sm_bdl,sizeof(struct scsi_bd)));

        from += to->sms_hd.sm_bdl;

        while(from < (fromstart + to->sms_hd.sm_length))
        {
                pghdp = (struct scsi_mspghd *) from;
                bavail = pghdp->pghd_plen + sizeof (struct scsi_mspghd);

                switch(pghdp->pghd_pcode)
                {
                case 1:         /* errpage */
                        bcopy(from, &to->sms_erp,
                                MIN(sizeof(struct scsi_mserppage), bavail));
                        from += bavail;
                        continue;
                case 2:         /* connpage */
                        bcopy(from, &to->sms_cop,
                                MIN(sizeof(struct scsi_msconnpage), bavail));
                        from += bavail;
                        continue;
                case 3:         /* dadfpage */
                        bcopy(from, &to->sms_daf,
                                MIN(sizeof(struct scsi_msdadfpage), bavail));
                        from += bavail;
                        continue;
                case 4:         /* rigidpage */
                        bcopy(from, &to->sms_rdg,
                                MIN(sizeof(struct scsi_msrigidpage), bavail));
                        from += bavail;
                        continue;
                case 8:         /* Ra cache page */
                        bcopy(from, &to->sms_rac,
                                MIN(sizeof(struct scsi_msracache), bavail));
                        from += bavail;
                        continue;
                case 56:        /* CDC Wren cache page */
                        bcopy(from, &to->sms_csh,
                                MIN(sizeof(struct scsi_mscachepage), bavail));
                        from += bavail;
                        continue;
                case 34:        /* reconnection timing page */
                        bcopy(from, &to->sms_rtc,
                                MIN(sizeof(struct scsi_rtcpage), bavail));
                        from += bavail;
                        continue;
                case 33:        /* additional error recovery page */
                        bcopy(from, &to->sms_aer,
                                MIN(sizeof(struct scsi_msaerpage), bavail));
                        from += bavail;
                        continue;
                case 32:        /* Adaptec dis/reconecct page  */
                        bcopy(from, &to->sms_atc,
                                MIN(sizeof(struct scsi_msatconnpage), bavail));
                        from += bavail;
                        continue;
                case 7:         /* Verify error recovery page */
                        bcopy(from, &to->sms_ver,
                                MIN(sizeof(struct scsi_msverpage), bavail));
                        from += bavail;
                        continue;
                default:
                        printf("Unknown mode sense page code 0x%x, length=%d bytes\n",
                                pghdp->pghd_pcode, pghdp->pghd_plen);
                        from += bavail;
                        continue;
                }
        }

}

char *
xxcstr(c)
u_char c;
{
    static char     outstr[3];
    char           *convstr = "0123456789abcdef";

    outstr[0] = convstr[(c >> 4) & 0xf];
    outstr[1] = convstr[c & 0xf];
    outstr[2] = '\0';

    return outstr;
}


xxhdump(cp, n)
u_char         *cp;
int             n;
{
    int             i = 0;

    while (n--)
    {
        printf("%s", xxcstr(*cp++));
        ++i;
        if ((i % 32) == 0)
        {
            printf("\n");
        }
        else
        {
            if ((i % 4) == 0)
            {
                printf(" ");
            }
        }
    }
    if (i % 32)
    {
        printf("\n");
    }
}

