.A4
.nr Pt 2
.nr Ej 1
.TL
\s+12A device driver connecting tapes and disks
.br
to the IBM RT/PC using the
.br
Small Computer System Interface (SCSI).\s0
.S
.AF "Chalmers University of Technology"
.AU "Christer Bern\(e'rus" CB CT CE 1668 4126B
.ds CB S-412 96, Gothenburg, SWEDEN
.AS
A device driver has been developed for connecting SCSI disks and tapes
to the IBM RT/PC under the AOS 4.3 operating system using the 
Adaptec AHA1540A/1542 SCSI host adapter. The
driver is modularised so that other types of SCSI cards could be
integrated into the system without changing the driver code that deals
with the disks and tapes. This report contains the description of the
driver and some collected experience during the development work.
.AE
.MT 4 1
.ds HF 3 3 3 2 2 2 2
.ds HP 12 12 11 10 10
.nr Hb 5
.nr Hs 1
.ta 0.8i +0.8i +0.8i +0.8i
.de Sd
.DS 1 1
.nf
.ft C
.S -2
..
.de Se
.S
.ft R
.DE
..
.H 1 "INTRODUCTION"
In February 1988, I was employed by the UTC at Chalmers University of
Technology (CTH). UTC is a support organisation for the Andrew system
at CTH. One of the first things that had to be done was to bring life
to some kind of backup system. The trouble was that IBM didn't (and
doesn't) have any good backup storage drives. The only tape running on
the RT/PC was the IBM 6157 streaming tape.  One such tape contains a
maximum of 60Mb. Considering the volume of data on our fileservers
(5.5Gb) that unit was quickly ruled out.
.P
After some market investigation we decided to buy 2 Pertec CS240
streaming 3480 cartridge tape stations that had a SCSI connection. IBM
had a SCSI card and a disk driver so we planned to write a tape driver
as an add-on to the existing driver. A slight problem popped up shortly
after ordering the tapes, the IBM host adapter used differential SCSI
whilst most SCSI products on the market used single-ended SCSI. This
was solved with a pair of Rancho RT-SDA SCSI converter cards.
.P
While we waited for the delivery of the tape stations, I had a look at
the IBM driver for their 9332 disks. The first look was a slight shock
\- the driver filled about 75 A4 sized papers. After a closer look I
found that it would be hard to convert that disk driver into a driver
that could support both tapes and disks, since there were no natural
(or easily seen) division between code dependent on the disk and code
dependent on the host adapter. Therefore we soon decided to buy another
host adapter for interfacing the tape and writing a tape driver for
that card.
.P
An obvious problem arose: When (not if) we want to have more disk space
on our file servers, just 2 SCSI cards with one only serving the tape
just won't get us very far. It is only possible to have a maximum of 2
IBM SCSI cards per machine since there are only 2 register addresses to
choose between.  We also would like to have 2 file servers connected to
the same disks (and tape) for redundancy reasons. This was and still is
impossible with the IBM SCSI card since their card is
.I hardwired
at SCSI address 7 \- no DIP switches.
.P
The alternative was to find another SCSI card from elsewhere to connect
to the RT's AT-bus. Finding such a card was easy, actually using the
card of our choice was a painful experience, more on that below.
.P
Meanwhile, Chalmers had set up some 1000 student accounts into our
Andrew system and disk space became a desperate problem.  A good
solution to that seemed to be to buy a pile of inexpensive SCSI disks
and connecting them to the existing SCSI bus.
.H 1 "HARDWARE INVOLVED"
At that time, the only usable disk for bulk storage was the 9332 400Mb
which was extremely expensive compared to the disks available at the
"pirate" market.  It was then decided to buy nine Maxtor XT-4380S
~380Mb 5 1/2 inch winchesters.  The nine 4380's were mounted together
into what we call a "Disk Hotel" with 5 disks and 1 tape in an 19"
case. Two of these hotels were put together and mounted in an old PDP11
rack. We decided to try using these disks and tapes with the Adaptec
AHA-1540 host adapter which we bought for just peanuts.
.H 2 "Problems and fixes to the hardware"
When the first prototype of the driver was first tested, nothing worked.
.br
The error codes sent from the host adapter (HA) were totally weird. A
newly delivered logic analyzer (thanks TEK!) was plugged into the
AT-bus of the computer and we found that the HA, when reading data from
the system memory just didn't care if valid data was present or not.
The cause for this stupid behaviour was that the HA didn't honor the
signal on the AT-bus called I/O CH RDY.
.br
The specification for the AT-bus says:
.DS 1 1
.S -1
.ll -10n
I/O Channel Ready (normally high) is pulled low by a selected device to
lengthen the current I/O or memory cycle. Any slow device using this
line should drive it low when a valid select is decoded and a read or
write command is active. Once the device has stored data during a write
operation or it has gated valid data onto the data bus during a read
operation, it should then drive 'I/O CH RDY' high to indicate that the
controller may end the current operation.
.ll +10n
.S
.DE
The RT did that.
.br
The AHA-1540 just didn't care.
.br
On an ordinary AT, the fact that the HA didn't look at this signal
wouldn't cause any trouble, since the AT's memory is directly connected
to the AT-bus and memory nowadays are always fast enough.  However, on
the RT, memory is on a special system bus with the I/O channel
controller in between. In this setup, considerable delay will sometimes
occur, and I/O CH RDY is used to signal that no valid data is present.
.H 2 "How to fix the AHA-1540 host adapter"
When the trouble above was encountered and analyzed, I decided to fight
the elephant and rewrite the HA dependent parts of the driver for the
IBM SCSI card instead. Fortunately, one of the daring hardware guys at
the department asked if we could do a hardware patch to the card to see
if we could make it wait for the relevant data. I asked if he had
anything particular in mind and the answer was simply:
.I "\- Yes, we just stop its clock!"
And so we did. When we finally got it free from spikes and races the
card worked fairly well.  Appendix A contains a detailed description of
the patch.
.P
One of the earlier versions of the HW patch also stopped a clock signal from the AT-bus. When we
received our second HA this part of the patch was mistakingly omitted. The card worked better than
the old one which had problems reading short records from the tape. Credit for the better
functionality was first put on the fact that that the new card had a later revision of the firmware,
but after moving the PROM's from the new card to the old card the problems persisted. A close
examination of the patch revealed the mistake and the new card was ''fixed'' to be equal to the old
card and voila, the problems shoved up on the new card too!
We decided to leave out that part of the patch.
.P
Many months later, Adaptec came out with another card, AHA1542 with all of the DMA logic integrated
into a big chip. This version worked OK without any patches and seems to be a much more mature
product in other respects too. It can even be used in SCSI target mode, but we haven't found any use
for this yet, maybe we'll run TCP/IP on the SCSI bus...
.H 1 "BRIEF DESCRIPTION OF THE DRIVER"
This section deals with the gross structure of the code, process flows and hardware relationships.
Other software that required changes is also described.
.H 2 "Building blocks"
The driver consists of essentially three building blocks. Two of them
are device drivers in its normal sense and one is an interface between
the device driver and the host adapter, much like the Massbus or Unibus
drivers on the VAX. The blocks are designed so that no block will have
to know anything about what block is at the other end or how it
operates.  This design makes it possible to exchange device drivers or
the interface block independently.  However, the interface between the
various blocks have to be thoroughly specified.  This is done in
chapter 5.  The figure below show the interrelationship between the
blocks, the hardware and the top half of the UNIX kernel.
.PS
.SP 40
.FG "Relationship between the various blocks and hardware"
.PE
.SK
.SP
The model is expandable for accomodating more SCSI buses and host
adapter models:
.PS
.SP 35
.FG "Expanded model of the driver system"
.PE
.SP
In order to make this structure possible, modifications were made to
the autoconfig code in the UNIX kernel and the config(8) program. Other
changes were made to the syntax of /sys/conf/devices file in order to
make more than 8 disk partitions possible. The minidisk(8) program
needed a small patch in order to recognise these SCSI disks as being
such. Code were also added to /dev/MAKEDEV and to /etc/mkfs, the last
one should be regarded as a bug fix.
.H 2 "What the blocks are allowed to know about their environment"
The device driver blocks have no relationship to other device driver
blocks. A device driver block is allowed to know things about the type
of device it controls. E.g. SCSI command codes, sense information and
the operation of the device. It is
.I not
allowed to know anything about the host adapter to which the device is
connected. It is not allowed to control the HA directly, nor is it
allowed to use any codes specific to the interface block.  Complete
SCSI commands may be sent to the interface block since SCSI commands
are sent transparently to the SCSI bus.
.P
The interface block must not know anything about the devices that is
connected to the SCSI bus, nor should it know anything about how the
device driver block works apart from what is specified below.  The
interface block must not export any hardware specific code to other
blocks. Any SCSI commands sent from the device drivers should be
accepted and sent to the SCSI device. Any information derived from that
SCSI command should be specified in the ANSI SCSI specification, vendor
unique information may not be used in the interface block.
.H 1 "INTEGRATING THE DRIVER INTO THE 4.3 BSD SYSTEM"
Quite a lot of work had to be done in order to get the driver into the
system. The work has little to do with driving hardware, but has to be done
or otherwise debugging the driver and porting to other systems would be very
difficult. Parts of the work is essential for proper operation.
.H 2 "Conf.c \- Major device numbers"
There are two tables in the system that describe all device interfacing. These
tables are located in the file 
.I /sys/machine/conf.c.
The
.I cdevsw
table describe all character (raw) devices and the
.I bdevsw
table describe all block devices.
.P
The 
.I major
number of a device specifies an index into one of these tables and selects
a
.I class
of devices.
Raw and block devices do
.I not
share the same number space, and thus raw device 10 isn't necessarily the
same device class as block device 10.
.P
The tables describe a list of 
.I possible
devices, but does not list what is actually present on a system.
.P
There are no entries for the SCSI interface cards, only for the devices that
the cards control. In the IBM AOS4.3 system, major device numbers 0-24  for character devices, and 0-9 for block devices are 
reserved for IBM. 
.P
In this implementation, the tape major numbers are 25 for raw I/O and 10 for block I/O.
The disk major numbers are 26 for raw I/O and 11 for block I/O.
.H 3 "Layout of the cdevsw table"
The cdevsw table has the following layout. Each entry is the only link between the main
UNIX code and a driver.
.Sd
struct cdevsw
{
        int     (*d_open)();    \fR/* Called at every user open, used in order ti initialise the device */\fP
        int     (*d_close)();	\fR/* Routine to shut down a device, called only on last user close */\fP
        int     (*d_read)();	\fR/* Device specific routine to collect data from a device */\fP
        int     (*d_write)();	\fR/* device specific routine to send data to a device */\fP
        int     (*d_ioctl)();	\fR/* Routine to manipulate device specific functions*/\fP
        int     (*d_stop)();	\fR/* If the driver is a terminal interface, this is the device specific routine to suspend output */\fP
        int     (*d_reset)();	\fR/* This routine will be called to reset a device if the IOCC adapter is also reset */\fP
        struct tty *d_ttys;	\fR/* If driver is a terminal ifc, this is the address of an array of tty structures, one per line. */\fP
        int     (*d_select)();	\fR/* Device specific support to augment the select system call. */\fP
        int     (*d_mmap)();	\fR/* Never used on the RT. Maybe used on other UNIX systems, probably to do some kind of memory mapping. */\fP
};
.Se
Any routine entry may be
.I nulldev
or
.I nodev.
Nulldev means that there is no action for this function, nodev means that
an error action should be performed for this function.
.br
.H 3 "Layout of the bdevsw table"
The cdevsw table has the following layout. As above, each entry is the 
only link between the main code and a device driver.
.Sd
struct bdevsw
{
        int     (*d_open)();
        int     (*d_close)();
        int     (*d_strategy)();
        int     (*d_dump)();
        int     (*d_psize)();
        int     d_flags;
        int     (*d_minphys)();
};
.Se
The various entries have the following meaning:
.H 4 "Open routine"
This routine is called at every user
.I open.
It is used in order to initialise the device.
.H 4 "Close routine"
Routine to shut down a device. Called only on last user
.I close.
.H 4 "Strategy routine"
Performs all block I/O for a device. 
Responsible for finding the best way to order I/O requests.
.H 4 "Dump routine"
Called by the system to perform a post mortem crash dump of the system.
.H 4 "Psize routine"
This routine should return the number os blocks in a device partition, or -1
if the partition isn't allowed. The pointer should be 0
.B not
.I nodev,
if the routine is undefined.
.H 4 "Flags"
Buf style flags passed into block I/O requests, typically B_TAPE, B_CALL etc.
.H 4 "Minphys routine"
This is a very unfortunately named routine since it
calculates the
.I maximum
number of physical bytes to be transferred during a single DMA operation
for a device. The kernel supplies a routine called
.I minphys
that returns the maximum transfer length that the 
.I kernel
can handle.
.H 2 "Ioconf.c \- configuration file"
This file is automatically generated by the config(8) program. It contains 
initialised structures according to the configuration script for the system
generated. The following structures are initialised:
.H 3 "Iocccinit"
This structure contain information about all 
.I configured
controllers (adapters) on the I/O channel. It has the type
.I "struct iocc_ctlr."
See below for detailed information about this structure.
.H 3 "Ioccdinit"
This structure contain information about all
.I configured
devices that connect to any of the controllers above or that connect
directly to the IOCC. The type is
.I "struct iocc_device."
See below for detailed information about this structure.
.H 3 "Xhdinit"
This structure contain information about all
.I configured
SCSI targets 
.I configured
to be connected to any of the \fIx\fPha controllers found in iocccinit.
See below for detailed information about this structure.
.H 3 "Xhsinit"
This structure contain information about all
.I configured
SCSI logical units (LUN's)
.I configured
to be connected to any of the SCSI targets mentioned above.
See below for detailed information about this structure.
.H 2 "Kernel structures for autoconfiguration and driver use"
The kernel contain many data structures usable by the device drivers. 
These structures are also used when autoconfiguring the system. The form
a tree which resembles the hardware configuration of the particular machine.
.H 3 "Iocc_hd"
This structure hold pointers to dma registers, the state of the channel etc.
There is one structure per dma channel, the layout is:
.Sd
struct  iocc_hd {
        caddr_t hd_addr;                	/* dummy to keep config happy */
        caddr_t dh_8237_reg;            	/* hardware register location */
        unsigned dh_pagebitmask[IOCC_PAGE_SIZE]; /* bitmap to allocate page modeTCW's */
        unsigned dh_region_map[IOCC_REGION_SIZE]; /* region mode map */
        short   dh_channel;             	/* channel number */
        short   dh_subchan;             	/* subchannel on the 8237 chip */
        short   dh_state;               	/* state of this channel (see dmavar.h)*/
        struct  dma_callback *dh_callfwd; 	/* head of callback queue */
        struct  dma_callback *dh_calllst;	/* tail of callback queue */
        struct  iocc_ctlr *dh_actf;     	/* head of queue to transfer */
        struct  iocc_ctlr *dh_actl;     	/* tail of queue to transfer */
};
.Se
The field hd_addr is initialised in ioconf.c which really is a dummy,
but it makes it possible to keep the config(8) program structure almost as it
was on the VAX!
.H 3 "Iocc_ctlr"
This is the "per-controller" structure. There is one for each controller
(adapter) which control more than one device. If an adapter has devices attached
there are iocc_device structures that reference the corresponding iocc_ctlr structure. This structure isqueued in iocc resource wait and saves information about
iocc resources which are used. The queue of devices waiting to transfer is also
attached here. The layout is:
.Sd
struct iocc_ctlr {
        struct  iocc_driver *ic_driver;
        short   ic_ctlr;        	/* controller index in driver */
        short   ic_alive;       	/* controller exists */
        caddr_t ic_addr;        	/* address of device in i/o space */
        int     ic_irq;         	/* the IRQ level of the device */
        struct  iocc_hd *ic_hd; 	/* link back to the header */
        struct  buf ic_tab;     	/* queue of devices for this controller */
        short   ic_dmachannel;          /* dma channel number */
        int     ic_dmaflags;            /* dma transfer flags */
        struct  buf *ic_dmabuf;         /* buffer to transfer */
        struct iocc_ctlr *ic_dmaforw;	/* Next ctlr on the dma channel */
};
.Se
The fields ic_driver to ic_irq are initialised in ioconf.c. The rest
is set up at boot time or when the system is running.
.H 3 "Iocc_device"
This is the "per-device" structure. A controller has devices or uses DMA, 
everything else is a "device". If a controller has many drives attached, 
then there will be several iocc_device structures associated with a 
single iocc_ctlr structure.
.P
This structure contains all the information necessary to run
a non-dma device such as an async line card.  It also contains information
for slaves of iocc controllers as to which device on the slave
this is.  A flags field here can also be given in the system specification
and is used to tell which asynchronous lines are hard wired or other device
specific parameters. The layout is as follows:
.Sd
struct iocc_device {
        struct  iocc_driver *iod_driver;/* corresponding driver struct */
        short   iod_unit;       	/* unit number on the system */
        short   iod_ctlr;       	/* mass ctlr number; -1 if none */
        short   iod_slave;      	/* slave on controller */
        caddr_t iod_addr;       	/* address of device in i/o space */
        short   iod_irq;        	/* interrupt request level */
        short   iod_dk;         	/* if init 1 set to number for iostat */
        int     iod_flags;      	/* parameter from system specification */
        short   iod_alive;      	/* device exists */
        short   iod_type;       	/* driver specific type information */
        caddr_t iod_physaddr;   	/* phys addr, for standalone (dump) code */
        struct  iocc_device *iod_forw;	/* Next device on this ctlr */
        struct  iocc_ctlr *iod_mi;	/* Connected ctlr, if any */
        struct  iocc_hd *iod_hd;	/* Ptr to dma channel header struct */
};
.Se
The fields iod_driver to iod_flags are initialised in the ioconf.c file. 
The rest is set up at boot time.
.H 3 "Iocc_driver"
This structure, one per device driver, define entries for a set of routines 
in the device driver code that are used at boot time by the configuration
routine.
The following layout is used:
.Sd
struct iocc_driver {
        int     (*idr_probe)();         /* see if a device is really there */
        int     (*idr_slave)();         /* see if a slave is there */
        int     (*idr_attach)();        /* setup device for a slave */
        int     (*idr_dgo)();           /* controller specific dma setup */
        caddr_t *idr_addr;              /* device csr addresses */
        char    *idr_dname;             /* name of a device */
        struct  iocc_device **idr_dinfo;/* backpointers to iodinit structs */
        char    *idr_mname;             /* name of a controller */
        struct  iocc_ctlr **idr_minfo;  /* backpointers to iominit structs */
        int     (*idr_intr)();          /* interrupt service routine */
#define INT_SERVICED    0
#define INT_NOT_MINE    1
        int     idr_csr;                /* offset to read/write csr */
        int     (*idr_chanrelse)();     /* dma channel release request */
        char    idr_flags;              /* all zero in old drivers! */
#define EARLY_INT       0x01    /* interrupt handler called on initial
                                 * (probe) interrupt and int_8259 does the
                                 * shared interrupt reset */
#define DRIVER_SUSPEND  0x02    /* driver wants call on suspend */
        int     (*idr_suspend)();       /* device suspend */
#define SUSPEND_START   0               /* device suspend start */
#define SUSPEND_DONE    1               /* device suspend done */
};
.Se
The contents of this structure is initialised in the driver code.
.H 3 "Xha_hd"
Now we comes to the structures that have been added for the SCSI driver.
The first structure is much alike the iocc_hd structure. There is one such
for every SCSI host adapter on the system. It contain information about
the host adapter, also there are pointers to xha_device structures which
describe configured SCSI targets. The layout is as follows:
.Sd
/* Per SCSI controller structure */
struct xha_hd
{
        struct  iocc_driver *xh_driver;     /* driver structure */
        short                xh_hatype;     /* Type of ctrlr */
#define HATYPE_NONE     0                   /* Initial value, structure unused */
#define HATYPE_AHA      1                   /* Adaptec AHA-1540 */
#define HATYPE_IBM      2                   /* IBM SCSI Adapter */
        short                xh_active;     /* set if xha is active */
        short                xh_ndrive;     /* number of devices */
        caddr_t              xh_xha;        /* virt addr of xha */
        char                *xh_haname;     /* Name of host adapter */
        struct  xha_device  *xh_xhip[8];    /* attached ctrlrs */
        struct  iocc_ctlr   *xh_iocc;       /* Backptr */
        struct  xha_device  *xh_actf;       /* xfer q head */
        struct  xha_device  *xh_actl;       /* xfer q tail */
};
.Se
The fields in xha_hd are all initialised at boot time by the autoconfig
routine.
.H 3 "Xha_device"
The xha_device structure is a "one-per-target" structure. They contain
information about a SCSI target configured to a be connected to a 
SCSI host adapter described in an xha_hd structure. Since each target
may control many logical units, there is no LUN info in this structure.
Info about LUN's are in the xha_slave structure. The xha_device
structure looks like this:
.Sd
/* Per target structure */

struct xha_device
{
        struct  xha_driver  *xi_driver;
        short                xi_unit;   /* System's unit no */
        short                xi_ctlr;   /* SCSI ctrl it is on */
        short                xi_drive;  /* Ctrlr on scsi bus */
        short                xi_dk;     /* Driver no for iostat */
        short                xi_hatype; /* Type of ctlr it is on */
        short                xi_alive;  /* Target exists */
        u_long               xi_type;   /* Unit type */
        struct buf           xi_tab;    /* Head of Q for this dev */
        struct xha_device   *xi_forw;
        struct xha_slave    *xi_slaves[8]; /* Pointers to slave structs */
        struct xhac_driver  *xi_hadriver;  /* Pointers to ha's driver routines *
/
        /* Short cuts */
        caddr_t              xi_xha;
        struct  xha_hd      *xi_hd;

};
.Se
Of these fields, the xi_driver to xi_hatype are initialised in ioconf.c. The 
rest are set up at boot time or simply used during system operation.
.H 3 "Xha_slave"
This structure describe logical SCSI units, see above.
Layout:
.Sd
struct  xha_slave
{
        struct  xha_driver  *xs_driver;
        short                xs_ctlr;   /* Which formatter */
        short                xs_unit;   /* Which unit to system */
        short                xs_slave;  /* Which slave to formatter (LUN)*/
        short                xs_alive;  /* Device alive */
        /* Short cut back */
        struct xha_device   *xs_device; /* Pointer to formatter device struct */
}
.Se
Of these fields, the xs_driver to xs_slave are initialised in ioconf.c. The
rest are set up at boot time.
.H 3 "Xha_driver"
For each SCSI device type supported, i.e. for each SCSI device driver, there
is an xha_driver structure.
The structure, define entries for a set of routines 
in the device driver code that are used at boot time by the configuration
routine or by the host adapter driver. It looks as follows:
.Sd
/* Per device type structure */

struct xha_driver
{
    int                 (*xd_probe)();          /* See if target exists */
    int                 (*xd_slave)();          /* See if a slave is there */
    int                 (*xd_attach)();         /* Attach a device */
    int                 (*xd_ustart)();         /* Start unit */
    int                 (*xd_start)();          /* Setup data xfer */
    int                 (*xd_int)();            /* Data xfer complete */
    short                *xd_type;              /* Drive type codes */
    char                 *xd_dname;             /* Device name */
    char                 *xd_sname;             /* Slave name */
    struct  xha_device  **xd_dinfo;             /* Backpointers */
    struct  xha_slave   **xd_sinfo;             /* Backpointers */
    int                 (*xd_ttl)();            /* Find out time to live */
    int                   xd_flags;             /* Driver flags */
};
.Se
These fields are all initialised in the corresponding driver's code.
.H 3 "Xhac_driver"
For each type of SCSI host adapter and thus for each host adapter
driver there will be an xhac_driver structure. It is used by the SCSI device
drivers to access certain defined functions in the host adapter driver.
The structure looks like this:
.Sd
/* Per host adapter type structure */
struct xhac_driver
{
        int     (*xhc_tur)();           /* Test if unit ready */
        int     (*xhc_doscsi)();        /* Send SCSI command */
        int     (*xhc_ustart)();        /* Unit start routine */
};
.Se
These fields are all initialised in the corresponding host adapter
driver's code.
.H 2 "The config(8) program"
The config(8) program builds a set of system-configuration files from a
short file that describes the system being configured. Config also takes
as input a file that tells it which files are needed to generate a
system.  This can be augmented by a configuration-specific set of files
that gives alternate files for a specific machine.
The files generated are the makefile, ioconf.c and swapvmunix.c who are
generated into the directory where the system is built. Also, for each device,
an \fIxx\fP.h is built which only contains a single 
.I #define
which tells the compiler how many devices of the kind
.I xx
that has been configured.
.H 3 "Syntax of the configuration file"
The configuration file contains three logical pieces of information:
.BL
.LI 
parameters global to all system images
.LI
parameters specific to each system image to be generated
.LI
device specifications
.LE 1
I won't discuss the first two items on the list above since they
doesn't have anything to do with the device drivers.
.P
For the RT, a device specification takes one of the following forms:
.BL
.LI
	\fBcontroller	\fIdevice-name device-info\fR
.LI
	\fBdevice	\fIdevice-name device-info\fR
.LI
	\fBdisk	\fIdevice-name device-info\fR
.LI
	\fBtape	\fIdevice-name device-info\fR
.LE 1
For the SCSI devices the following item should be added to this list:
.BL
.LI
	\fBmaster	\fIdevice-name device-info\fR
.LE 1
A controller is an adapter that controls one or more disks or tapes
or it uses DMA. Everything else is a device.
The
.I device-name
is one of the standard device names concatenated with the 
.I logical
unit number assigned to the device. (This sould not be confused with
the logical unit numbers, LUN's used in the SCSI context.) Standard device names
are documented in the User's Reference Manual, chapter 4.
For our SCSI system the follownig names have been used:
.BL
.LI
	controller	\fBaha\fIn\fR	\- Adaptec SCSI host adapter.
.LI
	master	\fBxtc\fIn\fR	\- SCSI disk target controller.
.LI
	master	\fBcsc\fIn\fR	\- SCSI tape target controller.
.LI
	disk	\fBxt\fIn\fR	\- SCSI disk.
.LI
	tape	\fBcs\fIn\fR	\- SCSI streamer tape.
.LE 1
.P
The 
.I device-info
describes how the hardware is connected in the interconnection hierarchy. The
beginning of the hierarchy is defined as follows:
.TS 
tab(;);
lw(0.8i) lfB l l.
 ;controller;iocc0;\fBat nexus\fP ?
.TE
.ta 0.8i +0.8i +0.8i +0.8i
The remaining legal interconnections are:
.BL
.LI
A controller can be connected to another controller.
.LI
A master is connected to a controller.
.LI
A disk or tape is always attached to a controller or a master.
.LI
A device is always connected to a controller.
.LE 1
On the RT, the controller specification takes the form:
.TS 
tab(;);
lw(0.8i) lfB l l.
 ;controller;xxcn;\fBat\fP iocc0 \fBcsr\fP addr \fBpriority\fP irq
.TE
.ta 0.8i +0.8i +0.8i +0.8i
where
.DS
.nf
	"xx"	is the two or three letter name of the device.
	"n"	is the controller number.
	"addr"	is the controller adapter base address.
	"irq"	is the PC/AT IRQ level for the adapter.
.DE
For the 
.B aha
adapter, the 
.I addr
value may be specified as 0. This will cause the autoconfig code to try
the standard addresses defined for the Adaptec adapter.
.P
The master specification take the form:
.TS 
tab(;);
lw(0.8i) lfB l l.
 ;master;xxcn;\fBat\fP \fIx\fPham \fBdrive\fP target
.TE
.ta 0.8i +0.8i +0.8i +0.8i
where
.DS
.nf
	"xx"	is the two letter name of the device type.
	"n"	is the target controller number.
	"m"	is the host adapter number.
	"target"	is the SCSI target number for the device.
.DE
.P
The disk and tape specification takes one of the following forms:
.TS 
tab(;);
lw(0.8i) lfB l l.
 ;disk;xxn;\fBat\fP xxcz \fBdrive\fP z
 ;disk;xxn;\fBat\fP xxcz \fBslave\fP lun
 ;tape;xxn;\fBat\fP xxcz \fBdrive\fP z
 ;tape;xxn;\fBat\fP xxcz \fBslave\fP lun
.TE
.ta 0.8i +0.8i +0.8i +0.8i
where
.DS
.nf
	"xx"	is the name of the device
	"n"	is the unit number
	"y"	is the controller number
	"z"	is the slave unit number
	"lun"	is the SCSI logical unit number.
.DE
.H 3 "Changes to config(8)"
The config(8) program had to be changed in order to make it generate systems
with the SCSI driver. The main reason for this is that new kernel structures
are introduced that have to be initialised in 
.I ioconf.c.
The changes are introduced in the source files 
.I config.h,
.I config.y,
.I mkioconf.c
and
.I mkswapconf.c.
.H 4 "Change in config.h"
This header file is only changed in order to introduce two new global
variables
.I seen_aha
and
.I seen_iha
which are booleans set to TRUE by the parser when it sees the keywords
.I aha
or
.I iha
in the config file.
The value of these variables are used later in the program in order to
determine if the new structures should be generated or not.
.H 4 "Change in config.y"
The change in config.y introduces the recognition of the keywords 
.I aha
and
.I iha
into the parser. The variables mentioned above are set to TRUE if those
keywords are recognised.
.H 4 "Changes in mkioconf.c"
The changes here introduces code to generate the appropriate
.I #include
statements and to declare the 
.I xhdinit
and 
.I xhsinit
variables initialised with the appropriate values. There is also a change
that allows the 
.I aha
adapter to be configured with the csr value of 0. This value causes the
autoconfiguration code to ask the driver's probe routine to use addresses 
predefined in the driver thus enabling the config script to wildcard the csr
address. The code in autoconfig works for other devices too, but I restricted
the use of csr 0 to the 
.I aha
adapter since only that driver code is under my control.
.H 4 "Changes to mkswapconf.c"
Traditionally, the UNIX operating system has only allowed a disk to use
a maximum of 8 partitions per disk. As an interesting exercise I wanted to
extend the maximum number of partitions to be a device type specific figure, 
different on different device types. This exercise involved changes in 
mkswapconf.c since minor device numbers are generated here. If I want to
do swapping on 
.I /dev/xt1b, 
the minor device number should be 17 for this 
partition if we allow 16 partitions on an xt disk. If (as normally) only 
8 partitions are allowed, the figure would have been 9.
The maximum number of partitions allowed for a disk type is specified in the
.I devices.ca
file in /sys/conf as an extension to the syntax of this file. A third parameter
now may be given, specifying the maximum number of partitions for this disk
type.
.H 2 "Adding source files to the kernel"
When new source files are added to the kernel, these sources must be specified
in the
.I /sys/conf/files
or the
.I /sys/conf/files.ca
files.
For the SCSI system the following lines had to be added in /sys/conf/files.ca
.Sd
machineio/iha.c         optional iha device-driver
machineio/aha.c         optional aha device-driver
machineio/cs.c          optional cs device-driver
machineio/xt.c          optional xt device-driver
.Se
Which describe the various driver source code files to the config(8) program.
.H 2 "Defining new swap devices"
If a new device type is going to be used as a swap device, it must be defined
in the
.I devices.ca
file. The file consist of a number of lines with the format
.BL
.LI
\fIxx	majdev#	\(u[maxpart\(u]\fP
.LE 1
Where
.DS
.nf
	"xx"	is the two letter code for the disk type.
	"majdev#"	is the major-device-number for the disk type.
	"maxpart"	is the optional max-partitions parameter.
			This an extension to the original syntax. If this 
			parameter is not specified, it's default value is 8.
.DE
.H 1 "DETAILED DESCRIPTION OF THE DRIVER CODE"
The following chapter discuss in detail what happens whithin the SCSI driver.
.H 2 "Definitions"
.BL
.LI
.B Device
the hardware interfacing the real world e.g. tape drives, serial 
line interfaces, disks, etc.
.LI
.B Controller
a piece of hardware that communicate with devices which cannot talk to the
computer directly. A controller commonly have more than one device of the same
or different kinds connected to itself.
.LI
.B Adapter
is the IBM name for a controller (more or less).
.LI 
.B Host adapter
in this context means a controller that connects between the internal bus
of a computer and a SCSI I/O bus.
.LE
.H 2 "Kernel routines commonly used in a device driver"
In the common part of the kernel, there are a lot of routines that device
drivers use. Many of them are self-evident to the average C programmer and 
some are quite special to the kernel. In order to be as complete as possible,
I will deal with all routines that have been used in the SCSI driver.
.H 3 "I/O routines"
These are routines directly involved with the process of doing I/O.
.H 4 "Physio"
.H 4 "Minphys"
.H 4 "Disksort"
.H 4 "Bsdtofsb"
.H 3 "Process control"
Sometimes in device drivers it is necessary to change the status of the process
that is executing. The routines below are used in these cases.
.H 4 "Sleep"
.H 4 "Wakeup"
.H 4 "Iowait"
.H 4 "Iodone"
.H 3 "DMA routines"
The IBM AOS contain some routines to do DMA on the RT. These SHOULD be used.
Doing DMA by oneself isn't healthy.
.H 4 "Dma_map"
.H 4 "Dma_setup"
.H 4 "Dma_free_map"
.H 4 "Dma_go"
.H 4 "Dma_get_minphys"
.H 3 "Hardware interfacing routines"
These routines deal with the processor itself such as altering the interrupt 
priority or doing address translations.
.H 4 "Spl\fIn\fP, splx"
.H 4 "Real_buf_addr"
.H 4 "GET_VR0 macro"
.H 4 "SET_VR macro"
.H 3 "Routines useful for debugging"
Some debugging of device drivers are usually neccessary. While in kernel, some
routines and macros are particularly useful.
.H 4 "Printf"
.H 4 "Uprintf"
.H 4 "DEBUGF macro"
.H 3 "Bulk data manipulation routines"
Doing I/O means moving data. Usage of the CPU for doing this isn't very 
effective, but sometimes necessary. The routines below are designed to 
manipulate lots of data, but also useful for small pieces.
.H 4 "Bzero"
.H 4 "Bcopy"
.H 4 "Clrbuf"
.H 4 "Strncpy, strcpy"
.H 4 "Strncmp"
.H 3 "Other routines"
Some other kernel routines have also been used in the SCSI driver. I didn't
manage to put any nice label on these:
.H 4 "Geterror"
.H 4 "DELAY macro"
.H 4 "PROBE_DELAY macro"
.H 4 "Timeout"
.H 2 "Routines commonly found in a device driver"
Now that we have looked at the routines in the kernel that aren't part of any
device driver, we'll have a look into what we could find in a typical
(disk) device driver.
.H 3 "Configuration routines"
These routines are used during the autoconfiguration process. The autoconfig
program will reach these routines through the 
.I iocc_driver
or the
.I xha_driver
structures.
.H 4 "Probe routine"
This routine is used in order to verify the existence of a device. It also
determine the interrupt vector for the device. The probe routine should verify
that the type of the device is what is expected for the driver in case that
there may be different device types at the same logical location.
The possible return values are:
.BL
.LI
PROBE_BAD \- The probe failed.
.LI
PROBE_NOINT \- Probe was OK without interrupt.
.LI
PROBE_OK \- Probe was OK with interrupt.
.LI
PROBE_BAD_INT \- We lost or didn't get interrupt even 
if the device seemed to be there.
.LE 1
The SCSI device probe routines only return PROBE_NOINT or PROBE_BAD since
they doesn't try to cause an interrupt, however, the probe routine for the
SCSI host adapter uses PROBE_OK since that card uses interrupts to the CPU.
.H 4 "Slave routine"
This routine should verify the existence of specific slave devices on a
controller. If the slave device exists, 1 should be returned, otherwise 0.
.H 4 "Attach routine"
This routine is called by the configuration routines when a slave is located.
The attach routine is used to initialize the driver variables for the
slave. The initialization process may require inquiring of the devices certain
specifics such as disk geometry, tape sizes etc. This routine shouldn't return
anything.
.H 3 "Raw I/O entry points"
These are the routines called from the upper parts of the kernel when doing
character (raw) I/O.
.H 4 "Open routine"
The open routine is used to mark the device as open to the rest of the 
system. If the open is successful, a file descriptor is returned (not
by this routine) to the caller and all subsequent read, write, ioctl and
close operations using that descriptor are accepted as valid.
.P
Before an open can complete this routine must verify that the device was 
properly autoconfigured. It should also verify that the minor number 
of the device are 
within acceptable limits. On certain devices it should check that the open 
.I mode
is acceptable. Tapes should be marked for exclusive use. Device registers
and driver variables may be initialized. 
.P
If the open meets all applicable criteria, zero should be returned, otherwise
an appropriate error code shold be returned, typically 
.I "ENXIO, EIO"
or 
.I EBUSY.
.P
The open routine shold be declared as:
.Sd
\fIxx\fPopen(dev_t dev,int mode)
.Se
.BL
.LI
.I dev
is the major/minor device number of the device. Of these the major number
usually isn't used by the driver code. Major and minor numbers 
.I should
be extracted using the macros 
.I major(dev)
and
.I minor(dev).
.LI
.I mode
is the mode flag passed by the user to the open system call.
.LE 
.H 4 "Close routine"
The close routine is called on the last user close of the device. If there are
any open file descriptors that remain associated with the device after the user
close, the close routine is
.I not
called.
The routine should unlock the device from any exclusive access, disable 
interrupts, tapes should be rewound (if specified by the minor device number)
after any eventual end-of-tape marks have been written. Phone lines should be 
hung up etc.
.br
The syntax at the driver level is:
.Sd
\fIxx\fPclose(dev_t dev,int mode, struct file *fp)
.Se
.BL
.LI
.I dev
is the major/minor device numbers as above.
.LI
.I mode
is the same mode field with which the device was opened, usable for flushing
buffers, rewinding tapes etc.
.LI
.I fp
is the address of the system file table descriptor that corresponds to
the user file descriptor number. This parameter is very seldom used or even
declared but usable i.e. to find inodes.
.LE
.H 4 "Read/write routines"
These routine transfer data from/to the device to user space. They should be
declared as:
.Sd
\fIxx\fPread(dev_t dev,struct uio *uio)
\fIxx\fPwrite(dev_t dev,struct uio *uio)
.Se
.BL
.LI
.I dev
is the major/minor device number.
.LI
.I uio
is the reference to the user I/O buffer structure that contains information
about the data to be transferred.
.LE 1
If the operation is successful return 0, otherwise the error code should be
returned.
.H 4 "Ioctl routine"
This routine should perform any device specific functions that aren't covered by
read, write, open and close. It should be declared as:
.Sd
\fIxx\fPiotcl(dev_t dev, int cmd, caddr_t data, int flag)
.Se
.BL
.LI
.I dev
is the major/minor device number.
.LI
.I cmd
specified which action to be performed, see ioctl.h.
.LI
.I data
is an address to a buffer either containing parameters for the command or
space where results could be placed.
.LI
.I flag
is a parameter usually only used in terminal drivers where it is sent along
to the line discipline's ioctl routine.
.LE
.H 3 "Cooked I/O entry points"
.H 4 "Open routine"
.H 4 "Close routine"
.H 4 "Strategy routine"
.H 3 "I/O routines in general"
.H 4 "Interrupt routine"
.H 2 "What the device driver is supposed to do"
.H 2 "The interface block"
.H 2 "The disk driver"
.H 2 "The tape driver"
.H 2 "The interface between the device driver and the interface block"
.H 2 "Performance issues"
.H 1 "SOME PROBLEMS ENCOUNTERED"
.H 2 "Partial sector I/O"
.H 2 "Hanging devices"
.H 2 "Lost interrupts"
.H 2 "Activating the AHA"
.H 2 "Resource limitations"
.H 2 "Some performance issues"
.H 1 "CONCLUSIONS"
.H 1 "ACKNOWLEDGEMENTS"
.TC
.CS
