\begindata{text,268707936}
\textdsversion{12}
\template{default}
\define{italic
menu:[Font~1,Italic~11]
attr:[FontFace Italic Int Set]
attr:[FontFamily Andy Int 0]}
\define{bold
menu:[Font~1,Bold~10]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]}
\define{chapter
menu:[Title~3,Chapter~20]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]
attr:[FontSize PreviousFontSize Point 4]}
\define{section
menu:[Title~3,Section~21]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]
attr:[FontSize PreviousFontSize Point 2]}
\define{subsection
menu:[Title~3,Subsection~22]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]}
\define{paragraph
menu:[Title~3,Paragraph~23]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[FontFace Italic Int Set]
attr:[FontFamily Andy Int 0]}
\define{example
menu:[Region~4,Example~12]
attr:[LeftMargin LeftMargin Inch 32768]
attr:[Justification LeftJustified Point 0]
attr:[Flags NoFill Int Set]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace FixedFace Int Set]
attr:[FontFamily AndyType Int 0]
attr:[FontSize PreviousFontSize Point -3]}
\define{description
menu:[Region~4,Description~11]
attr:[LeftMargin LeftMargin Cm 27743]
attr:[Indent LeftMargin Cm -30054]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]}
\define{heading
menu:[Title~3,Heading~11]
attr:[LeftMargin LeftMargin Inch -13107]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]}
\define{majorheading
menu:[Title~3,MajorHeading~10]
attr:[Justification Centered Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFamily Andy Int 0]
attr:[FontSize PreviousFontSize Point 4]}
\define{subheading
menu:[Title~3,Subheading~12]
attr:[Justification LeftJustified Point 0]
attr:[Flags KeepPriorNL Int Set]
attr:[Flags KeepNextNL Int Set]
attr:[FontFace Bold Int Set]
attr:[FontFamily Andy Int 0]}
\define{index
menu:[Title~3,Index~91]
attr:[FontFace Italic Int Set]
attr:[FontFamily Andy Int 0]}
\define{normal
menu:[Font~1,Normal]
attr:[FontFamily Andy Int 0]
attr:[FontSize ConstantFontSize Point 10]}
\begindata{lookz, 268667204}
hidden
\enddata{lookz, 268667204}
\view{lookzview,268667204,0,0,0}\center{\majorheading{\indent{A device driver 
connecting tapes and disks to the IBM RT/PC using the Small Computer System 
Interface (SCSI).

}}}\center{
\italic{Christer Bern\^{i}rus

University Techlology Centre for Andrew (UTC)

Department of Computer Engineering

Chalmers University of Technology

S-412 96, Gothenburg, SWEDEN}

}

\indent{A device driver has been developed for connecting SCSI disks and tapes 
to the IBM RT/PC under the AOS 4.3 operating system using the  Adaptec 
AHA1540A/1542 SCSI host adapter. The driver is modularized so that other types 
of SCSI cards could be integrated into the system without changing the driver 
code that deals with the disks and tapes. This report contains the description 
of the driver and some collected experience during the development work.}

\begindata{bp,268675324}
\enddata{bp,268675324}
\view{bpv,268675324,1,0,0}
\chapter{1	INTRODUCTION

}
\normal{In February 1988, I was employed by the UTC at Chalmers University of 
Technology (CTH). UTC is a support organisation for the Andrew system at CTH. 
One of the first things that had to be done was to bring life to some kind of 
backup system. The trouble was that IBM didn't (and doesn't) have any good 
backup storage drives. The only tape running on the RT/PC was the IBM 6157 
streaming tape.  One such tape contains a maximum of 60Mb. Considering the 
volume of data on our fileservers (5.5Gb) that unit was quickly ruled out.

After some market investigation we decided to buy 2 Pertec CS240 streaming 
3480 cartridge tape stations that had a SCSI connection. (The EXAByte sales 
rep. told us they didn't have anything available for the RT).  IBM had a SCSI 
card and a disk driver so we planned to write a tape driver as an add-on to 
the existing driver. A slight problem popped up shortly after ordering the 
tapes, the IBM host adapter used differential SCSI whilst most SCSI products 
on the market used single-ended SCSI. This was solved with a pair of Rancho 
RT-SDA SCSI converter cards.

While we waited for the delivery of the tape stations, I had a look at the IBM 
driver for their 9332 disks. The first look was a slight shock - the driver 
filled about 75 A4 sized pages. After a closer look I found that it would be 
hard to convert that disk driver into a driver that could support both tapes 
and disks, since there were no natural (or easily seen) division between code 
dependent on the disk and code dependent on the host adapter. Therefore we 
soon decided to buy another host adapter for interfacing the tape and writing 
a tape driver for that card.

An obvious problem arose: When (not if) we want to have more disk space on our 
file servers, just 2 SCSI cards with one only serving the tape just won't get 
us very far. It is only possible to have a maximum of 2 IBM SCSI cards per 
machine since there are only 2 register addresses to choose between.  We also 
would like to have 2 file servers connected to the same disks (and tape) for 
redundancy reasons. This was and still is impossible with the IBM SCSI card 
since their card is \italic{ hardwired} at SCSI address 7.

The alternative was to find another SCSI card from elsewhere to connect to the 
RT's AT-bus. Finding such a card was easy, actually using the card of our 
choice first became  a painful experience, more on that below.

Meanwhile, Chalmers had set up some 1000 student accounts into our Andrew 
system and disk space now became a desperate problem.  A good solution to that 
seemed to be to buy a pile of inexpensive SCSI disks and connecting them to 
the existing SCSI bus.}

\begindata{bp,268667168}
\enddata{bp,268667168}
\view{bpv,268667168,2,0,0}\section{
}\chapter{2	HARDWARE INVOLVED

}
\normal{At that time, the only usable disk for bulk storage was the 9332 400Mb 
which was extremely expensive compared to the disks available at the "pirate" 
market.  Without my knowledge, it was then decided to buy nine Maxtor XT-4380S 
~380Mb 5 1/2 inch winchesters.  The nine 4380's were mounted together into 
what we call a "Disk Hotel" with 5 disks and 1 tape in an 19" case. Two of 
these hotels were put together and mounted in an old PDP11 rack. We decided to 
try using these disks and tapes with the Adaptec AHA-1540 host adapter which 
we bought for just peanuts.

}
\section{2.1	Problems and fixes to the hardware}

\normal{When the first prototype of the driver was first tested, nothing 
worked.

The error codes sent from the host adapter (HA) were totally weird. A newly 
delivered logic analyzer (thanks TEK!) was plugged into the AT-bus of the 
computer and we found that the HA, when reading data from the system memory 
just didn't care if valid data was present or not. The cause for this stupid 
behaviour was that the HA didn't honor the signal on the AT-bus called I/O CH 
RDY.

The specification for the AT-bus says:}


\display{\italic{I/O Channel Ready (normally high) is pulled low by a selected 
device to

lengthen the current I/O or memory cycle. Any slow device using this

line should drive it low when a valid select is decoded and a read or

write command is active. Once the device has stored data during a write

operation or it has gated valid data onto the data bus during a read

operation, it should then drive 'I/O CH RDY' high to indicate that the

controller may end the current operation.

}}
\normal{
Not many products on the PC market ever made use of this signal, but the RT 
did and the AHA-1540 just didn't care.

On an ordinary AT, the fact that the HA didn't look at this signal wouldn't 
cause any trouble, since the AT's memory is directly connected to the AT-bus 
and memory nowadays are always fast enough.  However, on the RT, memory is on 
a special system bus with the I/O channel controller in between. In this 
setup, considerable delay will sometimes occur, and I/O CH RDY \italic{is} 
used to signal that no valid data is present.}


\section{2.2	How to fix the AHA-1540 host adapter}

\normal{When the trouble above was encountered and analyzed, I decided to 
fight the elephant and rewrite the HA dependent parts of the driver for the 
IBM SCSI card instead. Fortunately, one of the daring hardware guys at the 
department asked if we could do a hardware patch to the card to see if we 
could make it wait for the relevant data. I asked if he had anything 
particular in mind and the answer was simply:}


\quotation{- Yes, we just stop its clock!

}
\normal{And so we did. When we finally got it free from spikes and races the 
card worked fairly well.

One of the earlier versions of the HW patch also stopped a clock signal from 
the AT-bus. When we received our second HA this part of the patch was 
mistakingly omitted. The card worked better than the old one which had 
problems reading short records from the tape. Credit for the better 
functionality was first put on the fact that that the new card had a later 
revision of the firmware, but after moving the PROM's from the new card to the 
old card the problems persisted. A close examination of the patch revealed the 
mistake and the new card was ''fixed'' to be equal to the old card and voila, 
the problems shoved up on the new card too! We decided to leave out that part 
of the patch.

Many months later, Adaptec came out with another card, AHA1542 with all of the 
DMA logic integrated into a big chip. This version worked OK without any 
patches and seems to be a much more mature product in other respects too. It 
can even be used in SCSI target mode, but we haven't found any use for this 
yet, maybe we'll run TCP/IP on the SCSI bus...}

\begindata{bp,268682896}
\enddata{bp,268682896}
\view{bpv,268682896,3,0,0}\chapter{
3	BRIEF DESCRIPTION OF THE DRIVER

}
\normal{This section deals with the gross structure of the code, process flows 
and hardware relationships.

Other software that required changes is also described.

}\section{
3.1	Building blocks}

\normal{The driver consists of essentially three building blocks. Two of them 
are device drivers in its normal sense and one is an interface between the 
device driver and the host adapter, much like the Massbus or Unibus drivers on 
the VAX. The blocks are designed so that no block will have to know anything 
about what block is at the other end or how it operates.  This design makes it 
possible to exchange device drivers or the interface block independently. In 
order to make it easier to write new drivers, device and adapter independent 
parts have been put into separate files and the functions therein have been 
 written so that they can be used from any of the device drivers or from any 
adapter driver. 

The interface between the various blocks have to be thoroughly specified. 
 This is done in chapter 5.  The figure below show the interrelationship 
between the blocks, the hardware and the top half of the UNIX kernel.}





\italic{Relationship between the various blocks and hardware}


\normal{The model is expandable for accomodating more SCSI buses and host

adapter models.}







\italic{Expanded model of the driver system

}
\normal{In order to make this structure possible, modifications were made to 
the autoconfig code in the UNIX kernel and the config(8) program. Other 
changes were made to the syntax of /sys/conf/devices file in order to make 
more than 8 disk partitions possible. The minidisk(8) program needed a small 
patch in order to recognise these SCSI disks as being such. Code were also 
added to /dev/MAKEDEV and to /etc/mkfs, the last one should be regarded as a 
bug fix.

}\section{
3.2	What the blocks are allowed to know about their environment}

\normal{The device driver blocks have no relationship to other device driver 
blocks. A device driver block is allowed to know things about the type of 
device it controls. E.g. SCSI command codes, sense information and the 
operation of the device. It is \italic{not} allowed to know anything about the 
host adapter to which the device is connected. It is not allowed to control 
the HA directly, nor is it allowed to use any codes specific to the HA driver. 
 Complete SCSI commands may be sent to the HA driver since SCSI commands are 
sent transparently to the SCSI bus.

The HA driver must not know anything about the devices that is connected to 
the SCSI bus, nor should it know anything about how the device driver block 
works apart from what is specified in the interface description. The HA driver 
must not export any hardware specific code to other blocks. Any SCSI commands 
sent from the device drivers should be accepted and sent to the SCSI device. 
Any information derived from that SCSI command should be specified in the ANSI 
SCSI specification, vendor unique information may not be used in the HA 
driver.}

\begindata{bp,268688404}
\enddata{bp,268688404}
\view{bpv,268688404,4,0,0}\chapter{
4	INTEGRATING THE DRIVER INTO THE 4.3 BSD SYSTEM}

\normal{Quite a lot of work had to be done in order to get the driver into the 
system. The work has little to do with driving hardware, but has to be done or 
otherwise debugging the driver and porting to other systems would be very 
difficult. Parts of the work is essential for proper operation.}


\section{4.1	Conf.c - Major device numbers}

\normal{There are two tables in the system that describe all device 
interfacing. These tables are located in the file 
\italic{/sys/machine/conf.c}. The \italic{cdevsw }table describe all character 
(raw) devices and the \italic{bdevsw }table describe all block devices.

The \italic{major }number of a device specifies an index into one of these 
tables and selects a  \italic{class }of devices. Raw and block devices do 
\italic{not }share the same number space, and thus raw device 10 isn't 
necessarily the same device class as block device 10.

The tables describe a list of \italic{possible }devices, but does not list 
what is actually present on a particular system.

There are no entries for the SCSI interface cards, only for the devices that 
the cards control. In the IBM AOS4.3 system, major device numbers 0-24  for 
character devices, and 0-9 for block devices are reserved for IBM. 

In this implementation, the selected tape major numbers are 25 for raw I/O and 
10 for block I/O. The disk major numbers selected are 26 for raw I/O and 11 
for block I/O.}


\subsection{4.1.1	Layout of the cdevsw table}

\normal{The cdevsw table has the following layout. Each entry is the only link 
between the main UNIX code and a driver.}


\example{\smaller{struct cdevsw

\{

        int     (*d_open)();	/* Called at every user open, used in order to 
initialize the device */

        int     (*d_close)();	/* Routine to shut down a device, called only on 
last user close */

        int     (*d_read)();	/* Device specific routine to collect data from a 
device */

        int     (*d_write)();	/* device specific routine to send data to a 
device */

        int     (*d_ioctl)();	/* Routine to manipulate device specific 
functions*/

        int     (*d_stop)();	/* If the driver is a terminal interface, this is 




				   the device specific routine to suspend output */

        int     (*d_reset)();	/* This routine will be called to reset a device 
if

				   the IOCC adapter is also reset */

        struct tty *d_ttys;	/* If driver is a terminal ifc, this is the 
address 

				   of an array of tty structures, one per line. */

        int     (*d_select)();	/* Device specific support to augment the 
select system call. */

        int     (*d_mmap)();	/* Never used on the RT. Maybe used on other UNIX 
systems, probably to do some kind of memory mapping. */

\};

}}
\normal{Any routine entry may be \italic{nulldev }or \italic{nodev}.

Nulldev means that there is no action for this function, nodev means that an 
error action should be performed for this function.}


\subsection{4.1.2	Layout of the bdevsw table}

\normal{The cdevsw table has the following layout. As above, each entry is the 
only link between the main kernel code and a device driver.

}
\example{struct bdevsw

\{

        int     (*d_open)();

        int     (*d_close)();

        int     (*d_strategy)();

        int     (*d_dump)();

        int     (*d_psize)();

        int     d_flags;

        int     (*d_minphys)();

\};}


\normal{The various entries have the following meaning:}


\paragraph{4.1.2.1	Open routine }\normal{This routine is called at every user 
open. It is used in order to initialize the device.}

\paragraph{4.1.2.2	Close routine }\normal{Routine to shut down a device. 
Called only on last user close.}

\paragraph{4.1.2.3	Strategy routine }\normal{Performs all block I/O for a 
device.  Responsible for finding the best way to order I/O requests.}

\paragraph{4.1.2.4	Dump routine }\normal{Called by the system to perform a 
post mortem crash dump of the system.}

\paragraph{4.1.2.5	Psize routine }\normal{This routine should return the 
number os blocks in a device partition, or -1 if the partition isn't allowed. 
The pointer should be 0 \italic{\bold{not }}\italic{nodev}, if the routine is 
undefined.}

\paragraph{4.1.2.6	Flags }\normal{Buf style flags passed into block I/O 
requests, typically} B_TAPE, B_CALL \normal{etc.}

\paragraph{4.1.2.7	Minphys routine }\normal{\normal{This is a very 
unfortunately named routine since it calculates the \italic{maximum }number of 
physical bytes to be transferred during a single DMA operation for a device. 
The kernel supplies a routine called  \italic{minphys }that returns the 
maximum transfer length that the \italic{kernel }can handle.}}


\section{4.2	Ioconf.c - kernel configuration file}

\normal{This file is automatically generated by the config(8) program. It 
contains initialized structures according to the configuration script for the 
system generated. The following structures are initialized:}


\subsection{4.2.1	Iocccinit 

}\normal{This structure contain information about all \italic{configured 
}controllers (adapters) on the I/O channel. It has the type \italic{struct 
iocc_ctlr. }See below for detailed information about this structure.}


\subsection{4.2.2	Ioccdinit 

}\normal{This structure contain information about all \italic{configured 
}devices that connect to any of the controllers above or that connect directly 
to the IOCC. The type is \italic{struct iocc_device}. See below for detailed 
information about this structure.}


\subsection{4.2.3	Xhdinit 

}\normal{This structure contain information about all \italic{configured }SCSI 
targets \italic{configured }to be connected to any of the \italic{x}ha 
controllers found in iocccinit. See below for detailed information about this 
structure.}


\subsection{4.2.4	Xhsinit 

}\normal{This structure contain information about all \italic{configured }SCSI 
logical units (LUN's) \italic{configured}

to be connected to any of the SCSI targets mentioned above. See below for 
detailed information about this structure.

}
\section{4.3	Kernel structures for autoconfiguration and driver use}

\normal{The kernel contain many data structures usable by the device drivers. 
These structures are also used when autoconfiguring the system. They form a 
tree which resembles the hardware configuration of the particular machine.

}
\subsection{4.3.1	Iocc_hd}

\normal{This structure hold pointers to dma registers, the state of the 
channel etc.

There is one structure per dma channel, the layout is:}


\example{struct  iocc_hd \{

        caddr_t hd_addr;                	/* dummy to keep config happy */

        caddr_t dh_8237_reg;            	/* hardware register location */

        unsigned dh_pagebitmask[IOCC_PAGE_SIZE]; /* bitmap to allocate page 
modeTCW's */

        unsigned dh_region_map[IOCC_REGION_SIZE]; /* region mode map */

        short   dh_channel;             	/* channel number */

        short   dh_subchan;             	/* subchannel on the 8237 chip */

        short   dh_state;               	/* state of this channel (see 
dmavar.h)*/

        struct  dma_callback *dh_callfwd; 	/* head of callback queue */

        struct  dma_callback *dh_calllst;	/* tail of callback queue */

        struct  iocc_ctlr *dh_actf;     	/* head of queue to transfer */

        struct  iocc_ctlr *dh_actl;     	/* tail of queue to transfer */

\};}


\normal{The field hd_addr is initialized in ioconf.c which really is a dummy, 
but it makes it possible to keep the config(8) program structure almost as it 
was on the VAX.}


\subsection{4.3.2	Iocc_ctlr}

\normal{This is the "per-controller" structure. There is one for each 
controller (adapter) which control more than one device. If an adapter has 
devices attached there are iocc_device structures that reference the 
corresponding iocc_ctlr structure. This structure is queued in iocc resource 
wait and saves information about iocc resources which are used. The queue of 
devices waiting to transfer is also attached here. The layout is:}


\example{struct iocc_ctlr \{

        struct  iocc_driver *ic_driver;

        short   ic_ctlr;        	/* controller index in driver 	*/

        short   ic_alive;       	/* controller exists 		*/

        caddr_t ic_addr;        	/* address of device in i/o space 	*/

        int     ic_irq;         	/* the IRQ level of the device 	*/

        struct  iocc_hd *ic_hd; 	/* link back to the header 		*/

        struct  buf ic_tab;		/* queue of devices for this controller */

        short   ic_dmachannel;		/* dma channel number 		*/

        int     ic_dmaflags;		/* dma transfer flags 		*/

        struct  buf *ic_dmabuf;		/* buffer to transfer 		*/

        struct iocc_ctlr *ic_dmaforw;	/* Next ctlr on the dma channel 	*/

\};}


\normal{The fields ic_driver to ic_irq are initialized in ioconf.c. The rest 
is set up at boot time or when the system is running.}


\subsection{4.3.3	Iocc_device}

\normal{This is the "per-device" structure. A controller has devices or uses 
DMA,  everything else is a "device". If a controller has many drives attached, 
 then there will be several iocc_device structures associated with a  single 
iocc_ctlr structure.

This structure contains all the information necessary to run a non-dma device 
such as an async line card.  It also contains information for slaves of iocc 
controllers as to which device on the slave this is.  A flags field here can 
also be given in the system specification and is used to tell which 
asynchronous lines are hard wired or other device specific parameters. The 
layout is as follows:}


\example{struct iocc_device \{

        struct  iocc_driver *iod_driver;		/* corresponding driver struct */

        short   iod_unit;       		/* unit number on the system */

        short   iod_ctlr;       		/* mass ctlr number; -1 if none */

        short   iod_slave;      		/* slave on controller */

        caddr_t iod_addr;       		/* address of device in i/o space */

        short   iod_irq;        		/* interrupt request level */

        short   iod_dk;         		/* if init 1 set to number for iostat */

        int     iod_flags;      		/* parameter from system specification */

        short   iod_alive;      		/* device exists */

        short   iod_type;       		/* driver specific type information */

        caddr_t iod_physaddr;   		/* phys addr, for standalone (dump) code */

        struct  iocc_device *iod_forw;		/* Next device on this ctlr */

        struct  iocc_ctlr *iod_mi;		/* Connected ctlr, if any */

        struct  iocc_hd *iod_hd;		/* Ptr to dma channel header struct */

\};

}
\normal{The fields iod_driver to iod_flags are initialized in the ioconf.c 
file.  The rest is set up at boot time.}


\subsection{4.3.4	Iocc_driver}

\normal{This structure, one per device driver, define entries for a set of 
routines in the device driver code that are used at boot time by the 
configuration routine. The following layout is used:}


\example{struct iocc_driver \{

        int     (*idr_probe)();         	/* see if a device is really there 
	*/

        int     (*idr_slave)();        	/* see if a slave is there 		*/

        int     (*idr_attach)();       	/* setup device for a slave 	*/

        int     (*idr_dgo)();           	/* controller specific dma setup 	*/

        caddr_t *idr_addr;              	/* device csr addresses 		*/

        char    *idr_dname;             	/* name of a device 		*/

        struct  iocc_device **idr_dinfo;	/* backpointers to iodinit structs 
	*/

        char    *idr_mname;             	/* name of a controller 		*/

        struct  iocc_ctlr **idr_minfo;  	/* backpointers to iominit structs 
	*/

        int     (*idr_intr)();          	/* interrupt service routine 	*/

#define INT_SERVICED    0

#define INT_NOT_MINE    1

        int     idr_csr;                	/* offset to read/write csr 	*/

        int     (*idr_chanrelse)();     	/* dma channel release request 	*/

        char    idr_flags;              	/* all zero in old drivers! 	*/

#define EARLY_INT       0x01    	/* interrupt handler called on initial

                                 	 * (probe) interrupt and int_8259 does the

                                	 * shared interrupt reset 		*/

#define DRIVER_SUSPEND  0x02    	/* driver wants call on suspend 	*/

        int     (*idr_suspend)();       	/* device suspend 			*/

#define SUSPEND_START   0               	/* device suspend start 		*/

#define SUSPEND_DONE    1               	/* device suspend done 		*/

\};}


\normal{The contents of this structure is initialized in the driver code.}


\subsection{4.3.5	Xha_hd}

\normal{Now we comes to the structures that have been added for the SCSI 
driver. The first structure is much alike the iocc_hd structure. There is one 
such for every SCSI host adapter on the system. It contain information about 
the host adapter, also there are pointers to xha_device structures which 
describe configured SCSI targets. The layout is as follows:}


\example{/* Per SCSI controller structure */

struct xha_hd

\{

        struct  iocc_driver *xh_driver;     /* driver structure */

        short                xh_hatype;     /* Type of ctrlr */

#define HATYPE_NONE     0                   /* Initial value, structure unused 
*/

#define HATYPE_AHA      1                   /* Adaptec AHA-1540 */

#define HATYPE_IBM      2                   /* IBM SCSI Adapter */

        short                xh_active;     /* set if xha is active */

        short                xh_ndrive;     /* number of devices */

        caddr_t              xh_xha;        /* virt addr of xha */

        char                *xh_haname;     /* Name of host adapter */

        struct  xha_device  *xh_xhip[8];    /* attached ctrlrs */

        struct  iocc_ctlr   *xh_iocc;       /* Backptr */

        struct  xha_device  *xh_actf;       /* xfer q head */

        struct  xha_device  *xh_actl;       /* xfer q tail */

\};}


\normal{The fields in xha_hd are all initialized at boot time by the 
autoconfig routine.}


\subsection{4.3.6	Xha_device}

\normal{The xha_device structure is a "one-per-target" structure. They contain 
information about a SCSI target configured to a be connected to a SCSI host 
adapter described in an xha_hd structure. Since each target may control many 
logical units, there is no LUN info in this structure. Info about LUN's are in 
the xha_slave structure. The xha_device structure looks like this:}


\example{/* Per target structure */


struct xha_device

\{

        struct  xha_driver  *xi_driver;

        short                xi_unit;   		/* System's unit no */

        short                xi_ctlr;   		/* SCSI ctrl it is on */

        short                xi_target;  	/* Target on scsi bus */

        short                xi_hatype; 		/* Type of ctlr it is on */

        short                xi_alive;  		/* Target exists */

        u_long               xi_type;   		/* SCSI type of device */

        struct xha_slave    *xi_slaves[8]; 	/* Pointers to slave structs */

        struct xhac_driver  *xi_hadriver; 	/* Pointers to ha's driver routines 
*/

        /* Short cuts */

        caddr_t              xi_xha;

        struct  xha_hd      *xi_hd;


\};

}

\normal{Of these fields, the xi_driver to xi_hatype are initialized in 
ioconf.c. The rest are set up at boot time or simply used during system 
operation.}


\subsection{4.3.7	Xha_slave}

\normal{This structure describe logical SCSI units, see above.

Layout:}


\example{struct	xha_slave	

\{

	struct	xha_driver        *xs_driver;

	short		     	xs_unit;		/* Which unit to system */

	short		     	xs_ctlr;		/* Which SCSI it is on */

	short		     	xs_target;	/* Which target on SCSI bus */

	short			xs_lun;		/* Which logical unit (LUN)*/

	short			xs_alive;		/* Device alive */

	short			xs_dk;		/* Driver no for iostat */

	struct buf		xs_tab;    	/* Head of Q for this dev */

   	short                	xs_inq;    	/* True if the device is in q */

	short		     	xs_flags;		/* Some flags:		*/

#define XSFL_EXOPEN		1		/* Device is exclusively opened */

#define XSFL_SPECSCSI		2		/* Special SCSI command follows	*/

#define XSFL_HASSENSE		4		/* Sense data saved */

	int		     	xs_ocnt;		/* Open count */

	union	scsi_cdb     	xs_cdb;		/* SCSI cmd to emit on next I/O */

	struct	scsi_esense  	xs_esense;	/* Sense data of last spec scsi */

	struct xha_slave    	*xs_forw;   	/* Ptr to next device in q */

	struct xha_slave    	*xs_back;   	/* Ptr to prev device in q */

/* Short cut back */

	struct xha_device   *xs_xi; 	/* Pointer to formatter device struct */

\};

}

\normal{Of these fields, the xs_driver to xs_slave are initialized in 
ioconf.c. The

rest are set up at boot time.}

\subsection{4.3.8	Xha_driver}

\normal{For each SCSI device type supported, i.e. for each SCSI device driver, 
there

is an xha_driver structure.

The structure, define entries for a set of routines 

in the device driver code that are used at boot time by the configuration

routine or by the host adapter driver. It looks as follows:}


\example{/* Per device type structure */


struct xha_driver

\{

    int                 (*xd_probe)();          /* See if target exists */

    int                 (*xd_slave)();          /* See if a slave is there */

    int                 (*xd_attach)();         /* Attach a device */

    int                 (*xd_ustart)();         /* Get operation on xfer */

    int                 (*xd_start)();          /* Get SCSI CDB for xfer */

    int                 (*xd_int)();            /* Data xfer complete */

    short                *xd_type;              /* Drive type codes */

    char                 *xd_dname;             /* Device name */

    char                 *xd_sname;             /* Slave name */

    struct  xha_device  **xd_dinfo;             /* Backpointers */

    struct  xha_slave   **xd_sinfo;             /* Backpointers */

    int                 (*xd_ttl)();            /* Find out time to live */

    int                   xd_flags;             /* Driver flags */

\};}


\normal{These fields are all initialized in the corresponding driver's code.}


\subsection{4.3.9	Xhac_driver}

\normal{For each type of SCSI host adapter and thus for each host adapter 
driver there will be an xhac_driver structure. It is used by the SCSI device 
drivers to access certain defined functions in the host adapter driver. The 
structure looks like this:}


\example{/* Per host adapter type structure */

struct xhac_driver

\{

	u_short	(*xhc_doscsi)(struct xha_slave *,

			     union scsi_cdb *, 

			     caddr_t, int, int);	/* Pass scsi cmds during autoconf */

	void	(*xhc_cstart)(struct xha_slave *);	/* Enter this slave and start channel 
*/

	int     	(*xhc_ustart)(struct xha_slave *);	/* Start this slave */

\};}


\normal{These fields are all initialized in the corresponding host adapter 
driver's code.}


\section{4.4	The config program}

\normal{The config(8) program builds a set of system-configuration files from 
a short file that describes the system being configured. Config also takes as 
input a file that tells it which files are needed to generate a system.  This 
can be augmented by a configuration-specific set of files that gives alternate 
files for a specific machine. The files generated are the makefile, ioconf.c 
and swapvmunix.c who are generated into the directory where the system is 
built. Also, for each device, an\italic{ xx}.h is built which only contains a 
single 

\italic{#define }which tells the compiler how many devices of the kind\italic{ 
xx }that has been configured.}


\subsection{4.4.1	Syntax of the configuration file}

\normal{The configuration file contains three logical pieces of information:


\indent{parameters global to all system images

parameters specific to each system image to be generated

device specifications

}
I won't discuss the first two items on the list above since they

doesn't have anything to do with the device drivers.


For the RT, a device specification takes one of the following forms:}


	\bold{controller}	\italic{device-name device-info}

	\bold{device}		\italic{device-name device-info}

	\bold{disk}		\italic{device-name device-info}

	\bold{tape}		\italic{device-name device-info}


\normal{For the SCSI devices the following item should be added to this list:}


	\bold{master}		\italic{device-name device-info}


\normal{A controller is an adapter that controls one or more disks or tapes or 
it uses DMA. Everything else is a device. The \italic{device-name }is one of 
the standard device names concatenated with the \italic{logical }unit number 
assigned to the device. (This sould not be confused with the logical unit 
numbers, LUN's used in the SCSI context.) Standard device names are documented 
in the User's Reference Manual, chapter 4. For our SCSI system the following 
names have been used:}

\normal{
	controller		\bold{aha}\italic{n}	- Adaptec SCSI host adapter.

	master		\bold{xtc}\italic{n}	- SCSI disk target controller.

	master		\bold{csc}\italic{n}	- SCSI tape target controller.

	disk		\bold{xt}\italic{n}	- SCSI disk.

	tape		\bold{cs}\italic{n}	- SCSI streamer tape.}


\normal{The \italic{device-info }describes how the hardware is connected in 
the interconnection hierarchy. The beginning of the hierarchy is defined as 
follows:


 	\bold{controller	}iocc0	\bold{at nexus} ?


The remaining legal interconnections are:


\indent{A controller can be connected to another controller.

A master is connected to a controller.

A disk or tape is always attached to a controller or a master.

A device is always connected to a controller.

}
On the RT, the controller specification takes the form:


 	\bold{controller	}\italic{xx}c\italic{n	}\bold{at} iocc0 \bold{csr} addr 
\bold{priority} irq


where


	\italic{xx}	is the two or three letter name of the device.

	\italic{n}	is the controller number.

	\italic{addr}	is the controller adapter base address.

	\italic{irq}	is the PC/AT IRQ level for the adapter.


For the  \bold{aha }adapter, the \italic{addr }value may be specified as 0. 
This will cause the autoconfig code to try the standard addresses defined for 
the Adaptec adapter.

The master specification take the form:

	\bold{master}		\italic{xx}c\italic{n}	\bold{at} \italic{x}ha\italic{m} 
\bold{drive} \italic{target}

where

	\italic{xx}	is the two letter name of the device type.

	\italic{x}ha	is the name of the host adatper type.

	\italic{n}	is the target controller number.

	\italic{m}	is the host adapter number.

	\italic{target}	is the SCSI target number for the device.


The disk and tape specification takes one of the following forms:


	\bold{disk}	\italic{xxn} \bold{at} \italic{xx}c\italic{z }\bold{drive} 
\italic{z}

	\bold{disk}	\italic{xxn} \bold{at}\italic{ xx}c\italic{z} \bold{slave} 
\italic{lun}

	\bold{tape}	\italic{xxn} \bold{at} \italic{xx}c\italic{z} \bold{drive} 
\italic{z}

	\bold{tape}	\italic{xxn} \bold{at} \italic{xx}c\italic{z} \bold{slave} 
\italic{lun}


where


	\italic{xx}	is the name of the device

	\italic{n}	is the unit number

	\italic{y}	is the controller number

	\italic{z}	is the slave unit number

	\italic{lun}	is the SCSI logical unit number.

}
\subsection{4.4.2	Changes to config.}

\normal{The config(8) program had to be changed in order to make it generate 
systems with the SCSI driver. The main reason for this is that new kernel 
structures are introduced that have to be initialized in \italic{ioconf.c}.

The changes are introduced in the source files \italic{config.h}, 
\italic{config.y}, \italic{mkioconf.c }and \italic{mkswapconf.c}.

}
\paragraph{4.4.2.1	Change in config.h }\normal{This header file is only 
changed in order to introduce two new global variables \italic{seen_aha }and 
\italic{seen_iha }which are booleans set to TRUE by the parser when it sees 
the keywords \italic{aha }or  \italic{iha }in the config file. The value of 
these variables are used later in the program in order to determine if the new 
structures should be generated or not.


\paragraph{4.4.2.2	Change in config.y }The change in config.y introduces the 
recognition of the keywords \italic{aha }and \italic{iha }into the parser. The 
variables mentioned above are set to TRUE if those keywords are recognised.


\paragraph{4.4.2.3	Changes in mkioconf.c }The changes here introduces code to 
generate the appropriate \italic{#include }statements and to declare the 
\italic{xhdinit }and \italic{xhsinit} arrays initialized with the appropriate 
values. There is also a change that allows the \italic{aha }adapter to be 
configured with the csr value of 0. This value causes the autoconfiguration 
code to ask the driver's probe routine to use addresses  predefined in the 
driver thus enabling the config script to wildcard the csr address. The code 
in autoconfig works for other devices too, but I restricted the use of csr 0 
in the config script to the \italic{aha }adapter since only that driver code 
is under my control.

 

\paragraph{4.4.2.4	Changes to mkswapconf.c }Traditionally, the UNIX operating 
system has only allowed a disk to use a maximum of 8 partitions per disk. As 
an interesting exercise I wanted to extend the maximum number of partitions to 
be a device type specific figure,  different on different device types. This 
exercise involved changes in mkswapconf.c since minor device numbers are 
generated here. If I want to do swapping on \italic{/dev/xt1b}, the minor 
device number should be 17 for this partition if we allow 16 partitions on an 
xt disk. If (as normally) only 8 partitions are allowed, the figure would have 
been 9. The maximum number of partitions allowed for a disk type is specified 
in the \italic{devices.ca }file in /sys/conf as an extension to the syntax of 
this file. A third parameter now may be given, specifying the maximum number 
of partitions for this disk type.


\section{4.5	Adding source files to the kernel}

When new source files are added to the kernel, these sources must be specified 
in the \italic{/sys/conf/files }or the \italic{/sys/conf/files.ca }files.

For the SCSI system the following lines had to be added in /sys/conf/files.ca


\example{machineio/iha.c         optional iha device-driver

machineio/aha.c         optional aha device-driver

machineio/xha.c	  optional aha device-driver

machineio/cs.c          optional cs device-driver

machineio/xt.c          optional xt device-driver

machineio/xxc.c	  optional cs xt device-driver}


Which describe the various driver source code files to the config(8) program.


\section{4.6	Defining new swap devices}

If a new device type is going to be used as a swap device, it must be defined

in the \italic{devices.ca }file. The file consist of a number of lines with 
the format


\italic{xx	majdev#	[maxpart]}


Where


	\italic{xx}	is the two letter code for the disk type.

	\italic{majdev#}	is the major-device-number for the disk type.

	\italic{maxpart}	is the optional max-partitions parameter.

		This an extension to the original syntax. If this 

		parameter is not specified, it's default value is 8.}

\begindata{bp,268697952}
\enddata{bp,268697952}
\view{bpv,268697952,5,0,0}
\chapter{5	DEVICE DRIVER ENVIRONMENT

}
\normal{The following chapters discuss in detail what happens whithin the SCSI 
driver. First a description of the routines that a typical disk driver have 
and the routines that a driver make use of..


\section{5.1	Definitions

}
\bold{Device} is the hardware interfacing the real world e.g. tape drives, 
serial line interfaces, disks, etc.

\bold{Controller }is a piece of hardware that communicate with devices which 
cannot talk to the computer directly. A controller commonly have more than one 
device of the same or different kinds connected to itself.

\bold{Adapter} is the IBM name for a controller (more or less).

\bold{Host adapter }in this context means a controller that connects between 
the internal bus of a computer and a SCSI I/O bus.

\bold{DMA - Direct Memory Access }DMA is a method of transferring large blocks 
of sequential data between a device and the processor memory with minimal 
interference  to the system processor. DMA permits simultaneous use of I/O 
adapters and  the system processor. 

\bold{Alternate controller }The IBM RT supports two types of DMA adapters. One 
is an adapter  \italic{without }the ability of handling addresses or I/O 
control signals. It uses the RT system's DMA controller for addressing and for 
I/O channel control.

The other type is called anternate controller, or sometimes controller using 
"3:rd party DMA", is an adapter \italic{with }the ability of handling its own 
addressing and I/O channel control. This means that the adapter may have a DMA 
chip onboard. The system DMA channel does not generate addresses, these are 
instead generated by the I/O adapter itself. All alternate controllers must be 
16-bit devices.

\bold{TCW - Translation Control Word }The addresses generated by either the 
system DMA or the alternate controller are translated using one or more TCW's. 
The TCW's must be set up before starting  the DMA transfer. Each TCW maps a 2 
Kbyte memory area on the I/O channel to a 2 kByte page in the system memory 
real map. The I/O addresses FE0000 to FFFFFF in the memory map are used as a 
window into system memory.


\section{5.2	Kernel routines commonly used in a device driver}

In the common part of the kernel, there are a lot of routines that device 
drivers use. Many of them are self-evident to the average C programmer and 
 some are quite special to the kernel. In order to be as complete as possible, 
I will deal with all routines that have been used in the SCSI driver.


\subsection{5.2.1	I/O routines}

These are routines directly involved with the process of doing I/O.


\paragraph{5.2.1.1	Physio }This routine is used by device drivers to do 
character I/O to block devices. It is called from the \italic{read }and 
\italic{write }routines in the device driver. It's synopsis is:


\example{physio(int (*strat)(), struct buf *bp, dev_t dev,int rw,unsigned 
(*mincnt)(),struct uio *uio)

}
Where:

\description{\italic{strat }	is a pointer to the strategy routine of the 
driver, see below.}

\description{\italic{buf	}is a pointer to a driver supplied \italic{buf 
}structure.}

\description{\italic{dev	}is the major/minor numbers of the device in 
question.}

\description{\italic{rw	}is a buf-style flag that denote the type of 
operation, either B_WRITE or B_READ.}

\description{\italic{mincnt	}is a pointer to a kernel or driver supplied 
\italic{minphys }routine. See [4.1.2.7] and below.}

\description{uio 	is a pointer to the user I/O buffer structure that contain 
info about the data to be transferred.

}
The routine loops through the I/O vector found in \italic{uio }doing the 
requested I/O operation on all the data spaces found in the I/O vector. For 
each transfer, \italic{physio }will:


\description{A. Verify the user's access priviledges.}

\description{B. Then; while there is more data to be transferred


\description{1. Call the minphys routine indicated by \italic{mincnt}. The 
size of the transfer can be decreased by that operation, therefore it has to 
loop as long as there is any data left.}

\description{2. Lock all affected virtual memory pages in real memory.}

\description{3. Call the driver supplied strategy routine which perform the 
actual transfer.}

\description{4. Unlock the virtual memory pages.

}}
\paragraph{5.2.1.2	Minphys }This kernel routine effectively limits all 
transfers to a maximum of \italic{MAXPHYS }bytes. On the RT, MAXPHYS is 
defined as 128 kBytes. Other systems commonly use 63 kBytes. The synopsis is:


\example{minphys(struct buf *bp)}


Where \italic{bp }points to the buffer structure associated with the transfer 
to be done. If the driver supplies a specialized \italic{xx}minphys routine, 
that routine must call the kernel routine \italic{minphys}.


\paragraph{5.2.1.3	Disksort}

Is a routine used by disk drivers. It is used in order so do seek sorting of 

the transfer queue.

It is declared as:


\example{disksort(struct buf *dp, struct buf *bp)}


The argument dp structure holds an activity chain pointer on which two queues 
are kept, sorted in ascending cylinder order. The first queue holds those 
requests which are positioned after the current cylinder. The second queue 
holds requests which came in after their cylinder number was passed. Thus a 
one way scan is implemented, retracting after reaching the end of the drive to 
the first request on the second queue, The argument bp is a pointer to the buf 
structure associated with the  transfer to be done. The buf structure variable 
b_resid should contain the number of the cylinder that the request will cause 
a seek to.


\paragraph{5.2.1.4	Bdbtofsb }Is a macro that maps a "block device block" 
number to the file system block number. This translation really should be 
device dependent but that hasn't been implemented yet. The macro is simple and 
looks like this:


\example{#define bdbtofsb(bn)    ((bn) / (BLKDEV_IOSIZE/DEV_BSIZE))}


The argument \italic{bn  }is the UNIX int\italic{e}rnal block number. 

On the RT, BLKDEV_IOSIZE is defined as 2048 bytes, DEV_BSIZE is a fixed 
constant with the value 512 which is equal to the common sector size of the 
disks.


\subsection{5.2.2	Process control}

Sometimes in device drivers it is necessary to change the status of the 
process that is executing. The routines below are used in these cases.

\paragraph{5.2.2.1	Sleep } is used in order to give up the processor until 
something happens

that makes it possible to continue. It is the primary means of synchronization 
of processes within the kernel.

Sleep is defined thus:


\example{sleep(caddr_t wchan, int pri)}


The wait channel \italic{wchan }denotes an event for which the process is to 
wait. By convention, this event is represented by the address to a relevant 
data structure. When the event occurs, the process enters the scheduling queue 
at priority \italic{pri}.

The most important effect of pri is that when\italic{ pri} is less than or 
equal to PZERO a signal cannot disturb the sleep; if pri is greater than PZERO 
signals will be processed. Callers of this routine must be prepared for 
premature return, and check that the reason for sleeping has gone away. A 
typical sleep sequence therefore looks like this:


\example{s = splbio()		/* Disable interrupts */

while(\italic{device_in_use})

\{

	sleep(&\italic{device_data_structure}, priority);

\}

\italic{device_in_use} = 1;

splx(s);		/* Enable interrupt */}


It is \italic{illegal }to call sleep from within an interrupt handler,  such a 
call will crash the system immediately. Also, wchan equal to 0 will also crash 
the system. Every device driver writer should be aware of these facts.

Another warning here is that a wakeup that occurs before the sleep won't be 
remembered, this is why the interrupts are shut off in the example above.

If an interrupt was allowed to occur berween the \italic{while }and the 
\italic{sleep }statements, the process would probably sleep forever.

\paragraph{5.2.2.2	Wakeup }A  wakeup on a wait channel awakens \italic{all 
}processes waiting on that channel. The corresponding wakeup sequence to the 
example above is executed  by some other process or an interrupt handler and 
could look like:


\example{\bigger{\italic{device_in_use} = 0;

wakeup(&\italic{device_data_structure});}}


\paragraph{5.2.2.3	Iowait }Is a macro that only renames biowait to iowait (or 
the other way round). Biowait waits for I/O completion on a buffer and return 
errors to the user. It's definition is:


\example{biowait(struct buf *bp)}


\italic{Bp }is a pointer to the buffer structure for which transfer we want to 
wait for.

\paragraph{5.2.2.4	Iodone }Is also a macro that renames biodone to iodone 
(wonder why they have done it this way?) Biodone's definition looks like:


\example{biodone(struct buf *bp)

}
The routine will mark I/O complete on the buffer pointed to by \italic{bp}. If 
some routine should be called (this can be specified in the buf structure) 
that routine will be called. Otherwise, biodone will wake up anyone waiting 
for the buffer.


\subsection{5.2.3	DMA routines}

The IBM AOS contain some routines to do DMA on the RT. These SHOULD be used. 
Doing DMA by oneself isn't healthy.


\paragraph{5.2.3.1	Dma_setup}


\example{int

dma_setup(struct iocc_ctlr *ic)}


Dma_setup is called whenever a device first wants to initiate a transfer. 
 \italic{Ic }is a pointer to a \italic{iocc_ctlr }structure which look like:


\example{struct iocc_ctlr \{

	struct	iocc_driver *ic_driver;

	short	ic_ctlr;			/* controller index in driver */

	short	ic_alive;			/* controller exists */

	caddr_t	ic_addr;			/* address of device in i/o space */

	int	ic_irq;			/* the IRQ level of the device */

	/* end of ioconf filled in fields */

	struct	iocc_hd *ic_hd; 		/* link back to the header */

	struct	buf ic_tab;		/* queue of devices for this controller */

	short	ic_dmachannel;		/* dma channel number */

	int	ic_dmaflags;		/* dma transfer flags */

	struct	buf *ic_dmabuf;		/* buffer to transfer */

/* This is the forwrd link in a list of controllers on a dma channel */

	struct iocc_ctlr *ic_dmaforw;

\};}


\description{The channel number \italic{ic_dmachannel}.} \description{Flags 
\italic{ic_dmaflags.}} A buffer describing the transfer is pointed to by 
\description{\italic{ic_dmabuf}. This pointer can be set to 0 to set up the 
channel only.

}
\paragraph{5.2.3.2	Dma_map}

	

\example{s=spl_dma();

unsigned 

dma_map(short chan, struct buf *bp);

splx(s);}


Dma_map is used to map TCW's for DMA transfers. Dma_setup automatically call

this routine for the buffer pointer passed in ic_dmabuf, if any. \italic{Chan 
}is the channel for the transfer. \italic{Bp} is a pointer to the buf 
structure that describe the transfer. Dma_map returns the I/O address for the 
transfer, i.e. the AT-bus address that shoud be used. If there aren't enough 
contiguous free TCW's to support the transfer, dma_map will return 
DMA_INV_IOADDR. The spl's are needed since the routine manipulates static 
data. This fact isn't documented in the AOS manual.


\paragraph{5.2.3.3	Dma_free_map

}
\example{s=spl_dma();

void

dma_free_map(short chan, unsigned ioaddr, int len);

splx(s);}


Dma_free_map frees TCW's allocated by dma_map. \italic{Chan }is the cannel as 
aboce. \italic{Ioaddr }is the I/O address returned by dma_map. \italic{Len} is 
the length of the transfer in bytes.The spl's are needed since the routine 
manipulates static data. This fact isn't documented in the AOS manual.


\paragraph{5.2.3.4	Dma_go}


\example{void

dma_go(short chan)}


Dma_go enables the DMA channel for a transfer.


\paragraph{5.2.3.5	Dma_done}


\example{void

dma_done(short chan)}


Dma_done frees the channel for other devices to use. All TCW's are freed.


\paragraph{5.2.3.6	Dma_get_minphys}


\example{void

(*dma_get_minphys(struct iocc_ctlr *ic))()}


Dma_get_minphys returns a pointer to the proper \italic{minphys }routine to be 
called. 


\subsection{5.2.4	Hardware interfacing routines}

These routines deal with the processor itself such as altering the interrupt 
priority or doing address translations.


\paragraph{5.2.4.1	Spln, splx }These routines are used for changing the 
processor's interrupt priority. The RT privides eight priority levels, ranging 
from 0 to 7. In the UNIX kernel, priorities also ranges from 0 to 7. However, 
on the RT,  level 0 is the highest but in the UNIX system, level 7 is. For 
this reason, 2 sets of routines are provided for changing the system priority 
level.


spl0, spl1, through spl7 set the system priority level to UNIX level 0 through 
7

respectively.


_spl0, _spl1, through _spl7 set the system priority level to RT level 0 
 through 7 respectively.


These routine return an integer that is the priority level before they were 
called. The return value can be used in the \italic{splx }routine to restore 
the previous level. A typical example is:


\example{int	s;

.

.

s = splN();	/* change to UNIX priority level N */

.

. 		/* critical region of code */

.

splx(s);	/* restore to previous level */

}
\paragraph{5.2.4.2	Real_buf_addr}


\example{caddr_t

real_buf_addr(struct buf *bp,char *bufaddr)}


Real_buf_addr translate a virtual address into a real memory address. 
\italic{Bp }is a pointer to the buffer structure associated with the data. 
\italic{Bufaddr }is the real or virtual address for which the real address is 
sought.

\paragraph{5.2.4.3	GET_VR0 macro}

\paragraph{5.2.4.4	SET_VR macro

}
\subsection{5.2.5	Routines useful for debugging}

Some debugging of device drivers are usually neccessary. While in kernel, some

routines and macros are particularly useful.

\paragraph{5.2.5.1	Printf}

\paragraph{5.2.5.2	Uprintf}

\paragraph{5.2.5.3	DEBUGF macro

}
\subsection{5.2.6	Bulk data manipulation routines}"

Doing I/O means moving data. Usage of the CPU for doing this isn't very 
 effective, but sometimes necessary. The routines below are designed to 
 manipulate lots of data, but are also useful for small pieces.

\paragraph{5.2.6.1	Bzero}

\paragraph{5.2.6.2	Bcopy}

\paragraph{5.2.6.3	Strncpy, strcpy}

\paragraph{5.2.6.4	Strncmp

}
\subsection{5.2.7	Other routines}

Some other kernel routines have also been used in the SCSI driver. I didn't

manage to put any nice label on these:

\paragraph{5.2.7.1	Geterror}

\paragraph{5.2.7.2	DELAY macro}

\paragraph{5.2.7.3	PROBE_DELAY macro}

\paragraph{5.2.7.4	Timeout

}
\section{5.3	Routines commonly found in a device driver}

Now that we have looked at the routines in the kernel that aren't part of any 
device driver, we'll have a look into what we could find in a typical (disk) 
device driver.


\subsection{5.3.1	Configuration routines

}
These routines are used during the autoconfiguration process. The autoconfig 
program will reach these routines through the \italic{iocc_driver }or the 
\italic{xha_driver }structures.


\paragraph{5.3.1.1	Probe routine }This routine is used in order to verify the 
existence of a device. It also determine the interrupt vector for the device. 
The probe routine should verify that the type of the device is what is 
expected for the driver in case that there may be different device types at 
the same logical location. The possible return values are:


\description{PROBE_BAD	- The probe failed.}

\description{PROBE_NOINT	- Probe was OK without interrupt.}

\description{PROBE_OK 	- Probe was OK with interrupt.}

\description{PROBE_BAD_INT 	- We lost or didn't get interrupt even if the 
device seemed to be there.}


The SCSI device probe routines only return PROBE_NOINT or PROBE_BAD since they 
doesn't try to cause an interrupt, however, the probe routine for the SCSI 
host adapter uses PROBE_OK since that card uses interrupts to the CPU.


\paragraph{5.3.1.2	Slave routine }This routine should verify the existence of 
specific slave devices on a controller. If the slave device exists, 1 should 
be returned, otherwise 0.


\paragraph{5.3.1.3	Attach routine }This routine is called by the configuration 
routines when a slave is located. The attach routine is used to initialize the 
driver variables for the slave. The initialization process may require 
inquiring of the devices certain specifics such as disk geometry, tape sizes 
etc. This routine shouldn't return anything.


\subsection{5.3.2	Raw I/O entry points}

These are the routines called from the upper parts of the kernel when doing

character (raw) I/O.


\paragraph{5.3.2.1	Open routine }The open routine is used to mark the device 
as open to the rest of the  system. If the open is successful, a file 
descriptor is returned (not by this routine) to the caller and all subsequent 
read, write, ioctl and close operations using that descriptor are accepted as 
valid.

Before an open can complete this routine must verify that the device was 
 properly autoconfigured. It should also verify that the minor number  of the 
device are  within acceptable limits. On certain devices it should check that 
the open \italic{mode }is acceptable. Tapes should be marked for exclusive 
use. Device registers and driver variables may be initialized. 

If the open meets all applicable criteria, zero should be returned, otherwise 
an appropriate e\italic{rror code shold be returned, typically \italic{ENXIO, 
EIO }or EBUSY.}

The open routine shold be declared as:


\example{\italic{xx}open(dev_t dev,int mode)}


\description{D\italic{ev }is the major/minor device number of the device. Of 
these the major number usually isn't used by the driver code. Major and minor 
numbers \italic{should }be extracted using the macros \italic{major(dev) }and 
\italic{minor(dev).}}


\description{\italic{Mode }is the mode flag passed by the user to the open 
system call.}


\paragraph{5.3.2.2	Close routine }The close routine is called on the last user 
close of the device. If there are any open file descriptors that remain 
associated with the device after the user close, the close routine is 
\italic{not }called. The routine should unlock the device from any exclusive 
access, disable interrupts, tapes should be rewound (if specified by the minor 
device number) after any eventual end-of-tape marks have been written. Phone 
lines should be hung up etc.The syntax at the driver level is:


\example{\italic{xx}close(dev_t dev,int mode, struct file *fp)}


\description{\italic{Dev }is the major/minor device numbers as above.}

\description{\italic{Mode }is the same mode field with which the device was 
opened, usable for flushing buffers, rewinding tapes etc.}

\description{\italic{Fp }is the address of the system file table descriptor 
that corresponds to the user file descriptor number. This parameter is very 
seldom used or even declared but usable i.e. to find inodes.

}
\paragraph{5.3.2.3	Read/write routines }These routine transfer data from/to 
the device to user space. They should be declared as:


\example{\italic{xx}read(dev_t dev,struct uio *uio)

\italic{xx}write(dev_t dev,struct uio *uio)}


\description{\italic{Dev }is the major/minor device number.}

\description{\italic{Uio }is the reference to the user I/O buffer structure 
that contain information about the data to be transferred.}


If the operation is successful return 0, otherwise the error code should be 
returned.


\paragraph{5.3.2.4	Ioctl routine }This routine should perform any device 
specific functions that aren't covered by read, write, open and close. It 
should be declared as:


\example{\italic{xx}iotcl(dev_t dev, int cmd, caddr_t data, int flag)

}
\description{\italic{Dev }is the major/minor device number.}

\description{\italic{Cmd }specified which action to be performed, see ioctl.h. 
\italic{The length of the data is also encoded here.}}

\description{\italic{Data} is an address to a buffer either containing 
parameters for the command or space where results could be placed.}

\description{\italic{Flag }is a parameter usually only used in terminal 
drivers where it is sent along to the line discipline's ioctl routine.}


\subsection{5.3.3	Block I/O entry points

}
\paragraph{5.3.3.1	Open routine }This is usually the same routine as the open 
routine for raw I/O. For disks, it is callel (once) when a filesystem is 
mounted, but not when a file in the filesystem is opened.


\paragraph{5.3.3.2	Close routine }As open, this is also usually the same 
routine as for raw I/O. It is only called upon the \italic{last }close. I.e. 
umount.

\paragraph{5.3.3.3	Strategy routine }The strategy routine is responsible for 
ordering I/O requests into a device request queue and if necessary start I/O 
on that queue. It is an entry point for block I/O but for raw I/O, the call 
chain will go through read/write via physio to get here.


\subsection{5.3.4	I/O routines in general}

\paragraph{5.3.4.1	Interrupt routine

}
\chapter{6	SCSI driver implementation

}As said before, the driver consists of essentially three blocks. However, 
efforts has been made to identyfy portions of code that isn't necessarily 
device dependent. This has led to that the host adapter driver is split 
between two files aha.c and xha.c, where xha.c contains the device independent 
parts. The device drivers also have a file xxc.c which contains code used by 
bothe the tape and the disk driver. In the following discussion I will, 
however, speak of is as if it were onlt three blocks, except when neccessary. 
The function names will point out where the function live. Functions beginning 
with xha... generally live in xha.c and functions beginning with xx... can be 
found in xxc.c. The other prefixes  are self-evident.

\section{6.1	Host adapter driver}

The host adapter code is divided into 9 sections, static data, configuration, 
I/O setup, Interrupt, special, bookkeeping, hardware control, address 
translation and debugging functions. Some compilation options need to be 
described:


\description{AHASTATISTICS will enable code that counts used mailboxes and 
CCB's .


PARANOID will enable numerous checks of zero pointers, priority levels (see 
below) and other range checks. This can be defined if one suspects bugs that 
crash the system.


SPL_MUCH will make large parts of the driver run on the splbio level. This can 
be turned on if driver bugs are suspected. Usage of this #define may impair 
the performance of the asynchronous tty driver, causing silo overflows and 
lost characters, and is thus deprecated.

}
\subsection{6.1.1	Static data}

This section of the code defines some ????????????????

\subsection{6.1.2	Configuration functions}

\subsection{6.1.3	I/O setup functions}

This section contains the functions that handle the setup of normal I/O 
operations to be performed after autoconfiguration is done. The following 
functions are defined: 


\description{Xhacstart, xhaqdevice and xhastartdevices which are independent 
of the host adapter and associated structures. They are useful for dealing 
with simultaneous requests to many devices that share common resources.}

\description{Ahaustart, ahaxsetup, ahasetupccb, ahalinkccb, ahafillccb, 
ahafillmbo and ahastartmbo all deal with setting up necessary control blocks 
for starting I/O in the Adaptec host adapter. These are, of course, dependent 
on the architecture of the Adaptec card.


T}he functions maintain a queue of devices, connected to the host adapter 
called the \italic{device queue} implemented as a double linked list. A device 
is entered in the device queue whenever a device has a nonempty\italic{ 
request queue }which is a simple linked list with pointers to bothe the head 
and the tail of the list.


\paragraph{6.1.3.1	Xhacstart}(struct buf *) is called from the device driver's 
strategy routine via the pointer \italic{xhc_cstart} in the xhac_driver 
structure. The only thing performed is a check on the parameter and then a 
call to xhaqdevice followed by a call to xhastartdevices. Nothing is returned.


\paragraph{6.1.3.2	Xhaqdevice}(struct xha_slave *) is called from the 
xhacstart routine and when the host adapter's interrupt routine has found a 
device with a nonempty \italic{request queue}. The routine first checks if the 
device is already in the device queue. If so, nothing more is done. If not, 
the device is entered in the queue. Nothing is returned from this function.


\paragraph{6.1.3.3	Xhastartdevices}(struct xha_hd *) is called  from xhacstart 
and in the interrupt routine when any device has been queued. This routine 
walks through the device queue and calls the device's corresponding host 
adapter routine that deal with starting the requests available for a 
particular device. This is done via the pointer\italic{ xhc_ustart} in the 
xhac_driver structure. In this case the ahaustart function will be called. If 
that function returns XHS_DONE and the device's request queue is empty, the 
device is removes from the device queue. In other device drivers, normally 
processing an interrupt will reactivate only the device that caused the 
interrupt. In this driver is, however, resources shared among the devices and 
a setup of an I/O will eventually fail. When they do it is impossible to sleep 
until the resources become available since the setup routines are also called 
from the interrupt routine. The remedy of this situation is to give up and let 
the requests stay in the request queue. This method implies that a processed 
request that free's any resources must activate \italic{all} devices that 
might wait for the resource. For the moment the code isn't completely right in 
thes aspect since the TCW resource is shared among \italic{all devices }on the 
system including those not connected to the Adaptec card. This might cause 
trouble if more than one HA is used since this driver uses lots of TCW's.


\paragraph{6.1.3.4	Ahaustart}(struct xha_slave *)  is called from 
xhastartdevices via the pointer \italic{xhc_ustart} in the xhac_driver 
structure.  This routine will attempt to start the I/O requests available for 
a device. The host adapter driver here has two (or three) modes of operation 
and a fourth way is possible although not implemented.

\description{ 

Either the HA driver will start one request and wait for completion where the 
interrupt routine will make sure that the next request is started by calling 
xhastartdevices. }

\description{Another possibility is to go through the request list and set up 
a chain of linked SCSI commands. In this mode, many requests, possibly all, 
will be sent to the HA in one operation.} 

\description{A third possibility used in by the tape driver is to decide to 
not start I/O but dropping the request.} 

\description{The 4:th possibility, not implemented, is to create one MBO/CCB 
pair for as many requests as possible. This mode was tried during the 
development of the driver, but was discarded since it didn't seem to provide 
any performance gain over SCSI command linking although it might be useful for 
devices that do not support command linking.

}
 The routine will walk through the request queue and for each request 
available ask the corresponding device driver what should be done to the 
request. The device driver can respond in one of three ways:

\description{
XHU_DODATA will start I/O for the request and then stop processing of the 
request queue awaiting I/O completion.


XHU_DOLINKS will set up for a transfer using SCSI command linking. When the 
request list or any necessary resources are exhausted, the chain is started. 
Note that this mode does not guarantee that all available requests will be 
started and be performed atomically. It is only a means of speeding things up.


XHU_NEXT will skip the request altogether and processing is continued with the 
next request.


\paragraph{6.1.3.5	Ahaxsetup}( struct xha_slave *, struct buf *, struct 
ahaccb*,union scsi_cdb *)

\paragraph{6.1.3.6	Ahasetupccb}(struct xha_slave *, union scsi_cdb *, 
ioaddr_t, struct buf *)

\paragraph{6.1.3.7	Ahalinkccb}(int ctlr, struct ahaccb *from,struct ahaccb 
*to)

\paragraph{6.1.3.8	Ahafillccb}(struct ahaccb *, union scsi_cdb *, ioaddr_t, 
int dlen, struct xha_slave *, struct buf *)

\paragraph{6.1.3.9	Ahafillmbo}(int ctlr, struct ahambox *, struct ahaccb *)

\paragraph{6.1.3.10	Ahastartmbo}(int ctlr, struct ahaccb *, struct ahambox *)

}
\subsection{6.1.4	Interrupt functions}

This section has essentially two functions, ahaint and ahascanmbi although 
ahascanmbi uses two minor functtions for decoding MBI status and HA status to 
something not so device dependent.


\paragraph{6.1.4.1	Ahaint}(int) is called from the lower levels of the 
kernel's interrupt handling routines. The parameter supplied is the AHA 
controller number. This routine takes care of the AHA registers and interrupt 
flags, checks for stray interrupts and preforms some bookkeeping to be able to 
determine if any interrupt was missed. If the AHA needs mailbox initialization 
is needed the routine ahainitmbox is called to do this. If a MBI was filled or 
if a SCSI reset condition is detected, the function ahascanmmbi is called 
which will do most of the work. When this work is done, the interrupt flag is 
cleared and any now outstanding MBO's are started and the routine is finished.


\paragraph{6.1.4.2	Ahascanmbi}(int ctlr, int scsireset) is the largest and 
most complicated function in the whole driver set. The routine performs all 
actions necessary to take care of the completed I/O requests. The routine has 
some #defines that can be toggled in order to shift some of the algorithm:


\description{NOMBIHOLES can be #defined in order to use a mode effective 
algorithm in the search for MBI's. If this is defined, the function will stop 
searching for MBI's when the first empty MBI is found. As the name suggests, 
this will work only is the AHA  will never create a hole in the sequence of 
completed MBI's. To date, I have found no eveidence that the AHA should create 
such holes, but on the other hand Adaptec have made no guarantee's.


PARTIALFILLCHECK can be defined if one suspects that the AHA fill the MBI's in 
an improper order. The old model AHA-1540 did this and sometimes the MBI had a 
status byte telling us that the MBI was filled, but the CCB address wasn't yet 
filled in. 


CCBPCHECK. The problem above caused a lot of headache and many parts of the 
code in ahascanmbi is devoted to checking the validity of the MBI address. If 
CCBPCHECK is #define'd these checks are turned on. However, with the release 
of the AHA-1542 the partially filled MBI problem seems to have been fixed.


XSCHECK will enable some checks of the pointer \italic{xs }Enable this if 
driver or autoconfig bugs are suspected.


The routine briefly do the following things:

	}For each filled mailbox:

\indent{\description{Pick the ccb address and translate to a virtual address.

Clear the corresponding MBO.

Decide a adapter independent completion code based on the MBI code and host 
adapter status.

If the MBI had a corresponding buffer pointer (its perfectly normal if it 
doesn't) 

\indent{Call the corresponding device driver's interrupt routine to get a 
decision on what to do with the buffer. This might result in 4 different 
answers:


XHD_RESETRETRY: A bus device reset should be sent and the buffer is to be 
requeued.


XHD_SCRESETRETRY: A SCSI bus reset should be sent and the buffer is to be 
requeued.


XHD_RETRY: The buffer is to be requeued.


XHD_DONE: I/O was completed successfully and iodone should be called.


}After this is done, any allocated DMA maps, the CCB and the MBI are released.

Lastly if the target status isn't one telling that a part of a SCSI link chain 
was completed, the request queue of the device is checked and if it isn't 
empty, the device is put on the device queue by calling xhaqdevice.

}}\description{When the mailboxes are processed, then if any device has been 
put on the device queue, xhastartdevices will be called and things get started 
again.}


\subsection{6.1.5	Special functions}


\paragraph{6.1.5.1	Ahatout} is a routine which takes care of all those little 
events that doesn't occur. I.e. when something goes wrong and the hardware 
refuses to do what is expected. This routine is scheduled to be called through 
the system's timeout mechanism. This is done whenever an I/O is initiated. The 
routine will do the following:

\indent{
\description{If the host adapter for some reason wasn't started, (this is done 
regularly for performance reasons since starting it usually isn't necessary), 
the host adapter is started explicitly, and a new timeout is scheduled.


If there are no outstanding I/O requests, the routine returns without 
scheduling a new timeout.


If there are outstanding I/O, and an interrupt has occurred, things seem to be 
alive, so no action is taken except of scheduling a new timeout. When this 
happens and no interrupt has been taken while there are still outstanding I/O, 
it's time to take a closer look:


If the controller has set its interrupt bit, we've probably missed it, so one 
is simulated by calling ahaint().


If not, we go through all of the outbound mailboxes to see if there are anyone 
that has timed out. Each CCB  has a timestamp and a field which determines the 
maximum estimated time for the request to be completed. If one such MBO is 
found, it is first restarted a maximum of three timeout periods, and then it 
will be reported as timed out to the interrupt routine. When the interrupt 
routine find any such mailbox, it will let the device driver decide what to do 
with the request. Either a bus device reset may me issued, or a scsi reset be 
issued and the I/O will be requeued, or the device driver can request that the 
I/O shall fail without retry (e.g. tapes).}}


\subsection{6.1.6	Bookkeeping functions}

\subsection{6.1.7	Hardware control functions}

\subsection{6.1.8	Address translation functions}

\subsection{6.1.9	Debugging functions}

\section{6.2	The disk driver}

\section{6.3	The tape driver}

\section{6.4	Flow of operation}

\subsection{6.4.1	Autoconfiguration.

}The autoconfiguration operation is primarily driven by the code in 
\italic{machineio/autoconf.c.} This code will first configure all standard IBM 
devices connected to the IOCC. Thereafter, if any host adapter has been 
configured (The HA is here regarded as a normal IBM device) the devices all of 
the host adapters should be configured. The host adapter's probe routine work 
as normal device probe routines do, i.e. trying to make the device generate an 
interrupt so that the interrupt level can be determined.

When the stuff on the SCSI bus is to be probed, things must be set up so that 
the normal interrupt routines will be entered upon interrupt. This is easily 
accomplished on AOS using the EARLY_INT flag in the iocc_driver structure.

The device probe routine will then do the following things to determine if the 
expected unit is actually there:


\indent{\description{For each possible LUN, issue a SCSI INQUIRY command to 
see if there is any device on the expected target. Doing a Test_Unit_Ready 
will not suffice, since a disk that is there but not spun up will return a NOT 
READY condition as well as a nonexistent unit will do. It can be argued that 
the host adapter could inform me whether we got a selection timeout, but that 
would easily make the probe routine dependent on the host adapter codes which 
I'd like to avoid. The other thing is that the INQUIRY command will tell me 
the device type which I'm also interested in.

If any of the inquiries for lun's complete OK, the device type returned is 
compared against the expected type. If this is also OK, the probe routine 
returns PROBE_NO_INT indicating that the \italic{target controller} is there 
but no interrupt level is to be noted. If nothing is fount, the probe routine 
will DELAY for a short time and repeat the procedure since some units need 
time to complete any self-tests that may be initiated by the SCSI reset issued 
when the host adapter is attached. If nothing is found during the second 
round, or, if something with an unexpected device type is found, the probe 
routine will return PROBE_BAD which causes autoconf to go on probing the next 
device in the xhdinit structure.}

}
If the probe for a target controller succeeds, the autoconfiguration process 
will mark the controller as being \italic{alive} and go through the 
\italic{xhsinit} structure for LUN's expected to be attached to the newly 
found target. If any such is found, the autoconf code will call the 
corresponding \italic{xx}slave  routine which will do the following things to 
see if there really is such a LUN ready.


\indent{\description{\italic{Xx}slave will first issue a TEST UNIT READY 
command. If the unit isn't ready it will issue a START UNIT command in order 
to start any spun-down disks etc. If this fails, \italic{xx}slave will return 
0 indicating that the LUN didn't get ready or didn't even exist. If the unit 
is properly started or was ready from the beginning, a MODE SENSE command is 
issued in order to be sure that the unit really is there (some target 
controllers actually lies about nonexistent LUN's being ready when TEST UNIT 
READY is issued). If the mode sense goes well, \italic{xx}slave returns 1 
indicating to autoconf that the device is ready.

}}
When autoconf sees a ready unit, it will call the unit's \italic{xx}attach 
routine thus making possible for the device driver to initialize its internal 
variables, reading partition tables etc.


\subsection{6.4.2	Normal flow of operation}

This section will describe what happens when an I/O request enters the driver.

\begindata{zip,268697800}
%ViewWidth 616
%ViewHeight 662
*D;-1000,1400
N8.5X11
>-1000,1400
*I;-260,186
S1
>-260,180
\begindata{text,269025660}
\textdsversion{12}
\enddata{text,269025660}
*N;100,-400
>500,-600
*N;0,900
>400,700
*N;400,900
>800,700
*N;800,900
>1200,700
*N;900,600
>1300,400
*N;900,200
>1300,0
*N;100,400
>500,200
*N;100,0
>500,-200
*N;100,-1013
>500,-1213
*N;87,-1300
>487,-1500
*N;-1000,1000
>-600,800
*N;-1000,700
>-600,500
*N;-500,800
>-100,600
*N;-1000,0
>-600,-200
*N;-500,-100
>-100,-300
*N;-1000,-400
>-600,-600
*N;-500,-500
>-100,-700
*N;-500,-800
>-100,-1000
*N;-1000,-1313
>-600,-1513
*N;-1000,-1013
>-600,-1213
*N;-1300,-650
>-900,-850

\enddata{zip,268697800}
\view{zipview,268697800,6,618,664}
\paragraph{6.4.2.1	Routines calling the driver. }An I/O request is typically 
coming from the UNIX kernel routines \italic{bread, bwrite} or \italic{breada} 
for block oriented I/O. These routines  call the \italic{xx}strategy routines 
directly. Raw I/O requests first enter the device driver routines 
\italic{xx}read or \italic{xx}write which call the kernel routine 
\italic{physio} which in its turn call \italic{xx}strategy. Thus, all I/O 
requests finally enters the strategy routine. 


\paragraph{6.4.2.2	The strategy routine }The duty of the strategy routine is 
to take a buffer passed and enter it at the proper place in the I/O request 
queue. It also performs validation of the logical unit and the calculations 
neccessary to implement the disk partitioning. The tape's strategy routine 
takes care of selecting the proper buffering mode. If the unit is found to be 
inactive after the buffer is placed into the I/O queue the strategy routine 
calls the host adapter's xhacstart routine to start the I/O.


\paragraph{6.4.2.3	The xhacstart routine }This is a simple routine that will 
in sequence call xhaqdevice and then xhastartdevices. These routines really 
are host adapter independent and do not depend on any host adapter specific 
structures. Therefore these routines are placed in the file xha.c.


\paragraph{6.4.2.4	The xhaqdevice routine }will take the passed device and 
enter it in a device queue if it isn't already there.


\paragraph{6.4.2.5	The xhastartdevices routine} will go through the 
abovementioned device queue and for all devices found call the host adapter 
specific routine \italic{x}haustart. If the result is that all I/O requests 
are started, the device will be removed from the device queue.


We now enter the routines that are host adapter specific. Since the only host 
adapter implemented is the Adaptec AHA1540A/1542 the routines are now named 
aha.... You find these in \italic{machineio/aha.c.}


Ahaustart  is responsible for walking through the device queue and start the 
available requests. This can be done in some different ways depending on the 
capabilitis of the unit in question.  For each request, ahaustart will ask the 
units xxustart what to do with the request. There are three answers to that 
question.


\description{XHU_NEXT - skip this request and get the next one. This is used 
by the tape driver.}

\description{XHU_DODATA - start transferring the data, and wait for completion 
before starting next request.}

\description{XHU_DOLINKS - build a SCSI link chain of the requests available 
in the request queue. When the queue drains or no no more transfers can be set 
up, the chain is started.}


Before any requests can be started, there are certain resources that must be 
available. First, we need an outbound mailbox (MBO) where we will place a 
pointer to the (first) command control block (CCB). The MBO is allocated by 
the routine ahagetmbo.  Next, we need one CCB for every request to be started. 
This is allocated and set up by the routine ahaxsetup whic will, if everything 
went OK, return a pointer to the CCB that was set up. If something went wrong 
0 is returned. When all necessary setups are done, the MBO prevously allocated 
will be set up (and the transfer started) by the routine ahastartmbo. When the 
transfer is done, the processing will continue in the ahaint routine (see 
below).


\section{6.5	The interface between the device drivers and the HA driver.}

\section{6.6	Performance issues}}.

\normal{\chapter{7	SOME PROBLEMS ENCOUNTERED}

\section{7.1	Partial sector I/O.}

\section{7.2	Hanging devices.}

\section{7.3	Lost interrupts.}

\section{7.4	Activating the AHA.}

\section{7.5	Resource limitations.}}

\chapter{8	CONCLUSIONS}

\chapter{9	ACKNOWLEDGEMENTS}

Lastly, I wish to thank some people who has contributed to this work.


\description{\bold{Dan Klein} who gave me the first insights into device 
driver design during a one day course at EUUG, London 1988.


Numerous \bold{students} in the school of computer engineering, who suffered 
during the development of this driver and thus did much of the testing in a 
production environment.


\bold{Hakan Winbom }for the code dealing with the cache on the Wren VI disk 
and major contributions to the disk manipulation program \italic{dk.

}
\bold{Borje Lindh}, who bought the pile of disks which turned the driver from 
just a tape driver into something more flexible.


\bold{Stig Ostholm} who helped me proofreading the code when the bugs were 
eating us.


\bold{Sven Tafvelin }my boss, who let me do this work without complaining 
about broken time schedules, bug count etc.

}\enddata{text,268707936}
