#!/bin/bsh
# # @(#)60        1.2  R2/sysx/disk/enhancements/new_disks.sh, sysxdisk, bos320, 9230320a 7/24/92 09:40:30#
#
# COMPONENT_NAME: (SYSXDISK)
#
# FUNCTIONS: new_disks
#                                                                    
# ORIGINS: 27 
#
# (C) COPYRIGHT International Business Machines Corp. 1992
# All Rights Reserved
# Licensed Material - Property of IBM
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#                                                                    


# Invoke Selective Enhancement conversion program for new disks that
# were formerly osdisks (OEM) to make them into IBM supported disks
/usr/lpp/bos/_scdisk_/convert_scdisk disk/scsi/osdisk


# After disks are converted, a bosboot needs to take place, if the
# system is not a client.
if [ -n "$INUCLIENTS" ]; then
        bosboot -a -d /dev/network
	savebase -d /etc/basecust
	exit 0
fi

SLASHHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/") print $1 }'`
USRHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/usr") print $1 }'`
if [ "$SLASHHOST" = "-" -a "$USRHOST" = "-" ]
then
	# if both / and /usr are local then
	# execute bosboot in the normal way.
	bosboot -a -d /dev/ipldevice
	exit $?
fi
if [ "$SLASHHOST" = "-" -a "$USRHOST" != "-" ]; then
	# if bos / is local and /usr is remote then
	# execute bosboot with the proto file for remote /usr
	bosboot -a -d /dev/ipldevice -p /usr/lib/boot/netdisk.proto
	exit $?
fi

exit  0
