#!/bin/bsh
# # @(#)62        1.1  R2/sysx/disk/enhancements/reject_1370mb.sh, sysxdisk, bos320, 9210320b 3/3/92 13:21:57#
#
# COMPONENT_NAME: (SYSXDISK)
#
# FUNCTIONS: reject_new_disks
#                                                                    
# ORIGINS: 27 
#
# (C) COPYRIGHT International Business Machines Corp. 1992
# All Rights Reserved
# Licensed Material - Property of IBM
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#                                                                    


# Reject Selective Enhancement of new IBM disks and convert them to 
# osdisks (OEM) disks
/usr/lpp/bos/_scdisk_/convert_scdisk disk/scsi/1000mb
/usr/lpp/bos/_scdisk_/convert_scdisk disk/scsi/1370mb


if [ -n "$INUCLIENTS" ]; then
	exit 0
fi

SLASHHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/") print $1 }'`
USRHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/usr") print $1 }'`
if [ "$SLASHHOST" = "-" -a "$USRHOST" = "-" ]
then
	# if both / and /usr are local then
	# execute bosboot in the normal way.
	bosboot -a -d /dev/ipldevice
	exit $?
fi
if [ "$SLASHHOST" = "-" -a "$USRHOST" != "-" ]; then
	# if bos / is local and /usr is remote then
	# execute bosboot with the proto file for remote /usr
	bosboot -a -d /dev/ipldevice -p /usr/lib/boot/netdisk.proto
	exit $?
fi

exit  0
