#! /bin/ksh
# # @(#)26        1.1  R2/sysx/disk/sd/enhancement/reject_1.1gb.sh, sysxdisk, bos320, 9210320 2/28/92 17:24:25#
# COMPONENT_NAME: (SYSXDISK)
#
# FUNCTIONS: reject_1.1gb
#                                                                    
# ORIGINS: 27 
#
# (C) COPYRIGHT International Business Machines Corp. 1992
# All Rights Reserved
# Licensed Material - Property of IBM
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#                                                                    


# If the 1.1 GB selective enhancement is rejected then remove all customized 
# attributes and devices that were created as result of this selective 
# enhancement

odmget -q PdDvLn=disk/serdasdc/serdasdd4 CuDv|grep name |awk '{print $3}' |sed s/\"//g > /tmp/1.1gb_choices

odmget -q PdDvLn=disk/serdasdc/serdasdd5 CuDv|grep name |awk '{print $3}' |sed s/\"//g >> /tmp/1.1gb_choices

for i in `cat /tmp/1.1gb_choices`
do
	odmdelete -q name=$i -o CuAt
	odmdelete -q name=$i -o CuDv

done

/bin/rm -f /tmp/1.1gb_choices



if [ -n "$INUCLIENTS" ]; then
	exit 0
fi

SLASHHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/") print $1 }'`
USRHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/usr") print $1 }'`
if [ "$SLASHHOST" = "-" -a "$USRHOST" = "-" ]
then
	# if both / and /usr are local then
	# execute bosboot in the normal way.
	bosboot -a -d /dev/ipldevice
	exit $?
fi
if [ "$SLASHHOST" = "-" -a "$USRHOST" != "-" ]; then
	# if bos / is local and /usr is remote then
	# execute bosboot with the proto file for remote /usr
	bosboot -a -d /dev/ipldevice -p /usr/lib/boot/netdisk.proto
	exit $?
fi

exit  0
