#!/bin/bsh
# @(#)01        1.1  R2/sysx/tape/enhancements/new_tapes.sh, sysxtape, bos322 6/25/92 09:38:33
#
# COMPONENT_NAME: (SYSXTAPE)
#
# FUNCTIONS: new_tapes
#                                                                    
# ORIGINS: 27 
#
# (C) COPYRIGHT International Business Machines Corp. 1992
# All Rights Reserved
# Licensed Material - Property of IBM
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#                                                                    


# Invoke Selective Enhancement conversion program for new tapes that
# were formerly ost (OEM) to make them into IBM supported tapes
/usr/lpp/bos/_sctape_/convert_sctape tape/scsi/ost


# After tapes are converted, a bosboot needs to take place, if the
# system is not a client.
if [ -n "$INUCLIENTS" ]; then
	exit 0
fi

SLASHHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/") print $1 }'`
USRHOST=`mount |tail +3 |sed -e "s/^ /-/" |
awk '{ if($3 == "/usr") print $1 }'`
if [ "$SLASHHOST" = "-" -a "$USRHOST" = "-" ]
then
	# if both / and /usr are local then
	# execute bosboot in the normal way.
	bosboot -a -d /dev/ipldevice
	exit $?
fi
if [ "$SLASHHOST" = "-" -a "$USRHOST" != "-" ]; then
	# if bos / is local and /usr is remote then
	# execute bosboot with the proto file for remote /usr
	bosboot -a -d /dev/ipldevice -p /usr/lib/boot/netdisk.proto
	exit $?
fi

exit  0
