#ifdef __cplusplus
extern "C" {
#endif
#ifndef _PARAMS
#if defined(__STDC__) || defined(__cplusplus)
#define _PARAMS(ARGS) ARGS
#else
#define _PARAMS(ARGS) ()
#endif
#endif /* _PARAMS */
/*
 * Copyright (c) 1985 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that: (1) source distributions retain this entire copyright
 * notice and comment, and (2) distributions including binaries display
 * the following acknowledgement:  ``This product includes software
 * developed by the University of California, Berkeley and its contributors''
 * in the documentation or other materials provided with the distribution
 * and in all advertising materials mentioning features or use of this
 * software. Neither the name of the University nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * All recipients should regard themselves as participants in an ongoing
 * research project and hence should feel obligated to report their
 * experiences (good or bad) with these elementary function codes, using
 * the sendbug(8) program, to the authors.
 *
 *	@(#)math.h	4.8 (Berkeley) 6/1/90
 */

extern double asinh _PARAMS((double)), acosh _PARAMS((double)), atanh _PARAMS((double));
extern double erf _PARAMS((double)), erfc _PARAMS((double));
extern double exp _PARAMS((double)), expm1(), log _PARAMS((double)), log10 _PARAMS((double)), log1p(), pow _PARAMS((double, double));
extern double fabs _PARAMS((double)), floor _PARAMS((double)), ceil _PARAMS((double)), rint _PARAMS((double));
extern double lgamma _PARAMS((double));
extern double hypot _PARAMS((double, double)), cabs();
extern double copysign _PARAMS((double, double)), drem _PARAMS((double, double)), logb _PARAMS((double)), scalb _PARAMS((double, double));

#if defined(__vax__) || defined(tahoe)
extern double infnan();
#endif

extern int finite _PARAMS((double));
extern double j0 _PARAMS((double)), j1 _PARAMS((double)), jn _PARAMS((int, double)), y0 _PARAMS((double)), y1 _PARAMS((double)), yn _PARAMS((int, double));
extern double sin _PARAMS((double)), cos _PARAMS((double)), tan _PARAMS((double)), asin _PARAMS((double)), acos _PARAMS((double)), atan _PARAMS((double)), atan2 _PARAMS((double, double));
extern double sinh _PARAMS((double)), cosh _PARAMS((double)), tanh _PARAMS((double));
extern double cbrt _PARAMS((double)), sqrt _PARAMS((double));
extern double modf _PARAMS((double, double *)), ldexp _PARAMS((double, int)), frexp _PARAMS((double, int *)), atof _PARAMS((const char *));

#ifdef ibm032
#define HUGE	1.7976931348623158e308
#else
#define HUGE	1.701411733192644270e38
#endif
#ifdef __cplusplus
extern double fmod (double, double);
#endif /* defined(__cplusplus) */
#ifdef __cplusplus
}
#endif
