/*
 * Copyright (c) 1988 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution is only permitted until one year after the first shipment
 * of 4.4BSD by the Regents.  Otherwise, redistribution and use in source and
 * binary forms are permitted provided that: (1) source distributions retain
 * this entire copyright notice and comment, and (2) distributions including
 * binaries display the following acknowledgement:  This product includes
 * software developed by the University of California, Berkeley and its
 * contributors'' in the documentation or other materials provided with the
 * distribution and in all advertising materials mentioning features or use
 * of this software.  Neither the name of the University nor the names of
 * its contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	@(#)machlimits.h	7.2 (Berkeley) 6/28/90
 */

#include <limits.h>	/* GCC has many of these defined in here */

#ifndef	CHAR_BIT
#define	CHAR_BIT	8		/* number of bits in a char */
#endif
#ifndef	CLK_TCK
#define	CLK_TCK		60		/* ticks per second */
#endif
#ifndef	MB_LEN_MAX
#define	MB_LEN_MAX	1		/* no multibyte characters */
#endif

#ifndef	SCHAR_MIN
#define	SCHAR_MIN	0x80		/* max value for a signed char */
#endif
#ifndef	SCHAR_MAX
#define	SCHAR_MAX	0x7f		/* min value for a signed char */
#endif

#ifndef	UCHAR_MAX
#define	UCHAR_MAX	0xff		/* max value for an unsigned char */
#endif
#ifndef	CHAR_MAX
#define	CHAR_MAX	0xff		/* max value for a char */
#endif
#ifndef	CHAR_MIN
#define	CHAR_MIN	0x00		/* min value for a char */
#endif

#ifndef	USHRT_MAX
#define	USHRT_MAX	0xffff		/* max value for an unsigned short */
#endif
#ifndef	SHRT_MAX
#define	SHRT_MAX	0x7fff		/* max value for a short */
#endif
#ifndef	SHRT_MIN
#define	SHRT_MIN	0x8000		/* min value for a short */
#endif

#ifndef	UINT_MAX
#define	UINT_MAX	0xffffffff	/* max value for an unsigned int */
#endif
#ifndef	INT_MAX
#define	INT_MAX		0x7fffffff	/* max value for an int */
#endif
#ifndef	INT_MIN
#define	INT_MIN		0x80000000	/* min value for an int */
#endif

#ifndef	ULONG_MAX
#define	ULONG_MAX	0xffffffff	/* max value for an unsigned long */
#endif
#ifndef	LONG_MAX
#define	LONG_MAX	0x7fffffff	/* max value for a long */
#endif
#ifndef	LONG_MIN
#define	LONG_MIN	0x80000000	/* min value for a long */
#endif

#ifndef _ANSI_SOURCE    
/* Quad constants must be written as expressions; #define GCC_ME_HARDER. */
#ifndef UQUAD_MAX
#define UQUAD_MAX	((u_quad_t)0-1) /* max value for a uquad_t */
#endif
					/* max value for a quad_t */
#ifndef QUAD_MAX
#define QUAD_MAX	((quad_t)(UQUAD_MAX >> 1))
#endif
#ifndef QUAD_MIN
#define QUAD_MIN	(-QUAD_MAX-1)   /* min value for a quad_t */
#endif

#ifndef SIZE_T_MAX
#define SIZE_T_MAX	UINT_MAX
#endif
#endif
