#	@(#)bsd.man.mk	8.1 (Berkeley) 6/8/93

.if exists(${.CURDIR}/../Makefile.inc)
.include "${.CURDIR}/../Makefile.inc"
.endif

MANGRP?=	bin
MANOWN?=	bin
MANMODE?=	444

MANDIR?=	/usr/share/man/cat

MINSTALL=	install -c -o ${MANOWN} -g ${MANGRP} -m ${MANMODE}

COMPRESS_MAN?=	gzip -f -9
COMPRESS_EXT?=	.gz

maninstall:
.if defined(MAN1) && !empty(MAN1)
	${MINSTALL} ${MAN1} ${DESTDIR}${MANDIR}1${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}1${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN1})
.endif
.endif
.if defined(MAN2) && !empty(MAN2)
	${MINSTALL} ${MAN2} ${DESTDIR}${MANDIR}2${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}2${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN2})
.endif
.endif
.if defined(MAN3) && !empty(MAN3)
	${MINSTALL} ${MAN3} ${DESTDIR}${MANDIR}3${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}3${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN3})
.endif
.endif
.if defined(MAN3F) && !empty(MAN3F)
	${MINSTALL} ${MAN3F} ${DESTDIR}${MANDIR}3f${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}3f${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN3F})
.endif
.endif
.if defined(MAN4) && !empty(MAN4)
	${MINSTALL} ${MAN4} ${DESTDIR}${MANDIR}4${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}4${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN4})
.endif
.endif
.if defined(MAN5) && !empty(MAN5)
	${MINSTALL} ${MAN5} ${DESTDIR}${MANDIR}5${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}5${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN5})
.endif
.endif
.if defined(MAN6) && !empty(MAN6)
	${MINSTALL} ${MAN6} ${DESTDIR}${MANDIR}6${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}6${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN6})
.endif
.endif
.if defined(MAN7) && !empty(MAN7)
	${MINSTALL} ${MAN7} ${DESTDIR}${MANDIR}7${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}7${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN7})
.endif
.endif
.if defined(MAN8) && !empty(MAN8)
	${MINSTALL} ${MAN8} ${DESTDIR}${MANDIR}8${MANSUBDIR}
.if defined(COMPRESS_MAN)
	(cd ${DESTDIR}${MANDIR}8${MANSUBDIR}; \
	${COMPRESS_MAN} ${MAN8})
.endif
.endif
.if defined(MLINKS) && !empty(MLINKS)
	@set ${MLINKS}; \
	while test $$# -ge 2; do \
		name=$$1; \
		shift; \
		dir=${DESTDIR}${MANDIR}`expr $$name : '[^\.]*\.\(.*\)'`; \
		l=$${dir}${MANSUBDIR}/`expr $$name : '\([^\.]*\)'`.0; \
		name=$$1; \
		shift; \
		dir=${DESTDIR}${MANDIR}`expr $$name : '[^\.]*\.\(.*\)'`; \
		t=$${dir}${MANSUBDIR}/`expr $$name : '\([^\.]*\)'`.0; \
		if test -n "${COMPRESS_MAN}"; then \
			rm -f $$t; \
			t=$${t}${COMPRESS_EXT}; \
			l=$${l}${COMPRESS_EXT}; \
		fi ; \
		echo $$t -\> $$l; \
		rm -f $$t; \
		ln $$l $$t; \
	done; true
.endif
