/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1986 Carnegie-Mellon University
 *  
 * This software was developed by the Mach operating system
 * project at Carnegie-Mellon University's Department of Computer
 * Science. Software contributors as of May 1986 include Mike Accetta, 
 * Robert Baron, William Bolosky, Jonathan Chew, David Golub, 
 * Glenn Marcy, Richard Rashid, Avie Tevanian and Michael Young. 
 * 
 * Some software in these files are derived from sources other
 * than CMU.  Previous copyright and other source notices are
 * preserved below and permission to use such software is
 * dependent on licenses from those institutions.
 * 
 * Permission to use the CMU portion of this software for 
 * any non-commercial research and development purpose is
 * granted with the understanding that appropriate credit
 * will be given to CMU, the Mach project and its authors.
 * The Mach project would appreciate being notified of any
 * modifications and of redistribution of this software so that
 * bug fixes and enhancements may be distributed to users.
 *
 * All other rights are reserved to Carnegie-Mellon University.
 ****************************************************************
 */
/*
 * HISTORY
 * 13-Jun-87  Daniel Julin (dpj) at Carnegie-Mellon University
 *	Fixed definition of I_BR15. Defined I_BRX15.
 *	Defined STEP_RETURN. Declared call_depth.
 *
 * 31-Jan-87  Daniel Julin (dpj) at Carnegie-Mellon University
 *	Created for kernel debugger KDB.
 *
 *
 */

int	sstepmode;
int	icount;
int	call_depth;

#define STEP_NONE	0
#define	STEP_NORM	1
#define STEP_PRINT	2
#define	STEP_CALLT	3
#define	STEP_RETURN	4

#define	M_BLINK		0xff00
#define	I_BALA		0x8a00
#define	I_BALAX		0x8b00
#define	I_BALI		0x8c00
#define	I_BALIX		0x8d00
#define	I_BALR		0xec00
#define	I_BALRX		0xed00
#define	I_BR15		0xe88f
#define	I_BRX15		0xe98f

#define I_BPT		0xbd00
