/*
 ****************************************************************
 * Mach Operating System
 * Copyright (c) 1989 Carnegie-Mellon University
 * Copyright (c) 1988 Carnegie-Mellon University
 * Copyright (c) 1987 Carnegie-Mellon University
 * Copyright (c) 1986 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 ****************************************************************
 */
/*
 * 5799-WZQ (C) COPYRIGHT IBM CORPORATION  1986
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */


 # Move up to the NPS interrupt setup area
	.org real0 + 0x100

 #***************************************************************
 #*	LEVEL 0 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x100   *
 #***************************************************************
LV0:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int0 - real0		# New IAR
	.short	NOTRANS_ICS+INT_PRI0	# New ICS
	.short	0x0000			# Reserved
 #***************************************************************
 #*	LEVEL 1 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x110   *
 #***************************************************************
LV1:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int1 - real0		# New IAR
	.short	NOTRANS_ICS+INT_PRI1	# New ICS
	.short	0x0000			# Reserved
 #***************************************************************
 #*	LEVEL 2 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x120   *
 #***************************************************************
LV2:	.long	0xB0B0B0B0			# Old IAR
	.short	0xB0B0				# Old ICS (SCR 14)
	.short	0xB0B0				# Old CS  (SCR 15)
	.long	int2 - real0			# New IAR
	.short	NOTRANS_ICS+INTMASK_ICS+INT_PRI2# New ICS
	.short	0x0000				# Reserved
 #***************************************************************
 #*	LEVEL 3 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x130   *
 #***************************************************************
LV3:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int3 - real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #***************************************************************
 #*	LEVEL 4 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x140   *
 #***************************************************************
LV4:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int4 - real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #***************************************************************
 #*	LEVEL 5 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x150   *
 #***************************************************************
LV5:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int5 - real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #***************************************************************
 #*	LEVEL 6 INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x160   *
 #***************************************************************
LV6:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	int6 - real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #*********************************************************************
 #*	MACHINE CHECK INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x170   *
 #*********************************************************************
MACHK:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	mck0 - real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #*********************************************************************
 #*	PROGRAM CHECK INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x180   *
 #*********************************************************************
PGMCHK:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	pck0 -real0		# New IAR
	.short	FLIHICS			# New ICS
	.short	0x0000			# Reserved
 #*********************************************************************
 #*	SVC INTERRUPT OLD/NEW PROGRAM STATUS AREA. 0x190	     *
 #*********************************************************************
SVC:	.long	0xB0B0B0B0		# Old IAR
	.short	0xB0B0			# Old ICS (SCR 14)
	.short	0xB0B0			# Old CS  (SCR 15)
	.long	svc0 - real0		# New IAR
	.short	NOTRANS_ICS+INTMASK_ICS+INT_PRI0	# New ICS
SVCODE:	.short	0x0000			# SVC CODE

 #
 # the Model has a POST (Power On Self Test) table at 0x800 that must
 # be intact for the 'control-alt-pause/break'  
 # to work. The loaders protect this area if one leaves room (zeros)
 # in that area.
 #
 # Move past the POST
	.org real0 + 0x1000
