/* 
 * Mach Operating System 
 * Copyright (c) 1987 Carnegie-Mellon University 
 * All rights reserved.  The CMU software License Agreement specifies 
 * the terms and conditions for use and redistribution. 
 */ 
/* 
 * HISTORY $Log:	consdefs.h,v $
 * Revision 2.2  88/10/06  17:41:01  sanzi
 * 	Added include of "device_base.h".  Merge with ACIS to minimize differences.
 * 	Fix includes.
 * 
 */ 
#include <cacons/device_base.h>

/*
 * 5799-WZQ (C) COPYRIGHT IBM CORPORATION 1986,1987
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */
/* $Header: consdefs.h,v 2.2 88/10/06 17:41:01 sanzi Exp $ */
/* $ACIS:consdefs.h 9.2$ */
/* $Source: /afs/cs.cmu.edu/source_mach/rcs/kernel/cacons/consdefs.h,v $ */

#if !defined(lint) && !defined(LOCORE)  && defined(RCS_HDRS)
static char *rcsidconsdefs = "$Header: consdefs.h,v 2.2 88/10/06 17:41:01 sanzi Exp $";
#endif

#ifndef DEBUGF
#include <ca/debug.h>
#endif


#define min(x,y) x < y ? x : y
#define max(x,y) x > y ? x : y

#define in(port) IN(port)
#define out(port,value) OUT(port,value)
#define inw(port) INW(port)
#define outw(port,value) OUTW(port,value)

#define CRT_1 0x3b8		       /* crt port 1 */
#define PUT_SCR_REG(reg,value) out(0x3b4,reg); out(0x3b5,value);
#define PUT_SCR_REG_C(reg,value) out(0x3d4,reg); out(0x3d5,value); /* EGA */

#ifdef DEBUG
#define LOCAL			       /* make it external */
#else
#define LOCAL	static		       /* make it local */
#endif

extern int edebug;
#define EDEBUG(cond, stmt) DEBUGF((edebug & cond), stmt)

#if !defined(DEBOUNCE) && defined(IBMRTPC)
#define DEBOUNCE        1
#endif

#define CONS_SWITCH_FOCUS_CODE	0x5f

#ifdef DEBUG
#define TRACEF(x) if (cndebug) printf x			/* cndebugging stuff */
#else
#define TRACEF(x) 					/* cndebugging stuff */
#endif
