/* 
 * Mach Operating System
 * Copyright (c) 1987 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */
/*
 * 5799-CGZ (C) COPYRIGHT IBM CORPORATION 1987
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */

/* Include for ioctl commands to SCSI driver */
#define SCSIIOCFORMAT	_IOW(S,0,struct scsiformat)
#define SCSIIOCKICKCMD	_IOW(S,1,int)	/* pgc from 1.7 */
#define SCSIIOCKICKDMA	_IOW(S,2,int)	/* pgc from 1.7 */

struct scsiformat {
	u_char level;		/* Fomat Level */
	u_char interleave;	/* Interleave Factor */
};

#define MIN_INTERLEAVE 0	/* Lun will Use Default in this case */
#define MAX_INTERLEAVE 8

/* Format Levels P = (Manufactures Defect list), G = (Grown Defect list)  */
#define FL_CHIL		0x00	/* Level 1 - Just changes interleave factor */
#define FL_ONLYP	0x18	/* Level 2 - Format with only P list */
#define FL_PANDG	0x10	/* Level 3 - Format with P and G list */
