/* 
 * Mach Operating System
 * Copyright (c) 1987 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */


/*
 **********************************************************************
 * HISTORY
 * $Log:	ux_exception.h,v $
 * Revision 2.3  89/01/15  16:35:44  rpd
 * 	Use decl_simple_lock_data.
 * 	[89/01/15  15:19:58  rpd]
 * 
 * Revision 2.2  88/08/24  02:52:12  mwyoung
 * 	Adjusted include file references.
 * 	[88/08/17  02:27:27  mwyoung]
 * 
 *
 * 29-Sep-87  David Black (dlb) at Carnegie-Mellon University
 *	Created.
 *
 **********************************************************************
 */

/*
 *	Codes for Unix software exceptions under EXC_SOFTWARE.
 */


#define EXC_UNIX_BAD_SYSCALL	0x10000		/* SIGSYS */

#define EXC_UNIX_BAD_PIPE	0x10001		/* SIGPIPE */

#ifdef	KERNEL
/*
 *	Kernel data structures for Unix exception handler.
 */

#include <sys/port.h>
#include <sys/lock.h>

decl_simple_lock_data(,	ux_handler_init_lock)
port_t			ux_exception_port;

#endif	KERNEL
