/* 
 * Mach Operating System
 * Copyright (c) 1987 Carnegie-Mellon University
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */
/*
 * HISTORY
 * $Log:	ipc_copyout.h,v $
 * Revision 2.4  89/01/10  23:28:42  rpd
 * 	Removed port_copyout.
 * 	[89/01/09  14:45:57  rpd]
 * 
 * Revision 2.3  88/09/25  22:10:39  rpd
 * 	Added object_copyout_cache.  Changed msg_destroy to void.
 * 	[88/09/24  17:58:35  rpd]
 * 	
 * 	Changed name of object_delete to object_destroy.
 * 	Added declaration of msg_destroy.
 * 	[88/09/21  00:45:41  rpd]
 * 	
 * 	Changed includes to the new style.
 * 	[88/09/19  16:11:55  rpd]
 * 
 * Revision 2.2  88/08/06  18:14:17  rpd
 * Created.
 * 
 */ 

#ifndef	_IPC_COPYOUT_
#define	_IPC_COPYOUT_	1

#include <sys/message.h>

extern void port_destroy_receive();
extern void port_destroy_own();
extern void port_destroy_receive_own();

extern int port_copyout_receive();
extern int port_copyout_own();
extern int port_copyout_receive_own();

extern void object_destroy();
extern void object_copyout();
extern void object_copyout_cache();

extern msg_return_t msg_copyout();
extern void msg_destroy();

#endif	_IPC_COPYOUT_
