
#include "uucp.h"
VERSION("$Id: callers.c,v 1.3 1993/02/26 13:32:56 roger Exp $")

#ifdef mc68k
/*
 * CT -- define BSD this module only for TCP connect
 */
/* #define BSD4_2 */
#define bcopy(b1,b2,len) memcpy(b2,b1,len)
#include <syslocal.h>
#endif /* mc68k */

#ifdef BSD
#include <netdb.h>
#include <netinet/in.h>
#include <sys/socket.h>
#endif
#ifdef UNET
#include  "UNET/unetio.h"
#include  "UNET/tcp.h"
#endif


int alarmtr();
extern jmp_buf Sjbuf;
extern char *fdig();

static int _Mcntl = FALSE;
int _Hflow = TRUE;	/* enable hardware flow control */
void	getMcntl();

#ifdef STANDALONE
extern short DialModem;		/* let cu dial direct with -m */
#else 
short DialModem = 0;		/* don't touch CLOCAL in fixline() */
#endif /* STANDALONE */

/*
 *	to add a new caller:
 *	declare the function that knows how to call on the device,
 *	add a line to the callers table giving the name of the device
 *	(from Devices file) and the name of the function
 *	add the function to the end of this file
 */

#ifdef unixpc
int	s4call();
int	linedisc = 0;		/* are we currently connected to OBM? */
int	fgetty = 0;		/* did we really remove the getty? */
char 	gettydev[20];		/* device we removed the getty from */
#  ifdef STARLAN
int	slancall();
#  endif /* STARLAN */
#endif /* unixpc */

#ifdef DIAL801
int	dial801();
#endif

#ifdef DATAKIT
int	dkcall();
#endif /* DATAKIT */

#ifdef V8
int	Dialout();
#endif

#ifdef TCP
int	unetcall();
int	tcpcall();
#ifdef mc68k
int	bsdtcpopn();
#endif /* mc68k */
#endif /* TCP */

#ifdef SYTEK
int	sytcall();
#endif /* SYTEK */

#ifdef TLI
int	tlicall();
#endif /* TLI */

struct caller Caller[] = {

#ifdef DIAL801
	{"801",		dial801},
	{"212",		dial801},
#endif /* DIAL801 */

#ifdef V8
	{"Dialout",	Dialout},	/* ditto but using dialout(III) */
#endif

#ifdef TCP
#ifdef BSD
#ifdef mc68k
	{"TCP",		tcpcall},	/* 4.2BSD sockets, ATT style */
	{"UCBTCP",	bsdtcpopn},	/* 4.2BSD sockets, UCB style */
#else
	{"TCP",		tcpcall},	/* 4.2BSD sockets */
#endif /* mc68k */
#else /* !BSD */
#ifdef UNET
	{"TCP",		unetcall},	/* 3com implementation of tcp */
	{"Unetserver",	unetcall},
#endif /* UNET */
#endif /* BSD */
#endif /* TCP */

#ifdef DATAKIT
	{"DK",		dkcall},	/* standard AT&T DATAKIT VCS caller */
#endif /* DATAKIT */

#ifdef SYTEK
	{"Sytek",	sytcall},	/* untested but should work */
#endif /* SYTEK */

#ifdef TLI
	{"TLI",		tlicall},	/* AT&T Transport Layer Interface */
#ifdef TLIS
	{"TLIS",	tlicall},	/* AT&T Transport Layer Interface */
#endif /*  TLIS  */
#endif /* TLI */
#ifdef unixpc
	{"OBM",		s4call},	/* UnixPC internal modem */
	{"PC7300",	s4call},	/* UnixPC internal modem */
#  ifdef STARLAN
	{"STARLAN",	slancall},	/* STARLAN using nls routines */
#  endif
#endif /* unixpc */

	{NULL, 		NULL}		/* this line must be last */
};

/***
 *	exphone - expand phone number for given prefix and number
 *
 *	return code - none
 */

static void
exphone(in, out)
char *in, *out;
{
	FILE *fn;
	char pre[MAXPH], npart[MAXPH], tpre[MAXPH], p[MAXPH];
	char buf[BUFSIZ];
	char *s1;

	if (!isalpha(*in)) {
		(void) strcpy(out, in);
		return;
	}

	s1=pre;
	while (isalpha(*in))
		*s1++ = *in++;
	*s1 = NULLCHAR;
	s1 = npart;
	while (*in != NULLCHAR)
		*s1++ = *in++;
	*s1 = NULLCHAR;

	tpre[0] = NULLCHAR;
	fn = fopen(DIALCODES, "r");
	if (fn != NULL) {
		while (fgets(buf, BUFSIZ, fn)) {
			if ( sscanf(buf, "%s%s", p, tpre) < 1)
				continue;
			if (EQUALS(p, pre))
				break;
			tpre[0] = NULLCHAR;
		}
		fclose(fn);
	}

	(void) strcpy(out, tpre);
	(void) strcat(out, npart);
	return;
}

/*
 * repphone - Replace \D and \T sequences in arg with phone
 * expanding and translating as appropriate.
 */
static char *
repphone(arg, phone, trstr)
register char *arg, *phone, *trstr;
{
	extern void translate();
	static char pbuf[2*(MAXPH+2)];
	register char *fp, *tp;

	for (tp=pbuf; *arg; arg++) {
		if (*arg != '\\') {
			*tp++ = *arg;
			continue;
		} else {
			switch (*(arg+1)) {
			case 'T':
				exphone(phone, tp);
				translate(trstr, tp);
				for(; *tp; tp++)
				    ;
				arg++;
				break;
			case 'D':
				for(fp=phone; *tp = *fp++; tp++)
				    ;
				arg++;
				break;
			default:
				*tp++ = *arg;
				break;
			}
		}
	}
	*tp = '\0';
	return(pbuf);
}

/*
 * processdev - Process a line from the Devices file
 *
 * return codes:
 *	file descriptor  -  succeeded
 *	FAIL  -  failed
 */

processdev(flds, dev)
register char *flds[], *dev[];
{
	int dcf = -1;
	register struct caller	*ca;
	char *args[D_MAX+1], dcname[20];
	register char **sdev;
	extern int (*Setup)();
	extern void translate(), setdevcfg();
	register nullfd;
	char *phonecl;			/* clear phone string */
	char phoneex[2*(MAXPH+2)];	/* expanded phone string */

	DEBUG(5, "Processing device %s\n", dev[D_CALLER]);
	sdev = dev;
	for (ca = Caller; ca->CA_type != NULL; ca++) {
		/* This will find built-in caller functions */
		if (EQUALS(ca->CA_type, dev[D_CALLER])) {
			DEBUG(5, "Internal caller type %s\n", dev[D_CALLER]);
			if (dev[D_ARG] == NULL) {
				/* if NULL - assume translate */
				dev[D_ARG+1] = NULL;	/* needed for for loop later to mark the end */
				dev[D_ARG] = "\\T";
			}
			dev[D_ARG] = repphone(dev[D_ARG], flds[F_PHONE], "");
			if ((dcf = (*(ca->CA_caller))(flds, dev)) < 0)
				return(dcf) ;
			if ( interface( ca->CA_type ) ) {
				DEBUG(5, "interface(%s) failed", ca->CA_type);
				Uerror = SS_DEVICE_FAILED;
				/*	restore vanilla unix interface	*/
				(void)interface("UNIX");
				return(FAIL);
			}
			dev += 2; /* Skip to next CALLER and ARG */
			break;
		}
	}
	if (dcf == -1) {
		/* Here if not a built-in caller function */
		getMcntl(dev[D_LINE]);
		if ( *dev[D_LINE] != '/' ) {
			(void) sprintf(dcname, "/dev/%s", dev[D_LINE]);
		} else {
			(void) strcpy(dcname, dev[D_LINE] );
		}
		if (mlock(dev[D_LINE]) == FAIL) { /* Lock the line */
			DEBUG(5, "mlock %s failed\n", dev[D_LINE]);
			Uerror = SS_LOCKED_DEVICE;
			return(FAIL);
		}
		DEBUG(5, "mlock %s succeeded\n", dev[D_LINE]);
		/*
		 * Open the line
		 */
		/* take care of the possible partial open fd */
		(void) close(nullfd = open("/", 0));
		if (setjmp(Sjbuf)) {
			(void) close(nullfd);
			DEBUG(1, "generic open timeout\n", 0);
			logent("generic open", "TIMEOUT");
			Uerror = SS_CANT_ACCESS_DEVICE;
			goto bad;
		}
		(void) signal(SIGALRM, alarmtr);
		(void) alarm(10);
#ifdef O_NDELAY
		if (_Mcntl == TRUE)
			CDEBUG(1, "opening with O_NDELAY set\n", "");
		dcf = open(dcname, _Mcntl == TRUE ? O_NDELAY | O_RDWR : O_RDWR);
		if (dcf >= 0 && _Mcntl == TRUE) {
			CDEBUG(1, "clear O_NDELAY\n", "");
			fcntl(dcf, F_SETFL,
				fcntl(dcf, F_GETFL, 0) & ~O_NDELAY);
		}
#else
		dcf = open(dcname, 2);
#endif
		(void) alarm(0);
		if (dcf < 0) {
			(void) close(nullfd);
			DEBUG(1, "generic open failed, errno = %d\n", errno);
			logent("generic open", "FAILED");
			Uerror = SS_CANT_ACCESS_DEVICE;
			goto bad;
		}
		fixline(dcf, atoi(fdig(flds[F_CLASS])),
			DialModem ? D_DIRECT : D_ACU);
	}

	/*	init device config info	*/
	DEBUG(5, "processdev: calling setdevcfg(%s, ", Progname);
	DEBUG(5, "%s)\n", flds[F_TYPE]);
	setdevcfg(Progname, flds[F_TYPE]);

	if ( (*Setup)( MASTER, &dcf, &dcf ) ) {
		/*	any device lock files we should remove?	*/
		DEBUG(5, "MASTER Setup failed", 0);
		Uerror = SS_DEVICE_FAILED;
		/*	restore vanilla unix interface	*/
		(void)interface("UNIX");
		return(FAIL);
	}
	/*
	 * Now loop through the remaining callers and chat
	 * according to scripts in dialers file.
	 */
	for (; dev[D_CALLER] != NULL; dev += 2) {
		register int w;
		/*
		 * Scan Dialers file to find an entry
		 */
		if ((w = gdial(dev[D_CALLER], args, D_MAX)) < 1) {
			DEBUG(1, "%s not found in Dialers file\n", dev[D_CALLER]);
			logent("generic call to gdial", "FAILED");
			Uerror = SS_CANT_ACCESS_DEVICE;
			goto bad;
		}
		if (w <= 2)	/* do nothing - no chat */
		{
#ifdef 0 /* unixpc */
			if (!strcmp(dev[D_CALLER],"OBM") || 
					!strcmp(dev[D_CALLER], "PC7300"))
				goto okchat;
			else
#endif /* unixpc */
			break;
		}
		/*
		 * Translate the phone number
		 */
		if (dev[D_ARG] == NULL) {
			/* if NULL - assume no translation */
			dev[D_ARG+1] = NULL; /* needed for for loop to mark the end */
			dev[D_ARG] = "\\D";
		}
		
		phonecl = repphone(dev[D_ARG], flds[F_PHONE], args[1]);
		exphone(phonecl, phoneex);
		translate(args[1], phoneex);
		/*
		 * Chat
		 */
okchat:
		if (chat(w-2, &args[2], dcf, phonecl, phoneex) != SUCCESS) {
			Uerror = SS_CHAT_FAILED;
			goto bad;
		}
	}
	/*
	 * Success at last!
	 */
	strcpy(Dc, sdev[D_LINE]);
	return(dcf);
bad:
	(void)close(dcf);
	delock(sdev[D_LINE]);
	return(FAIL);
}

/*
 * translate the pairs of characters present in the first
 * string whenever the first of the pair appears in the second
 * string.
 */
static void
translate(ttab, str)
register char *ttab, *str;
{
	register char *s;

	for(;*ttab && *(ttab+1); ttab += 2)
		for(s=str;*s;s++)
			if(*ttab == *s)
				*s = *(ttab+1);
}

#define MAXLINE	512
/*
 * Get the information about the dialer.
 * gdial(type, arps, narps)
 *	type	-> type of dialer (e.g., penril)
 *	arps	-> array of pointers returned by gdial
 *	narps	-> number of elements in array returned by gdial
 * Return value:
 *	-1	-> Can't open DIALERFILE
 *	0	-> requested type not found
 *	>0	-> success - number of fields filled in
 */
static
gdial(type, arps, narps)
register char *type, *arps[];
register int narps;
{
	static char info[MAXLINE];
	register na;
	extern void dialreset();

	DEBUG(2, "gdial(%s) called\n", type);
	while (getdialline(info, sizeof(info))) {
		if ((info[0] == '#') || (info[0] == ' ') ||
		    (info[0] == '\t') || (info[0] == '\n'))
			continue;
		if ((na = getargs(info, arps, narps)) == 0)
			continue;
		if (EQUALS(arps[0], type)) {
			dialreset();
			bsfix(arps);
			return(na);
		}
	}
	dialreset();
	return(0);
}

/*
 * getMcntl - get the modem control letter from the input string.
 * input:
 *	str - string from Devices file (dev[D_LINE])--the ,
 *		delimits the modem control string
 *		e.g. tty000,M 
 * output:
 *	str - the , (if present) will be replaced with NULLCHAR
 *	global Mcntl will be modified
 * return:  none
 */

void
getMcntl(str)
char *str;
{
	register char *p;

	DEBUG(5, "getMcntl(%s): ", str);
	if ( (p=strchr(str, ',')) != NULL) {
	    *p = NULLCHAR;
	    for (p++; *p; p++) 
		switch (*p) {
		    case 'M':
			_Mcntl = TRUE;
			break;
		    case 'H':
			_Hflow = FALSE;
			break;
		}
	}
	if (DialModem)		/* override switch from cu */
	    _Mcntl = TRUE;
	DEBUG(5, "_Mcntl=%s ", _Mcntl == TRUE ? "TRUE" : "FALSE");
	DEBUG(5, "_Hflow=%s\n", _Hflow == TRUE ? "TRUE" : "FALSE");
}

#ifdef DATAKIT

/***
 *	dkcall(flds, dev)	make a DATAKIT VCS connection
 *				  DATAKIT VCS is a trademark of AT&T
 *
 *	return codes:
 *		>0 - file number - ok
 *		FAIL - failed
 */

#include "dk.h"

dkcall(flds, dev)
char *flds[], *dev[];
{
	register fd;
#ifdef V8
	extern int cdkp_ld;
#endif

	char	dialstring[64];

	strcpy(dialstring, dev[D_ARG]);

#ifndef STANDALONE
	if(*flds[F_CLASS] < '0' || *flds[F_CLASS] > '9')
		sprintf(dialstring, "%s.%s", dev[D_ARG], flds[F_CLASS]);
#endif

	DEBUG(4, "dkcall(%s)\n", dialstring);


#ifdef V8
	if (setjmp(Sjbuf)) {
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}

	(void) signal(SIGALRM, alarmtr);
	(void) alarm(15);
	DEBUG(4, "tdkdial(%s", flds[F_PHONE]);
	DEBUG(4, ", %d)\n", atoi(flds[F_CLASS]));
    	if ((fd = tdkdial(flds[F_PHONE], atoi(flds[F_CLASS]))) >= 0)
	    if (dkproto(fd, cdkp_ld) < 0)
	       {
	    	close(fd);
	    	fd = -1;
	       }
	(void) alarm(0);
#else
	fd = dkdial(dialstring);
#endif

	(void) strcpy(Dc, "DK");
	if (fd < 0) {
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}
	else
		return(fd);
}

#endif /* DATAKIT */

#ifdef TCP

/***
 *	tcpcall(flds, dev)	make ethernet/socket connection
 *
 *	return codes:
 *		>0 - file number - ok
 *		FAIL - failed
 */

#ifndef BSD
/*ARGSUSED*/
tcpcall(flds, dev)
char	*flds[], *dev[];
{
	Uerror = SS_NO_DEVICE;
	return(FAIL);
}
#ifdef mc68k
/*ARGSUSED*/
bsdtcpopn(flds, dev)
char	*flds[], *dev[];
{
	Uerror = SS_NO_DEVICE;
	return(FAIL);
}
#endif /* mc68k */
#else /* BSD */
tcpcall(flds, dev)
char *flds[], *dev[];
{
	int ret;
	short port;
	extern int	errno, sys_nerr;
	extern char *sys_errlist[];
	struct servent *sp;
	struct hostent *hp;
	struct sockaddr_in sin;

	port = atoi(dev[D_ARG]);
	if (port == 0) {
		sp = getservbyname("uucp", "tcp");
		ASSERT(sp != NULL, "No uucp server", 0, 0);
		port = sp->s_port;
	}
	else port = htons(port);
	hp = gethostbyname(flds[F_NAME]);
	if (hp == NULL) {
		logent("tcpopen", "no such host");
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	DEBUG(4, "tcpdial host %s, ", flds[F_NAME]);
	DEBUG(4, "port %d\n", ntohs(port));

	ret = socket(AF_INET, SOCK_STREAM, 0);
	if (ret < 0) {
		if (errno < sys_nerr) {
			DEBUG(5, "no socket: %s\n", sys_errlist[errno]);
			logent("no socket", sys_errlist[errno]);
		}
		else {
			DEBUG(5, "no socket, errno %d\n", errno);
			logent("tcpopen", "NO SOCKET");
		}
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	sin.sin_family = hp->h_addrtype;
	bcopy(hp->h_addr, (caddr_t)&sin.sin_addr, hp->h_length);
	sin.sin_port = port;
	if (setjmp(Sjbuf)) {
		DEBUG(4, "timeout tcpopen\n", 0);
		logent("tcpopen", "TIMEOUT");
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	(void) signal(SIGALRM, alarmtr);
	(void) alarm(30);
	DEBUG(7, "family: %d\n", sin.sin_family);
	DEBUG(7, "port: %d\n", sin.sin_port);
	DEBUG(7, "addr: %08x\n",*((int *) &sin.sin_addr));
	if (connect(ret, (caddr_t)&sin, sizeof (sin)) < 0) {
		(void) alarm(0);
		(void) close(ret);
		if (errno < sys_nerr) {
			DEBUG(5, "connect failed: %s\n", sys_errlist[errno]);
			logent("connect failed", sys_errlist[errno]);
		}
		else {
			DEBUG(5, "connect failed, errno %d\n", errno);
			logent("tcpopen", "CONNECT FAILED");
		}
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	(void) signal(SIGPIPE, SIG_IGN);  /* watch out for broken ipc link...*/
	(void) alarm(0);
	(void) strcpy(Dc, "IPC");
	return(ret);
}

#ifdef mc68k
bsdtcpopn(flds, dev)
char *flds[], *dev[];
{
	int ret;
	short port;
	extern int	errno, sys_nerr;
	extern char *sys_errlist[];
	struct servent *sp;
	struct hostent *hp;
	struct sockaddr_in sin;

	sp = getservbyname(flds[F_CLASS], "tcp");
	if (sp == NULL) {
		port = htons(atoi(flds[F_CLASS]));
		if (port == 0) {
			logent("bsdtcpopn", "UNKNOWN PORT NUMBER");
			Uerror = SS_NO_DEVICE;
			return(FAIL);
		}
	} else
		port = sp->s_port;
	hp = gethostbyname(flds[F_PHONE]);
	if (hp == NULL) {
		logent("bsdtcpopn", "no such host");
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	DEBUG(4, "tcpdial host %s, ", flds[F_PHONE]);
	DEBUG(4, "port %d\n", ntohs(port));

	ret = socket(AF_INET, SOCK_STREAM, 0);
	if (ret < 0) {
		if (errno < sys_nerr) {
			DEBUG(5, "no socket: %s\n", sys_errlist[errno]);
			logent("no socket", sys_errlist[errno]);
		}
		else {
			DEBUG(5, "no socket, errno %d\n", errno);
			logent("bsdtcpopn", "NO SOCKET");
		}
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	sin.sin_family = hp->h_addrtype;
	bcopy(hp->h_addr, (caddr_t)&sin.sin_addr, hp->h_length);
	sin.sin_port = port;
	if (setjmp(Sjbuf)) {
		DEBUG(4, "timeout bsdtcpopn\n", "");
		logent("bsdtcpopn", "TIMEOUT");
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	(void) signal(SIGALRM, alarmtr);
	(void) alarm(30);
	DEBUG(7, "family: %d\n", sin.sin_family);
	DEBUG(7, "port: %d\n", sin.sin_port);
	DEBUG(7, "addr: %08x\n",*((int *) &sin.sin_addr));
	if (connect(ret, (caddr_t)&sin, sizeof (sin)) < 0) {
		(void) alarm(0);
		(void) close(ret);
		if (errno < sys_nerr) {
			DEBUG(5, "connect failed: %s\n", sys_errlist[errno]);
			logent("connect failed", sys_errlist[errno]);
		}
		else {
			DEBUG(5, "connect failed, errno %d\n", errno);
			logent("bsdtcpopn", "CONNECT FAILED");
		}
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}
	(void) signal(SIGPIPE, SIG_IGN);  /* watch out for broken ipc link...*/
	(void) alarm(0);
	(void) strcpy(Dc, "IPC");
	return(ret);
}
#endif /* mc68k */
#endif /* BSD */

/***
 *	unetcall(flds, dev)	make ethernet connection
 *
 *	return codes:
 *		>0 - file number - ok
 *		FAIL - failed
 */

#ifndef UNET
unetcall(flds, dev)
char	*flds[], *dev[];
{
	Uerror = SS_NO_DEVICE;
	return(FAIL);
}
#else /* UNET */
unetcall(flds, dev)
char *flds[], *dev[];
{
	int ret;
	int port;
	extern int	errno;

	port = atoi(dev[D_ARG]);
	DEBUG(4, "unetdial host %s, ", flds[F_NAME]);
	DEBUG(4, "port %d\n", port);
	(void) alarm(30);
	ret = tcpopen(flds[F_NAME], port, 0, TO_ACTIVE, "rw");
	(void) alarm(0);
	endhnent();
	if (ret < 0) {
		DEBUG(5, "tcpopen failed: errno %d\n", errno);
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}
	(void) strcpy(Dc, "UNET");
	return(ret);
}
#endif /* UNET */

#endif /* TCP */

#ifdef SYTEK

/****
 *	sytcall(flds, dev)	make a sytek connection
 *
 *	return codes:
 *		>0 - file number - ok
 *		FAIL - failed
 */

/*ARGSUSED*/
sytcall(flds, dev)
char *flds[], *dev[];
{
	extern int errno;
	int dcr, dcr2, nullfd, ret;
	char dcname[20], command[BUFSIZ];

	(void) sprintf(dcname, "/dev/%s", dev[D_LINE]);
	DEBUG(4, "dc - %s, ", dcname);
	if (mlock(dev[D_LINE]) == FAIL) { /* Lock the line */
		DEBUG(5, "mlock %s failed\n", dev[D_LINE]);
		Uerror = SS_LOCKED_DEVICE;
		return(FAIL);
	}
	dcr = open(dcname, O_WRONLY|O_NDELAY);
	if (dcr < 0) {
		Uerror = SS_DIAL_FAILED;
		DEBUG(4, "OPEN FAILED %s\n", dcname);
		delock(dev[D_LINE]);
		return(FAIL);
	}

	sytfixline(dcr, atoi(fdig(dev[D_CLASS])), D_DIRECT);
	(void) sleep(2);
	DEBUG(4, "Calling Sytek unit %s\n", dev[D_ARG]);
	(void) sprintf(command,"\r\rcall %s\r", dev[D_ARG]);
	ret = (*Write)(dcr, command, strlen(command));
	(void) sleep(1);
	DEBUG(4, "COM1 return = %d\n", ret);
	sytfix2line(dcr);
	(void) close(nullfd = open("/", 0));
	(void) signal(SIGALRM, alarmtr);
	if (setjmp(Sjbuf)) {
		DEBUG(4, "timeout sytek open\n", 0);
		(void) close(nullfd);
		(void) close(dcr2);
		(void) close(dcr);
		Uerror = SS_DIAL_FAILED;
		delock(dev[D_LINE]);
		return(FAIL);
	}
	(void) alarm(10);
	dcr2 = open(dcname,O_RDWR);
	(void) alarm(0);
	(void) close(dcr);
	if (dcr2 < 0) {
		DEBUG(4, "OPEN 2 FAILED %s\n", dcname);
		Uerror = SS_DIAL_FAILED;
		(void) close(nullfd);	/* kernel might think dc2 is open */
		delock(dev[D_LINE]);
		return(FAIL);
	}
	return(dcr2);
}

#endif /* SYTEK */

#ifdef DIAL801

/***
 *	dial801(flds, dev)	dial remote machine on 801/801
 *	char *flds[], *dev[];
 *
 *	return codes:
 *		file descriptor  -  succeeded
 *		FAIL  -  failed
 *
 *	unfortunately, open801() is different for usg and non-usg
 */

/*ARGSUSED*/
dial801(flds, dev)
char *flds[], *dev[];
{
	char dcname[20], dnname[20], phone[MAXPH+2], *fdig();
	int dcf = -1, speed;

	if (mlock(dev[D_LINE]) == FAIL) { /* Lock the line */
		DEBUG(5, "mlock %s failed\n", dev[D_LINE]);
		Uerror = SS_LOCKED_DEVICE;
		return(FAIL);
	}
	(void) sprintf(dnname, "/dev/%s", dev[D_CALLDEV]);
	(void) sprintf(phone, "%s%s", dev[D_ARG]   , ACULAST);
	(void) sprintf(dcname, "/dev/%s", dev[D_LINE]);
	CDEBUG(1, "Use Port %s, ", dcname);
	DEBUG(4, "acu - %s, ", dnname);
	CDEBUG(1, "Phone Number  %s\n", phone);
	VERBOSE("Trying modem - %s, ", dcname);	/* for cu */
	VERBOSE("acu - %s, ", dnname);	/* for cu */
	VERBOSE("calling  %s:  ", phone);	/* for cu */
	speed = atoi(fdig(dev[D_CLASS]));
	dcf = open801(dcname, dnname, phone, speed);
	if (dcf >= 0) {
		fixline(dcf, speed, D_ACU);
		(void) strcpy(Dc, dev[D_LINE]);	/* for later unlock() */
		VERBOSE("SUCCEEDED\n", 0);
	} else {
		delock(dev[D_LINE]);
		VERBOSE("FAILED\n", 0);
	}
	return(dcf);
}


#ifndef ATTSV
/*ARGSUSED*/
open801(dcname, dnname, phone, speed)
char *dcname, *dnname, *phone;
{
	int nw, lt, pid = -1, dcf = -1, nullfd, dnf = -1;
	unsigned timelim;

	if ((dnf = open(dnname, 1)) < 0) {
		DEBUG(5, "can't open %s\n", dnname);
		Uerror = SS_CANT_ACCESS_DEVICE;
		return(FAIL);
	}
	DEBUG(5, "%s is open\n", dnname);

	(void) close(nullfd = open("/dev/null", 0));	/* partial open hack */
	if (setjmp(Sjbuf)) {
		DEBUG(4, "timeout modem open\n", 0);
		logent("801 open", "TIMEOUT");
		(void) close(nullfd);
		(void) close(dcf);
		(void) close(dnf);
		if (pid > 0) {
			kill(pid, 9);
			wait((int *) 0);
		}
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}
	(void) signal(SIGALRM, alarmtr);
	timelim = 5 * strlen(phone);
	(void) alarm(timelim < 30 ? 30 : timelim);
	if ((pid = fork()) == 0) {
		sleep(2);
		nw = (*Write)(dnf, phone, lt = strlen(phone));
		if (nw != lt) {
			DEBUG(4, "ACU write error %d\n", errno);
			logent("ACU write", "FAILED");
			exit(1);
		}
		DEBUG(4, "ACU write ok%s\n", 0);
		exit(0);
	}
	/*  open line - will return on carrier */
	dcf = open(dcname, 2);

	DEBUG(4, "dcf is %d\n", dcf);
	if (dcf < 0) {	/* handle like a timeout */
		(void) alarm(0);
		longjmp(Sjbuf, 1);
	}

	/* modem is open */
	while ((nw = wait(&lt)) != pid && nw != -1)
		;
	(void) alarm(0);

	(void) close(dnf);	/* no reason to keep the 801 open */
	if (lt != 0) {
		DEBUG(4, "Fork Stat %o\n", lt);
		(void) close(dcf);
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}
	return(dcf);
}

#else /* ATTSV */

open801(dcname, dnname, phone, speed)
char *dcname, *dnname, *phone;
{
	int nw, lt, dcf = -1, nullfd, dnf = -1, ret;
	unsigned timelim;

	(void) close(nullfd = open("/", 0));	/* partial open hack */
	if (setjmp(Sjbuf)) {
		DEBUG(4, "DN write %s\n", "timeout");
		(void) close(dnf);
		(void) close(dcf);
		(void) close(nullfd);
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	}
	(void) signal(SIGALRM, alarmtr);
	timelim = 5 * strlen(phone);
	(void) alarm(timelim < 30 ? 30 : timelim);

	if ((dnf = open(dnname, O_WRONLY)) < 0 ) {
		DEBUG(5, "can't open %s\n", dnname);
		Uerror = SS_CANT_ACCESS_DEVICE;
		return(FAIL);
	}
	DEBUG(5, "%s is open\n", dnname);
	if (  (dcf = open(dcname, O_RDWR | O_NDELAY)) < 0 ) {
		DEBUG(5, "can't open %s\n", dcname);
		Uerror = SS_CANT_ACCESS_DEVICE;
		return(FAIL);
	}

	DEBUG(4, "dcf is %d\n", dcf);
	fixline(dcf, speed, D_ACU);
	nw = (*Write)(dnf, phone, lt = strlen(phone));
	if (nw != lt) {
		(void) alarm(0);
		DEBUG(4, "ACU write error %d\n", errno);
		(void) close(dnf);
		(void) close(dcf);
		Uerror = SS_DIAL_FAILED;
		return(FAIL);
	} else 
		DEBUG(4, "ACU write ok%s\n", 0);

	(void) close(dnf);
	(void) close(nullfd = open("/", 0));	/* partial open hack */
	ret = open(dcname, 2);  /* wait for carrier  */
	(void) alarm(0);
	(void) close(ret);	/* close 2nd modem open() */
	if (ret < 0) {		/* open() interrupted by alarm */
		DEBUG(4, "Line open %s\n", "failed");
		Uerror = SS_DIAL_FAILED;
		(void) close(nullfd);		/* close partially opened modem */
		return(FAIL);
	}
	(void) fcntl(dcf,F_SETFL, fcntl(dcf, F_GETFL, 0) & ~O_NDELAY);
	return(dcf);
}
#endif /* ATTSV */

#endif /* DIAL801 */

#ifdef V8
Dialout(flds)
char *flds[];
{
    int fd;
    char phone[MAXPH+2];

    exphone(flds[F_PHONE], phone);

    DEBUG(4, "call dialout(%s", phone);
    DEBUG(4, ", %s)\n", flds[F_CLASS]);
    fd = dialout(phone, flds[F_CLASS]);
    if (fd == -1)
	Uerror = SS_NO_DEVICE;
    if (fd == -3)
	Uerror = SS_DIAL_FAILED;
    if (fd == -9)
	Uerror = SS_DEVICE_FAILED;

    (void) strcpy(Dc, "Dialout");

    return(fd);
}
#endif /* V8 */

#ifdef TLI
/*
 *
 * AT&T Transport Layer Interface
 *
 * expected in Systems:
 *	system time TLI speed number  
 *
 * expected in Devices
 *	TLI line1 - - TLI 
 */

#include <sys/tiuser.h>

/*
 * returns fd to remote uucp daemon
 */
int
tlicall(flds, dev)
char *flds[];
char *dev[];
{
	char		addrbuf[ BUFSIZ ];
	char		devname[MAXNAMESIZE];
	int		fd, service;
	register int	i, j;
	struct t_bind	*bind_req = 0, *bind_ret = 0;
	struct t_info	tinfo;
	struct t_call	*sndcall = 0, *rcvcall = 0;
	extern int	errno, t_errno;
	extern char	*sys_errlist[], *t_errlist[];

	if ( dev[D_LINE][0] != '/' ) {
		/*	dev holds device name relative to /dev	*/
		sprintf(devname, "/dev/%s", dev[D_LINE]);
	} else {
		/*	dev holds full path name of device	*/
		strcpy(devname, dev[D_LINE]);
	}
	/* gimme local transport endpoint */
	errno = t_errno = 0;
	fd = t_open(devname, O_RDWR, &tinfo);
	if (fd < 0) {
		tfaillog(fd, "t_open" );
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}

	/* allocate tli structures	*/
	errno = t_errno = 0;
	if ( (bind_req = (struct t_bind *)t_alloc(fd, T_BIND, T_ALL)) == 
	    (struct t_bind *)NULL
	|| (bind_ret = (struct t_bind *)t_alloc(fd, T_BIND, T_ALL)) == 
	    (struct t_bind *)NULL
	|| (sndcall = (struct t_call *)t_alloc(fd, T_CALL, T_ALL)) == 
	    (struct t_call *)NULL
	|| (rcvcall = (struct t_call *)t_alloc(fd, T_CALL, T_ALL)) ==
	    (struct t_call *)NULL ) {
		tfaillog(fd, "t_alloc" );
		tfreeall( bind_req, bind_ret, sndcall, rcvcall );
		Uerror = SS_NO_DEVICE;
		return(FAIL);
	}

	/* bind */
	errno = t_errno = 0;
	if (t_bind(fd, (struct t_bind *) 0, bind_ret ) < 0) {
		tfaillog(fd, "t_bind" );
		tfreeall( bind_req, bind_ret, sndcall, rcvcall );
		Uerror = SS_NO_DEVICE;
		(void) t_close(fd);
		return(FAIL);
	}
	DEBUG(5, "tlicall: bound to %s\n", bind_ret->addr.buf);

	/*
	 * Prepare to connect.
	 * Walk thru dev[D_ARG], connection address, looking for \N,
	 * change to NULLCHAR.
	 * Note:  If a NULLCHAR must be part of the connection address,
	 * it must be overtly included in the address.  One recommended
	 * way is to do it in the Devices file, thusly:
	 *		Netname /dev/netport - - TLI \D\0
	 * bsfix() turns \0 into \N and then the loop below makes it a real,
	 * included-in-the-length null-byte.
	 */
	DEBUG(5, "t_connect to addr \"%s\"\n",
		strecpy( addrbuf, dev[D_ARG], "\\" ) );
	for( i = j = 0; dev[D_ARG][i] != NULLCHAR; ++i, ++j ) {
		if( dev[D_ARG][i] == '\\'  &&  dev[D_ARG][i+1] == 'N' ) {
			addrbuf[j] = NULLCHAR;
			++i;
		}
		else {
			addrbuf[j] = dev[D_ARG][i];
		}
	}
	sndcall->addr.buf = addrbuf;
	sndcall->addr.maxlen = sndcall->addr.len = j;

	if (setjmp(Sjbuf)) {
		DEBUG(4, "timeout tlicall\n", 0);
		logent("tlicall", "TIMEOUT");
		tfreeall( bind_req, bind_ret, sndcall, rcvcall );
		Uerror = SS_NO_DEVICE;
		(void) t_unbind(fd);
		(void) t_close(fd);
		return(FAIL);
	}
	(void) signal(SIGALRM, alarmtr);
	(void) alarm(30);

	/* connect to the service */
	errno = t_errno = 0;
	if (t_connect(fd, sndcall, rcvcall) < 0) {
		(void) alarm(0);
		tfaillog(fd, "t_connect");
		tfreeall( bind_req, bind_ret, sndcall, rcvcall );
		Uerror = SS_NO_DEVICE;
		(void) t_unbind(fd);
		(void) t_close(fd);
		return(FAIL);
	}
	(void) alarm(0);
	tfreeall( bind_req, bind_ret, sndcall, rcvcall );
	errno = t_errno = 0;
	(void) strcpy(Dc, dev[D_CALLER]);
	return(fd);
}


static
tfreeall( b1, b2, c1, c2 )
struct t_bind	*b1, *b2;
struct t_call	*c1, *c2;
{
	if( b1 )
		t_free( b1 );
	if( b2 )
		t_free( b2 );
	if( c1 )
		t_free( c1 );
	if( c2 )
		t_free( c2 );
}
#endif /* TLI */

#ifdef unixpc
#  ifdef STARLAN

/* these shouldn't be here.  But then again, we probably shouldn't
 * be using cu with the network the way we do.   But... in the mean
 * time, this reduces the number of Systems entries that we need to have.
 */
#define UUCP_SERVICE	"102"
#define	RLOGIN_SERVICE	"1"

/*
 * STARLAN dialer
 *
 * The dialer connects to the address specified in the phone field.
 *
 * returns:
 *	file descriptor	-> succeeded
 *	FAIL		-> connection attempt failed
 *
 * expected in Systems:
 *	system time STARLAN - node  
 *
 * expected in Devices
 *	STARLAN line1 - - STARLAN 
 */

int
slancall(flds, dev)
register char *flds[];
register char *dev[];
{
    register fd;
    register ret;
    char dcname[20], *port;
    int iport;
    extern int t_errno;
    extern char *t_errlist[];

    DEBUG(9, "slancall: entered%s\n", "");
    (void) sprintf(dcname, "/dev/%s", dev[D_LINE]);
    DEBUG(9, "slancall: dev: %s\n", dcname);

    /* futures: a way to change the port. (ie, service) */
    port = atoi (dev[D_CALLDEV]) == 0 ? 
#ifdef STANDALONE
	    RLOGIN_SERVICE
#else
	    UUCP_SERVICE
#endif
	    : dev[D_CALLDEV] ;
    DEBUG(9, "slancall: port: %s\n", port);
    t_errno=0;

    /* return here if timeout */
    /* this isn't needed, since nlsestablish times out on its own. rlf */
    if (setjmp(Sjbuf)) {
	(void)t_close(fd);
	DEBUG(4, "timeout on connect%s\n", "");
	(void)logent("connect", "TIMEOUT");
	return(FAIL);
    }

    (void)signal(SIGALRM, alarmtr);
    (void)alarm(30);

    /* Issue a connection request to the destination machine */
    DEBUG(9, "slancall: connecting to name %s\n", flds[F_PHONE]);
    if ((fd = nlsestablish(flds[F_PHONE], dcname)) < 0) {
	(void)alarm(0);
	(void)t_close(fd);
	DEBUG(6, "slancall: nlsestablish t_err=%s\n", t_errlist[t_errno]);
	Uerror = SS_DIAL_FAILED;
	return(FAIL);
    }
    (void)alarm(0);
    DEBUG(9, "slancall: nlsestablish ret=%d\n", fd);

    if ((ret = nlsrequest(fd, port)) != 0) {
	if (ret < 0) {
	    DEBUG(5,"slancall: nlsrequest t_err=%s\n", t_errlist[t_errno]);
	} else {
	    DEBUG(5,"slancall: nlsrequest listener err=%d\n", ret);
	}
	(void)t_close(fd);
	Uerror = SS_DIAL_FAILED;
	return(FAIL);
    }
    if ((ret = t_getstate(fd)) != T_DATAXFER) {
	DEBUG(5,"slancall: invalid state %d after nlsrequest\n", ret);
	(void)t_close(fd);
	Uerror = SS_DIAL_FAILED;
	return(FAIL);
    }
    VERBOSE("Connected%c\n", '\007');
    return(fd);
}
#  endif /* STARLAN */

#include <sys/phone.h>

s4call(flds,dev)
char *flds[];
char *dev[];
/*
-------------------------------------------------------------------------
|  s4call is used to make calls on the phone device.  It accepts	|
|  standard termio ioctls in addition to new ioctls used for dialling	|
|  and line control.							|
|									|
|  INPUT:	flds[], array of char pointers to destination and 	|
|		line parameters.					|
|  OUTPUT:	returns the file descriptor if connection can be	|
|		established; otherwise returns -1.			|
-------------------------------------------------------------------------
*/
{
    int			fd;		/* file descriptor of ph line	*/
    char		dcname[20];	/* path name of ph device	*/
    char		cb[128+MAXPH];
    long		ts, te;		/* start of call, end of call	*/
    char		phone[MAXPH+1];


    /*
    -------------------------------------------------------------
    |  Expand the phone number if needed and construct the	|
    |  path name for the phone device.  Set the lock file for	|
    |  the line being used.					|
    -------------------------------------------------------------
    */
	if ( dev[D_LINE][0] != '/' ) {
		/*	dev holds device name relative to /dev	*/
		sprintf(dcname, "/dev/%s", dev[D_LINE]);
	} else {
		/*	dev holds full path name of device	*/
		strcpy(dcname, dev[D_LINE]);
	}

	CDEBUG(1, "In s4dial() dcname=%s\n",dcname);
	if (mlock(dev[D_LINE]) == FAIL || 
	   (( fgetty = rmgetty(dcname)) < 0 )) { /* Lock the line */
		DEBUG(5, "mlock %s failed\n", dev[D_LINE]);
		Uerror = SS_LOCKED_DEVICE;
		return(FAIL);
	}
    /*
    -------------------------------------------------------------
    |  Open the phone device for read/write previledge, this	|
    |  will set the line for data mode.  On a successful open	|
    |  go and dial the number.  s4dial will block until a	|
    |  connection has been established or until failure has	|
    |  been determined.						|
    -------------------------------------------------------------
    */
    time(&ts);
CDEBUG(1, "In s4dial() flds=%s\n",flds[F_PHONE]);
    exphone(flds[F_PHONE], phone);   /* A_LO */
    if (( fd = open(dcname, O_RDWR | O_NDELAY)) < 0)
    {
	DEBUG(1, "Line open %s\n", "failed");
	time(&te);
	sprintf(cb, "%s %s P%s %ld", "DIALUP LINE open", dcname, phone, te-ts);
	goto pherr;
    }

    if (s4dial(fd, flds) == FAIL)
    {
	DEBUG(1, "Line dialling %s\n", "failed");
	time(&te);
	sprintf(cb, "%s %s P%s %ld", "DIALUP LINE dialling", dcname, phone, te-ts);
pherr:
	logent(cb, "FAILED");
        delock(dev[D_LINE]);
	return(FAIL);
    }
    /*
    -------------------------------------------------------------
    |  Now change the device to blocking until a character is 	|
    |  received.						|
    -------------------------------------------------------------
    */
    if (fcntl(fd, F_SETFL, O_RDWR) < 0)
    {
	DEBUG(1, "Changing file mode %s\n", "failed");
	time(&te);
	sprintf(cb, "%s %s P%s %ld", " Changing line mode", dcname, phone, te-ts);
	goto pherr;
    }

    time(&te);
    sprintf(cb, "%s %s P%s %ld", "DIAL", dcname, phone, te-ts);
    logent(cb, "OK");
    return(fd);
}



s4dial(fd, flds)
int		fd;
char		*flds[];
/*
-------------------------------------------------------------------------
|  s4dial sets the baudrate and other line parameters.  Then it 	|
|  expands the phone number and make ioctl calls to do the dialling.	|
|									|
|  INPUT:	flds[], array of char pointers to destination and 	|
|		line parameters.					|
|  OUTPUT:	returns the file descriptor if connection can be	|
|		established; otherwise returns -1.			|
-------------------------------------------------------------------------
*/
{
    int			linespeed;
    struct updata	lv;
    struct termio	lvp;
    char		i;
    char		phone[MAXPH+1];

    /*
    -------------------------------------------------------------
    |  Get the line speed, adjust it to one that we support	|
    -------------------------------------------------------------
    */
    linespeed = atoi(fdig(flds[F_CLASS]));

    exphone(flds[F_PHONE], phone);
    DEBUG(1, "call phone number %s\n", phone);

    (void) ioctl(fd, PIOCGETP, &lv);

    lv.c_lineparam |= DATA;	/* set to outgoing */
    lv.c_lineparam &= ~(VOICE|INCMNG);

    if ( ioctl(fd, PIOCSETP, &lv) < 0)
	 DEBUG(4, "ioctl PIOSETP/ s4 dial failed: %d\n", errno);

    (void) ioctl(fd, TCGETA, &lvp);
	lvp.c_iflag = (ushort) 0;
	lvp.c_oflag = (ushort) 0;
	lvp.c_lflag = (ushort) 0;
	lvp.c_cflag = CS8|CREAD|((linespeed >= 1200)?B1200:B300);
	lvp.c_cc[VMIN] = 6;
	lvp.c_cc[VTIME] = 1;
    if (ioctl(fd, TCSETA, &lvp) < 0)
	 DEBUG(4, "ioctl TCSETA/ s4 dial failed: %d\n", errno);

    if (linedisc) (void) ioctl(fd, PIOCDISC, " ");    /* A LO */
    if (ioctl(fd, PIOCOFFHOOK, &lv) < 0)
    {
	DEBUG(4, "ioctl/PIOCOFFHOOK s4 dial failed: %d\n", errno);
	goto hangup;
    }

    /*
    -------------------------------------------------------------
    |  Now dial the number a digit at a time until completed;	|
    |  after dialling, dial a "$" to signal ready for connect.	|
    -------------------------------------------------------------
    */
    i = 0;
    while (phone[i] != NULL)
    {
	if (ioctl(fd, PIOCDIAL, &phone[i]) < 0)
	{
	   DEBUG(4, "ioctl/PIOCDIAL s4 dial failed: %d\n", errno);
	   logent("NO DIALTONE", "CONNECT FAILED: ");
	   goto hangup;
	}
	i++;
    }
    if (ioctl(fd, PIOCDIAL, "$") < 0)
    {
	logent("BUSY or NO ANSWER", "CONNECT FAILED: ");
hangup:
        linedisc = 0;      /* A LO */
	(void) ioctl(fd, PIOCDISC, " ");
	return (FAIL);
    }
    linedisc = 1;       /* A LO */
    return(fd);
}

rmgetty(pdev)
char	*pdev;
{
    char	devname[6];
    char	shcmd[40];

    strcpy ( gettydev , pdev);
    while ( *pdev ) pdev++;
    pdev = pdev - 3;
   
    fgetty = 0;
    sprintf( shcmd, "/usr/bin/getoff.sh %s", pdev);
    CDEBUG(1, "removing getty on port = <%s>\n", pdev);
    return (system(shcmd));
}

putgetty(pdev)
char	*pdev;
{
    char	shcmd[40];
    CDEBUG(1, "In putgetty() fgetty =%x", fgetty);
    if ( fgetty > 0x100 )
    {
	while ( *pdev ) pdev++;
	pdev = pdev - 3;
    
	sprintf( shcmd, "/usr/bin/geton.sh %s\n", pdev);
	return ( system(shcmd) );
    }
}

#endif /* unixpc */
