.ds YP \s-2NIS\s0
.if \n(1T .bp
.NH 1
\&The Sun Network File System Service
..IX NFS "administering" "" "" PAGE START
.LP
This chapter explains how to administer
the Sun Network File System (\s-2NFS\s0\u\(tm\d) service.  
It also tells you how to diagnose and fix
\s-2NFS\s0-related problems.
The text explains:
.IP \(bu
How \s-2NFS\s0 works, as an overview
.IP \(bu
How to administer an \s-2NFS\s0 file server
.IP \(bu
How to administer an \s-2NFS\s0 client
.IP \(bu
How to set up network security
.IP \(bu
How to troubleshoot \s-2NFS\s0-related problems
.LP
.NH 3
\&What is \s-2NFS\s0
.LP
..IX RPC "" "" "" PAGE MAJOR
\s-2RPC\s0 (Remote Procedure Call)
procedures provide the means by which one process
(termed the \fIcaller process\fR\|) can have some other process
(the \fIserver process\fR\|) execute a procedure call
as if the caller process itself had executed the
procedure.
.LP
\s-2NFS\s0 is an \s-2RPC\s0 service that
..IX NFS "" "" "" PAGE MAJOR
enables machines to share files
across
a network.
In conjunction with other \s-2RPC\s0 services such as
.I mount (3R),
it permits the user to access remote files and 
hierarchies transparently, as if they were local
to the user's machine.
To the user, all files accessed through \s-2NFS\s0
look just like local files.
There is no apparent difference between reading
and writing a file on a local disk and a file
located on the disk of a machine in a different
location.
.LP
The advantages to using \s-2NFS\s0 are many.  \s-2NFS\s0 allows multiple machines
to use the same files, so data can be made accessible to any
machine on a network.  Furthermore, storage costs may be kept down by
having machines share large programs with each other.  You can also achieve 
consistency in the use of
databases, as well as reliability, by having all users
read the same set of files.  
.LP
You need to read at least part of this chapter,
unless you administer a non-networked, timesharing
or stand\(hyalone machine.
If you administer an \s-2NFS\s0 client,
you should read the \s-2NFS\s0 overview
and sections that explain how to mount hierarchies,
set up network security,
and diagnose problems on an \s-2NFS\s0 client.
If you administer an \s-2NFS\s0 server,
read the entire chapter.
You may have to fix problems on
clients as well as on servers.
.LP
.NH 2
\&How \s-2NFS\s0 Works-an Overview
.LP
This overview explains
how \s-2NFS\s0 works, including the procedures to share file hierarchies,
and how to access those hierarchies on remote machines.
It also explains how various daemons (the
server processes) interact to
enable sharing and mounting.
These daemons communicate with the kernel and 
daemons on other machines to get the
job done; they are all based on \s-2RPC\s0 procedures.
..IX "filesystem" "how to create hierarchies with NFS"
.NH 3
\&File Hierarchies
.LP
When you mount a file system from a local disk onto
a mount point, you mount the entire file system, starting
at its root. 
You start, for instance, with two file systems, 
.I root 
and 
.I usr ,
in different partitions of the disk,
as illustrated by the following figure:
.LP
.KS
.LP
.ce
Figure: File Systems on a Disk
.\" .\s-2PS\s0 < mnt.local.start.pic
.PS
ellipse at 3.650,8.725 wid 0.450 ht 0.450
ellipse at 4.487,8.713 wid 0.450 ht 0.450
ellipse at 5.350,8.700 wid 0.450 ht 0.450
ellipse at 4.487,9.800 wid 0.450 ht 0.450
ellipse at 1.488,9.800 wid 0.450 ht 0.450
ellipse at 2.350,8.700 wid 0.450 ht 0.450
ellipse at 1.488,8.713 wid 0.450 ht 0.450
ellipse at 0.650,8.725 wid 0.450 ht 0.450
line from 5.362,8.475 to 5.675,7.862
line from 5.138,8.125 to 5.325,7.862
line from 5.362,8.475 to 4.912,7.838
line from 3.675,8.500 to 3.225,7.862
line from 3.438,8.150 to 3.625,7.888
line from 3.675,8.500 to 3.975,7.888
line from 4.513,8.512 to 4.825,7.888
line from 4.275,8.162 to 4.475,7.888
line from 4.513,8.512 to 4.075,7.875
line from 1.525,8.500 to 1.087,7.862
line from 1.288,8.150 to 1.488,7.888
line from 1.525,8.500 to 1.837,7.888
line from 0.662,8.512 to 0.212,7.875
line from 0.425,8.162 to 0.613,7.888
line from 0.662,8.512 to 0.963,7.888
line from 4.475,9.575 to 3.800,8.912
line from 4.487,9.575 to 4.487,8.963
line from 4.500,9.550 to 5.250,8.900
line from 1.500,9.550 to 2.237,8.900
line from 1.488,9.575 to 1.488,8.963
line from 1.475,9.575 to 0.800,8.912
.ps 10
"\&\fI/\fR" at 4.475,9.781 ljust
"\&\fIbin\fR" at 3.5,8.731 ljust
"\&\fIetc\fR" at 4.35,8.731 ljust
"\&\fIetc\fR" at 1.35,8.731 ljust
"\&\fIusr\fR" at 2.225,8.731 ljust
"\&\fIbin\fR" at 0.5,8.731 ljust
"\&\fI/\fR" at 1.475,9.781 ljust
"\&\fIroot\fP File System on Partition a" at 0.188,10.243 ljust
"\&\fIusr\fP File System on Partition g" at 3.263,10.256 ljust
"\&\fIman\fR" at 5.210,8.706 ljust
.PE
.KE
.LP
When you mount the 
.I usr 
file system on the 
.I /usr 
directory of the 
.I root 
file system, 
you access the 
root of the 
.I usr 
partition through
the 
.I /usr 
directory, as illustrated in the following figure:
.KS
.LP
.ce
Figure: File Systems after mounting
.\" .\s-2PS\s0 < mnt.local.end.pic
.PS
ellipse at 3.500,8.825 wid 0.425 ht 0.425
ellipse at 4.338,8.800 wid 0.425 ht 0.425
ellipse at 5.162,8.800 wid 0.425 ht 0.425
ellipse at 4.338,9.863 wid 0.425 ht 0.425
ellipse at 1.413,9.863 wid 0.425 ht 0.425
ellipse at 2.263,8.800 wid 0.425 ht 0.425
ellipse at 1.413,8.800 wid 0.425 ht 0.425
ellipse at 0.600,8.825 wid 0.425 ht 0.425
line from 5.175,8.588 to 5.487,7.987
line from 4.950,8.238 to 5.138,7.987
line from 5.175,8.588 to 4.750,7.963
line from 3.525,8.613 to 3.087,7.987
line from 3.313,8.275 to 3.462,8.000
line from 3.525,8.613 to 3.825,8.000
line from 4.350,8.613 to 4.650,8.012
line from 4.125,8.287 to 4.325,8.012
line from 4.350,8.613 to 3.925,8.000
line from 1.438,8.613 to 1.000,7.987
line from 1.212,8.275 to 1.387,8.000
line from 1.438,8.613 to 1.738,8.000
line from 0.600,8.613 to 0.150,8.000
line from 0.375,8.287 to 0.550,8.012
line from 0.600,8.613 to 0.887,8.012
line from 4.325,9.650 to 3.638,8.988
line from 4.325,9.650 to 4.325,9.050
line from 4.338,9.625 to 5.050,8.988
line from 1.425,9.625 to 2.138,8.988
line from 1.387,9.650 to 1.387,9.050
line from 1.375,9.650 to 0.725,8.988
dashwid = 0.050i
line dashed from 2.425,8.925 to 4.112,9.787
line from 4.035,9.720 to 4.112,9.787 to 4.012,9.764
.ps 10
"\&\fI/\fR" at 4.325,9.843 ljust
"\&\fIbin\fR" at 3.40,8.831 ljust
"\&\fIetc\fR" at 4.2,8.831 ljust
"\&\fIetc\fR" at 1.3,8.831 ljust
"\&\fIusr\fR" at 2.15,8.831 ljust
"\&\fIbin\fR" at 0.5,8.831 ljust
"\&\fI/\fR" at 1.375,9.843 ljust
"\&\fIroot\fP File System on Partition a" at 0.138,10.306 ljust
"\&\fIusr\fP File System on Partition g" at 3.125,10.331 ljust
"\&\fIman\fR" at 5.05,8.831 ljust
.PE
.KE
.LP
The situation is different in SunOS 4.x when you mount through \s-2NFS\s0: you
are not constrained to do the mounting starting at the
root of the file system.
For instance, consider the following two machines,
with the following file systems in their disks:
.LP
.KS
.LP
.ce
Figure: File Systems on Separate Machines
.\" .\s-2PS\s0 < mnt.nfs.start.pic
.PS
ellipse at 2.362,7.550 wid 0.450 ht 0.450
ellipse at 5.987,7.112 wid 0.450 ht 0.450
ellipse at 5.438,7.100 wid 0.450 ht 0.450
ellipse at 4.850,7.112 wid 0.450 ht 0.450
ellipse at 3.663,8.650 wid 0.450 ht 0.450
ellipse at 4.513,8.637 wid 0.450 ht 0.450
ellipse at 5.400,8.625 wid 0.450 ht 0.450
ellipse at 1.488,9.738 wid 0.450 ht 0.450
ellipse at 2.350,8.625 wid 0.450 ht 0.450
ellipse at 1.488,8.637 wid 0.450 ht 0.450
ellipse at 0.625,8.650 wid 0.450 ht 0.450
ellipse at 4.513,9.738 wid 0.450 ht 0.450
line from 2.350,8.387 to 2.350,7.800
line from 5.975,6.875 to 5.675,6.450
line from 5.813,6.638 to 5.938,6.463
line from 5.975,6.875 to 6.162,6.463
line from 5.425,6.838 to 5.625,6.438
line from 5.263,6.600 to 5.400,6.438
line from 5.425,6.838 to 5.112,6.425
line from 4.838,6.850 to 4.537,6.438
line from 4.675,6.612 to 4.813,6.450
line from 4.838,6.850 to 5.025,6.450
line from 4.513,8.387 to 4.825,7.775
line from 4.287,8.037 to 4.475,7.775
line from 4.513,8.387 to 4.075,7.750
line from 3.663,8.387 to 3.212,7.750
line from 3.425,8.037 to 3.625,7.775
line from 3.663,8.387 to 3.975,7.775
line from 1.488,8.387 to 1.800,7.775
line from 1.250,8.037 to 1.450,7.775
line from 1.488,8.387 to 1.025,7.750
line from 0.588,8.387 to 0.138,7.750
line from 0.350,8.037 to 0.550,7.775
line from 0.588,8.387 to 0.900,7.775
line from 4.500,9.512 to 3.813,8.838
line from 4.513,9.512 to 4.513,8.887
line from 4.525,9.488 to 5.275,8.825
line from 1.500,9.488 to 2.237,8.825
line from 1.475,9.512 to 1.475,8.887
line from 1.462,9.512 to 0.775,8.838
line from 5.425,8.387 to 4.950,7.325
line from 5.425,8.387 to 5.425,7.325
line from 5.438,8.375 to 5.987,7.325
.ps 10
"\&\fIman\fR" at 2.237,7.543 ljust
"\&\fI/\fR" at 4.500,9.731 ljust
"\&\fIbin\fR" at 3.550,8.656 ljust
"\&\fIusr\fR" at 5.27,8.656 ljust
"\&\fIetc\fR" at 4.400,8.656 ljust
"\&\fIetc\fR" at 1.41,8.656 ljust
"\&\fIusr\fR" at 2.237,8.656 ljust
"\&\fIbin\fR" at 0.5,8.656 ljust
"\&\fI/\fR" at 1.462,9.731 ljust
"Machine A" at 1.000,10.206 ljust
"Machine B" at 4.075,10.206 ljust
"\&\fIlocal\fR" at 5.763,7.093 ljust
"\&\fIshare\fR" at 5.225,7.093 ljust
"\&\fIman\fR" at 4.713,7.093 ljust
.PE
.KE
You do not have to mount the whole
.I /usr 
file system from machine B in order to reach its
.I /usr/man 
directory (including its files and subdirectories).
You can simply mount machine B's
.I /usr/man 
as follows:
.KS
.LP
.ce
Figure: File Hierarchies on Separate Machines after an NFS Mount
.\" .\s-2PS\s0 < mnt.nfs.end.pic
.PS
ellipse at 2.362,7.550 wid 0.450 ht 0.450
ellipse at 5.987,7.112 wid 0.450 ht 0.450
ellipse at 5.438,7.100 wid 0.450 ht 0.450
ellipse at 4.850,7.112 wid 0.450 ht 0.450
ellipse at 3.663,8.650 wid 0.450 ht 0.450
ellipse at 4.513,8.637 wid 0.450 ht 0.450
ellipse at 5.400,8.625 wid 0.450 ht 0.450
ellipse at 1.488,9.738 wid 0.450 ht 0.450
ellipse at 2.350,8.625 wid 0.450 ht 0.450
ellipse at 1.488,8.637 wid 0.450 ht 0.450
ellipse at 0.625,8.650 wid 0.450 ht 0.450
ellipse at 4.513,9.738 wid 0.450 ht 0.450
dashwid = 0.050i
line dashed from 2.600,7.500 to 4.600,7.138
line from 4.497,7.131 to 4.600,7.138 to 4.506,7.180
line from 2.350,8.387 to 2.350,7.800
line from 5.975,6.875 to 5.675,6.450
line from 5.813,6.638 to 5.938,6.463
line from 5.975,6.875 to 6.162,6.463
line from 5.425,6.838 to 5.625,6.438
line from 5.263,6.600 to 5.400,6.438
line from 5.425,6.838 to 5.112,6.425
line from 4.838,6.850 to 4.537,6.438
line from 4.675,6.612 to 4.813,6.450
line from 4.838,6.850 to 5.025,6.450
line from 4.513,8.387 to 4.825,7.775
line from 4.287,8.037 to 4.475,7.775
line from 4.513,8.387 to 4.075,7.750
line from 3.663,8.387 to 3.212,7.750
line from 3.425,8.037 to 3.625,7.775
line from 3.663,8.387 to 3.975,7.775
line from 1.488,8.387 to 1.800,7.775
line from 1.250,8.037 to 1.450,7.775
line from 1.488,8.387 to 1.025,7.750
line from 0.588,8.387 to 0.138,7.750
line from 0.350,8.037 to 0.550,7.775
line from 0.588,8.387 to 0.900,7.775
line from 4.500,9.512 to 3.813,8.838
line from 4.513,9.512 to 4.513,8.887
line from 4.525,9.488 to 5.275,8.825
line from 1.500,9.488 to 2.237,8.825
line from 1.475,9.512 to 1.475,8.887
line from 1.462,9.512 to 0.775,8.838
line from 5.425,8.387 to 4.950,7.325
line from 5.425,8.387 to 5.425,7.325
line from 5.438,8.375 to 5.987,7.325
.ps 10
"\&\fIman\fR" at 2.237,7.543 ljust
"\&\fI/\fR" at 4.500,9.731 ljust
"\&\fIbin\fR" at 3.550,8.656 ljust
"\&\fIusr\fR" at 5.27,8.656 ljust
"\&\fIetc\fR" at 4.41,8.656 ljust
"\&\fIetc\fR" at 1.398,8.656 ljust
"\&\fIusr\fR" at 2.237,8.656 ljust
"\&\fIbin\fR" at 0.50,8.656 ljust
"\&\fI/\fR" at 1.462,9.731 ljust
"Machine A" at 1.000,10.206 ljust
"Machine B" at 4.075,10.206 ljust
"\&\fIlocal\fR" at 5.763,7.093 ljust
"\&\fIshare\fR" at 5.225,7.093 ljust
"\&\fIman\fR" at 4.713,7.093 ljust
.PE
.KE
.LP
On \s-2UNIX\s0 machines this situation coincides with
the concept of file systems and portions of file systems;
\s-2NFS\s0, however, works across operating systems, and the
concept of file systems may be meaningless in other,
non-\s-2UNIX\s0 operating systems. The concept of file hierarchies,
however, is operating system independent.
.NH 3
\&Servers and Clients
.LP
A 
..IX server "" "" "" PAGE MAJOR 
.I "file server"
is a machine that shares \(em that is, lets other machines 
mount \(em at least one of its file hierarchies.
A
..IX client "NFS" "" "" PAGE MAJOR 
..IX "NFS client" "" "" "" PAGE MAJOR
.I client
is a machine that mounts at least one file
hierarchy from a file server.
Any machine 
(except diskless machines, which cannot
be servers)
can be an \s-2NFS\s0 server or an
\s-2NFS\s0 client or both at the same time.
.NH 3
\&Servers and Exporting
.LP
..IX server "and exporting file systems"
..IX "filesystem" "exporting via NFS"
On a server, the
.I exportfs 
system program and the
.I "rpc.mountd" 
..IX rpc.mountd "" "\&\fIrpc.mountd\fP daemon"
..IX daemons "rcp.mountd" "" "\&\fIrpc.mountd\fP"
and
.I nfsd 
..IX daemons nfsd "" "\&\fInfsd\fP"
..IX nfsd "" "\&\fInfsd\fP daemon"
daemons control \s-2NFS\s0.
When an \s-2NFS\s0 file server
.I exports
file hierarchies,
it essentially advertises the directories
on its disk(s) that it 
will permit other computers to access.
The file server's
.I /etc/exports 
file lists these available directories,
which clients are allowed to access them,
and any access restrictions that must be
applied.
When you boot an \s-2NFS\s0 file server, 
the
.I /etc/rc.local 
..IX rc.local "" "\&\fIrc.local\fP script"
script automatically starts up the 
.I exportfs 
program.
This program then looks at the
.I /etc/exports 
file and informs the server's kernel about the
permissions applicable to each exported file hierarchy.
.LP
You can also explicitly export and unexport
a file hierarchy after the
server is up, or change the export permissions
of an exported file hierarchy, by using the
.I exportfs 
command. 
..IX exportfs "" "\&\fIexportfs\fP \(em export directories to NFS"
Explicit exporting is explained in the section
\fISetting Up and Maintaining an NFS Server\fP.
.NH 3
\&Clients and Mounting
.LP
Clients access files on the server by
.I mounting
..IX mounting "" "" "" PAGE MAJOR
..IX network "mounting" "" "and mounting"
..IX NFS mounting
..IX client mounting "" "and mounting"
..IX "NFS client" mounting "" "and mounting"
the server's exported directories.
When a client mounts a directory, it does
not make a copy of that directory.
Rather, the mounting process uses a 
series of
remote procedure calls
to enable a
client to transparently access the directories
on the server's disk. 
.LP
\s-2RPC\s0s running on the file server receive the information
in a special format, called \s-2XDR\s0 format.
The information is processed by the
.I rpc.mountd 
daemon, and the client is permitted (or not)
to mount the file hierarchy.
.LP
Once a client mounts a remote directory,
it appears to the users that all they have
to do to go to a mounted directory is
to type
.I cd 
and the directory's pathname,
just as they would for a local directory. 
.LP
..IX binding "" "" "" PAGE MAJOR 
..IX server binding "" "and binding"
..IX NFS binding "" "and binding"
The process by which a client locates
a file server that exports the information
it wants, then sets up communication
between itself and that server,
is called
.I binding .
\s-2NFS\s0 binding occurs during an \s-2NFS\s0 mount.
.LP
\s+2\fBNote\fP\s0: This chapter refers to mounting
directories or file hierarchies, but you can also mount
single files and access them as any other file, except
that you cannot move or remove them.
.LP
.LP
A client can mount a directory when it boots,
explicitly mount a directory when a
user issues a 
.I mount 
command, or mount a directory through the automounter.
The
.I /etc/fstab 
file, first described in the chapter
\fIIntroducing the SunOS Operating System\fP,
lists all file hierarchies that the client
mounts at boot time.
You can also explicitly mount a file hierarchy during a
work session by using the 
..IX mount "" "\&\fImount\fP \(em mount file hierarchies"
.I mount 
and
.I umount 
..IX umount "" "\&\fIumount\fP \(em unmount file hierarchies"
commands.  
Finally, you can enable the automounter so that clients
can automatically mount a file hierarchy
without having to issue the
.I mount 
command.
For further information on the automounter, see the chapter
\fIUsing the NFS Automounter\fP.
.LP
.NH 2
\&Setting Up and Maintaining an \s-2NFS\s0 Server
.LP
..IX server NFS "" "" PAGE START
..IX "NFS server" "creating and maintaining" "" "" PAGE START
This section explains the files you need to edit 
or create to set up and successfully maintain an \s-2NFS\s0 file server.
It also describes other actions to take after the server's 
initial installation.
.NH 3
\&Setting Up a Server
.LP
Recall that when you set up the server during
SunInstall ,
you did the following:
.IP \(bu
Identified the machine as an \s-2NFS\s0 file server.
.IP \(bu
Defined the server's 
disk or disks, indicating which partitions would hold
the file systems to be shared among the clients.
.IP \(bu
Defined parameters for each of the server's clients
on the Client Form.
.LP
After you reconfigure the kernel and boot up your
\s-2NFS\s0 server, it has dedicated root directories,
home directories, and swap space for each client on
its disk, as defined through
SunInstall .
Furthermore, it has a default
.I "/etc/exports" 
file that automatically
exports these directories, which clients need as soon as
they boot up.
.LP
The above establishes the machine as an \s-2NFS\s0 file server for
diskless or standalone machines.
If you want the machine to export only selected file
hierarchies, without exporting the above mentioned dedicated
directories,
you don't have to set it as a server through SunInstall.
All you have to do is to create an appropriate
.I /etc/exports 
file, as explained below, and reboot the machine.
If rebooting the machine is not convenient, you can
enter the following commands:
..IX exportfs "" "\&\fIexportfs\fP \(em export directories to NFS"

.DS
.ft CW
# exportfs -a
# nfsd 8 &
.DE

..IX daemons nfsd "" "\&\fInfsd\fP"
..IX nfsd "" "\&\fInfsd\fP daemon"
These commands advertise all of the file hierarchies listed in
.I /etc/exports 
and then status up eight 
.I nfsd 
server daemons.
.LP
..IX security "port checking"
If you are running C2 security, you should make sure that port checking
is enabled, as explained later in this chapter (or consult your 
.I /etc/rc.local 
to see how it's done).
For a full discussion on the subject of C2 security, please refer to
the chapter on \fIAdministering C2 Security\fP.  
.NH 3
\&Maintaining a Server
.LP
At this point you have only established
basic \s-2NFS\s0 file service.
You still need to perform many other 
\s-2NFS\s0-related activities, mostly in the area
of file creation and modification.
This is particularly important if you do not plan to
provide \*(YP service for your network domain.
.LP
Other activities you may need to perform include:
.IP \(bu
Adding additional entries to the default
.I /etc/exports 
file, if needed.
.IP \(bu
Changing access permissions to
.I /etc/exports ,
as needed, ensuring that all users can read it but only
root can write it.
.IP \(bu
Directly exporting and unexporting directories during
a server's work session.
.IP \(bu
If you have more than one \s-2NFS\s0 server in your network,
you may decide that one or more of them will also
be clients of the other servers.
This is not a recommended strategy; servers should not 
mount hierarchies from other servers.
However, if you must set up a server also as a client,
follow the procedures specified below for
setting up and maintaining a client.
.IP \(bu
Creating mount points in the server's file hierarchies
for directories that it will mount from other
servers, \s-2OR\s0 create automount maps, as described
in \fIUsing the NFS Automounter\fP.  
.IP \(bu
Upgrading a homogeneous server to heterogeneous, as
required by your site.
.IP \(bu
Upgrading a standalone or time-sharing
machine to \s-2NFS\s0 server, if required.
.IP \(bu
Editing the following network databases 
if you are not going to use 
\*(YP:
.DS
.ft CW
/etc/passwd
/etc/group
/etc/hosts
/etc/ethers
.DE
.IP \(bu
Checking network status on a regular basis, and update
related files, as necessary.
.IP \(bu
Setting up security for your network, as determined
by your site's requirements.
.IP \(bu
Diagnosing and fixing \s-2NFS\s0 related problems as they arise.
.LP
.NH 3
\&Exporting Directories
.LP
..IX server directories "" "and exporting directories"
..IX "NFS server" directories "" "and exporting directories"
You can control how a server exports directories
in two ways:
.IP \(bu
At boot time,
through the
.I /etc/exports 
file.
.IP \(bu
As needed, by using the
.I exportfs 
command.
.NH 4
\&The \&\fI/etc/exports\fP File
..IX exports "" "\&\fI/etc/exports\fP file" "" PAGE MAJOR
.LP
The
.I /etc/exports 
file lists all file hierarchies that an \s-2NFS\s0 file
server exports to its clients.
Mounting itself is initiated by the client.
Through
.I /etc/exports ,
servers can control which client(s) may mount a hierarchy by limiting
access to it to a desired client or netgroup.
.LP
A typical
.I /etc/exports 
on a server for diskless clients, set up through
SunInstall, resembles the following:
.LP

.DS
.ft CW
/usr                    -access=engineering:accounting
/home                   -access=engineering:accounting
/var/spool/mail         -access=engineering:accounting
/export/exec/sun3       -access=engineering
/export/exec/sun3.sunos.4.1       -access=engineering:accounting
/export/exec/kvm/sun3.sunos.4.1   -access=engineering:accounting
/export/root/birch      -access=birch,root=birch
/export/swap/birch      -access=birch,root=birch
/export/root/oak        -access=oak,root=oak
/export/swap/oak        -access=oak,root=oak
/export/root/willow     -access=willow,root=willow
/export/swap/willow     -access=willow,root=willow
/export/root/pine       -access=pine,root=pine
/export/swap/pine       -access=pine,root=pine
.DE

Each line in the file has the syntax:

.DS
.ft CW
\fIdirectory	-option[,option]\fP
.DE

where
.I directory
is the pathname of a directory, a file,
or an entire file system or file hierarchy.
.I option
represents a list of options that indicates
which clients are allowed to access the directory,
and with what restrictions, if any.
.LP
The
\fISunOS Reference Manual\fP
fully describes all options in the man page for
.I exports (5).
The most frequently used options are defined below.
.IP "\&\fIro\fP" 1.5i
This option specifies that clients are limited
to read-only access to the specified directory.
Therefore, they can read the directory's files
but cannot change them.  If
.I ro 
is not specified for a directory, clients are given
read-write (\&\fIrw\fP) access by default.
.IP "\&\fIroot=\fIhostnames\fR" 1.5i
This option indicates that root access to the
directory is given
only to superusers from a specified
.I hostname .
In the previous example, the line 
.DS
.ft CW
/export/root/birch -root=birch 
.DE
indicates that root access to 
.I "/export/root/birch" 
is given only to those who can run superuser on
client birch.
Note above that root access to the other 
default client directory,
.I "/export/swap/birch" ,
is also given to superusers on
client birch.  A superuser on client oak,
for example, 
instead of accessing files on 
.I /export/root/birch 
as user root would access them as user nobody
(see below, \fIMaking the Network More Secure\fP).  
.IP "\&\fIaccess=\fIclient\fR" 1.5i
This option indicates that access to the particular
directory should be given to the named client, clients,
or netgroup.
To limit access to a directory to a single client,
use the parameter
.I "-access=\fIclient_name\fP" .
The parameter
.DS
.ft CW
-access=birch
.DE
grants mount access to
.I "/export/root/birch" 
and
.I "/export/swap/birch" 
to all users on client birch.
.IP 
You can grant access to more than one client,
using a colon\(hyseparated list, as follows:
.DS
.ft CW
/     -access=client1:client2:client3
.DE
Finally, you can limit mount access to a
directory to a designated netgroup if you are running \*(YP.
A netgroup
is a network-wide group allowed access
to certain network resources for security and organizational
reasons.
You set up netgroups by modifying the
.I netgroup 
\*(YP database
as described
in \fIThe Network Information Service\fP.  
See 
.I netgroup (5)
in the
\fISunOS Reference Manual\fP.  
.IP "\&\fIsecure\fR" 1.5i
This option indicates that a more secure protocol is
used for \s-2NFS\s0 transactions. 
See the section \fISecure NFS\fP
later in this chapter.
.NH 4
\&Editing \&\fI/etc/exports\fP
..IX exports "modifying" "\&\fI/etc/exports\fP file"
.LP
When you bring up your \s-2NFS\s0 file server after installing Release 4.1,
you may want to modify the existing contents of
.I "/etc/exports" .
For example, you might want to designate 
.I /usr 
as read-write, permit access of a directory
to a netgroup, or add more directories for exporting.
Once you have modified
.I /etc/exports ,
the \s-2NFS\s0 file server will automatically export these files
every time you boot it up.
Therefore, you should modify 
.I /etc/exports 
so that it contains directories that you
want the server to export at all times.
.LP
The following instructions
explain how to edit
.I "/etc/exports" :
.IP 1.
Become superuser and 
edit the
.I "/etc/exports" 
file, using your preferred text editor.
.IP 2.
Enter the full pathname of the file hierarchy you want to
export.
For example,
suppose you want all members of the accounting netgroup to mount a new
billing program that you have installed in its own file hierarchy,
.I "/billing" .
Because this information is confidential,
you do not want network users who aren't in the accounting netgroup
to mount this directory.
The entry in
.I "/etc/exports" 
should look like the following:

.DS
.ft CW
/billing       -access=accounting
.DE

(This example assumes that there is a netgroup called \(lqaccounting\(rq.)
.IP 3.
Save the modified file.
.IP 4.
Run
.I exportfs 
as follows,
to update the exports information in the server's kernel. 

.DS
.ft CW
# \&\fB/usr/etc/exportfs -a\fP
.DE

The
.I -a 
option tells
.I exportfs 
to send all information in
.I "/etc/exports" 
to the kernel.
.LP
You cannot export a directory that is either a parent or
subdirectory of a directory \fIwithin the same file system\fP that is
already exported.
It is illegal, for example, to export both
.I /usr 
and 
.I /usr/local 
if both directories reside on the
same disk partition.
.NH 3
\&Explicitly Exporting Directories with \&\fIexportfs\fP
..IX exportfs "" "\&\fIexportfs\fP \(em export directories to NFS"
.LP
As mentioned above, you can use the
.I exportfs 
command to explicitly export hierarchies that have
not been exported at boot time.
You probably will want to use
.I exportfs 
in this fashion for hierarchies that you only want
to export for a finite amount of time, then unexport.
.LP
.LP
\s+2\fBNote: \s0\fPYou must become superuser
to use \&\fIexportfs\fP with arguments.
.LP
.I exportfs 
has the following syntax:

.DS
.ft CW
/usr/etc/exportfs [ -avu ] [ -o \fIoptions\fP ] [ \fIdirectory\fP ]
.DE

The
.I exportfs (8)
entry
in the 
\fISunOS Reference Manual\fP
completely describes this command's arguments.
The more commonly used arguments are defined below:
.IP "\&\fI-a\fP" 1i
Export all the directories in
.I /etc/exports ,
as illustrated in the previous subsection.
.IP "\&\fI-u\fP" 1i
Unexport the indicated directories.
.IP "\&\fI-o \fIoptions\fR" 1i
Execute the list of options following
.I -o .
The arguments to 
.I options
are the same as the options for
.I "/etc/exports" .
For example, you can specify 
.DS
.ft CW
/usr/etc/exportfs -o ro \fIdirectory\fP
.DE
to export a directory with read-only access to everybody.
You can also use the
.DS
.ft CW
\&\fIr\^o\^o\^t\^=\^\fP\&\fIhostname\fP
.DE
and
.DS
.ft CW
access=\&\fIclient\fP
.DE
or
.DS
.ft CW
access=\&\fInetgroup\fP
.DE
parameters in the same fashion as in 
.I /etc/exports .
.IP "\fIdirectory\fP" 1i
This is the full pathname of the directory that
you want to export or unexport.
.LP
To export the 
.I /usr 
hierarchy
read/write to the netgroup \(lqengineering,\(rq you 
simply enter the command:

.DS
.ft CW
# \&\fBexportfs -o access=\fP\&\fIengineering\fP /usr
.DE

.LP
If you want to make sure that client \(lqdancer\(rq
can access
.I /usr 
read\(hyonly, you enter:

.DS
.ft CW
# \&\fBexportfs -o access=\fP\&\fIengineering\fP,ro=\&\fIdancer\fP /usr
.DE

.LP
You can also use
.I exportfs 
to modify the current list of characteristics of an already
exported file hierarchy. 
For instance, if 
.I /etc/exports 
lists
.I /usr 
as exported to the group \(lqengineering,\(rq
and there is one or more machines that do not belong to
that group but should be able to mount that directory
at a particular time, you can use
.I exportfs 
from the command line to accomplish this:

.DS
.ft CW
# \&\fBexportfs -o access=\fP\&\fIengineering\fP:\&\fIothers\fP  /usr
.DE

.LP
If you type
.I /usr/etc/exportfs 
without an argument, you receive a display of currently
exported directories.
You do not have to be superuser in this case.
.NH 3
\&Unexporting Hierarchies
.LP
Unexporting a file hierarchy means making that file hierarchy
unavailable to other machines for mounting.
.NH 4
\&Explicitly Unexporting Hierarchies with \&\fIexportfs\fP
..IX exportfs u "\&\fIexportfs\fP \(em export directories to NFS" "and \&\fI-u\fP option" PAGE MAJOR
.LP
File hierarchies that you export either
through the
.I /etc/exports 
file or through an explicit call to
.I exportfs 
can be unexported at any time by using the command
.I "exportfs -u"
For instance, if you want to deny \s-2NFS\s0 access to the
.I /usr 
file hierarchy, you enter the command:

.DS
.ft CW
# \&\fBexportfs -u /usr\fP
.DE

To unexport all exported hierarchies, enter

.DS
.ft CW
# \&\fBexportfs -ua\fP
.DE

.NH 4
\&The \&\fI/etc/xtab\fP File
.LP
Whenever 
.I exportfs 
(or
.I "exportfs -u"
runs, it updates 
the
.I /etc/xtab 
file,
which lists currently exported
directories in a
format identical to that of
.I /etc/exports .
Its contents change whenever
you run
.I exportfs .
On the other hand,
.I /etc/exports '
contents remain static until you
manually change them.
Thus, only
.I xtab 
contains a correct list of the hierarchies being
exported at any given time.
.NH 3
\&Upgrading an \s-2NFS\s0 Server from Homogeneous to Heterogeneous
..IX "NFS server" "upgrading from homo- to heterogeneous"
..IX server "upgrading from homo- to heterogeneous via NFS"
.LP
As your site's needs grow, you may need
to add clients of a different architecture to a network
served by a homogeneous \s-2NFS\s0 server.
Only clients with the same application architecture as the server
can use the executables in its
.I /usr 
file system.
Moreover, machines with the same application architecture
but different kernel architecture from the
server cannot use its critical
.I /usr/kvm 
files.
If your \s-2NFS\s0 server now must support clients of several 
application or kernel architectures,
you have to install the
.I /usr 
and possibly
.I /usr/kvm 
executables for those architectures from the 4.1 Release tape.
For a thorough discussion of kernel and application
architectures, and their implications for exporting file
systems to clients, see the chapter
\fIIntroducing the SunOS Operating System\fP.  
..IX server NFS "" "" PAGE END 
..IX "NFS server" "creating and maintaining" "" "" PAGE END 
.NH 2
\&Setting Up and Maintaining an \s-2NFS\s0 Client
..IX client setting "" "(NFS) setting up and maintaining"
..IX "NFS client" "setting up and maintaining"
.LP
This section contains information related to setting
up and maintaining any type of \s-2NFS\s0 client machine on a network.
You should read this if you are responsible for
administering your client machine, or if you
are administering both servers and clients on your
network.
.LP
This section first presents an overview of the actions you must
take to set up a client, followed by an
overview of any other actions you must take
after its initial installation.
Finally, it explains in detail of the files and
commands involved in the above actions.
.NH 3
\&Setting Up a Client
.LP
The initial activities you need to perform in order to
set up a machine as an \s-2NFS\s0 client include:
.IP \(bu
Declaring the machine a diskless or dataless client
during SunInstall.
.IP \(bu
Modifying the client's
..IX fstab modifying "\&\fIfstab\fP file"
.I "/etc/fstab" 
file to include other hierarchies the
client is to mount.
.IP \(bu
Making mount points in your client's directory tree for the hierarchies
mounted through the
.I "/etc/fstab" 
file.
.IP \(bu
Optionally enabling the automounter for the client,
instead of performing the tasks above for hierarchies not
related to booting,
as explained in \fIUsing the NFS Automounter\fP.  
.IP \(bu
After modifying
.I fstab 
and creating the mount points, the client is ready to start mounting
the hierarchies as explained below.
.NH 3
\&Maintaining a Client
.LP
Once you set up a machine as an \s-2NFS\s0 client, you may need to:
.IP \(bu
Directly mount and unmount hierarchies as needed.
.IP \(bu
Add/remove entries in the client's
.I /etc/fstab 
file.
.IP \(bu
Add/remove mount points.
.IP \(bu
Make sure that the server is exporting the file hierarchies the client
wants to mount.
.IP \(bu
Diagnosing and fixing network-related problems on the client.
.NH 3
\&Mounting Files from an \s-2NFS\s0 Server
..IX "NFS server" mount "" "and mounting files"
..IX server NFS "" "(NFS) and mounting files"
..IX mounting
.LP
Once an \s-2NFS\s0 file server exports a file hierarchy, the latter 
can be accessed by a client through
.I mount 's
\s-2RPC\s0 requests.
Mounting generally occurs at boot time, when the 
.I mount 
program reads the
.I fstab 
file.
..IX fstab "" "\&\fIfstab\fP file" "" PAGE START 
You can also dynamically mount and unmount hierarchies at any time by
using the
.I mount 
and
.I umount 
commands. 
These two operations can be bypassed by enabling the
automounter for \s-2NFS\s0 mounting (see 
\fIUsing the NFS Automounter\fP).  
.LP
The next section explains how to set up
clients to perform \s-2NFS\s0 mounts through
.I /etc/fstab 
and the
.I mount 
command.
.LP
.NH 4
\&An \s-2NFS\s0 Client's \&\fIfstab\fP File
..IX "NFS client" fstab "" "and the \&\fIfstab\fP file"
..IX client fstab "" "(NFS) and the \&\fIfstab\fP file"
.LP
When you first install Release 4.1 on a server,
SunInstall
creates default
.I fstab 
files for each of the server's clients.
The default 
.I /etc/fstab 
file for a diskless client resembles the following:

.DS
.ft CW
oak:/export/root/boomer / nfs rw 0 0
oak:/export/exec/sun3        /usr nfs ro 0 0
oak:/export/exec/kvm/sun3    /usr/kvm nfs ro 0 0
oak:/usr/share       /usr/share nfs ro 0 0
oak:/home/oak /home/oak nfs rw,bg 0 0
.DE

.LP
\s-2NFS\s0 entries in the file 
.I /etc/fstab 
file have the following syntax:

.DS
.ft CW
\fIfilesystem	directory   type   options   freq   pass\fP
.DE

.LP
\s+2\fBNote: \s0\fPIf you decide to enable the
automounter, do not remove these mounts (except
.I /home )
from the client's
.I /etc/fstab 
file.  The client cannot automount these critical
directories.
.LP
.IP "\fIfilesystem\fP" 1i
In the case of an \s-2NFS\s0 entry, this has the form
.I host:pathname ,
where
.I host
is the name of the server exporting the
directory the client wants to mount,
and
.I pathname
is the name of the directory to be mounted from the indicated server.
Note that in the default
.I fstab 
file for the client,
the only mounted directories are those
that the client requires to operate:
its individual
.I root ,
.I home ,
.I share 
and
.I "exec" 
.I /usr ""
and
.I /usr/kvm 
for the client's architecture).
These file hierarchies, along with the client
.I root 
files contain all essential SunOS programs.
.IP "\fIdirectory\fP" 1i
This is the full pathname of the mount point on the client 
where 
.I filesystem
should be mounted.
.ne 6
.LP
\s+2\fBNote: \fP\s0If an \s-2NFS\s0 file server is also
a client of another \s-2NFS\s0 server,
edit the server's \&\fIfstab\fP
to include both 
.I 4.2 
and 
.I nfs 
mounts.
.LP
.IP "\fItype\fP" 1i
..IX NFS mount
..IX mount "NFS mount"
This is the type of mount taking place.
In the example above, this is an \s-2NFS\s0 mount.
If the client has a local disk, you can also set up its
.I fstab 
file so that it can perform 
.I 4.2 
mounts of file systems
on its local disk. 
.IP "\fIoptions\fP" 1i
This can be any one of a number of options provided
for 
.I nfs 
or 
.I 4.2 
mounts.  Refer to the
.I fstab (5)
man page for a complete list.
For example, if you are running secure \s-2NFS\s0,
you may want to select the
.I secure 
option for \s-2NFS\s0 mounts.
.IP
The example file shows the client performing
\s-2NFS\s0 mounts with the common options 
.I rw 
or
.I ro .
The client can mount its
own
.I root ,
.I swap ,
and
.I home 
directories with read-write access.
However, it accesses the server's
.I /usr 
directory with read-only permission;  thus, a user
on the client cannot add or modify a file in
.I /usr .
.IP "\fIfreq\fP"
This is the interval in days between dumps of
the directory.
Since these directories are backed up on the server,
not on the client, this field should always be zero
when the mount type is 
.I nfs .
.IP "\fIpass\fP
This indicates the
.I fsck 
pass in which the listed file system is checked.
For \s-2NFS\s0 mounts, this should be zero,
so no
.I fsck 
checking is attempted.
.LP
The contents of
.I "/etc/fstab" 
remain the same until you change them.
.NH 4
\&Making Mount Points
.LP
..IX NFS "mount point" "" "" PAGE MAJOR
..IX "mount point" "" "" "" PAGE MAJOR 
Mount points are locations within a directory tree
through which your computer accesses mounted hierarchies.
Your machine can mount these hierarchies 
locally from a disk or tape, or remotely from another computer
on the network. 
Any directory can serve as a mount point.
The mount points for 
.I / ,
.I /usr ,
and
.I /home 
are provided automatically for you at installation time,
together with an extra mount point arbitrarily called
.I /mnt .
.LP
If you need further mount points,
simply create new directories 
with the
..IX mkdir "" "\&\fImkdir\fP \(em make directory"
.I "mkdir" 
command.
Just type:

.DS
.ft CW
# \&\fBmkdir \fImount_point\fR
.DE

where
..IX "mount point"
.I "mount_point"
is the pathname of the directory you want to
create.
Next, make sure the mode and permissions of 
the new mount point match those of the directory
to be mounted on it.
Use
.I chmod 
as needed (see the man page for 
.I chmod (1V)).
.NH 3
\&Mounting and Unmounting File Hierarchies
.LP
This subsection shows how to perform two
different mount procedures:
statically, through the
.I fstab 
file, or explicitly,
through the
.I mount 
and
.I umount 
commands.
.LP
.SH
\&Procedures for Modifying the Client's \&\fIfstab\fP
..IX fstab modifying "\&\fIfstab\fP file"
.LP
If you want the client always to mount a
particular file hierarchies, you should add an
entry to its
.I fstab 
file.  Follow these directions:
.IP 1.
Log in
as superuser.
.ne 5
.LP
\fB\s+2Note\s0: \fPIf you edit a client's
.I fstab 
file while logged in to its server, this file is
located by default in
\&\fI/export/root/\fIclient\fP/etc/fstab\fR.
.LP
.IP 2.
Edit
.I /etc/fstab .
Create an entry in the file,
using the syntax shown in the previous
subsection.  List the server
exporting the directory you wish to mount,
that directory's pathname, the mount point on the client,
and so on.
.IP 3.
Create the mount point in the client's directory
tree using the
.I mkdir 
command.
.IP 4.
Type the following:

.DS
.ft CW
# \&\fBmount -a\fP
.DE

to mount everything in the current
.I fstab 
file.
.LP
After you finish these steps, the
client will always mount the hierarchies listed in its
.I /etc/fstab 
file until you modify it again.
.LP
..IX fstab "" "\&\fIfstab\fP file" "" PAGE END 
.LP
.NH 3
\&Explicitly Mounting Hierarchies with \&\fImount\fP
..IX mount "" "\&\fImount\fP \(em mount file hierarchies" "" PAGE MAJOR 
.LP
You can use the
.I mount 
command during the course of client operations
to mount a hierarchy.
It is advisable to use this command for
hierarchies that you only want to access for
a finite amount of time.
You must be super user to use
.I mount .
.LP
.I mount 
explicitly mounts a file hierarchy.
It only requires that the client
can reach the hierarchy's server over the network,
and that the server is exporting it (or a hierarchy
above it) to the client.
.LP
Here is a form of the
.I mount 
command that you can use for most
mount operations.
(Refer to the
.I mount (8)
man page for the complete syntax.)
 
.DS
.ft CW
# \&\fBmount -t \&\fItype [-rv]\fP -o \&\fI[\&\fIoptions\&\fI] \&\fIserver:pathname  /mount_point\fP
.DE

These parameters are explained below.
.IP "\&\fI-t \fItype\fR" 1.5i
This is the type of mount you want to perform,
.I nfs 
or
.I "4.2" ,
for example.
.IP "\fI[-rv]\fP" 1.5i
These are two options that you can supply
with
.I mount .
.I -r 
specifies that you want to mount the directory
read-only, even if it is specified as read/write in the
.I fstab 
file.
.I -v 
specifies the verbose option, in which
.I mount 
displays messages as it operates.
.IP "\&\fI-o \fIoptions\fR" 1.5i
This is a list of options specified after
the
.I -o 
flag.
Some \s-2NFS\s0-specific options are:
.RS
.IP "[\&\fIrw\fP | \&\fIro\fP]" 1i
Indicates whether the mounting is to be done read\(hyonly or
read/write. The default is \fBrw\fP.
.IP "[\&\fIsuid\fP | \&\fInosuid\fP]"
Indicates whether 
.I setuid 
and 
.I setgid 
bits
are to be obeyed or ignored
on execution, respectively.
Every hierarchy mounted \&\fIrw\fP is a good candidate
for \&\fInosuid\fP.
The default is \fBsuid\fP.
.IP "[\&\fIsoft\fP | \&\fIhard\fP]"
When the
.I hard 
option is specified,
an \s-2NFS\s0 request affecting any part of
the mounted file hierarchy is issued
repeatedly until the request is 
satisfied or 
until the maximum number of retries is
reached (see below, 
.I retry ).
When the
.I soft
option is specified,
the \s-2NFS\s0 request returns an error
if it cannot be accomplished,
and quits.
The default is \fBhard\fP.
.IP "[\&\fIbg\fP | \&\fIfg\fP]"
When the server does not respond to a mount request, retry in the
background or the foreground, respectively.
The default is \fBfg\fP.
.IP "\&\fIintr\fP"
Allow keyboards interrupts while the \s-2NFS\s0
request is being issued
(see above, 
.I soft\0|\0hard ).
.IP "\&\fIretry=\fP\&\fIn\fP"
Number of times to retry the mount operation.
The default for \&\fIn\fP is 10,000 times.
.IP "\&\fItimeo=\fP\&\fIn\fP"
Set the timeout on \s-2NFS\s0 requests to \&\fIn\fP tenths of a second.
The default is 7.
.IP "\&\fInocto\fP"
Suppress fresh attributes when opening a file.
.RE
.LP
The remaining options are 
fully described in the
.I mount (8)
man page.
.IP "\fIserver\fP" 1.5i
This is the name of the server exporting the directory.
.IP "\fIpathname\fP" 1.5i
This is the full pathname on the
server of the directory you want to mount
.IP "\fImount_point\fP" 1.5i
This is the mount point on the client through which the
directory is mounted.
.LP
Hierarchies accessed
through the
.I mount 
command stay mounted during a work session
unless you unmount them with the
.I umount 
command.
Moreover, if you reboot the machine,
the hierarchy is automatically unmounted
and remains so
(unless you also edited the
.I fstab 
file to include the mount.)
.LP
.ne 10
For example,
to hard mount (with read/write permissions, 
.I nosuid ,
interrupt enabled,) 
the man pages from remote machine \&\fIdancer\fP
to the local directory \&\fI/usr/man\fP,
you type either:

.DS
# \&\fBmount -o nosuid,intr dancer:/usr/man /usr/man\fP
.DE

or:

.DS
# \&\fBmount -o rw,nosuid,hard,intr dancer:/usr/man /usr/man\fP
.DE

.ne 5
.LP
To mount the hierarchy \&\fI/usr/local\fP from the remote
machine \&\fIdancer\fP on the mountpoint \&\fI/usr/local/dancer\fP,
with read only and soft mounted, you enter:

.DS
# \&\fBmount -o ro,soft dancer:/usr/local /usr/local/dancer
.DE

.LP
Here are some final points to remember about
.I mount :
.IP \(bu
Make the applicable mount point before
issuing the
.I "mount" 
command.
.IP \(bu
Consider soft mounting hierarchies such as the
man pages
so that if the server exporting
them goes down, your client will not hang.
.IP \(bu
Use the \&\fIhard\fP option 
with any file hierarchies you mount read-write.
.IP \(bu
Use
the \&\fIhard\fP option with any file hierarchies you run executables
from, whether mounted read-only or read-write. 
Otherwise, if the server goes does and the process pagefaults, the
page\(hyin will fail because of the soft mount and the program will
dump.
The reason for the failure may not be immediately obvious in this case.
.IP \(bu
Use the \&\fInosuid\fP option
with any file hierarchies you mount read-write, unless
you have compelling reasons not to do so.
.IP \(bu
Use the \&\fIintr\fP option with any file hierarchy 
you mount \&\fIhard\fP, so that if the server exporting it
goes down
you can interrupt the current operation.
.IP \(bu
Use the
.I nocto
option on hierarchies which you do not expect will change
(such as your
.I /usr 
or a file hierarchy mounted read\(hyonly).
.NH 3
\&Explicitly Unmounting Hierarchies with \&\fIumount\fP
..IX umount "" "\&\fIumount\fP \(em unmount file hierarchies" "" PAGE MAJOR 
.LP
You use
.I umount 
to explicitly unmount a currently mounted file hierarchy, whether
the mounting occurred
at boot time or through running 
.I mount .
You must be superuser to use
.I umount .
A simple form of
.I umount 
is shown below.
(Refer to the
.I umount (8)
man page for the complete syntax of this command.)
.ne 4

.DS
.ft CW
# \&\fBumount\fP \fImount_point\fP
.DE

.I mount_point
is the pathname on the client where you have
mounted the files from the file server.
You could specify 
\fIserver\fP:\fIpathname\fP
instead.
.SH
\&The \&\fI/etc/mtab\fP File
.LP
Whenever you explicitly mount or unmount a file hierarchy,
the
..IX mtab "" "\&\fImtab\fP" "" PAGE MAJOR
.I /etc/mtab 
file is modified to reflect the list of currently 
mounted file hierarchies.
This file has a format and contents similar to those of the
.I fstab 
file.
Some of the file hierarchies mountable through the automounter, however,
are displayed with type
.I ignore .
You can display
.I /etc/mtab 
by using the
.I cat 
or
.I more 
commands, but you cannot edit it, as you would
.I /etc/fstab .
.NH 2
\&Obtaining Information
.LP
Release 4.1 contains
a variety of tools to help you obtain information about
the status of the networked file system services.
.NH 3
\&\&\fIexportfs\fP
.LP
..IX exportfs "" "\&\fIexportfs\fP \(em export directories to NFS"
To list all file hierarchies that a server
currently exports, including to whom and with
what options, enter the command
.I exportfs 
with no arguments, while logged in to the server.
You do not have to be super user to use
.I exportfs 
in this fashion.
.NH 3
\&\&\fIshowmount\fP
.LP
To list all the file hierarchies that a server
is currently exporting, without having to log in at the server,
enter:

.DS
.ft CW
% \&\fBshowmount -e \fP\&\fIserver\fP 
.DE

.LP
..IX showmount "" "\&\fIshowmount\fP \(em show all remote mounts"
To list all the hierarchies that have been mounted from
a particular server, in the format 
.I "client:directory" ,
enter:

.DS
.ft CW
% \&\fBshowmount -a \fP\&\fIserver\fP 
.DE

.LP
To obtain a list of the hierarchies that have been remotely mounted by
clients, with no further details, enter:

.DS
.ft CW
% \&\fBshowmount -d \fP\&\fIserver\fP 
.DE

.LP
In the case of the
.I -a 
and
.I -d 
options, the mounts shown may not accurately reflect the
current situation, since a client that crashes does not modify
the database.
.I showmount 
uses 
.I /etc/rmtab 
(on the server), unless the clients reboots and executes
.I "umount -a" .  
.NH 3
\&\&\fImount\fP
.LP
To list all the resources currently
mounted by a machine, enter the 
command
.I "mount" .
..IX mount "" "\&\fImount\fP \(em mount file hierarchies"
This produces a listing like the following:

.DS L
.ft CW
stale:/export/root/junk on / type nfs (rw)
stale:/export/exec/sun3 on /usr type nfs (ro)
stale:/export/exec/kvm/sun3 on /usr/kvm type nfs (ro)
stale:/usr/share on /usr/share type nfs (ro)
stale:/export/local/sun3 on /usr/local type nfs (ro,soft,bg,noquota)
stale:/export/local/share on /usr/local/share type nfs (ro,soft,bg,noquota)
stale:/export/local/src on /usr/local/src type nfs (ro,soft,bg,noquota)
stale:/home/stale on /home/stale type nfs (rw,bg)
.DE

To list all \s-2NFS\s0 resources currently mounted, in
the same format of \&\fIfstab\fP, enter
.I "mount -p" .  
This will produce output similar to:
.DS
.ft CW
.TS
center tab(`);
l l l l l l.
stale:/export/root/junk`/`nfs`rw`0`0
stale:/export/exec/sun3`/usr`nfs`ro,nocto`0`0
stale:/export/exec/kvm/sun3`/usr/kvm`nfs`ro,nocto`0`0
stale:/usr/share`/usr/share`nfs`ro,nocto`0`0
stale:/export/local/sun3`/usr/local`nfs`ro,bg,intr,noquota`0`0
stale:/export/local/share`/usr/local/share`nfs`ro,soft,bg,noquota`0`0
stale:/export/local/src`/usr/local/src`nfs`ro,soft,bg,noquota`0`0
stale:/home/stale`/home/stale`nfs`rw,bg`0`0
.TE
.DE

The command

.DS
.ft CW
# \&\fBmount -p > /etc/fstab\fP
.DE

can be used to update
.I /etc/fstab 
if there have been changes produced manually by the use
of
..IX mount "changing fstab using" "\&\fImount\fP" "changing \&\fIfstab\fP using"
.I mount 
or
.I umount ;
\fBDo not\fP use this strategy if 
.I automount 
is used to mount some file hierarchies, as it would lead
to extreme confusion regarding what hierarchies are to 
be mounted through
.I mount 
and which through
.I automount .
.NH 3
\&\&\fIshowfh\fP
..IX showfh "" "\&\fIshowfh\fP \(em show file name"
.LP
When you receive an error message that refers to a file handle,
you can use the
.I showfh 
command to obtain the file name corresponding to the
file handle if the server from which it is mounted is
running the
.I showfhd 
daemon.
..IX showfhd "" "\&\fIshowfhd\fP daemon"
For instance, if you see an error message like the following:

.DS L
.ft CW
\s-2NFS\s0 write error 70 on host \&\fIserver\fP fh 305 1 a000 2990 53659758 a0000 2822 7f8bef77
.DE

you can obtain the name of the file in question by entering:

.DS
.ft CW
%\&\fB showfh \&\fIserver\fP 305 1 a000 2990 53659758 a0000 2822 7f8bef77\fP
.DE

For more details, please consult 
.I showfh (8c)
and
.I showfhd (8c)
in the
\fISunOS Reference Manual\fP.  
.NH 2
\&Handling \s-2NFS\s0 Problems
..IX NFS troubleshooting "" "" PAGE START
..IX troubleshooting "NFS problems" "" "" PAGE START
.LP
This section describes typical problems that occur on
machines using \s-2NFS\s0 services.
Topics discussed include:
.IP \(bu
Strategies for tracking \s-2NFS\s0 problems
.IP \(bu
\s-2NFS\s0-related error messages
.LP
Before trying to clear \s-2NFS\s0 problems,
it is suggested that you have a summary understanding of some of the
issues involved.
The information in this section contains
enough technical details to give
experienced network administrators
a thorough picture of what is happening
with their machines.
If you do not yet have this level of expertise, note that
it is not important to understand these daemons,
system calls and files fully. However, you should be able to
at least recognize their names and functions.
.LP
.NH 3
\&Determining Where \s-2NFS\s0 Service Has Failed
.LP
When tracking down an \s-2NFS\s0
problem, keep in mind that, like all network services, there are three
main points of failure: the server, the client, or the network itself.
The strategy outlined below tries to isolate each individual
component to find the one that is not working.
.LP
Note that it is not critical for you to understand in depth
how the daemons mentioned work.
You simply need to know that they exist, because you may have to
restart them if they stop for any reason.
Thus, you should familiarize yourself with
the following man pages, if you have not done so already:
.DS
.ft CW
mount \fR(8)\fP
umount \fR(8)\fP
exportfs \fR(8)\fP
mountd \fR(8C)\fP 
nfsd \fR(8)\fP
biod \fR(8)\fP
inetd \fR(8C)\fP 
inetd.conf \fR(5)\fP 
.DE
.LP
This summary begins as the server and the client boot up
and read the
file
.I /etc/rc.local ,
the pertinent section of which is listed here:

.DS L
.ft CW
if [ -f /etc/exports ]; then
        > /etc/xtab
        exportfs -a
        nfsd 8 &                echo -n ' nfsd'
        if [ -f /etc/security/passwd.adjunct ]; then
                # Warning! Turning on port checking may deny access to
                # older versions (pre-3.0) of \s-2NFS\s0 clients.
                rpc.mountd
                echo "nfs_portmon/W1" | adb -w /vmunix /dev/kmem >/dev/null 2>&1
        else
                rpc.mountd -n
        fi
fi
.DE

.ne 8
.LP
\s+2\fBNote: \fP\s0This explanation is written especially
for advanced system administrators and programmers.
You do not have to fully understand the
entire mount
process to clear problems involving remote mounts.
.LP
.IP 1.
When the server boots up,
if the file 
.I /etc/exports 
exists, indicating that the machine is a server,
.I /etc/rc.local 
executes
.I exportfs ,
..IX exportfs "" "\&\fIexportfs\fP \(em export directories to NFS"
which reads the server's
.I /etc/exports 
file, then tells the kernel which 
file hierarchies
the server can export and what access restrictions\(emif
any\(emare on these files.
.IP 2.
The file 
.I /etc/rc.local 
also starts the
.I rpc.mountd 
..IX daemons rpc.mountd "" "\&\fIrpc.mountd\fP"
..IX rpc.mountd "" "\&\fIrpc.mountd\fP daemon"
daemon and several
.I nfsd 
..IX daemons nfsd "" "\&\fInfsd\fP"
..IX nfsd "" "\&\fInfsd\fP daemon"
daemons (usually about eight).
The 
.I rpc.mountd 
daemon is called with the
.I -n 
flag, a slightly less secure procedure, unless C2 security is
in place.
.IP 3.
When the client 
boots up,
.I /etc/rc.local 
starts several (usually four)
.I biod 
daemons.
.IP 4.
The same file
also executes
.I "mount -vat"
which reads the client's 
.I fstab 
file and mounts all \s-2NFS\s0-type files mentioned there
in a manner similar to that described below.
.IP 5.
When the user enters the command:

.DS
#\&\fBmount -o ro,soft dancer:/usr/src /usr/src/dancer.src\fP
.DE

the
.I mount 
command validates that the user has super user permission
and that the mount point is a full pathname.
.\".\s-2IP\s0 6.
.\"If the conditions are valid,
.\".L mount 
.\"then opens 
.\".L /etc/mtab
.\"and checks that this mount has not
.\"already been done in step 4 above.
.IP 6.
.I mount 
parses the argument \fIfilesystem\fP into host dancer and remote
directory
.I /usr/src .
Because the argument has the form
.I server:pathname ,
.I mount 
interprets this to mean that this is an \s-2NFS\s0 mount.
.IP 7.
If the network uses the \*(YP service, 
.I mount 
obtains from the local portmapper information on how to contact
the local \*(YP binder daemon 
.I ypbind ,
which it then calls
to determine which server machine to find the \*(YP server process on.  It
then calls the 
.I ypserv 
daemon on that machine to get dancer's \s-2IP\s0 address.
.IP 8.
.I mount 
calls the portmapper on dancer to get the port number of dancer's
.I rpc.mountd .
.IP 9.
.I mount 
calls dancer's
.I rpc.mountd 
daemon and passes it
.I /usr/src ,
requesting it
to send a file handle 
.I fhandle )
for the directory. 
.IP 10.
If the network uses the \*(YP service,
dancer's
.I rpc.mountd 
daemon calls the \*(YP server
.I ypserv 
to expand the host names and netgroups in the export list for
.I /usr/src 
and to determine the client's host name based on its \s-2IP\s0 
address.
.IP 11.
The server's 
.I rpc.mountd 
..IX daemon rpc.mountd "" "\&\fIrpc.mountd\fP"
..IX rpc.mountd "" "\&\fIrpc.mountd\fP daemon"
daemon handles the client's mount requests.
If the directory
.I /usr/src 
is available to the client (or to the public),
the 
.I rpc.mountd 
daemon 
does a
.I getfh (2)
system call
on
.I /usr/src 
to get the
.I fhandle ,
and sends it to the client's mount process.
.IP 12.
.I mount 
checks if 
.I /usr/src/dancer.src 
is a directory.
.IP 13.
.I mount 
does a
.I mount (2)
system call with the directory
.I /usr/src/dancer.src 
as one of the arguments,
as well as a data structure containing, among other things, the
.I fhandle 
and the server address, port number, flags and so on.
.IP 14.
The client kernel looks up the directory 
.I /usr/src/dancer.src 
and, if everything is
okay, it ties the file handle to the hierarchy in a mount record.
From now on all file system requests to that directory and 
its subdirectories
go through the file handle to server dancer.
.IP 15.
The client's kernel does a
.I statfs (2)
call to dancer's \s-2NFS\s0
server
.I nfsd ).
.IP 16.
Mount's 
.I mount (2)
system call returns.
.IP 17.
.I mount 
opens
.I /etc/mtab 
and adds an appropriate entry to the end,
reflecting the new addition to the list of mounted files.
.IP 18.
Once the hierarchy is mounted,
when the client kernel does a file operation it
sends the \s-2NFS\s0 \s-2RPC\s0 information
to the server, where it is read by one of the
.I nfsd 
daemons to process the file request.
.IP 19.
The
.I nfsd 
daemons know how a hierarchy is exported from the
information sent to the server's kernel by
.I exportfs .
These daemons allow the client to access the
hierarchy according to its permissions.
.NH 4
\&Debugging Hints
.LP
Below are some general pointers for debugging of \s-2NFS\s0 problems, followed
by a list of possible errors and their probable causes.
.LP
The
.I rpc.mountd 
..IX rpc.mountd "" "\&\fIrpc.mountd\fP daemon"
..IX daemons rpc.mountd "" "\&\fIrpc.mountd\fP"
daemon must be present on the file server for a remote mount to
succeed.
Make sure 
.I rpc.mountd 
is available for an 
\s-2RPC\s0
call by checking that the following lines in
.I /etc/rc.local 
have not been deleted by mistake:

.DS L
.ft CW
if [ -f /etc/exports ]; then
        > /etc/xtab
        exportfs -a
        nfsd 8 &                echo -n ' nfsd'
        if [ -f /etc/security/passwd.adjunct ]; then
                # Warning! Turning on port checking may deny access to
                # older versions (pre-3.0) of \s-2NFS\s0 clients.
                rpc.mountd
                echo "nfs_portmon/W1" | adb -w /vmunix /dev/kmem >/dev/null 2>&1
        else
                rpc.mountd -n
        fi
fi
.DE

.LP
Remote mounts also need some number, typically 8, of 
.I nfsd 
daemons to
execute on \s-2NFS\s0 servers.
Make sure that the line

.DS
.ft CW
        nfsd 8 &                echo -n ' nfsd' 
.DE

is present in the fragment above.
.LP
You can also enable
these daemons without rebooting. 
Become superuser and type:

.DS
.ft CW
# \&\fBnfsd 8\fP
.DE

.LP
The client's
.I biod 
daemons 
are not necessary for \s-2NFS\s0 to work, but they
do increase performance in a very noticeable manner.
Make sure that the following (or similar) lines
are present in the client's 
.I /etc/rc.local :

.DS
.ft CW
if [ -f /usr/etc/biod ]; then
        biod 4;                 echo -n ' biod'
fi
.DE

You can also enable
these daemons without rebooting. 
Become superuser and type:

.DS
.ft CW
# \&\fBbiod 4\fP
.DE

.NH 4
\&Server Problems
..IX debugging "server problems" "" "" PAGE START 
..IX server debugging "" "(NFS) debugging" PAGE START
.LP
When the network or \s-2NFS\s0 file server has problems, programs that access hard
mounted remote files will fail differently than those that access soft
mounted remote files.  Hard mounted remote file hierarchies cause 
the client's kernel to retry the requests 
until the file server responds again.  Soft mounted remote file
hierarchies cause the client's system calls to return
an error after trying for a while.
When you use
.I mount 
with the
.I bg 
option, 
it retries the mount in the background if the
first mount attempt fails.  
.LP
When a file hierarchy is hard mounted, a program
..IX "NFS files" "hard-mounted" 
..IX "filesystem" "hard-mounted NFS hierarchies"
that tries to access it will hang if the server fails
to respond.
In this case, the message:

.DS
.ft CW
\s-2NFS\s0 server \fIhostname\fP not responding, still trying
.DE

will appear on the console.
When the server finally responds, the message

.DS
.ft CW
\s-2NFS\s0 server \fIhostname\fP ok
.DE

will appear on the console.
.LP
A program accessing a soft mounted file hierarchy
..IX "NFS files" "soft-mounted" 
..IX "filesystem" "soft-mounted NFS hierarchies"
whose server is dead or not responding may or may
not check the return conditions of file hierarchy
operations. 
If it does, it should print an error message; otherwise,
you may not see an error message on the terminal.
But in any case an error message such as the following should appear
on the console 
.DS
.ft CW

\&.\| . \|.\&\fIhostname\fP server not responding: \s-2RPC\s0: Timed out

.DE
.LP
If a client is having \s-2NFS\s0
trouble, check first to make sure the server
is up and running.  From a client you can type:
.\".\s-2LP\s0
.\"Robert: The rpcinfo command probably change from 3.0 to Sundisk.
.\".\s-2LP\s0
.\"Relevant error message:  "\s-2NFS\s0 getattr failed for server krypton:
.\"\s-2RPC\s0: Timed out

.DS
.ft CW
% \&\fBrpcinfo -p\fP \fIserver_name\fP
.DE

to see if the server is up at all.  
.I rpcinfo 
should give list of
program, version, protocol, and port numbers similar to the following:

.DS
.ft CW
 program vers proto   port
    100000    2   tcp    111  portmapper
    100000    2   udp    111  portmapper
    100004    2   udp    658  ypserv
    100004    2   tcp    659  ypserv
    100004    1   udp    658  ypserv
    100004    1   tcp    659  ypserv
    100007    2   tcp   1024  ypbind
    100007    2   udp   1027  ypbind
    100007    1   tcp   1024  ypbind
    100007    1   udp   1027  ypbind
    100029    1   udp    660  keyserv
    100028    1   tcp    665  ypupdated
    100028    1   udp    667  ypupdated
    100003    2   udp   2049  nfs
    100005    1   udp    709  mountd
    100005    2   udp    709  mountd
    100005    1   tcp    712  mountd
    100005    2   tcp    712  mountd
                   \&.
                   \&.
                   \&.
.DE

.sp 2
If that works, you can also use 
.I rpcinfo 
to check if the 
.I mountd 
daemon is running, type the following:

.DS
.ft CW
% \&\fBrpcinfo -u\fP \fIserver_name\fP mount
.DE

The command should respond:

.DS
.ft CW
program 100005 version 1 ready and waiting
program 100005 version 2 ready and waiting
.DE

If these fail, try logging in to the \s-2NFS\s0 file server's console.
If the server is up but your machine cannot 
communicate with it,
check the Ethernet connections between your machine and the server.
If the server is okay and the network is okay, use 
.I ps 
to check your client daemons.  You should have a
.I portmap 
and several 
.I biod 
daemons running.  
For example, running 
.I ps 
should result in output similar to the following:

.DS
.ft CW
% \&\fBps ax\fP
  \s-2PID\s0 \s-2TT\s0 \s-2STAT\s0  \s-2TIME\s0 \s-2COMMAND\s0
    0 ?  D     0:00 swapper
    1 ?  S     0:00 /sbin/init -
    2 ?  D     0:00 pagedaemon
   54 ?  \s-2IW\s0    0:01 portmap
   59 ?  \s-2IW\s0    0:00 ypbind
   61 ?  \s-2IW\s0    0:00 keyserv
   71 ?  S     0:14 in.routed
   74 ?  I     0:00  (biod)
   75 ?  I     0:00  (biod)
   76 ?  I     0:00  (biod)
   77 ?  I     0:00  (biod)
                   \&.
                   \&.
                   \&.
.DE

..IX debugging "server problems" "" "" PAGE END 
..IX server debugging "" "(NFS) debugging" PAGE END 
.NH 3
\&Clearing Remote Mounting Problems
.LP
This section deals with problems related to mounting.  If 
.I mount 
fails for any reason, check the next subsections for specific details.
They are arranged according to where they occur in
the mounting sequence and are labeled with the error message you are
likely to see.
.LP
.I mount 
can get its parameters explicitly from the command line or
from 
.I /etc/fstab .
The example
below assumes command line arguments, but the same debugging
techniques work if 
.I /etc/fstab 
is used in the 
.I "mount -a"
command.
.LP
Keep in mind the interaction of the various players in the mount
request.  If you understand this, the problem descriptions
below will make a lot more sense.
.NH 4
\&Error Messages Related to Remote Mounts
.LP
Any step in the remote mounting process can fail\(emsome of 
them in more than one way.
The sections below give detailed descriptions of the failures
associated with specific error messages.
.KS
.IP \(bu
\&\fI/etc/mtab: No such file or directory\fP
.IP
The mounted file hierarchy table is kept in the file 
.I /etc/mtab .
This file must exist before 
.I mount 
can succeed.
.KE
.KS
.IP \(bu
\&\fImount: ...  Block device required\fP
.IP
You probably did not specify the remote machine name in
the following command:

.DS
.ft CW
# \&\fBmount \fIremote.machine\fP:/usr/src /dancer.src\fR
.DE

The 
.I mount 
command assumes you are doing a local mount unless it
sees a colon in the file hierarchy name, or 
unless the 
.I /etc/fstab 
specifies that the file hierarchy is 
mounted via an \s-2NFS\s0 mount.
.KE
.KS
.IP \(bu
\&\fImount: ... not found in /etc/fstab\fP
.IP
If you issue the 
.I mount 
command with only a directory or file hierarchy name but
not both,
it looks in 
.I /etc/fstab 
for an entry whose file hierarchy or
directory field matches the argument.  For example,
the following command:

.DS
.ft CW
# \&\fB/mount /dancer.src\fP
.DE

.IP
searches 
.I /etc/fstab 
for a line that has a directory name
field of 
.I "/dancer.src" .
If it finds an entry, such as:

.DS
.ft CW
dancer:/usr/src /dancer.src nfs rw,hard 0 0
.DE

.IP
it will do the mount as if you had typed:

.DS
.ft CW
# \&\fBmount -o rw,suid,hard dancer:/usr/src /dancer.src\fP
.DE

.IP
The default options are read-write, hard, and 
.I suid .
.KE
.KS
.IP \(bu
\&\fI/etc/fstab: No such file or directory\fP
.IP
This message indicates that 
.I mount 
tried to look up 
the directory given it as an
argument in the 
.I /etc/fstab 
file, but could not find 
the
.I /etc/fstab 
file.  You need to create the file.
.KE
.KS
.IP \(bu
\&\fI \.\.\. invalid argument\fP
.IP
\s-2NFS\s0 is not configured into the kernel.
Reconfigure the kernel following the procedures
presented in the chapter
\fIReconfiguring the System Kernel\fP, 
making sure that the \s-2NFSCLIENT\s0 option is set.
.KE
.KS
.IP \(bu
\&\fI \.\.\. not in hosts database\fP
.IP
This message indicates
that the host specified to
.I mount 
is not in the
.I hosts 
database, either
.I /etc/hosts 
or 
its equivalent \*(YP map.
It could also indicate that
the \*(YP daemon
.I ypbind 
..IX daemons ypbind "" \&\fIypbind\fP
..IX ypbind "" "\&\fIypbind\fP daemon"
has died on the machine.
.IP
Check the spelling and
the placement of the colon in your 
.I mount 
command.
If the command is correct, 
and you only get this message for this
host name, check the entry in the
.I hosts 
database.
If your network is running \*(YP, make
sure that 
.I ypbind 
is running by typing:

.DS
.ft CW
# \&\fBps ax | grep ypbind\fP 
.DE

.IP
Try to 
.I rlogin 
to another machine, or use 
.I rcp 
to remote copy a file to another machine.  
If this also fails,
your 
.I ypbind 
daemon is probably dead or hung.  If you only get this
message for this host name,
you should check the 
.I hosts.byname 
map on the \*(YP master server.  See
\fIThe Network Information Service\fP
for more information about \*(YP problems.
.KE
.KS
.IP \(bu
\&\fImount: directory path must begin with '/'\fP
.IP
..IX mount "" "\&\fImount\fP \(em mount file systems"
The second argument to 
.I mount 
is the path of the directory to be
used as a mount point.
This must be a full pathname, starting at root ( / ).
.KE
.KS
.IP \(bu
\&\fImount: ... server not responding: \e
.br
		\s-2RPC_PMAP_FAILURE\s0 - \s-2RPC_TIMED_OUT\s0\fP
.IP
Either the \s-2NFS\s0 file server the client is trying to mount from is down,
or its portmapper is dead or hung.
Try rebooting the server to restart the
.I inetd ,
.I portmap ,
and (if running \*(YP)
.I ypbind 
daemons.
If you can't 
.I rlogin 
to the server but it is up,
check the client's Ethernet connection by trying to 
.I rlogin 
to some
other machine.  You should also check the server's Ethernet connection.
.KE
.KS
.IP \(bu
\&\fImount: ... server not responding: \e
.br
		\s-2RPC_PROG_NOT_REGISTERED\s0\fP
.IP
This means that 
.I mount 
got through to the portmapper, but the \s-2NFS\s0
mount daemon 
.I rpc.mountd 
was not registered.
.KE
.KS
.IP \(bu
\&\fImount: ...: No such file or directory\fP
.IP
Either the remote directory or the local directory does not exist.
Check the spelling of the directory names.
Try to use
.I ls 
on both directories.
.KE
.KS
.IP \(bu
\&\fImount: not in export list for ...\fP
.IP
Your machine name is not in the export list for the file hierarchies you
want to mount from the server.
You can get a list of the server's exported file hierarchies by running
..IX showmount "" "\&\fIshowmount\fP \(em show all remote mounts"

.DS
.ft CW
# \&\fBshowmount -e\fP \fIhostname\fP
.DE

.IP
If the file hierarchy you want is not in the list, or your machine name
or netgroup name is not in the user list for the file hierarchy, log in to
the server and check the 
.I /etc/exports 
file for the correct
file hierarchy entry.  A file hierarchy name that appears in the
.I /etc/exports 
file but not in the output from 
.I showmount ,
indicates a failure in 
.I mountd .
Either it could not understand that
line in the file, or 
.I mountd 
could not find the file hierarchy, or the
file hierarchy name was not a locally mounted file system.
See the 
.I exports (5)
man page for more information.  If the 
.I /etc/exports 
file looks correct, and your network runs \*(YP, 
check the server's 
.I ypbind 
daemon.  It may be dead or hung.
.KE
.KS
.IP \(bu
\&\fImount: ...: Permission denied\fP
.IP
This message is a generic indication
that some authentication failed on the file server.
It may be that you are not in the export list (see above),
that the server could not recognize your machine
.I ypbind ""
is dead),
or that the server does not believe you are who you say you are.
Check the file server's 
.I /etc/exports 
file, and, if applicable, 
.I ypbind .
.KE
.KS
.IP \(bu
\&\fImount: ...: Not a directory\fP
.IP
Either the remote path or the local path is not a directory.  Check
the spelling in your command,
and try to run 
.I ls 
on both directories.
.KE
.KS
.IP \(bu
\&\fIMust be root to use mount\fP
.IP
You have to run 
.I mount 
as root on your machine.
.KE
.KS
.IP \(bu
\&\fIStale \s-2NFS\s0 file handle\fP
.IP
You usually receive this message when a directory
you have successfully mounted
is removed from a server or is unexported.  As long as your machine
mounts a directory, it keeps the same file handle.
But if someone removes or unexports the directory from its server,
that file handle becomes invalid, or
\(lqstale.\(rq
.KE
.IP
Unmount the directory and try mounting it again.
.NH 4
\&When \&\fImount\fP Hangs Without an Error Message
.LP
The 
.I mount 
command hangs indefinitely if no 
.I nfsd 
daemons are running on the \s-2NFS\s0 server.
This happens when no 
.I /etc/exports 
file exists on the server when it is booted.
To clear the problem,
you need to:
.IP 1.
Become superuser on the \s-2NFS\s0 server, and
create the
.I /etc/exports 
file.
.IP 2.
Type

.DS
.ft CW
# \&\fBexportfs -a\fP
.DE

to send the information in
.I /etc/exports 
to the kernel
.IP 3.
Restart the
.I nfsd 
daemons by typing

.DS
.ft CW
# \&\fBnfsd 8\fP
.DE

.NH 3
\&Fixing Hung Programs
.LP 
If programs hang doing file\(enrelated work, your \s-2NFS\s0 server may be dead.
You may see the following:
.LP

.DS
.ft CW
\s-2NFS\s0 server \fIhostname\fP not responding, still trying
.DE

on your console.
The message indicates that
\s-2NFS\s0 server 
.I hostname
is down.
This indicates a problem with your \s-2NFS\s0 server or with the Ethernet.  
Programs can also hang if an \*(YP
server dies. 
.LP
If your machine hangs completely, check the server(s) from which you
have mounted file hierarchies.  
If one of them (or more) is down, do not 
be concerned.  When the
server comes back up, your programs continue automatically.
No files are destroyed.
.LP
If a soft mounted server dies, your work should not be affected.
Programs that time out trying to
access soft mounted remote files will fail with 
a message reported that they have timed out,
but you should still be able to access your other file
systems.
.LP
If all servers are running, ask someone else using the same
file servers as your machine if they are having trouble.
If more than one machine is having problems getting service, this
indicates a problem with the file server.
Log in to the file server.
Run
.I ps 
to see if
.I nfsd 
is running
and accumulating \s-2CPU\s0 time.
(This implies running
.I "ps -ax"
a few times, letting some time
pass between each call.)  If not, you may be able to kill and then
restart
.I nfsd .
If this does not work,
you will have to reboot the server.
..IX daemons nfsd "" "\&\fInfsd\fP"
..IX nfsd "" "\&\fInfsd\fP daemon"
.LP
If other systems seem to be up and running, check your Ethernet
connection and the connection of the server.
.
.NH 4
\&Fixing a Machine that Hangs Part Way Through Boot
.LP
If your machine boots up normally until it
tries to do remote mounts, probably one or more
servers is down, or your network connection is bad.
Try to reboot in single-user mode.
Then use the 
.I mount 
command to
manually mount each directory normally
mounted through the
.I /etc/fstab 
file.  See the previous two subsections for more help.
.
.NH 4
\&Speeding Up Slow Access Times
.LP
If access to remote files seems unusually slow, type:

.DS
.ft CW
# \&\fBps aux\fP
.DE

on the server to be sure that it is not being adversely affected 
by a runaway daemon, 
bad 
.I tty 
line, and so on.
If the server seems okay and others are
getting good response, make sure your 
.I biod 
daemons are running.
Try the following steps:
.IP 1.
Run

.DS
.ft CW
# \&\fBps ax | grep biod\fP
.DE

(at the client) and look for
.I biod 
daemons in the display.
To determine if the
.I biod s
are hung,
.I rcp 
a large file from a remote system, then run
.I ps 
as above again.
If the
.I biod s
do not accumulate any \s-2CPU\s0 time (as shown by the \s-2TIME\s0 column,) 
they are probably hung.
If they are not
running or are hung, continue with these steps.
.IP 2.
Kill these processes as follows:

.DS
.ft CW
# \&\fBkill -9\fP \fIpid1\ \ pid2\ \ pid3\ \ pid4\fP
.DE

.IP 3.
Restart them by typing:

.DS
.ft CW
# \&\fBbiod 4\fP
.DE

.LP
If the
.I biod s
are okay, check your Ethernet connection.  The
command 
.I "netstat -i"
introduced in the chapter
\fIThe SunOS Network Environment\fP,
tells you if you are dropping packets.
Also, you can use the commands
.I "nfsstat -c"
and 
.I "nfsstat -s
to tell if
the client or file server is doing a lot of retransmitting.  A
retransmission rate of 5 percent
is considered high.  Excessive retransmission
usually indicates a bad Ethernet board, a bad Ethernet tap, a mismatch
between board and tap, or a mismatch between your Ethernet board and
the server's board.  
.LP
..IX NFS troubleshooting "" "" PAGE END 
..IX troubleshooting "NFS problems" "" "" PAGE END 
.NH 2
\&Making the Network More Secure
..IX "network security" "" "" "" PAGE START 
..IX security NFS "" "and NFS" PAGE START
..IX "NFS security" "" "" "" PAGE START 
.LP
To obtain the maximum degree of security available
for remote mounts,
file hierarchies should be exported and mounted with the
.I secure 
option activated; this is possible only if the
\*(YP service is running.
Please consult the chapter on
\fIThe Network Information Service\fP
and the section
\fISecure NFS\fP
later in this chapter.
.NH 3
\&Allowing Root Access over the Network
.LP
Under \s-2NFS\s0, a server exports file hierarchies it owns, so that
clients can remotely mount them and users logged in on the
clients can access them transparently, as if they were local
to the client.
However, a user who becomes super user at a client
is denied root access to a remotely mounted file hierarchy.
When a person logged in as
.I root 
on one host requests access to a particular file from \s-2NFS\s0,
the user \s-2ID\s0 of the requester is changed to the user \s-2ID\s0 of
the user name
.I nobody 
..IX "user name" nobody "" "\&\fInobody\fP"
\(em generally
.I \&65534 .
The access rights of user \&\fInobody\fP are the same as those given
to the public for a particular file.
For example, if the public only has execute permission
for a file, then user
.I nobody 
can only execute that file.
.LP
When you export a file hierarchy,
you can permit
.I root 
on a particular machine to have
root access to that hierarchy
by specifying it in
.I /etc/exports 
on the server.  
For example, suppose you wanted 
.I root 
at machine samba (but no others) to have superuser access to the 
exported directory 
.I /usr/src .
You would enter the following line in
.I /etc/exports :

.DS
.ft CW
/usr/src	-root=samba
.DE

If you want more than one client to have root access, you can specify
a list, as follows:

.DS
.ft CW
/usr/src	-root=samba:raks:jazz
.DE

You can also enable superuser access for
processes with user \s-2ID\s0 0 on all clients, again using
the 
.I /etc/exports 
file. 
If you wanted to allow
superuser access
for all client processes with user \s-2ID\s0 0 accessing
.I /usr/src 
you would add the following line to
.I /etc/exports :

.DS
.ft CW
/usr/src	-anon=0
.DE

The 
.I anon 
is short for \(lqanonymous.\(rq
Anonymous requests, by default, get their user \s-2ID\s0
changed from its previous value (whatever it may be)
to 65534, the user \s-2ID\s0 of
.I nobody .
\s-2NFS\s0 servers label as anonymous any request from
a root user (someone whose current
effective user \s-2ID\s0 is 0) who is
not in the root list in
.I /etc/exports .
The above sample line in
.I /etc/exports 
tells the kernel to use the value 0
instead of 65534 for anonymous requests.
The result is
that all root users retain their user \s-2ID\s0 of 0.
Unfortunately, this has the side effect that
anonymous users are granted root access.
For obvious security reasons, you should weigh very
carefully whether to use the
.I root 
and 
.I anon 
options.
Finally, the following line in 
.I /etc/exports 
effectively prohibits anonymous access:

.DS
.ft CW
/usr/src	-anon=-1
.DE

.LP
See 
.I exports (5)
and 
.I exportfs (8)
for more information on exporting directories.
.LP
.NH 3
\&Privileged Ports
..IX "privileged ports"
..IX ports privileged
.LP
The SunOS operating system, and others whose networking
is derived from Berkeley \s-2UNIX\s0,
have some \s-2TCP\s0 and \s-2UDP\s0 source ports
to which only privileged users can attach.
These are known as 
.I "privileged ports" .
Currently, \s-2NFS\s0 does not check to see
if a client is bound to one of these.
That is, an \s-2NFS\s0 server has no way of knowing 
whether a client's file request
originated from the real client's kernel or from someone's user program.
If you get the following error message:

.DS
.ft CW
\s-2NFS\s0 request from unprivileged port
.DE

you should also see the \s-2IP\s0 address of the client on the console screen of the
server.  
You can turn on server port checking by making the following change:

.DS
.ft CW
# \&\fBadb -w /vmunix
nfs_portmon?W1\fP
_nfs_portmon: 0x0 = 		0x1
\&\fB<Control-D>\fP
.DE

.LP
The next time you boot your system, the source ports will be checked.
If you can trust all of the root users on your network,
then just doing the above is enough.
But be warned: most non-\s-2UNIX\s0 and some \s-2UNIX\s0
systems do not enforce the
privileged port convention (in particular, PCs with 3Com boards).
Another warning: all of a server's SunOS clients should be running software
release 3.0 or higher for this to work.
.LP
If you run C2 security in your network, the above is done
automatically on all the servers, in the lines in
.I /etc/rc.local 
that say:

.DS L
.ft CW
if [ -f /etc/security/passwd.adjunct ]; then
        # Warning! Turning on port checking may deny access to
        # older versions (pre-3.0) of \s-2NFS\s0 clients.
        rpc.mountd
        echo "nfs_portmon/W1" | adb -w /vmunix /dev/kmem >/dev/null 2>&1
else
        rpc.mountd -n
fi
.DE

.NH 3
\&The Lock Manager
..IX "Lock Manager"
.LP
Sun Release 4.1 supports a 
System V compatible record and file locking service.
The lock manager functionality applies to local record and file
locking as well as to record and file locking of remote 
file hierarchies on the network.  
File locking in accomplished with the 
.I lockf 
and 
.I fcntl 
functions.
The user, program, or
application can optionally invoke the service on a per-transaction,
or per-application basis.
Once a record is locked by one user or application, another user or
application trying to lock the same record will either (a) receive an
error message or (b) be placed in a queue and be appropriately notified
when the lock becomes available. 
.LP
The 
.I "Lock Manager"
implements a System V Interface Definition (\s-2SVID\s0)
compatible record and file locking service.  When multiple users
attempt to access the same record at the same time, only one will
have access and the rest will be locked out.
.NH 3
\&Synchronizing the time
..IX "synchronizing client-server time"
..IX server synchro "" "synchronizing time with client"
..IX client synchro "" "synchronizing time with server"
.LP
To prevent a client from having a totally different
notion of time than its server, diskless clients
coordinate their date with that of their server at
boot time through the following lines in 
.I /etc/rc.local :

.DS
.ft CW
if [ "$server" ]; then
        intr -a rdate $server
fi
.DE

The time a machine keeps, however,
is not absolute and depends on a variety of factors.
Sooner or later two machines whose date has been set
simultaneously will drift and display different
times.
To prevent a client from having a totally different
notion of time than its server, 
you may want to issue the command
..IX rdate "" "\&\fIrdate\fP \(em set system date from a remote host"
.I rdate 
periodically on the client, either
manually or through the client's
.I /usr/spool/cron/crontabs/root 
file.
.LP
Release 4.1 of the SunOS operating system does not supply
a mechanism for maintaining the same
date value across a network other than this command.
You should consider having all
machines obtain their date from a single server
at boot time and/or through daily invoking of 
.I rdate 
through the
.I crontab 
mechanism.
.EQ
delim $$
gsize 11
.EN
.NH 2
\&Secure \s-2NFS\s0
.LP
Although, as we have seen in this chapter, \s-2NFS\s0 is a 
powerful and convenient way for file sharing between
heterogeneous machine architectures and operating systems,
it is not without its shortcomings.
.NH 3
\&Security Shortcomings of \s-2NFS\s0
.LP
\s-2NFS\s0 servers authenticate a file request by authenticating the
machine making the request, but not the user. 
On \s-2NFS\s0-based file hierarchies that are exported to machines
where superuser access is not controlled,
it is a simple matter of running
.I su 
..IX su "NFS" "\&\fIsu\fP \(em become superuser" "and NFS"
..IX rlogin "NFS" "\&\fIrlogin\fP \(em remote login" "and NFS"
to impersonate the rightful owner of a file.
The familiar command
.I rlogin 
is subject to exactly the same attacks as \s-2NFS\s0
because it uses the same kind of authentication. 
.LP
Given
.I root 
access and a good knowledge of network programming,
anyone could be capable of injecting arbitrary data into the network,
and picking up any data from it.
However, on a local area network, no machine is capable of packet smashing \(en
capturing packets before they reach their destination, changing the contents, 
then sending packets back on their original course \(en
because packets reach all machines, including the server, at the same time.
..IX "network security" "packet smashing"
..IX security "packet smashing"
..IX "NFS security" "packet smashing"
Packet smashing is possible on a gateway, though,
so make sure you trust all gateways on the network.
The most dangerous attacks are those involving the injection of data,
such as impersonating a user by generating the right packets,
or recording conversations and replaying them later.
These attacks affect data integrity.
Attacks involving passive eavesdropping \(en
merely listening to network traffic without impersonating anybody \(en
are not as dangerous, since data integrity is not compromised.
Moreover, making sense of network traffic is not easy, and
users can protect the privacy of sensitive information
by encrypting data that goes over the network.
.LP
An easy solution to network security problems
is to leave the solution to each application.
A far better solution is to put authentication at the \s-2RPC\s0 level.
The result is a standard authentication system
that covers all \s-2RPC\s0-based applications,
such as \s-2NFS\s0 and \*(YP.
This system allows the authentication of users as well as machines.
The advantage of this is that it makes a network environment
more like a time\(hysharing environment.
Users can log in on any machine,
just as they could log in on any terminal. 
Their login password is their passport to network security.
No knowledge of the underlying authentication system is required.
The system is as secure and easy to use
as a time\(hysharing system. 
.LP
SunOS 4.1 includes an authentication system
that greatly improves the security of network environments.
The system is general enough to be used by other \s-2UNIX\s0 and non-\s-2UNIX\s0 systems.
The system uses \s-2DES\s0 encryption and public key cryptography
to authenticate both users and machines in the network. 
(\s-2DES\s0 stands for Data Encryption Standard.)
.LP
Public key cryptography is a cipher system that involves two keys:
one public and the other private.
The public key is published, while the private key is not;
the private (or secret) key is used to encrypt and decrypt data.
Sun's system differs from some other public key cryptography systems
in that the public and secret keys are used to generate a common key,
which is used in turn to create a \s-2DES\s0 key.
\s-2DES\s0 is relatively fast,
and, to make it even faster, optional Sun hardware is available
at present for most Sun computers.
.LP
In order to use this public key cryptography over the network,
you must also run \*(YP \(em see the chapter on
\fIThe Network Information Service\fP
\(em and you must install the Encryption
Kit (available only in the U.S.A.).
.LP
.NH 2
\&Administering Secure \s-2NFS\s0
..IX "administering secure \s-2NFS\s0"
..IX security administering
..IX "network security" administering
..IX "NFS security" administering
.LP
This section describes what the system administrator must do
in order to create a secure file hierarchy over \s-2NFS\s0.
First, the public and private keys must be generated for 
each user.
Then, file hierarchies must be exported secure, and mounted secure.
.IP 1.
The
.I publickey 
..IX "publickey" "" "\&\fIpublickey\fP database"
database contains three fields for each user:
.tr ~'

.DS
.ft CW
netname	 user's public key : user's secret key
.DE

.IP
where
.I "netname"
may be the name of a user or of a machine,
.I "user~s public key"
is that key in hexadecimal notation, and
.I "user~s secret key"
is that key encrypted with the user~s
password, also in hexadecimal notation.
If the netname is the name of a user, then the 
.I publickey 
entry takes the form \&\fIunix\fP.\&\fIuid\fP\^@\&\fIdomain\fP.
If it is the name of a machine, it takes the form
\&\fIunix\fP.\&\fIhost\fP\^@\&\fIdomain\fP.
.tr ~~
.IP
The corresponding \*(YP maps is available to \*(YP clients as
.I publickey.byname ,
but the database should reside on the \*(YP master server in the file
.I publickey 
in the directory
.I /etc 
(or similar).
.IP
The program 
.I newkey 
..IX newkey "" "\&\fInewkey\fP \(em create a key in \&\fIpublickey\fP database"
is provided to ease the task of updating the database.
Become superuser at the master
server and invoke
.I newkey 
for a given user:

.DS
.ft CW
# \&\fBnewkey -u \fIusername\fP
.DE

.IP
or for the superuser in a given host machine:

.DS
.ft CW
# \&\fBnewkey -h \fIhostname\fP
.DE

.IP
and at the prompt enter the appropriate login
password.
The program will then create a new public/secret key pair in
.I publickey ,
encrypted with the login password of the given user.
.\"Make sure
.\".L /etc/netid
.\"exists on the \*(YP master server.
As normally installed, the only user is
.I nobody .
.IP
Users can later on modify their own entries
by using the program 
.I chkey .
..IX chkey "" "\&\fIchkey\fP \(em change encryption key"
The user types:

.DS
.ft CW
% \&\fBchkey\fP
.DE

.IP
and then responds to prompts from the command.
A typical 
.I chkey 
session would look like this:

.DS
.ft CW
willow% \fBchkey\fP
Generating new key for \fIusername\fP
Password: \fIuser enters password\fP
Sending key change request to \fIserver\fP...
Done.
willow%
.DE

.IP
If there is an existing entry for 
.I nobody ,
users can use the 
.I chkey 
program to create their own entries.
The administrator can delete the entry for
.I nobody 
in the
.I publickey 
file on the \*(YP master server to prevent users from
creating new entries for themselves, 
but if they already have one they can still modify it.
.IP
Note that \*(YP takes time to propagate a new map,
so it's a good idea for users to run
.I chkey ,
or for the administrator to run
.I newkey ,
just before going home for the night.
.IP
Also note that in order for 
.I newkey 
and
.I chkey 
to be able to run properly, the daemon
.I rpc.ypupdated 
..IX ypupdated "" "\&\fIypupdated\fP daemon" "" 
..IX daemon ypupdated "" "\&\fIypupdated\fP daemon" "" 
must be running on the master server.
For more information, see 
\fIThe Network Information Service\fP.  
.LP
.IP 2.
Verify that the
.I keyserv 
..IX keyserv "" "\&\fIkeyserv\fP daemon"
..IX daemons keyserv "" "\&\fIkeyserv\fP"
and
.I ypbind 
daemons (which are normally started by
.I /etc/rc.local )
are still running.
.I keyserv 
performs public key encryption
and stores the private key (encrypted, of course) in
.I /etc/keystore :

.DS
.ft CW
% \&\fBps aux | grep keyserv\fP
root   61  0.0  0.0   56    0 ?  \s-2IW\s0   Dec 29  0:08 keyserv
.DE

When users log in with
.I login 
..IX login "" "\&\fIlogin\fP \(em log in to system"
..IX rlogin "" "\&\fIrlogin\fP \(em remote login"
or remote log in with
.I rlogin ,
these programs use the typed password to decrypt the secret key stored in
the
.I publickey.byname 
map.
This becomes the private key, and gets passed to the
.I keyserv 
daemon.
If users don't type a password for
.I login 
or
.I rlogin ,
either because their password field is empty
or because their machine is in the
.I hosts\fR.\fPequiv 
..IX "etc/hosts.equiv" "" "\&\fI/etc/hosts.equiv\fP"
file of the remote host,
they can still place a private key in
.I /etc/keystore 
by invoking the
.I keylogin 
..IX keylogin "" "\&\fIkeylogin\fP \(em decrypt and store secret key"
..IX keylogout "" "\&\fIkeylogout\fP \(em remove secret key"
program.
Before logging out, users can use the 
.I keylogout 
program to remove their private key.
Please refer to 
.I keylogin (1)
and 
.I keylogout (1)
in the
\fISunOS Reference Manual\fP.  
.LP
.IP 3.
To keep their secret key synchronized with their login
password, no user (except root) should have an entry in
the local 
.I /etc/passwd 
file; it is better to use the default
.I /etc/passwd 
as distributed with SunOS.
This way, when users invoke
.I passwd 
this command will behave like 
.I yppasswd 
(or 
.I "passwd -y"
and it will change the \*(YP database.
..IX yppasswd "" "\&\fIyppasswd\fP \(em change login password in NIS"
..IX passwd "" "\&\fIpasswd\fP \(em change password"
.LP
.IP 4.
When you reinstall, move, or upgrade a machine, save
.I /etc/keystore 
and
.I /etc/.rootkey 
(the latter file contains the private key for root)
along with everything else you normally save.
.IP
Note that if users use
.I login ,
.I rlogin ,
or
.I telnet 
to gain access
to another machine, are asked for their password, and type it correctly,
they have given away access to their own account.
This is because their secret key is now stored in
.I /etc/keystore 
on that remote machine.
This is only a concern if the remote machine is not trusted.
If this is the case,
users should never log in to a remote machine if it asks for their password,
or should make sure to use the
.I keylogout 
command just before logging out.
However, using
.I keylogout 
is also no guarantee that the secret key is actually destroyed \(en a
malicious superuser can install a fake version of 
.I login ,
.I keylogin ,
or
.I keylogout .
..IX keylogout "" "\&\fIkeylogout\fP \(em remove secret key"
Another alternative is for users to
use \s-2NFS\s0 to remote mount the files they are looking for.
.IP 5.
Edit the
.I /etc/exports 
..IX exports "" "\&\fI/etc/exports\fP file"
file and add the
.I -secure 
option for file hierarchies that should use \s-2DES\s0 authentication.
Here's how a server might export secure file hierarchies:

.DS
.ft CW
/usr/src	-secure,access=engineering
.DE

In this example,
.I engineering 
is the only network group with access to the
.I /usr/src 
file hierarchy.
.LP
.IP 6.
For each client machine, edit
.I /etc/fstab 
..IX fstab "" "\&\fIfstab\fP file"
(or have users edit their own files) to include
.I secure 
as a mount option on each secure file hierarchy.
Here's how a client might mount secure file hierarchies:

.DS
.ft CW
\&\fIserver\fP:/usr/src /usr/src nfs rw,secure,intr,bg 0 0
.DE

In this example, the
.I /usr/src 
file hierarchy from server \&\fIserver\fP
is mounted hard, read/write, and secure.
If a client machine does not mount a secure file hierarchy as
.I secure ,
everything works \s-2OK\s0, except that users have access as
.I nobody 
(user \s-2ID\s0 65534), rather than as themselves.
.LP
.LP
The remainder of this chapter discusses the theory of secure networking,
and is useful as a background for both users and administrators.
.LP
.NH 2
\&\s-2RPC\s0 Authentication
..IX RPC authentication 
..IX authentication RPC
.LP
Secure \s-2RPC\s0 is at the core of secure \s-2NFS\s0.
To understand the big picture,
it's necessary to understand how authentication works in \s-2RPC\s0.
\s-2RPC\s0's authentication is open-ended: 
a variety of authentication systems may be plugged into it
and may coexist on the network.
Currently there are two: \s-2UNIX\s0 and \s-2DES\s0. 
\s-2UNIX\s0 authentication is the older, weaker system;
\s-2DES\s0 authentication is the new system discussed in this chapter.
.LP
Two terms are important for any \s-2RPC\s0 authentication system:
.I credentials
and
.I verifiers .
Using \s-2ID\s0 badges as an example, the credential is what identifies a person:
a name, address, birth date, etc.
The verifier is the photo attached to the badge:
you can be sure the badge has not been stolen by checking the photo 
on the badge against the person carrying it.
In \s-2RPC\s0, things are similar.
The client process sends both a credential and a verifier 
to the server with each \s-2RPC\s0 request.
The server sends back only a verifier,
since the client already knows the server's credentials.
.LP
.NH 3
\&\s-2UNIX\s0 Authentication
..IX UNIX authentication 
..IX authentication UNIX
.LP
In \s-2UNIX\s0 authentication
the credentials contain the client's machine-name, 
user \s-2ID\s0, group \s-2ID\s0,
and group-access-list.
The verifier, on the other, contains \fBnothing\fP!
There are two problems with this system.
The glaring problem is the empty verifier,
which makes it easy to cook up the right credential using
.I hostname 
..IX hostname "" "\&\fIhostname\fP \(em display host name"
and
.I su .
..IX su "" "\&\fIsu\fP \(em become superuser"
If you trust all root users in the network, this is not really a problem.
But many networks are not this secure.
The \s-2NFS\s0 tries to combat deficiencies in \s-2UNIX\s0 authentication 
by checking the source Internet address of
.I mount 
requests as a verifier of the
.I hostname 
field, and accepting requests only from privileged Internet ports.
Still, it is not difficult to circumvent these measures, 
and \s-2NFS\s0 really has no way to verify the user-\s-2ID\s0.
.LP
The other problem with \s-2UNIX\s0 authentication appears in the name \s-2UNIX\s0.
It is unrealistic to assume that all machines on a network
will be \s-2UNIX\s0 machines.
The \s-2NFS\s0 works with
machines running other operating systems,
but \s-2UNIX\s0 authentication breaks down when applied to them.
For instance, \s-2MS\s0-\s-2DOS\s0\(rg doesn't even have a notion 
of different user \s-2ID\s0s.
.LP
Given these shortcomings,
it is clear what is needed in a different authentication system:
operating system independent credentials, and secure verifiers.
This is the essence of \s-2DES\s0 authentication discussed below.
.LP
.NH 3
\&\s-2DES\s0 Authentication
..IX DES authentication "" 
..IX authentication DES
.LP
The security of \s-2DES\s0 authentication is based on
a sender's ability to encrypt the current time,
which the receiver can then decrypt and check against its own clock.
The timestamp is encrypted with \s-2DES\s0.
Two things are necessary for this scheme to work:
1) the two agents must agree on what the current time is, and
2) the sender and receiver must be using the same encryption key.
.LP
If a network has time synchronization (Berkeley's \s-2TEMPO\s0 for example), 
then client/server time synchronization is performed automatically.
However, if this is not available,
timestamps can be computed using the server's time instead of network time.
In order to do this, the client asks the server what time it is,
before starting the \s-2RPC\s0 session,
then computes the time difference between its own clock and the server's.
This difference is used to offset the client's clock when computing timestamps.
If the client and server clocks get out of sync
to the point where the server begins rejecting the client's requests,
the \s-2DES\s0 authentication system resynchronizes with the server.
.LP
Here is how the client and server arrive at the same encryption key.
When a client wishes to talk to a server, it generates at random 
a key to be used for encrypting the timestamps (among other things). 
This key is known as the
.I "conversation key, \s-2CK\s0."
The client encrypts the conversation key using a public key scheme,
and sends it to the server in its first transaction.
This key is the only thing that is ever encrypted with public key cryptography.
The particular scheme used is described further on in this chapter.
For now, suffice to say that for any two agents A and B,
there is a \s-2DES\s0 key $K sub AB$ that only A and B can deduce.
This key is known as the
.I "common key,"
$K sub AB$.
.sp
.EQ
gsize 10
.EN
.ne 2i
.LP
.ce 1
Figure: \s-2DES\s0 Authentication Protocol
.in 0
.DS L
.PS
.in +.7i
circlerad=.4
boxht=.2
boxwid=1.3
circle "\s+9A\s-9" "(client)" at 0,1.2
circle "\s+9B\s-9" "(server)" at 5.1,1.2
line invis at .5,2 ; box invis "\fBCredential\fP"; line invis;
	box invis "\fBVerifier\fP"
arrow at .5,1.7; box "$A, K sub AB (CK), CK(win)$"; arrow;
	box "$CK(t sub 1 ), CK(win + 1)$"; arrow
arrow <- at .5,1.4; line right 1.3; line;
	box "$CK(t sub 1 - 1), ID$"; arrow <-
arrow at .5,1; box "ID"; arrow;
	box "$CK(t sub 2 )$"; arrow
arrow <- at .5,.7; line right 1.3; line;
	box "$CK(t sub 2 - 1), ID$"; arrow <-
arrow at .5,.3; box "ID"; arrow;
	box "$CK(t sub n )$"; arrow
arrow <- at .5,0; line right 1.3; line;
	box "$CK(t sub n - 1), ID$"; arrow <-
.PE
.DE
.EQ
gsize 11
.EN
.sp
.in 0
.LP
The figure above illustrates the authentication protocol in more detail, 
describing client A talking to server B. 
A term of the form $K(x)$ means $x$ encrypted with the \s-2DES\s0 key $K$.
Examining the figure, you can see that for its first request,
the client's credential contains three things: 
its name $A$, the conversation key $CK$ encrypted with the common key 
$K sub AB$, and a thing called $win$ (window) encrypted with $CK$.
What the window says to the server, in effect, is this:
.LP
.I
I will be sending you many credentials in the future,
but there may be crackers sending them too,
trying to impersonate me with bogus timestamps.
When you receive a timestamp, check to see if your current time
is somewhere between the timestamp and the timestamp plus the window.
If it's not, please reject the credential. 
.LP
For secure \s-2NFS\s0 file hierarchies, 
the window currently defaults to 60 minutes.
The client's verifier in the first request contains the encrypted timestamp
and an encrypted verifier of the specified window, $win + 1$. 
The reason this exists is the following.
Suppose somebody wanted to impersonate A by writing a program
that instead of filling in the encrypted fields of the credential and verifier,
just stuffs in random bits.
The server will decrypt \s-2CK\s0 into some random \s-2DES\s0 key,
and use it to decrypt the window and the timestamp.
These will just end up as random numbers.
After a few thousand trials, there is a good chance
that the random window/timestamp pair will pass the authentication system.
The window verifier makes guessing the right credential much more difficult.
.LP
After authenticating the client,
the server stores four things into a credential table:
the client's name A, the conversation key $CK$, the window, and the timestamp.
The reason the server stores the first three things should be clear:
it needs them for future use.
The reason for storing the timestamp is to protect against replays:
the server will only accept timestamps
that are chronologically greater than the last one seen,
so any replayed transactions are guaranteed to be rejected.
The server returns to the client in its verifier an index \s-2ID\s0
into its credential table, plus the client's timestamp minus one,
encrypted by $CK$.
The client knows that only the server could have sent such a verifier,
since only the server knows what timestamp the client sent.
The reason for subtracting one from it is to insure that it is invalid
and cannot be reused as a client verifier.
.LP
The first transaction is rather complicated,
but after this things go very smoothly.
The client just sends its \s-2ID\s0 and an encrypted timestamp to the server,
and the server sends back the client's timestamp minus one,
encrypted by $CK$.
.LP
.NH 3
\&Public Key Encryption
..IX encryption "public key"
..IX security encryption
..IX "NFS security" encryption
..IX "network security" encryption
..IX "public key encryption"
.LP
The particular public key encryption scheme Sun uses
is the Diffie-Hellman method.
The way this algorithm works is to generate a
.I "secret key"
$SK sub A$ at random
and compute a
.I "public key"
$PK sub A$ using the following formula
($PK$ and $SK$ are 128 bit numbers and \(*a is a well-known constant):
.EQ
PK sub A ~ = ~ alpha sup {SK sub A}
.EN
Public key $PK sub A$ is stored in a public directory,
but secret key $SK sub A$ is kept private.
Next, $PK sub B$ is generated from $SK sub B$ in the same manner as above.
Now common key $K sub AB$ can be derived as follows:
.EQ
K sub AB ~ = ~ PK sub B sup {SK sub A} ~ = ~
( alpha sup {SK sub B} ) sup {SK sub A} ~ = ~
alpha sup {( SK sub A SK sub B )}
.EN
Without knowing the client's secret key,
the server can calculate the same common key $K sub AB$
in a different way, as follows:
.EQ
K sub AB ~ = ~ PK sub A sup {SK sub B} ~ = ~
( alpha sup {SK sub A} ) sup {SK sub B} ~ = ~
alpha sup {( SK sub A SK sub B )}
.EN
Notice that nobody else but the server and client can calculate $K sub AB$,
since doing so requires knowing either one secret key or the other.
All of this arithmetic is actually computed modulo $M$,
which is another well-known constant.
It would seem at first that somebody could guess your secret key
by taking the logarithm of your public one, 
but $M$ is so large that this is a computationally infeasible task.
To be secure, $K sub AB$ has too many bits to be used as a \s-2DES\s0 key,
so 56 bits are extracted from it to form the \s-2DES\s0 key.
.LP
Both the public and the secret keys
are stored indexed by netname in the \*(YP map
.I publickey.byname ;
the secret key is \s-2DES\s0-encrypted with the user's login password.
When a user logs in to a machine, the
.I login 
program decrypts the encrypted secret key with the login password,
and gives it to a secure local keyserver to save
for use in future \s-2RPC\s0 transactions.
(This is what
.I keylogin 
does also).
Note that ordinary users do not have to be aware of 
their public and secret keys.
In addition to changing a user's login password, the
.I yppasswd 
program
..IX yppasswd "" "\&\fIyppasswd\fP \(em change login password in NIS"
(or
.I passwd 
if the user does not have an entry in the local 
.I /etc/passwd ,
or
.I "passwd -y"
randomly generates a new public/secret key pair as well.
.LP
The keyserver
.I keyserv (8c)
..IX keyserv "" "\&\fIkeyserv\fP daemon"
..IX daemons keyserv "" "\&\fIkeyserv\fP"
is an \s-2RPC\s0 service local to each machine
that performs all of the public key operations,
of which there are only three.  They are:

.DS
.ft CW
setsecretkey(secretkey)
encryptsessionkey(servername, des_key)
decryptsessionkey(clientname, des_key)
.DE

.I setsecretkey() 
..IX setsecretkey() "" "\&\fIsetsecretkey()\fP \(em store secret key"
tells the keyserver to store away the users' 
secret key $SK sub A$ for future use;
it is normally called by
.I login .
The client program calls
.I encryptsessionkey() 
..IX encryptsessionkey() "" "\&\fIencryptsessionkey()\fP \(em encrypt session"
to generate the encrypted conversation key
that is passed in the first \s-2RPC\s0 transaction to a server.
The keyserver looks up
.I servername 's
public key and combines it with the client's secret key (set up by a previous
.I setsecretkey() 
..IX setsecretkey() "" "\&\fIsetsecretkey()\fP \(em set secret key"
call) to generate the key that encrypts
.I des_key .
The server asks the keyserver to decrypt the conversation key by calling
.I decryptsessionkey() .
..IX decryptsessionkey() "" "\&\fIdecryptsessionkey()\fP \(em decrypt session key"
.LP
Note that implicit in these procedures is the name of caller,
who must be authenticated in some manner.
The keyserver cannot use \s-2DES\s0 authentication to do this,
since it would create a deadlock. 
The keyserver solves this problem by storing the secret keys by
user \s-2ID\s0,
and only granting requests to local root processes.
The client process then executes a
.I setuid 
process, owned by root, which makes the request on the part of the client,
telling the keyserver the real
user \s-2ID\s0
of the client.  Ideally, the three operations described above
would be system calls, and the kernel would talk to the keyserver directly,
instead of executing the
.I setuid 
program.
.LP
.NH 3
\&Naming of Network Entities
..IX authentication naming "" "and naming network entities"
..IX network "authentication and naming"
.LP
The old \s-2UNIX\s0 authentication system has a few problems when it comes to naming.
Recall that with \s-2UNIX\s0 authentication,
the name of a network entity is basically the
user \s-2ID\s0.
These
user \s-2ID\s0s
are assigned per \*(YP naming domain,
which typically spans several machines.
We have already stated one problem with this system,
that it is too \s-2UNIX\s0 system oriented, 
but there are two other problems as well.
One is the problem of
user \s-2ID\s0
clashes when domains are linked together.
The other problem is that the super-user (with
user \s-2ID\s0
of 0) should not be assigned on a per-domain basis, 
but rather on a per-machine basis.
By default, \s-2NFS\s0 deals with this latter problem in a severe manner:
it does not allow root access across the network by
user \s-2ID\s0
0 at all.
.LP
\s-2DES\s0 authentication corrects these problems
by basing naming upon new names called
.I netnames .
Simply put, a netname is just a string of printable characters,
and fundamentally, it is really these netnames that are authenticated.
The public and secret keys are stored on a per-netname,
rather than per-username, basis.
The \*(YP map
.I netid.byname 
..IX netid.byname "" "\&\fInetid.byname\fP map"
..IX "NIS maps" netid.byname "" "\&\fInetid.byname\fP" 
maps the netname into a local
user \s-2ID\s0, group \s-2ID\s0,
and group-access-list, 
though non-Sun environments may map the netname into something else.
.LP
The Internet naming problem is solved by choosing globally unique netnames.
This is far easier than choosing globally unique user \s-2ID\s0s.
In the Sun environment, user names are unique within each \*(YP domain.
Netnames are assigned by concatenating the operating system and user \s-2ID\s0
with the \*(YP and Internet domain names.
For example, a \s-2UNIX\s0 system user with a user \s-2ID\s0 of 508 in the domain
.I eng.sun.\s-2COM\s0 
would be assigned the following netname:
.I unix.508@eng.sun.\s-2COM\s0 .
A good convention for naming domains is to append 
the Internet domain name (\s-2COM\s0, \s-2EDU\s0, \s-2GOV\s0, \s-2MIL\s0) to the local domain name.
Thus, the \*(YP domain
.I eng 
within the Internet domain
.I sun.\s-2COM\s0 
becomes
.I eng.sun.\s-2COM\s0 .
.LP
The problem of multiple super-users per domain is solved
by assigning netnames to machines as well as to users.
A machine's netname is formed much like a user's.
For example, a \s-2UNIX\s0 machine named
.I hal 
in the same domain as before has the netname
.I unix.hal@eng.sun.\s-2COM\s0 .
Proper authentication of machines is very important for diskless machines
that need full access to their home directories over the net.
.LP
Non-Sun environments will have other ways of generating netnames, 
but this does not preclude them from accessing
the secure network services of the Sun environment.
To authenticate users from any remote domain,
all that has to be done is make entries for them in two \*(YP databases.
One is an entry for their public and secret keys, 
(in the 
.I publickey.byname 
map)
the other is for their local
user \s-2ID\s0
and group-access-list mapping
(in the 
.I netid.byname 
map).
Upon doing this, users in the remote domain
will be able to access all of the local network services,
such as \s-2NFS\s0 and remote logins.
.LP
.NH 3
\&Applications of \s-2DES\s0 Authentication
..IX authentication "DES applications"
.LP
The first application of \s-2DES\s0 authentication
is a generalized \*(YP update service. 
This service allows users to update private fields in \*(YP databases.
So far only the \*(YP map
.I publickey 
..IX "NIS maps" publickey "" \&\fIpublickey\fP
..IX publickey "" "\&\fIpublickey\fP database"
employs the \s-2DES\s0-based update service.
.\"Before the advent of an update service for mail aliases,
.\"Sun had to hire a full-time person just to update mail aliases.
.LP
The second application of \s-2DES\s0 authentication is the most important: 
a more secure Network File System.
There are three security problems with the 
old \s-2NFS\s0 using \s-2UNIX\s0 authentication.
The first is that verification of credentials occurs only at mount time
when the client gets from the server a piece of information
that is its key to all further requests: the
.I "file handle" .
Security can be broken if one can figure out a file handle
without contacting the server, perhaps by tapping into the net or by guessing.
After an \s-2NFS\s0 file hierarchy has been mounted,
there is no checking of credentials during file requests,
which brings up the second problem.
If a file hierarchy has been mounted from a server that serves multiple clients
(as is typically the case), there is no protection
against someone who has root permission on their machine using
.I su 
(or some other means of changing
user \s-2ID\s0)
gaining unauthorized access to other people's files.
The third problem with \s-2NFS\s0 is the severe method it uses to circumvent
the problem of not being able to authenticate remote client super-users: 
denying them super-user access altogether. 
.LP
The new authentication system corrects all of these problems. 
Guessing file handles is no longer a problem since in order to gain 
unauthorized access, the miscreant would also have to guess the right 
encrypted timestamp to place in the credential,
which is a virtually impossible task.
The problem of authenticating root users is solved,
since the new system can authenticate machines.
At this point, however,
secure \s-2NFS\s0 is not used for root file systems.
Root users of nonsecure file hierarchies are identified by \s-2IP\s0 address.
.LP
Actually, the level of security associated with each file hierarchy
may be altered by the administrator.  The file
.I /etc/exports 
..IX exports "" "\&\fI/etc/exports\fP file"
contains a list of file hierarchies and which machines may mount them. 
By default, file hierarchies are exported with \s-2UNIX\s0 authentication,
but the administrator can have them exported with \s-2DES\s0 authentication
by specifying
.I -secure 
on any entry in the
.I /etc/exports 
file.  Associated with \s-2DES\s0 authentication is a parameter:
the maximum window size that the server is willing to accept.
.LP
.NH 3
\&Security Issues Remaining
.LP
There are several ways to break \s-2DES\s0 authentication, but using
..IX authentication break "" "and break-ins"
.I su 
is not one of them.  In order to be authenticated,
a user's secret key must be stored by the user's workstation.
This usually occurs when the user logins, with the
.I login 
program decrypting the secret key with the login password,
and storing it away for the user.
If somebody tries to use
.I su 
to impersonate the user, it won't work,
because they won't be able to decrypt the secret key.  Editing
.I /etc/passwd 
isn't going to help them either, because what they need to edit, 
the encrypted secret key, is stored in the \*(YP database.
If you log into somebody else's workstation and type in your password,
then your secret key would be stored in their workstation and they could use
.I su 
to impersonate you.  But this is not a problem since you should not
be giving away your password to a machine you don't trust anyway. 
Someone on that machine could just as easily change
.I login 
to save all the passwords it sees into a file. 
This applies to 
.I keylogin 
too.
..IX su "" "\&\fIsu\fP \(em become superuser"
..IX login "" "\&\fIlogin\fP \(em log in to system"
..IX keylogin "" "\&\fIkeylogin\fP \(em decrypt and store secret key"
.LP
Not having
.I su 
to employ any more, how can nefarious users impersonate others now?
Probably the easiest way is to guess somebody's password,
since most people don't choose very secure passwords.
No ready\(hymade protection can be offered agains this;
it's up to each user to choose a secure password.
.LP
The next best attack would be to attempt replays.
For example, let's say user
.B A
has been squirreling away
all of user
.B B 's
\s-2NFS\s0 transactions with a particular server.
As long as the server remains up,
user
.B A
won't succeed by replaying them since the server always demands timestamps
that are greater than the previous ones seen.
But suppose user
.B A 
goes and pull the plug on user
.B B 's 
server, causing it to crash.
As it reboots, its credential table will be clean,
so it has lost all track of previously seen timestamps,
and now user
.B A 
is free to replay user
.B B 's 
transactions.
There are few things to be said about this.
First of all, servers should be kept in a secure place
so that no one can go and pull the plug on them.
But even if they are physically secure,
servers occasionally crash without any help.
Replaying transactions is not a very big security problem,
but even so, there is protection against it.
If a client specifies a window size that is smaller than the time it takes
a server to reboot (5 to 10 minutes), the server will reject
any replayed transactions because they will have expired.
.LP
To specify a window size other than the default, you have to modify
the kernel with
.I adb :
.EQ
delim off
.EN

.DS
.ft CW
# \&\fBadb -w /vmunix -\fP
\&\fBauthdes_win?D\fP
_authdes_win:
_authdes_win:   3600
\&\fB?W0t300\fP
_authdes_win:   0xe10           =       0x12c
\&\fBauthdes_win?D\fP 
_authdes_win:
_authdes_win:   300
\&\fB$q\fP
#
.DE

.EQ
delim $$
.EN
In the above example, the superuser has changed the default
window size from 3600 seconds (one hour) to 300 seconds (five minutes).
Remember that if you were to reconfigure the kernel you would have
to use
.I adb 
again.
.LP
There are other ways to break \s-2DES\s0 authentication, 
but they are much more difficult.
These methods involve breaking the \s-2DES\s0 key itself,
or computing the logarithm of the public key.
Generally, these methods are unfeasible for most crackers,
although it is important to realize that any lock can
be picked with a big enough hammer.
What secure \s-2NFS\s0 provides is as secure as any good
time\(hysharing system.
.LP
There is another security issue that \s-2DES\s0 authentication does not address, 
and that is tapping of the net.
Even with \s-2DES\s0 authentication in place, 
there is no protection against somebody watching what goes across the net.
There is no way in software to prevent unauthorized eavesdropping.
.\"This is not a big problem for most things,
.\"such as \s-2NFS\s0, since very few files are not publically readable, and besides,
.\"trying to make sense of all the bits flying over the net is not a trivial task.
.\"For logins, this is a bit of a problem because you wouldn't 
.\"want somebody to pick up your password over the net.
.\"As we mentioned before,
.\"a side effect of the authentication system is a key exchange, 
.\"so that the network tapping problem can be tackled on a per-application basis.
.LP
.NH 3
\&Performance
..IX "authentication" "performance"
..IX encryption performance
.LP
Public key systems are known to be slow,
but there is not much actual public key encryption going on in this system.
Public key encryption only occurs during the first transaction with a service,
and even then, there is caching that speeds things up considerably.
The first time a client program contacts a server,
both it and the server will have to calculate the common key.
The time it takes to compute the common key is basically the time it takes
to compute an exponential modulo $M$.
On a Sun-3 using a 192-bit modulus, this takes roughly 1 second, 
which means it takes 2 seconds just to get things started,
since both client and server have to perform this operation.
This is a long time,
but you have to wait only the first time you contact a machine.
Since the keyserver caches the results of previous computations, 
it does not have to recompute the exponential every time.
.LP
The most important service in terms of performance is secure \s-2NFS\s0,
which is acceptably fast.
The extra overhead that \s-2DES\s0 authentication requires versus \s-2UNIX\s0 authentication 
is the encryption.
A timestamp is a 64-bit quantity,
which also happens to be the \s-2DES\s0 block size.
Four encryption operations take place in an average \s-2RPC\s0 transaction:
the client encrypts the request timestamp, the server decrypts it,
the server encrypts the reply timestamp, and the client decrypts it.
On a Sun-3, the time it takes to encrypt one block is about
half a millisecond if performed by hardware,
and 1.2 milliseconds if performed by software.
So, the extra time added to the round trip time is about 
2 milliseconds for hardware encryption and 5 for software.
The round trip time for the average \s-2NFS\s0 request is about 20 milliseconds,
resulting in a performance hit of 10 percent if one has encryption hardware, 
and 25 percent if not.
Remember that is the impact on network performance.
The fact is that not all file operations go over the wire,
so the impact on total system performance will actually be lower than this.
It is also important to remember that security is optional, 
so environments that require higher performance can turn it off.
.LP
.NH 3
\&Problems with Booting and \&\fIsetuid\fP Programs
..IX booting setuid "" "and \&\fIsetuid\fP"
..IX booting "troubleshooting problems with"
..IX troubleshooting "booting problems"
.LP
Consider the problem of a machine rebooting,
say after a power failure at some strange hour when nobody is around.
All of the secret keys that were stored get wiped out,
and now no process is able to access secure network services,
such as mounting an \s-2NFS\s0 file hierarchy.
The important processes at this time are usually root processes,
so things would work \s-2OK\s0 if root's secret key were stored away, 
but nobody is around to type the password that decrypts it.
The solution to this problem is to store root's decrypted secret key in a file,
which the keyserver can read.
This works well for diskful machines that can store the secret key
on a physically secure local disk,
but not so well for diskless machines,
whose secret key must be stored across the network.
If someone taps the net when a diskless machine is booting,
they will find the decrypted key.
This is not very easy to accomplish, though.
.LP
Another booting problem is the single-user boot.
..IX booting "single-user" "" "in single-user mode"
There is a mode of booting known as single-user mode, where a
.I root 
login shell appears on the console.
The problem here is that a password is not required for this. 
With C2 security installed,
a password is required in order to boot single-user.
Without C2 security installed,
machines can still be booted single-user without a password,
as long as the entry for
.I console 
in the
.I /etc/ttytab 
..IX "ttytab" "" "\&\fI/etc/ttytab\fP file"
file is labeled as physically
.I secure 
(this is the default).
If the console is not physically secure, and you have security
considerations, you should change the entry (and make sure you
remember root's password).
For more details, see the chapters
\fIAdministering Security\fP
and
\fIAdministering C2 Security\fP.  
.LP
..IX booting diskless "" "and diskless machines"
Yet another problem is that diskless machine booting is not totally secure.
It is possible for somebody to impersonate the boot-server,
and boot a devious kernel that, for example, 
makes a record of a user's secret key on a remote machine.
The problem is that the secure \s-2RPC\s0 
system is set up to provide protection
only after the kernel and the keyserver are running.
Before that, there is no way to authenticate
the replies given by the boot server.
This is not considered a serious problem,
because it is highly unlikely that somebody would be able to write
this compromised kernel without source code.
Also, the crime is not without evidence.
If you polled the net for boot-servers, 
you would discover the devious boot-server's location.
In any case, if you do not trust the network, you should boot from
a local disk.
.LP
Not all
.I setuid 
programs will behave as they should.
For example, if a 
.I setuid 
program is owned by
.I dave ,
who has not logged into the machine since it booted,
then the program will not be able to access any secure network services as
.I dave .
The good news is that most
.I setuid 
programs are owned by root, 
and since root's secret key is always stored at boot time, 
these programs will behave as they always have.
.LP
.NH 3
\&Conclusion
..IX "network security" "summary"
..IX "NFS security" "summary"
..IX security "summary of network"
.LP
\s-2DES\s0 authentication satisfies the requirement of a networking
environment as secure as a time-shared system.
The way a user is authenticated in a time-sharing system
is by knowing the password.
With \s-2DES\s0 authentication, the same is true.
In time-sharing the trusted person is the system administrator,
who has an ethical obligation
not to change a password in order to impersonate someone.
In secure \s-2RPC\s0, the network administrator is trusted
not to alter entries in the public key database.
In one sense, this system is even more secure than time-sharing,
because it is useless to place a tap on the network
in hopes of catching a password or encryption key, 
since these are encrypted.
Most time-sharing environments do not encrypt data emanating from the terminal;
users must trust that nobody is tapping their terminal lines.
.LP
\s-2DES\s0 authentication is perhaps not the ultimate authentication system. 
.\"In the future it is likely there will be sufficient advances 
.\"in algorithms and hardware to render the public key system
.\"as we have defined it useless.
But at least \s-2DES\s0 authentication offers a smooth migration path for the future.
Syntactically speaking,
nothing in the protocol requires the encryption of the conversation 
key to be Diffie-Hellman, or even public key encryption in general. 
To make the authentication stronger in the future,
all that needs to be done is to strengthen the way
the conversation key is encrypted. 
Semantically, this will be a different protocol,
but the beauty of \s-2RPC\s0 is that it can be plugged in
and live peacefully with any authentication system.
.LP
For the present at least, \s-2DES\s0 authentication satisfies our requirements
for a secure networking environment.
From it we built a system secure enough for use in unfriendly networks,
such as a student-run university workstation environment.
The price for this security is not high.
Nobody has to carry around a magnetic card or remember
any hundred digit numbers.
You use your login password to authenticate yourself, just as before.
There is a small impact on performance,
but if this worries you and you have a friendly net,
you can turn authentication off.
.LP
.NH 2
\&Secure \s-2NFS\s0 References
..IX security bibliography
..IX "network security" bibliography
..IX "NFS security" bibliography
.LP
Diffie and Hellman, ``New Directions in Cryptography,''
\fI\s-2IEEE\s0 Transactions on Information Theory \s-2IT\s0-22,\fP
November 1976.
.LP
Gusella & Zatti, ``\s-2TEMPO\s0: A Network Time Controller
for a Distributed Berkeley \s-2UNIX\s0 System,''
\fI\s-2USENIX\s0 1984 Summer Conference Proceedings,\fP
June 1984.
.LP
National Bureau of Standards, ``Data Encryption Standard,''
\fIFederal Information Processing Standards Publication 46,\fP
January 15, 1977.
.LP
Needham & Schroeder, ``Using Encryption for Authentication
in Large Networks of Computers,''
\fIXerox Corporation \s-2CSL\s0-78-4,\fP
September 1978.
.EQ
delim off
.EN
..IX "network security" "" "" "" PAGE END 
..IX security NFS "" "and NFS" PAGE END 
..IX "NFS security" "" "" "" PAGE END
..IX NFS "administering" "" "" PAGE END
