.ds YP \s-2NIS\s0
.if \n(1T .bp
.NH 1
\&Using the \s-2NFS\s0 Automounter
.LP
.NH 2
\&The Automounter
.LP
The chapter \fIThe Sun Network File System Service\fP
explains how to export and mount file hierarchies through \s-2NFS\s0 with
the
.I mount 
command.
You can also \s-2NFS\s0 mount file hierarchies 
using a different method\(emautomounting.
The
..IX automount "" "\&\fIautomount\fP" "" PAGE START
.I automount 
program enables
users to mount and unmount remote directories on
an as-needed basis.
Whenever a user on a client machine running
the automounter invokes a command that needs
to access a remote file or directory, such as opening
a file with an editor,
the hierarchy to which that file or directory belongs
is mounted and remains mounted for as long
as it is needed. 
And whenever a certain amount of time
has elapsed without the hierarchy being accessed,
it is automatically unmounted.
No mounting is done at boot\(hytime,
and the user no longer has to know the superuser
password to mount a directory
or even use the
.I mount 
and
.I umount 
commands.
It is all done automatically and transparently.
.LP
Mounting some file hierarchies with
.I automount 
does not exclude the possibility of mounting
others with
.I mount .
A diskless machine
..IX automount "diskless client" "\&\fIautomount\fP" "and diskless clients" 
..IX "diskless client" "and automount" "" "and \&\fIautomount\fP"
.I must
mount 
.I "/" ,
.I "/usr" 
and 
.I "/usr/kvm" 
through the
.I mount 
command and the
.I /etc/fstab 
file.
In all cases, the automounter should not be used to mount
.I /usr/share .
.LP
This chapter explains how the automounter works,
how to write the files (maps) the automounter uses, how to
invoke it, and what are the error messages related to it.
This chapter assumes that you have read 
\fIThe Sun Network File System Service\fP.  
.NH 3
\&How the Automounter Works
.LP
Unlike 
.I mount ,
..IX automount "mount" "\&\fIautomount\fP" "vs. \&\fImount\fP"
.I automount 
does not consult the file
.I /etc/fstab 
for a list of hierarchies to mount.
Rather, it consults a series of maps, which can be either
direct or indirect.
The names of the maps can be passed to 
.I automount 
from the command line, or from another (master) map.
This is explained later, in the section
\fIPreparing the Maps\fP.  
.LP
The following is a simplified bird's eye view of
how the automounter works:
.LP
When 
.I automount 
..IX automount synopsis \&\fIautomount\fP
is started, either from the command line or from
.I rc.local ,
it forks a daemon to serve the mount points 
specified in the maps and makes
the kernel believe that the mount has taken place.
The daemon sleeps until a request is made to access
the corresponding file hierarchy.
At that time the daemon does the following:
.IP \(bu
Intercepts the request
.IP \(bu
Mounts the remote file hierarchy
.IP \(bu
Creates a symbolic link between
the requested mount point and the actual mount
point under 
.I /tmp_mnt .
.IP \(bu
Passes the symbolic link to the kernel, and steps
aside.
.IP \(bu
Unmounts the file hierarchy
when a predetermined amount of time has passed
with the link not being touched (generally five
minutes),
and resumes its previous position.
.LP
The automounter mounts everything under the directory
..IX "tmp_mnt" "" "\&\fItmp_mnt\fP, special directory"
.I /tmp_mnt ,
and provides a symbolic link from the requested mount point
..IX automount "and symbolic links" "\&\fIautomount\fP" 
to the actual mount point under 
.I /tmp_mnt .
For instance, if a user wants to mount a remote directory
.I src 
under
.I /usr/src ,
the actual mount point will be 
.I /tmp_mnt/usr/src ,
and 
.I /usr/src 
will be a symbolic link to that location.
Note that, as with any other kind of mount, a mount affected
through the automounter on a non\(hyempty mount point will hide
the original contents of the mount point for as long as
the mount is in effect.
.LP
The 
.I /tmp_mnt 
directory is created automatically by the automounter.
Its default name can be changed, as explained later in this
chapter.
.NH 2
\&Preparing the Maps
..IX "automount maps" "" "\&\fIautomount\fP maps" 
.LP
A server never knows, nor cares, whether the files
it exports are accessed through 
.I mount 
or 
.I automount .
Therefore, you need not do anything different
on the server for
.I automount 
than for 
.I mount .
.LP
A client, however, needs special files for the 
automounter.
As mentioned previously,
.I automount 
does not consult
.I /etc/fstab ;
rather, it consults the map file(s) specified on the
command line (see below, \fIStarting automount\fP).  
If no maps are specified, it looks for an \*(YP
map called 
.I auto.master 
(The chapter \fIThe Network Information Service\fP
explains how to make this map).
This is, in fact, how
it is invoked by default, through 
.I /etc/rc.local :

.DS
.ft CW
if [ -f /usr/etc/automount ]; then
        automount && echo -n ' automount'
fi
.DE

If no \*(YP
.I auto.master 
exists,
.I automount 
exits silently.
Later on, in this chapter, we explain how to invoke
.I automount 
so that it consults local maps.
.LP
By convention, all automounter maps are located in
the directory
.I /etc 
and their names all begin with the prefix 
.I auto .
.LP
There are three kinds of automount maps:
.IP \(bu
master
.IP \(bu
indirect
.IP \(bu
direct
.LP
The 
.I master
map lists (as if from the command line)
all other maps, applicable options and mount points,
as described below and summarized in the following figure:
.KS
.LP
.ce
Figure: Master, Direct, and Indirect Maps
.in -1i
.\".\s-2PS\s0 < maps.pic
.LP
.PS
scale=1.4
line from 3.875,8.813 to 4.263,7.513
line from 4.210,7.601 to 4.263,7.513 to 4.258,7.615
line from 3.438,9.350 to 1.188,7.525
line from 1.249,7.607 to 1.188,7.525 to 1.281,7.569
line from 0.163,7.425 to 1.125,7.425
line from 1.288,7.263 to 3.625,7.263 to 3.625,5.638 to 0.025,5.638 to 0.025,7.300
line from 1.125,7.425 to 1.288,7.275
line from 0.025,7.300 to 0.150,7.425
line from 3.775,7.300 to 3.900,7.425
line from 4.875,7.425 to 5.037,7.275
line from 5.037,7.263 to 7.375,7.263 to 7.375,5.638 to 3.775,5.638 to 3.775,7.300
line from 3.913,7.425 to 4.875,7.425
line from 1.475,10.225 to 1.637,10.400
line from 2.875,10.400 to 3.063,10.200
line from 3.063,10.188 to 6.000,10.188 to 6.000,8.150 to 1.475,8.150 to 1.475,10.225
line from 1.650,10.400 to 2.875,10.400
.ps 11
"optional" at 1.475,6.306 ljust
"optional" at 5.287,6.293 ljust
.ft I
"location" at 6.338,6.806 ljust
"options" at 5.300,6.806 ljust
"# key" at 4.050,6.806 ljust
.ft P
.ft I
"location" at 2.575,6.806 ljust
"options" at 1.500,6.806 ljust
"# key" at 0.350,6.806 ljust
"map-name" at 3.388,9.818 ljust
.ft R
"simple name" at 3.825,6.293 ljust
"server:path" at 6.225,6.306 ljust
"server:path" at 2.438,6.306 ljust
"full path" at 0.163,6.293 ljust
"directory" at 1.738,8.931 ljust
#"auto.indirect" at 3.888,7.331 ljust
"auto.indirect" at 3.888,7.231 ljust
"auto.direct" at 0.075,7.231 ljust
"auto.master" at 1.762,10.256 ljust
.ft I
"mount point" at 1.750,9.818 ljust
"options" at 4.838,9.818 ljust
"#" at 1.563,9.806 ljust
.ft R
"none" at 1.913,9.393 ljust
"direct" at 3.513,9.381 ljust
"optional" at 4.875,9.393 ljust
"indirect" at 3.487,8.918 ljust
"optional" at 4.888,8.931 ljust
.PE
.in +1i
.KE
.NH 4
\&The Master Map
..IX "automount maps" master "\&\fIautomount\fP maps" "" PAGE MAJOR
.LP
Each line in a master map, by convention called
.I /etc/auto.master ,
has the syntax:

.DS
.ft CW
mount\(hypoint		map\(hyname		[ mount\(hyoptions ]
.DE

.LP
where:
.IP \(bu
.I "mount\(hypoint"
is the full pathname of a directory.
If the directory does not exist, the automounter will create it if possible.
If the directory exists, and is not empty, mounting on it will hide its
contents.
The automounter will issue a warning message in this case.
.IP \(bu
.I map\(hyname
is the map the automounter should
use to find the mount points and locations.
.IP \(bu
.I "mount\(hyoptions"
is an optional, comma separated, list of options
that regulate the mounting of the entries mentioned
in 
.I map\(hyname ,
unless the
entries in
.I map\(hyname
list other options.
.LP
A line whose first character is \fB#\fP is treated
as a comment, and everything that follows until the
end of line is ignored.
A backslash (\|\e\|)
at the end of line permits splitting long lines
into shorter ones.
The notation 
.I \|/-\| 
as a mount point indicates that the map in question is a
direct map, and no particular mount point is associated
with the map as a whole.
.NH 4
\&Direct and Indirect Maps
..IX "automount maps" direct "\&\fIautomount\fP maps" "" PAGE MAJOR
..IX "automount maps" indirect "\&\fIautomount\fP maps" "" PAGE MAJOR
.LP
Lines in direct and indirect maps have
the syntax:

.DS
.ft CW
key		[ mount\(hyoptions ]		location
.DE

.LP
where
.IP \(bu
.I key
is the pathname of the mount point.
.IP \(bu
The 
.I "mount\(hyoptions"
are the options you want to apply to this particular
mount.
.IP \(bu
.I location
is the location of the resource, specified as
.I server:pathname .
.LP
As in the master map, a line whose first character is \fB#\fP is treated
as a comment and everything that follows until the
end of line is ignored.
A backslash at the end of line permits splitting long lines
into shorter ones.
.LP
The only formal difference between a direct and an
indirect map is that the key in a direct map is a full
pathname, whereas in an indirect pathname it is a simple
name (no slashes).
For instance, the following would be an entry in
a direct map:

.DS
.ft CW
/usr/man	-ro,intr	goofy:/usr/man
.DE

.LP
and the following would be an entry in an indirect map:

.DS
.ft CW
parsley		-ro,intr	veggies:/usr/greens
.DE

.LP
As you can see, the 
.I key
in the indirect map is begging for more information:
where is the mount point \fIparsley\fP really located?
That is why you must either provide that information
at the command line or through another map.
For instance, if the above line is part of a map
called 
.I /etc/auto.veggies ,
you would have to invoke it either as:

.DS
.ft CW
automount /veggies /etc/auto.veggies
.DE

.LP
or specify, in the master map:

.DS
.ft CW
/veggies	/etc/auto.veggies	-ro,soft,nosuid
.DE

.LP
In either case, you are associating a mount directory 
.I /veggies )
with the entries
.I parsley ""
in this case)
mentioned in the indirect map
.I /etc/auto.veggies .
The end result is that the hierarchy
.I /usr/greens 
from the machine 
.I veggies 
will be mounted on 
.I /veggies/parsley 
when needed.
.LP
.NH 3
\&Writing a Master Map
..IX "automount maps" master "\&\fIautomount\fP maps" "writing a master map" PAGE START 
.LP
As stated above, the syntax for each line in the
master map is

.DS
.ft CW
mount\(hypoint		map\(hyname		[ mount\(hyoptions ]
.DE

.LP
A typical 
.I auto.master 
file would contain
.ne 10
.LP
.ce
Figure: Sample \&\fIauto.master\fP Map

.DS
.ft CW
.TS
tab (`);
l 1 l l l.
`#Mount\(hypoint`Map`Mount\(hyoptions
`/\-`/etc/auto.direct`-ro,intr
`/home`/etc/auto.home`-rw,intr,secure
`/net`-hosts`
.TE
.DE

.LP
The automounter recognizes some special mount points
and maps, which are explained below.
.NH 4
\&Mount point /\-
..IX "mount point" "special_a" "" "\&\fI/\-\fP"
.LP
In the example above, the mount point 
.I /- 
is a filler that the automounter recognizes as a directive
not to associate the entries in 
.I /etc/auto.direct 
with any directory.
Rather, the mount points are
to be the ones mentioned in the map.
(Remember, in a direct
map the key is a full pathname.)
.NH 4
\&Mount point \&\fI/home\fP
..IX "mount point" "special_b" "" "\&\fI/home\fP"
.LP
The mount point
.I /home 
is to be the directory under which the entries listed
in 
.I /etc/auto.home 
(an indirect map) are to be mounted.
That is, they
will be mounted under
.I /tmp_mnt/home ,
and a symbolic link will be provided between
.I /home/\fIdirectory\fP 
and 
.I /tmp_mnt/home/\fIdirectory\fP .
.NH 4
\&Mount point \&\fI/net\fP
..IX "mount point" "special_c" "" "\&\fI/net\fP"
.LP
Finally, the automounter will mount under the directory
.I /net 
all the entries under the special map
.I -hosts .
This is a built\(hyin map that does not 
..IX hosts "automount" "\&\fIhosts\fP database" "and \&\fIautomount\fP"
use any external files except the hosts database
.I /etc/hosts ""
or the \*(YP map
.I hosts.byname 
if \*(YP is running)
Notice that
since the automounter does not mount the entries
until needed, the specific order is not important.
Once the automount daemon is in place, a user entering
the command

.DS
.ft CW
example % \&\fBcd\ \|/net/gumbo\fP
.DE

.LP
will change directory to the top of the hierarchy of
files (i.e., the root file system) of the machine
.I gumbo 
as long as the machine is in the hosts database
and it exports any of its file systems.
However, the user may not see under
.I /net/gumbo 
all the files and directories.
This is because the automounter can mount only the
.I exported
file systems of host
.I gumbo ,
in accordance with the restrictions placed on
the exporting.
.LP
The actions of the automounter when the command
in the example above
is issued are as follows:
.IP 1.
.I ping 
the null procedure of the server's mount service to see
if it's alive.
.IP 2.
Request the list of exported hierarchies from the server.
.IP 3.
Sort the exported list according to length of pathname.

.DS
.ft CW
/usr/src
/export/home
/usr/src/sccs
/export/root/blah
.DE

This sorting ensures that the mounting is done in the
proper order, that is, 
.I /usr/src 
is done before
.I /usr/src/sccs .
.LP
.IP 4.
Proceed down the list, mounting all the file systems at
mount points in 
.I /tmp_mnt 
(creating the mount points as needed).
.IP 5.
Return a symbolic link that points to the top of the
recently mounted hierarchy:
.\".\s-2PS\s0 < diag.d.pic
.LP
.PS
ellipse at 6.625,8.188 wid 0.100 ht 0.100
ellipse at 6.287,8.625 wid 0.100 ht 0.100
ellipse at 5.438,8.613 wid 0.100 ht 0.100
ellipse at 5.100,8.162 wid 0.100 ht 0.100
ellipse at 5.862,9.137 wid 0.100 ht 0.100
ellipse at 3.275,7.438 wid 0.175 ht 0.175
ellipse at 3.000,7.425 wid 0.175 ht 0.175
ellipse at 2.550,7.450 wid 0.175 ht 0.175
ellipse at 2.987,8.662 wid 0.200 ht 0.200
line from 5.125,8.137 to 5.375,7.763
line from 5.063,8.113 to 4.775,7.763
line from 5.463,8.575 to 5.700,8.287
line from 6.650,8.150 to 6.925,7.813
line from 6.588,8.150 to 6.263,7.813
line from 6.237,8.575 to 6.013,8.338
line from 6.325,8.575 to 6.588,8.213
line from 5.912,9.113 to 6.263,8.688
line from 5.838,9.100 to 5.100,8.213
line from 2.987,8.575 to 3.250,7.525
line from 2.987,8.563 to 2.987,7.513
line from 2.975,8.550 to 2.575,7.537 to 2.575,7.550
line from 1.988,9.500 to 2.987,8.775
spline from 3.362,7.487 to 3.813,8.300 to 4.275,8.787 to 5.000,9.125 to 5.487,9.150
line from 5.389,9.120 to 5.487,9.150 to 5.386,9.170
.ps 11
"/net" at 3.100,8.856 ljust
.PE
.LP
Note that, unfortunately, the automounter has to mount all
the file systems that the server in question exports.
Even if the request is as follows:

.DS
.ft CW
example % \&\fBls\ \|/net/gumbo/usr/include\fP
.DE

.LP
the automounter mounts all of 
.I gumbo 's
exported systems, not just 
.I /usr .
.LP
In addition, unmounting that occurs after a certain amount
of time has passed is from the bottom up.
This means if one of the directories at the top is busy,
the automounter has
to remount the hierarchy and try again later.
.LP
Nevertheless, the 
.I -hosts 
special map provides a very convenient way for users
to access directories in many 
different hosts without having
to use 
.I rlogin 
or 
.I rsh .
(These remote commands have to establish 
communication through the
network every time they are invoked.)
Furthermore, they no longer have to
modify their
.I /etc/fstab 
files or mount the directories by hand as superuser.
.LP
Notice that both 
.I /net 
and
.I /home 
are arbitrary names dictated by convention. 
The
automounter will create them if they do not exist already.
..IX "automount maps" master "\&\fIautomount\fP maps" "writing a master map" PAGE END
.NH 3
\&Writing an Indirect Map
..IX "automount maps" indirect "\&\fIautomount\fP maps" "writing an indirect map" PAGE START 
.LP
The syntax for an indirect map is:

.DS
.ft CW
key		[ mount\(hyoptions ]		location
.DE

.LP
where 
.I key
is the basename (not the full pathname) of 
the directory that will be used as mount point.
Once the key is obtained by the automounter, it is
suffixed to the mount point associated with it either
by the command line or by the master map that invokes
the indirect map in question.
.LP
For instance, one of the entries in the master map
presented above as an example, reads:

.DS
.ft CW
/home		/etc/auto.home	-rw,intr,secure
.DE

.LP
Here 
.I /etc/auto.home 
is the name of the indirect map that will contain the
entries to be mounted under 
.I /home .
.LP
A typical 
.I auto.home 
map might contain:
.LP
.ne 10
.ce
Figure: Sample \&\fIauto.home\fP Map

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`willow``willow:/home/willow
`cypress``cypress:/home/cypress
`poplar``poplar:/home/poplar
`pine``pine:/export/pine
`apple``apple:/export/home
`ivy``ivy:/home/ivy
`peach`-rw,nosuid`peach:/export/home
.TE
.DE

.LP
As an example, assume that the map above is on host 
.I oak .
If user 
.I laura
has an entry in the password database specifying her
home directory as
.I /home/willow/laura ,
then whenever she logs into machine oak,
the automounter will
mount (as  
.I /tmp_mnt/home/willow )
the directory 
.I /home/willow 
residing in machine willow.
If one of the directories is indeed
.I laura ,
she will be in her home directory,
which is mounted read/write, interruptible and secure, as 
specified by the options field in the master map entry.
.LP
Suppose, however, that 
.I laura 's
home directory is specified as
.I /home/peach/laura .
Whenever she logs into oak,
the automounter mounts the directory
.I /export/home 
from 
.I peach
under 
.I /tmp_mnt/home/peach .
Her home directory will be mounted
read/write, 
.I nosuid .
\fIAny option in the file entry overrides all options in
the master map or the command line\fP.
.LP
Now, assume
the following conditions occur:
.IP \(bu
User laura's home directory is listed in
the password database as
.I /home/willow/laura .
.IP \(bu
Machine 
.I willow 
exports its
.I home 
hierarchy to the machines mentioned in 
.I auto.home .
.IP \(bu
All those machines have a copy of the
same 
.I auto.home 
and the same password database.
.LP
Under these conditions,
user laura can run
.I login 
or 
.I rlogin 
on any of
these machines and have her home directory
mounted in place for her.
.LP
Furthermore, now laura can also enter the command

.DS
.ft CW
% \&\fBcd\ \|\s+2~\s-2brent\fP
.DE

.LP
and the automounter will mount brent's home directory
for her (if all permissions apply).
.LP
On a network without \*(YP,
you have to change all the relevant
databases (such as
.I /etc/passwd )
on all systems on the network in order
to accomplish this.
On a network running \*(YP,
make the changes on the \*(YP master server and propagate
the relevant databases to the slave servers.
..IX "automount maps" indirect "\&\fIautomount\fP maps" "writing an indirect map" PAGE END
.NH 3
\&Writing a Direct Map
..IX "automount maps" direct "\&\fIautomount\fP maps" "writing a direct map" PAGE START 
.LP
The syntax for a direct map (like that for an indirect
map) is:

.DS
.ft CW
key		[ mount\(hyoptions ]		location
.DE

.LP
where: 
.IP \(bu
.I key
is the 
.I full
pathname of the mount point. 
(Remember that
in an indirect map this is not a full pathname.)
.IP \(bu
.I mount\(hyoptions
are optional but, if present, override \(em for the entry
in question \(em the options of the calling line, if any,
or the defaults.
(See below, \fIStarting automount\fP.)  
.IP \(bu
.I location
is the location of the resource, specified as
.I server:pathname .
.LP
Of all the maps, the entries in a direct map most closely
resemble, in their simplest form, 
what their corresponding
entries in 
.I /etc/fstab 
might look like.
An entry that appears in
.I /etc/fstab 
as:

.DS
.ft CW
dancer:/usr/local /usr/local/tmp nfs  ro 0 0 
.DE

.LP
appears in a direct map as:

.DS
.ft CW
/usr/local/tmp -ro dancer:/usr/local
.DE

.LP
The following is a typical
.I /etc/auto.direct 
map:
.LP
.ne 20
.ce
Figure: Sample \&\fIauto.direct\fP Map

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-ro,soft`ivy:/export/local/share\|\e
``/src`-ro,soft`ivy:/export/local/src 
`/usr/man``-ro,soft`oak:/usr/man \e
````rose:/usr/man \e
````willow:/usr/man 
`/usr/games``-ro,soft`peach:/usr/games 
`/usr/spool/news``-ro,soft`pine:/usr/spool/news 
`/usr/frame``-ro,soft`redwood:/usr/frame2.0 \e
````balsa:/export/frame
.ps +1
.TE
.DE

.LP
There are a couple of unusual features in this map:
multiple mounts and multiple locations.
These are the subject of the next two subsections.
.NH 4
\&Multiple Mounts
..IX "multiple mounts"
.LP
A map entry can describe a multiplicity of mounts, where
the mounts can be from different locations and with
different mount options.
Consider the first entry in the previous
example:

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-ro,soft`ivy:/export/local/share \e
``/src`-ro,soft`ivy:/export/local/src 
.ps +1
.TE
.DE

This is, in fact, one
long entry whose readability has been improved by
splitting it into four lines by using the
backslash and indenting the continuation lines with 
blank spaces or tabs.
This entry mounts
.I /usr/local/bin ,
.I /usr/local/share 
and
.I /usr/local/src 
from the server 
.I ivy ,
with the options read\(hyonly and soft.
The entry could also read:
.sp
.ne 2.5i
.ce
Figure: Example of a Multiple Mount

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-rw,secure`willow:/usr/local/share \e
``/src`-ro,intr`oak:/home/jones/src
.ps +1
.TE
.DE

.LP
where the options are different and more than one
server is used.
The difference between the above and three separate entries, for
example:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l.
.ps -1
`/usr/local/bin`-ro,soft`ivy:/export/local/sun3
`/usr/local/share`-rw,secure`willow:/usr/local/share
`/usr/local/src`-ro,intr`oak:/home/jones/src
.ps +1
.TE
.DE

is that the first case, multiple mount, guarantees that all three
directories will be mounted when you reference one of them.
In the case of the separate entries, if you, for instance, enter:

.DS
.ft CW
% \&\fBcd /usr/local/bin
.DE

you cannot 
.I cd 
to one of the other directories using a relative path, because it
is not mounted yet:

.DS
.ft CW
% \&\fBcd ../src
\fP\&../src: No such file or directory
.DE

A multiple mount obviates this problem.
In multiple mounts, each
file hierarchy is mounted on a subdirectory within another
file hierarchy.
When the root of the hierarchy is referenced, the 
automounter mounts the whole hierarchy.
.LP
The concept of \fIroot\fP here is very important.
The symbolic link returned by the automounter to the
kernel request is a path to the mount root.
This is the root of the hierarchy that is mounted
under \&\fI/tmp_mnt\fP.
This mount point should theoretically be specified:

.DS
.ft CW
parsley		/	-ro,intr	veg:/usr/greens
.DE

.LP
In practice,
it is not specified because in a trivial
case of a single mount as above,
it is assumed that the
location of the mount point is \fIat\fP the mount
root or \(lq\&\fI/\fP.\(rq
So instead of the above it is perfectly acceptable,
indeed preferable, to enter:

.DS
.ft CW
parsley		-ro,intr	veg:/usr/greens
.DE

.LP
The mount point specification, however, becomes
..IX "multiple mounts" "and mount points"
important when mounting a hierarchy:
here the automounter
must have a mount point for each mount within the hierarchy.
The example above is a good illustration of multiple, 
non\(hyhierarchical mounts under
.I /usr/local 
when the latter is already mounted (or is a subdirectory
of another mounted system).
.LP
..IX "multiple mounts" hierarchical
When the root of the hierarchy has to be mounted also,
it has to be specified in the map, and the entry becomes
a \(lqhierarchical\(rq mount, which is a special case of multiple
mounts.
.LP
The following illustration shows a true hierarchical
mounting:
.LP
.ne 10
.ce
Figure: Example of a Hierarchical Multiple Mount

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/`-rw,intr`peach:/export/local \e
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-rw,secure`willow:/usr/local/share \e
``/src`-ro,intr`oak:/home/jones/src
.ps +1
.TE
.DE

..IX "multiple mounts" "example"
.LP
.LP
\s+2\fBNote: \fP\s0A true hierarchical mount can be
problematic if the server for the root of the hierarchy
goes down.
Any attempt to unmount the lower branches
will fail, since the unmounting has to proceed through
the mount root, which also cannot be unmounted while
its server is down.
.LP
The mount points used here for the hierarchy are 
.I / ,
.I /bin ,
.I /share ,
and
.I /src .
Note that these mount point paths are relative to the
.I mount
root, not the host's 
.I "file system"
root.
The first entry in the example above has 
.I / 
as its mount point.
It is mounted
.I at
the mount root.
There is no requirement that the first mount of a hierarchy be at 
the mount root.
The automounter will happily issue
.I mkdir 's
to build a path to the first mount point if it is not
at the mount root.
.LP
Finally, a word about mount options. 
In one of the examples above,
.ne 7

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-ro,soft`willow:/usr/local/share \e
``/src`-ro,soft`oak:/home/jones/src
.ps +1
.TE
.DE

all three mounts 
share the same options.
This could be modified to:
.ne 7

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local`-ro,soft \e``
``/bin`ivy:/export/local/sun3 \e
``/share`willow:/usr/local/share \e
``/src`oak:/home/jones/src
.ps +1
.TE
.DE

If one of the mount points needed a different specification,
you could then write:
.ne 7

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local`-ro,soft \e``
`/bin``ivy:/export/local/sun3 \e
`/share`-rw,secure`willow:/usr/local/share \e
`/src``oak:/home/jones/src
.ps +1
.TE
.DE

.LP
.KS
.NH 3
\&Multiple Locations
.LP
In the example for a direct map, which was:
.LP

.TS
tab(`);
l 1 l l l l.
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3\|\e
``/share`-ro,soft`ivy:/export/local/share\|\e
``/src`-ro,soft`ivy:/export/local/src 
.ft B
`/usr/man``-ro,soft`oak:/usr/man \e
````rose:/usr/man \e
````willow:/usr/man 
.ft R
`/usr/games``-ro,soft`peach:/usr/games 
`/usr/spool/news``-ro,soft`pine:/usr/spool/news 
.ft B
`/usr/frame``-ro,soft`redwood:/usr/frame2.0 \e
````balsa:/export/frame
.ft R
.TE

.KE
.LP
the mount points 
.I /usr/man 
and
.I /usr/frame 
(bolded in the example above)
list more than one location (three for the first, two for the second).
This means that the mounting can be done from any of the replicated
locations.
..IX "multiple mounts" "locations" "" "mount point locations"
This procedure makes sense only when you are mounting a
hierarchy read\(hyonly, since (at least theoretically) 
you must have
some control over the locations of files you write or modify
(that is, you don't want to modify files on one server on one
occasion and, minutes later, modify the \(lqsame\(rq file on
another server).
A good example is the man pages. 
In a large network, more than one server
may export the current set of manual pages.
It does not matter which server you mount them from, as long
as the server is up and running and exporting its file systems.
In the example above, multiple mount locations are expressed as 
a list of mount locations in the map entry:

.DS
.ft CW
/usr/man -ro,soft oak:/usr/man rose:/usr/man willow:/usr/man 
.DE

.LP
This could also be expressed as a comma separated list
of servers, followed by a colon and the pathname (as
long as the pathname is the same for all
the replicated servers):

.DS
.ft CW
/usr/man -ro,soft oak,rose,willow:/usr/man 
.DE

.LP
Here you can mount the man pages from the servers
.I oak ,
.I rose ,
or
.I willow .
From this list of servers the automounter first selects those that
are on the local network and 
..IX ping "" "\&\fIping\fP \(em send echo request to host"
.I ping s
these servers.
This launches a series of \s-2RPC\s0 requests to each server.
The first server to respond is selected, and an attempt is
made to mount from it.
Note that the list does not imply an ordering.
.LP
This redundancy, very useful in an environment
where individual servers may or may not be exporting their file systems,
is enjoyed only at mount time.
There is no status checking of the mounted\(hyfrom server by
the automounter once the mount occurs.
If the server goes down while the mount is in effect, the
file system becomes unavailable.
An option here is to wait five minutes until the auto\(hyunmount
takes place and try again. 
Next time around the automounter
will choose one of the other, available servers.
Another option is to use the
.I umount 
command, inform the automounter of the change in the
..IX umount "" "\&\fIumount\fP"
mount table (as specified in the later
section, \fIThe Mount Table\fP), 
and retry the mount.
..IX "automount maps" direct "\&\fIautomount\fP maps" "writing a direct map" PAGE END
.LP
.NH 3
\&Specifying Subdirectories
..IX "automount maps" "specifying subdirectories" "\&\fIautomount\fP maps"
.LP
The earlier subsection, 
\fIWriting an Indirect Map\fP, 
showed the following typical 
.I auto.home 
file:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`willow``willow:/home/willow
`cypress``cypress:/home/cypress
`poplar``poplar:/home/poplar
`pine``pine:/export/pine
`apple``apple:/export/home
`ivy``ivy:/home/ivy
`peach`-rw,nosuid`peach:/export/home
.TE
.DE

.LP
Given this
.I auto.home 
indirect file, every time a user wants to access
a home directory in, say, 
.I /home/willow ,
all the directories under it will be mounted.
Another way to organize an
.I auto.home 
file is by user name, as in:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`john``willow:/home/willow/john
`mary``willow:/home/willow/mary
`joe``willow:/home/willow/joe
.TE
.DE

.LP
The above example assumes that home
directories are of the form
.I /home/user
rather than
.I /home/server/user .
If a user now enters the following
command:

.DS
.ft CW
% \fBls\ \|~john\ \|~\mary\fP
.DE

.LP
the automounter has to perform the 
.I equivalent 
of the following actions:

.DS
.ft CW
mkdir /tmp_mnt/home/john
mount willow:/home/willow/john /tmp_mnt/home/john
ln -s /tmp_mnt/home/john /home/john

mkdir /tmp_mnt/home/mary
mount willow:/home/willow/mary /tmp_mnt/home/mary
ln -s /tmp_mnt/home/mary /home/mary
.DE

.LP
However, the complete syntax of a line in a direct or
indirect map is actually:

.DS
.ft CW
key	 [ mount\(hyoption ]   server:pathname[:subdirectory]
.DE

.LP
Until now you used the form
.I server:pathname
to indicate the location. 
This is an ideal place for you
to also indicate the subdirectory, like this:
.ne 10
.LP
.ce
Figure: Example of \fIsubdirectory\fP Field

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`john``willow:/home/willow:john
`mary``willow:/home/willow:mary
`joe``willow:/home/willow:joe
.TE
.DE

.LP
Here
.I john ,
.I mary 
and
.I joe 
are entries in the
.I subdirectory 
field.
Now when a user refers to 
.I john 's
home directory, the automounter mounts
.I willow:/home/willow .
It then places a symbolic link between
.I /tmp_mnt/home/willow/john 
and 
.I /home/john .
.LP
If the user then requests access to 
.I mary 's
home directory, the automounter sees that
.I willow:/home/willow 
is already mounted, so all it has to do is
return the link
between
.I /tmp_mnt/home/willow/mary 
and
.I /home/mary .
In other words, the automounter now only does:

.DS
.ft CW
mkdir /tmp_mnt/home/john
mount willow:/home/willow /tmp_mnt/home
ln -s /tmp_mnt/home/john /home/john

ln -s /tmp_mnt/home/mary /home/mary
.DE

.LP
In general, it is a good idea to provide a
.I subdirectory
entry in the
.I location
when different map entries refer to the same
mounted file system from the same server.
.LP
.NH 3
\&Metacharacters
.LP
The automounter recognizes some characters as having a special meaning.
Some are used for substitutions, some to escape other characters.
.NH 4
\&Ampersand (&)
.LP
If you have a map with a lot of subdirectories specified,
like:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l 1.
`#key`mount\(hyoptions`location
`john``willow:/home/willow:john
`mary``willow:/home/willow:mary
`joe``willow:/home/willow:joe
`able``pine:/export/home:able
`baker``peach:/export/home:baker
``[\&.\ \ \&.\ \ \&.]``
.TE
.DE

.LP
consider using string substitutions.
..IX "automount maps" "substitution_a" "\&\fIautomount\fP maps" "and use of &"
You can use the ampersand character (\fB&\fP)
to substitute the 
key wherever it appears.
Using the ampersand, the above map now looks
as follows:
.LP
.ne 10
.LP
.ce
Figure: Example of Use of Ampersand

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`john``willow:/home/willow:&
`mary``willow:/home/willow:&
`joe``willow:/home/willow:&
`able``pine:/export/home:&
`baker``peach:/export/home:&
``[\&.\ \ \&.\ \ \&.]``
.TE
.DE

.LP
If the name of the server is the same as the key
itself, for instance:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`willow``willow:/home/willow
`peach``peach:/home/peach
`pine``pine:/home/pine
`oak``oak:/home/oak
`poplar``poplar:/home/poplar
``[\&.\ \ \&.\ \ \&.]``
.TE
.DE

.LP
the use of the ampersand results in:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`willow``&:/home/&
`peach``&:/home/&
`pine``&:/home/&
`oak``&:/home/&
`poplar``&:/home/&
``[\&.\ \ \&.\ \ \&.]``
.TE
.DE

.NH 4
\&Asterisk (*)
.LP
Notice that all the above entries
have the same format.
This permits you to use the catch-all
substitute character, the asterisk
..IX "automount maps" "substitution_b" "\&\fIautomount\fP maps" "and use of *"
.B * ). (
The asterisk 
reduces the whole thing to:
.ne 5
.LP
.ce
Figure: Example of Use of Ampersand and Asterisk

.DS
.ft CW
*	&:/home/&
.DE

.LP
where each ampersand is substituted by the value
of any given key.
Notice that once the automounter reads the catch-all
key it does not continue reading the map, so that
the following map would be viable:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`oak``&:/export/&
`poplar``&:/export/&
`*``&:/home/&
.TE
.DE

.LP
whereas in the next map the last two entries would
always be ignored:
.LP

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`*``&:/home/&
`oak``&:/export/&
`poplar``&:/export/&
.TE
.DE

.LP
You could also use key substitutions in a direct map,
in situations like the following:
.LP

.DS
.ft CW
/usr/man		willow,cedar,poplar:/usr/man
.DE

.LP
which is a good candidate to be written as:
.LP

.DS
.ft CW
/usr/man		willow,cedar,poplar:&
.DE

.LP
Notice that the ampersand substitution uses the whole key
string, so if the key in a direct map starts with a 
.I / 
(as it should), that slash is carried over, and you could not
do something like

.DS
.ft CW
/progs  &1,&2,&3:/export/src/progs
.DE

.LP
because the automounter would interpret it as:

.DS
.ft CW
/progs  /progs1,/progs2,/progs3:/export/src/progs
.DE

.LP
.NH 4
\&Backslash (\|\e\|)
.LP
..IX "automount maps" "special_a" "\&\fIautomount\fP maps" "and escapes with special characters"
Under certain circumstances you may have to mount
directories whose names may confuse the automounter's
map parser. 
An example might be a directory called
.I rc0:dk1 ;
this could result in an entry like:

.DS
.ft CW
/junk		-ro		vmsserver:rc0:dk1
.DE

The presence of the two colons in the location field 
will confuse the automounter's parser.
To avoid this confusion, use a backslash to escape the
second colon and remove its special meaning of separator:

.DS
.ft CW
/junk		-ro		vmsserver:rc0\e:dk1
.DE

.tr ~"
.NH 4
\&Double quotes (\|~\|)
.LP
You can also use double quotes, as in the following example,
where they are used to hide the blank space in the name:

.DS
.ft CW
/smile	dentist:/"front teeth"/smile
.DE

.tr ~~
.LP
.NH 3
\&Environment Variables
..IX "automount maps" special_b "\&\fIautomount\fP maps" "and environment variables"
.LP
You can use the value of an environmental variable 
by prefixing a dollar sign
.B $ ) (
to its name.
You can also use
braces to delimit the name of the variable
from appended letters or digits.
You can use environmental variables anywhere in an entry line,
except as a 
.I key .
An interesting variable is
.I $\s-2ARCH\s0 ,
whose value is the name of the machine's architecture
as would be returned by the command
.I arch .
For instance, if you have a file server exporting binaries
for Sun-3 and Sun-4 architectures from
.I /usr/local/bin/sun3 
and
.I /usr/local/bin/sun4 
respectively, you can have the clients mount through a map entry
like the following:

.DS
.ft CW
/usr/local/bin      -\^r\^o		\&\fIserver\fP:/usr/local/bin/$\s-2ARCH\s0
.DE

Now the same entry on all the clients is good for all architectures.
.LP
The environmental variables can be inherited from the environment
or can be defined explicitly with the 
.I -D 
command line option.
For instance, if you want each client to mount client\(hyspecific
files in the network in a replicated format, you could
create a specific map for each client according to its name, so that
the relevant line for host oak would be:

.DS
.ft CW
/mystuff	cypress,ivy,balsa:/export/hostfiles/oak
.DE

.LP
and for willow it would be:

.DS
.ft CW
/mystuff	cypress,ivy,balsa:/export/hostfiles/willow
.DE

.LP
This scheme is viable within a small network, but maintaining
this kind of host specific maps across a large network
would soon become unfeasible.
The solution in this case would be to start the automounter
with a command line similar to the following:

.DS
.ft CW
automount -D \s-2HOST\s0=`hostname` ......
.DE

.LP
and have the entry in the direct map read:

.DS
.ft CW
/mystuff	cypress,ivy,balsa:/export/hostfiles/$\s-2HOST\s0
.DE

.LP
Now each host would find its own files in the
.I mystuff 
directory, and the task of centrally administering and
distributing the maps becomes easier.
.LP
Similarly, if you want to mount using 
.I "arch -k"
as the criterion, you could start the automounter as:

.DS
.ft CW
automount -D \s-2ARCH\s0=`arch -k` .....
.DE

and still use the entry

.DS
.ft CW
/usr/local/bin	-ro		\&\fIserver\fP:/usr/local/bin/$\s-2ARCH\s0
.DE

(or a similar one).
.NH 3
\&Including Other Maps
.LP
A line of the form
.I +\&\fImapname\fP 
causes the automounter to consult the mentioned map as if
it were included in the current map.
If \&\fImapname\fP is a relative pathname (no slashes), the automounter
assumes it is an \*(YP map. 
If the pathname is an absolute pathname the automounter looks for
a local map of that name.
If the mapname starts with a dash (\-), the automounter consults the
appropriate built\(hyin map.
.LP
For instance, you can have a few entries in your local
.I auto.home 
map for the most commonly accessed home directories, and
follow them with the included \*(YP map:

.DS
.ft CW
ivy 	-rw,intr,noquota	&:/home/&
oak		-rw,intr,noquota	&:/export/home
+auto.home
.DE

.LP
After consulting the included map, the automounter continues scanning
the current map if no match is found, so you can add more entries, for instance:

.DS
.ft CW
ivy     -rw,intr,noquota    &:/home/&
oak     -rw,intr,noquota    &:/export/home
+auto.home 
*		-rw					&:/home/&
.DE

.LP
Finally, as mentioned before, the map included can be a local file,
or even a built\(hyin map:

.DS
.ft CW
+auto.home.finance				# \*(YP map
+auto.home.sales				# \*(YP map
+auto.home.engineering			# \*(YP map
+/etc/auto.mystuff				# local map
+auto.home						# \*(YP map
+-hosts							# built\(hyin hosts map
*	&:/export/&					# wild card
.DE

Notice that in all cases the wild card should be the last entry,
because the automounter does not continue consulting the map
after it, on the assumption that the wild card will have found
a match.
.NH 2
\&Starting \&\fIautomount\fP
..IX "automount" starting "\&\fIautomount\fP"
.LP
Once the maps are written, you should make sure that there
are no equivalent entries in 
.I /etc/fstab ,
and that all the entries in the maps refer to \s-2NFS\s0 exported
files.
.LP
The syntax to invoke the automounter is:

.DS
\&\fBautomount\fP [ \&\fB\-mnTv\fP ] [ \&\fB\-D\fP \&\fI name \fP= \&\fBvalue\fP ] [ \&\fB\-f\fP \&\fImaster-file\fP ] [ \&\fB\-M\fP \&\fBmount-directory\fP ]
[ \&\fB\-tl\fP \&\fIduration\fP ] [ \&\fB\-tm\fP \&\fIinterval\fP ] [ \&\fB\-tw\fP \&\fIinterval\fP ] [ \&\fIdirectory\ \ map\fP [ \&\fI\-mount-options\fP ] ] .\|.\|.
.DE

.LP
The
.I automount (8)
man page contains a complete description of 
all options.
.LP
The 
.I mount\(hyoptions
that you can specify at either the command line
or in the maps are the same as those for
a standard \s-2NFS\s0
.I mount ,
excepting
.I bg 
(background) and
.I fg 
(foreground), which do not apply.
.LP
By default, the file
.I /etc/rc.local 
starts the automounter at boot time through the lines:

.DS
.ft CW
if [ -f /usr/etc/automount ]; then
        automount && echo -n ' automount'
fi
.DE

That is, if the file
.I /usr/etc/automount 
exists, start it.
When started like this, with no option, the automounter
looks for an \*(YP map called
.I auto.master .
If it finds it, it follows the instructions contained there.
If \*(YP is not running, or the map is not to be found,
the automounter exits silently.
The 
.I \-m 
option instructs the automounter not to look for the
\*(YP map.
The 
.I \-f 
option instructs it to look for the file named immediately after
the option.
If no
.I \-m 
or
.I \-f 
options are specified, the automounter expects a series of
mount points and maps (and optional mount options) 
specified on the command line.
.LP
Given the following set of three maps:
.IP \(bu
auto.master

.DS
.ft CW
.TS
tab (`);
l 1 l l l.
`#Mount\(hypoint`Map`Mount\(hyoptions
`/net`-hosts`
`/home`/etc/auto.home`-rw,intr,secure
`/\-`/etc/auto.direct`-ro,intr
.TE
.DE

.KS
.IP \(bu
auto.home

.DS
.ft CW
.TS
tab(`);
l 1 l l l
l 1 l l l.
`#key`mount\(hyoptions`location
`willow``willow:/home/willow
`cypress``cypress:/home/cypress
`poplar``poplar:/home/poplar
`pine``pine:/export/pine
`apple``apple:/export/home
`ivy``ivy:/home/ivy
`peach`-rw,nosuid`peach:/export/home
.TE
.DE

.KE
.KS
.IP \(bu
auto.direct

.DS
.ft CW
.TS
tab(`);
l 1 l l l l.
.ps -1
`/usr/local \e```
``/bin`-ro,soft`ivy:/export/local/sun3 \e
``/share`-ro,soft`ivy:/export/local/share\|\e
``/src`-ro,soft`ivy:/export/local/src 
`/usr/man``-ro,soft`oak:/usr/man \e
````rose:/usr/man \e
````willow:/usr/man 
`/usr/games``-ro,soft`peach:/usr/games 
`/usr/spool/news``-ro,soft`pine:/usr/spool/news 
`/usr/frame``-ro,soft`redwood:/usr/frame1.3 \e
````balsa:/export/frame
.ps +1
.TE
.DE
.KE

.LP
you can invoke the automounter 
(either from the command line or,
preferably, from 
.I rc.local )
in one of the following ways:
.LP
.IP 1.
You can specify all arguments to the automounter
without reference to the master map (either \*(YP or local), as in:

.DS 
automount /net -hosts /home /etc/auto.home -rw,intr,secure /- /etc/auto.direct -ro,intr
.DE

.LP
.IP 2.
You can specify the same in the 
.I "auto.master" 
file, and instruct
the automounter to look in it for instructions:

.DS
.ft CW
automount -f /etc/auto.master 
.DE

.LP
.IP 3.
You can specify more mount points and maps in addition to those
mentioned in the master map, as follows:

.DS
.ft CW
automount -f /etc/auto.master /src /etc/auto.src -ro,soft
.DE

or

.DS
.ft CW
automount /src /etc/auto.src -ro,soft
.DE

The first example specifies additions to the local master map,
the second additions to the \*(YP master map.
.LP
.IP 4.
You can nullify one of the entries in the master map.
(This is particularly
useful if you use a map that you cannot modify and does
not meet the needs of your machine):

.DS
.ft CW
automount -f /usr/lib/auto.master /home -null
.DE

This cancels the entry for 
.I /home 
in the master map (it could also be the \*(YP master map).
.LP
.IP 5.
You can replace one of the entries with
your own:

.DS L
.ft CW
automount -f /usr/lib/auto.master /home /myown/auto.home -rw,intr
.DE

.LP
In the example above, the automounter first mounts all
items in the map
.I /myown/auto.home 
under the directory
.I /home .
Then, when it consults the master file
.I /usr/lib/auto.master 
and reaches the line corresponding to
.I /home 
it simply ignores it, since it has already mounted on it.
.LP
Given the 
.I "auto.master" 
file of the previous example,
commands (1) and (2) are equivalent \fIas long as 
your network does not have a
distributed \&\fIauto.master\fI file.\fR 
This file is
only available on networks running \*(YP.
If your
network includes a
distributed \*(YP
.I "auto.master" 
file,
the second example would have to be 
modified in the following way 
to be equivalent to example 1:

.DS
.ft CW
automount -m -f /etc/auto.master
.DE

.LP
The 
.I -m 
option instructs the automounter not to consult the
master file distributed by \*(YP.
However, if you do not run \*(YP,
you do not have to specify the
.I -m 
option. 
The automounter is completely silent when
it does not find a distributed master file.
.LP
You can log in as superuser
and type
any of the above commands at
shell level to start the automounter.
Ideally,
you should edit
.I rc.local 
and include your preferred command there.
.NH 3
\&The Temporary Mount Point
..IX "tmp_mnt" "" "\&\fItmp_mnt\fP, special directory"
.LP
The default name for all mounts is
.I /tmp_mnt .
Like the other names, this is arbitrary. 
It can be changed at startup time by use of the
.I -M 
option.
For instance:

.DS
.ft CW
automount -M /auto ...
.DE

.LP
causes all mounts to happen under the directory
.I /auto ,
which the automounter will create if it does not exist.
It goes without saying that you should not designate
a directory in a read only file system,
as the automounter
would not be able to modify anything then.
.NH 3
\&The Mount Table
..IX "mount table" 
..IX automount "mount table" \&\fIautomount\fP
.LP
Every time the automounter mounts or unmounts 
a file hierarchy,
it modifies 
.I /etc/mtab 
to reflect the current situation.
The automounter keeps an image in memory of
.I /etc/mtab ,
and refreshes this image every time it performs a mounting
or an automatic unmounting.
If you use the
.I umount 
command
to unmount one of the
automounted hierarchies (a directory under 
.I /tmp_mnt ),
the automounter should be forced to re-read the 
.I /etc/mtab 
file.
..IX mtab "forcing re\(hyreading of" \&\fImtab\fP
To do that, enter the command:

.DS
.ft CW
example % \&\fBps -ef | grep automount | egrep -v grep\fP
.DE

.LP
This gives you the process \s-2ID\s0 of the automounter.
..IX automount "process ID" "\&\fIautomount\fP" "obtaining process ID"
The automounter is designed so that on receiving a \s-2SIGHUP\s0
signal it re-reads 
.I /etc/mtab .
So, to send it that signal, enter:

.DS
.ft CW
% \&\fBkill -1\fP \&\fI\s-2PID\s0\fP
.DE

where
.I \s-2PID\s0
stands for the process \s-2ID\s0 you obtained from the previous
.B ps
command.
.LP
.NH 3
\&Modifying the Maps
..IX "automount maps" modifying "\&\fIautomount\fP maps"
.LP
You can modify the automounter maps at any time, but
that does not guarantee that all your modifications
will take effect the next time the automounter mounts
a hierarchy.
It depends on what map you modify and what kind of
modification you introduce.
You may have to reboot the machine.  This is generally
the simplest way of restarting the automounter, although, if
it is used sparingly, you could theoretically kill it and restart
it from the command line.
.NH 4
\&Modifying the Master Map
.LP
The automounter consults the master map only at startup
time.
A modification to the master map will take effect only
next time you reboot the machine.
.NH 4
\&Modifying Indirect Maps
.LP
Entries can be modified, deleted, or added to indirect maps 
and the change will take effect next time the map is used,
which is next time a mount has to be done.
.NH 4
\&Modifying Direct Maps
.LP
Each entry in a direct map is an automount mount point, and
it only mounts itself at these mount points at startup.
Therefore, adding or deleting an entry in a direct map will
take effect only next time you reboot the machine.
However, existing entries can be modified (changing mount options
or server names, and so on, but not name of mount points) 
while the automounter is running, and will take effect when the entry 
is next mounted, because the automounter consults the direct maps 
whenever a mount has to be done.
.LP
For instance, suppose you modify the file
.I /etc/auto.direct 
so that the directory
.I /usr/src 
is now mounted from a different server.
The new entry takes effect
immediately (if 
.I /usr/src 
is not mounted at this time) when you try to access it.
If it is mounted now,
you can wait until the auto unmounting
takes place, and then access it. 
If this is not satisfactory,
you can unmount with the
.I umount 
command, notify 
.I automount 
that the mount table has changed (see above,
\fIThe Mount Table\fP), and then access it. 
The mounting should now be done from
the new server.
However, if you wanted to delete the entry, you would have
to reboot the machine for the deletion to take effect.
.LP
For this reason, and because they do not clutter the mount
table like direct maps do, indirect maps are preferable, and
should be used whenever possible.
.LP
.NH 3
\&Mount Point Conflicts
..IX "multiple mounts" "conflicts" "" "mount point conflicts"
.LP
If you have a home partition, on a local disk, that is mounted on
.I /home 
and you want also to use the automounter to mount other
home directories, you may encounter the problem that if
you give it the mount point
.I /home 
then the automounter will hide the local home partition
whenever you try to reach it.
.LP
The solution is to mount the partition somewhere else,
for instance on
.I /export/home .
You would then need, for instance, an entry in
.I /etc/fstab 
that says:

.DS
.ft CW
/dev/\&\fIxx#z\fP	\&.\&.\&.	/export/home	\&.\&.\&.
.DE

(where \&\fIxx#z\fP stands for the name of the partition)
and, assuming that the master file contains a line similar to:
.DS
.ft CW
/home /etc/auto.home
.DE
an entry in 
.I auto.home 
that says:

.DS
.ft CW
terra	terra:/export/home
.DE

where 
.I terra 
is the name of the machine.
.LP
If the partition is set up such as home directories are to be found as
.I /home/\&\fImachine\fP/\&\fIuser ,
move all the directories at the \&\fIuser\fP
level one level up, so as to eliminate the \&\fImachine\fP level:

.DS
.ft CW
# \&\fBcd /home \fP
# \&\fBmv\fP \&\fImachine\fP/\&\fB* \s+2.\s0\fP
# \&\fBrmdir\fP \&\fImachine\fP
.DE

.LP
There is no need to change the 
.I /etc/passwd 
entry for the user.
His or her home directory will still be accessible through
.I /home/\&\fImachine\fP/\&\fIuser\fP ,
as before.
Instead of doing a mount, the automounter will recognize that
the file system is on the same machine and will establish a
symbolic link from
.I /home/\&\fImachine 
to 
.I /export/home .
.NH 2
\&Problem Solving
..IX automount debugging \&\fIautomount\fP
.LP
From time to time you may encounter problems with the automounter.
This section is aimed at making the problem solving process easier.
It is divided in two subsections.
.LP
The first subsection expands on the bird's eye view explanation of how the
automounter works presented at the beginning of this chapter.
This explanation is written especially for advanced
system administrators and programmers, and you can skip it
without your ability to administer the automounter being affected.
However, you may want to read it so as to have an idea of
the issues involved.
.LP
The second subsection presents a list of the error messages the automounter
generates.
The list is divided in two parts:
.IP \(bu
Error messages generated by the verbose 
.I \-v )
option of 
.I automount ,
and
.IP \(bu
Error messages that may appear at any time.
.LP
In general, it is recommended that you start the automounter with
the verbose option, since otherwise you may experience problems 
without knowing why.
.LP
.NH 3
\&\&\fIautomount\fP Sequence of Events
..IX automount synopsis \&\fIautomount\fP
.LP
There are two distinct stages in the automounter's actions:
.IP \(bu
The initial stage,
boot time, when
.I rc.local 
boots the automounter.
.IP \(bu
The mounting stage, when a user tries to access a file or 
directory in a remote machine.
.LP
At the initial stage, when
.I rc.local 
invokes
.I automount ,
it opens a \s-2UDP\s0 socket and registers it with the
..IX "UDP socket"
portmapper service as an \s-2NFS\s0 server port.
It then forks off a server daemon that listens for \s-2NFS\s0 requests
on the socket.
The parent process proceeds to mount the daemon at its mount
points within the file system (as specified by the maps).
Through the 
..IX "mount (2)" "" "\&\fImount\fP(2) system call"
.I mount (2)
system call it passes the server daemon's port number and an 
\s-2NFS\s0 
.I "file handle"
that is unique to each mount point.
The arguments to the
.I mount (2)
system call vary according to the kind of file system;
for \s-2NFS\s0 file systems, the call is

.DS
.ft CW
mount ( "nfs", "/usr", &nfs_args );
.DE

.LP
where 
.I &nfs_args 
..IX "network address"
contains the network address for the \s-2NFS\s0 server.
By having the network address in
.I &nfs_args 
refer to the local process (the automount daemon),
.I automount 
in fact deceives the kernel into treating it as if
it were an \s-2NFS\s0 server.
Instead, once the parent process completes its calls to
.I mount (2)
it exits,
leaving the daemon to serve its mount points:
.\".\s-2PS\s0 < diag.a.pic
.sp
.KS
.ce
\fRFigure: Automount Disguised as NFS Server
.sp
.PS
ellipse at 4.025,8.350 wid 1.725 ht 0.525
ellipse at 2.837,9.125 wid 0.300 ht 0.300
line from 1.750,8.488 to 2.413,8.950
line from 2.345,8.872 to 2.413,8.950 to 2.316,8.913
line from 1.512,9.762 to 1.850,9.262
line from 1.975,10.262 to 2.725,9.250
line from 1.975,10.250 to 1.000,9.275
line from 2.975,9.113 	to 3.013,9.109\
	to 3.048,9.105\
	to 3.081,9.102\
	to 3.112,9.099\
	to 3.140,9.095\
	to 3.166,9.092\
	to 3.212,9.086\
	to 3.251,9.081\
	to 3.284,9.075\
	to 3.313,9.069\
	to 3.337,9.063\

line from 3.337,9.063 	to 3.379,9.049\
	to 3.429,9.031\
	to 3.456,9.021\
	to 3.484,9.010\
	to 3.513,8.998\
	to 3.542,8.986\
	to 3.571,8.973\
	to 3.599,8.960\
	to 3.626,8.947\
	to 3.652,8.935\
	to 3.700,8.910\
	to 3.737,8.887\

line from 3.737,8.887 	to 3.762,8.871\
	to 3.789,8.850\
	to 3.819,8.825\
	to 3.853,8.794\
	to 3.892,8.757\
	to 3.938,8.713\
	to 3.963,8.688\
	to 3.990,8.661\
	to 4.019,8.632\
	to 4.050,8.600\

.ps 11
"Automount" at 3.575,8.293 ljust
"\s-2NFS\s0 Mount" at 1.150,8.368 ljust
"\s-2NFS\s0/\s-2RPC\s0" at 3.425,9.168 ljust
.PE
.KE
.LP
In the second stage, when the user actually requests
access to a remote file hierarchy, 
the daemon intercepts the kernel \s-2NFS\s0 request
and looks up the name in the map associated with
the directory. 
Taking the location (\fIserver:pathname\fP)
of the remote file system from the map, the daemon then
mounts the remote file system under the directory
.I /tmp_mnt .
It answers the kernel, telling it is 
a symbolic link.
..IX automount "and symbolic links" "\&\fIautomount\fP" 
..IX "symbolic link"
The kernel sends an \s-2NFS\s0 \s-2READLINK\s0 request,
and the automounter returns a symbolic link
to the real mount point under 
.I /tmp_mnt .
.LP
The behavior of the automounter is affected by whether
the name is found in a direct or an indirect map.
.IP \(bu
If the name is found in a direct map, the automounter
emulates a symbolic link, as stated above. 
It
responds as if a symbolic link exists at its mount point.
In response to a \s-2GETATTR\s0, it describes itself as a 
symbolic link. 
When the kernel follows up with a \s-2READLINK\s0 it returns a
path to the 
.I real
mount point for the remote hierarchy in 
.I /tmp_mnt :
.\".\s-2PS\s0 < diag.c.pic
.KS
.sp
.ce
Figure: Automount's Symbolic Link: Direct Map
.PS
ellipse at 1.300,9.450 wid 0.100 ht 0.100
ellipse at 3.550,9.825 wid 0.100 ht 0.100
ellipse at 3.900,9.500 wid 0.100 ht 0.100
ellipse at 1.288,8.950 wid 0.925 ht 0.925
line from 2.300,10.275 to 1.300,9.488
line from 2.300,10.287 to 1.300,9.500
line from 2.288,10.287 to 1.300,9.500
line from 2.275,10.287 to 3.538,9.875
line from 2.288,10.300 to 3.538,9.887
line from 2.288,10.313 to 3.538,9.900
line from 2.300,10.275 to 1.300,9.475
line from 3.587,9.787 to 3.875,9.537
line from 3.513,9.762 to 3.125,9.475
line from 3.712,9.675 to 3.475,9.488
line from 3.938,9.463 to 4.287,9.100
line from 3.913,9.438 to 3.625,9.150
line from 4.088,9.275 to 3.900,9.100
dashwid = 0.050i
line dashed from 1.488,8.900 to 3.075,9.188
line from 2.981,9.145 to 3.075,9.188 to 2.972,9.194
.ps 11
"Symbolic link" at 2.175,8.881 ljust
"/tmp_mnt" at 3.625,9.956 ljust
"real mount point" at 4.037,9.531 ljust
.PE
.KE
.IP \(bu
If, on the other hand, the name is found in an indirect map,
the automounter emulates a directory of symbolic links.
It describes itself as a directory.
In response to a \s-2READLINK\s0, it returns a path to
the mount point in 
.I /tmp_mnt ,
and a readdir(3) of the automounter's mount point
returns a list of the entries that are
.I currently
mounted:
.\".\s-2PS\s0 < diag.b.pic
.KS
.sp
.ce
Figure: Automount's Symbolic Link: Indirect Map
.PS
ellipse at 0.838,8.425 wid 1.275 ht 1.275
ellipse at 0.838,9.100 wid 0.100 ht 0.100
ellipse at 3.450,9.262 wid 0.100 ht 0.100
ellipse at 2.950,8.975 wid 0.100 ht 0.100
ellipse at 3.263,8.450 wid 0.100 ht 0.100
ellipse at 3.925,7.725 wid 0.100 ht 0.100
line from 3.487,9.200 to 3.925,7.775
line from 3.475,9.213 to 3.275,8.500
line from 3.450,9.188 to 2.950,8.975
line from 2.163,9.813 to 0.850,9.175
dashwid = 0.050i
line dashed from 1.225,8.137 to 3.837,7.763
line from 3.735,7.752 to 3.837,7.763 to 3.742,7.801
line dashed from 1.238,8.387 to 3.188,8.450
line from 3.088,8.422 to 3.188,8.450 to 3.087,8.472
line dashed from 1.225,8.688 to 2.862,8.963
line from 2.768,8.921 to 2.862,8.963 to 2.760,8.971
line from 0.425,8.238 to 1.225,8.238 to 1.225,8.025 to 0.425,8.025 to 0.425,8.238
line from 0.425,8.500 to 1.225,8.500 to 1.225,8.300 to 0.425,8.300 to 0.425,8.500
line from 0.425,8.775 to 1.225,8.775 to 1.225,8.563 to 0.425,8.563 to 0.425,8.775
line from 3.475,9.200 to 3.925,7.775
line from 2.163,9.813 to 3.438,9.313
line from 2.163,9.800 to 3.438,9.300
line from 2.163,9.800 to 3.438,9.300
line from 3.475,9.200 to 3.925,7.775
line from 3.475,9.200 to 3.925,7.775
line from 3.462,9.213 to 3.263,8.500
line from 3.450,9.200 to 2.950,8.988
line from 2.163,9.800 to 3.438,9.300
line from 2.150,9.800 to 0.838,9.162
line from 2.950,8.975 to 2.712,8.650
line from 2.962,8.975 to 3.125,8.650
line from 2.813,8.775 to 2.913,8.637
line from 3.063,8.750 to 3.000,8.637
line from 3.388,8.150 to 3.313,8.050
line from 3.138,8.200 to 3.225,8.050
line from 3.300,8.375 to 3.438,8.063
line from 3.288,8.387 to 3.038,8.063
line from 3.938,7.700 to 3.700,7.362
line from 3.950,7.700 to 4.112,7.362
line from 3.813,7.500 to 3.900,7.350
line from 4.050,7.463 to 3.987,7.350
.ps 11
"mount points" at 3.837,8.343 ljust
"Real " at 3.837,8.518 ljust
"/tmp_mnt" at 3.563,9.356 ljust
"Symbolic links" at 1.663,8.206 ljust
.PE
.KE
.LP
Whatever the case, that is, whether the map is direct
or indirect, if the file hierarchy is already mounted
and the symbolic link has been read recently,
the cached symbolic link is returned immediately.
Since the automounter is on the same host, the
response is much faster than a \s-2READLINK\s0 to a remote
\s-2NFS\s0 server.
On the other hand, if the file hierarchy is not mounted,
a small delay will occur while the mounting takes place.
.NH 3
\&Error Messages Related to \&\fIautomount\fP
..IX "debugging" "and automount" "" "and \&\fIautomount\fP" PAGE START 
.LP
The following paragraphs
are labeled with the error message you are likely to
see if the automounter fails, and an indication of what the
problem may be.
.NH 4
\&Error Messages Generated by the Verbose Option
.LP
.KS
.IP \(bu
\&\fIno mount maps specified\fP
.IP
The automounter was invoked with no maps to serve,
and it cannot find the \*(YP
.I "auto.master" 
map.
It exits.
Recheck the command, or restart \*(YP
if that was the intention.
.KE
.KS
.IP \(bu
\&\fI\&\fImapname\fP: Not found\fP
.IP
The required map cannot be located.
This message is produced only when the 
.I -v 
option is given.
Check the spelling and pathname of the map name.
.KE
.KS
.IP \(bu
\&\fIleading space in map entry \&\fIentry text\fP in \&\fImapname\fP
.IP
The automounter has discovered an entry in an automount
map that contains leading spaces.  This is usually an 
indication of an improperly continued map entry e.g.

.DS
.ft CW
foo    
   /bar     frobz:/usr/frotz   
.DE

.IP
In the example above, the warning is generated when the automounter
encounters the second line, because the first line should be
terminated with a backslash (\e).
.KE
.KS
.IP \(bu
\&\fIbad key "key" in indirect map \&\fImapname\fP
.IP
While scanning an indirect map the automounter has found
an entry key containing a "/".  Indirect map keys must
be simple names - not pathnames.
.KE
.KS
.IP \(bu
\&\fIbad key "key" in direct map \&\fImapname\fP
.IP
While scanning a direct map the automounter has found an
entry key without a prepended "/".  Keys in direct maps
must be full pathnames.
.KE
.KS
.IP \(bu
\&\fI\*(YP bind failed
.IP
The automounter was unable to communicate with the
ypbind daemon.  This is information only - the
automounter will continue to function correctly provided
it requires no explicit \*(YP support.
If you need \*(YP, check to see if there is a ypbind daemon running.
.KE
.KS
.IP \(bu
\&\fICouldn't create mountpoint "mountpoint": \&\fIreason\fP
.IP
The automounter was unable to create a mountpoint required
for a mount.  This most frequently occurs when attempting
to hierarchically mount all of a server's exported file systems.
A required mountpoint may exist only in a file system that
cannot be mounted (it may not be exported) and it cannot
be created because the exported parent file system is 
exported read only.
.KE
.KS
.IP \(bu
\&\fI\s-2WARNING\s0: \&\fImountpoint\fP already mounted on
.IP
The automounter is attempting to mount over an existing
mountpoint.  This is indicative of an internal error in
the automounter (a bug).
.KE
.KS
.IP \(bu
\&\fI\&\fIserver\fP:\&\fIpathname\fP already mounted on \&\fImountpoint\fP
.IP
The automounter is attempting to mount over a previous
mount of the same file system.  This could happen if an
entry appears both in 
.I /etc/fstab 
and in an automounter map (either by accident
or because the output of 
.I "mount -p"
was redirected to
.I fstab ).
Delete one of the redundant entries.
.KE
.KS
.IP \(bu
\&\fIcan't mount \&\fIserver\fP:\&\fIpathname\fP: \&\fIreason\fP
.IP
The mount daemon on the server refuses to provide a
file handle for \&\fIserver\fP:\&\fIpathname\fP
Check the export table on \&\fIserver\fP.
.KE
.KS
.IP \(bu
\&\fIremount \&\fIserver\fP:\&\fIpathname\fP on \&\fImountpoint\fP: server not responding
.IP
The automounter has failed to remount a file system it
previously unmounted.  This message may appear at intervals
until the file system is successfully remounted
.KE
.KS
.IP \(bu
\&\fI\s-2WARNING\s0: \&\fImountpoint\fP not empty!
.IP
The mount point is not an empty directory.
The directory \&\fImountpoint\fP contains entries that will be
hidden while the automounter is mounted there.
This is advisory only.
.KE
.in 0
.NH 4
\&General Error Messages
.KS
.IP \(bu
\&\fIpathok: couldn't find devid \&\fIdevice id\fP
.IP
An internal automounter error (bug)
.KE
.KS
.IP \(bu
\&\fI\s-2WARNING\s0: default option "\&\fIoption\fP" ignored for map \&\fImapname\fP
.IP
Where \&\fIoption\fP is an unrecognized default mount option 
for the map \&\fImapname\fP.
.KE
.KS
.IP \(bu
\&\fI\&\fIoption\fP ignored for \&\fIkey\fP in \&\fImapname\fP
.IP
The automounter has detected an unknown mount option.
This is advisory only.
Correct the entry in the appropriate map.
.KE
.KS
.IP \(bu
\&\fIbad entry in map \&\fImapname\fP "\&\fIkey\fP"\fP
.IP \(bu
\&\fImap \&\fImapname\fP, key \&\fIkey\fP: bad\fP
.IP
The map entry is malformed,
and the automounter cannot interpret it.
Recheck the entry; perhaps there are characters in it that
need escaping.
.KE
.KS
.IP \(bu
\&\fICan't get my address
.IP
The automounter cannot find an entry for its host
in 
.I /etc/hosts (or
.I hosts.byname ).
.KE
.KS
.IP \(bu
\&\fICannot create \s-2UDP\s0 service
.IP
Automounter cannot establish a \s-2UDP\s0 connection.
.KE
.KS
.IP \(bu
\&\fIsvc_register failed
.IP
Automounter cannot register itself as an \s-2NFS\s0 server.
Check the kernel configuration file.
.KE
.KS
.IP \(bu
\&\fIcouldn't create \&\fIpathname\fP: \&\fIreason\fP
.IP
Where \&\fIpathname\fP is 
.I /tmp_mnt 
or the argument to the
-M command line option.
.KE
.KS
.IP \(bu 
\&\fICan't mount \&\fImountpoint\fP: \&\fIreason\fP
.IP
The automounter couldn't mount its daemon at \&\fImountpoint\fP
.KE
.KS
.IP \(bu
\&\fICan't update \&\fIpathname\fP
.IP
Where \&\fIpathname\fP is 
.I /etc/mtab 
it means that the automounter
was not able to update the mount table.
Check the permissions of the file.
.KE
.KS
.IP \(bu
\&\fIexiting
.IP
This is an advisory message only.
The automounter has received a \s-2SIGTERM\s0 (has been killed) and is exiting.
.KE
.KS
.IP \(bu
\&\fI\s-2WARNING\s0: \&\fIpathname\fP: line \&\fIline number\fP: bad entry
.IP
Where \&\fIpathname\fP is 
.I /etc/mtab 
it means that the automounter
has detected a malformed entry in the 
.I /etc/mtab 
file.
.KE
.KS
.IP \(bu
\&\fI\&\fIserver\fP:\&\fIpathname\fP no longer mounted
.IP
The automounter is acknowledging that \&\fIserver\fP:\&\fIpathname\fP
which it mounted earlier has been unmounted by the umount
command.  The automounter will notice this within 1 minute
of the unmount or immediately if it receives a \s-2SIGHUP\s0.
.KE
.KS
.IP \(bu
\&\fItrymany: servers not responding: \&\fIreason\fP
.IP
No server in a replicated list is responding.
This may indicate a network problem.
.KE
.KS
.IP \(bu
\&\fI\&\fIserver\fP:\&\fIpathname\fP - \&\fIlinkname\fP : dangerous symbolic link
.IP
The automounter is attempting to use \&\fIserver\fP:\&\fIpathname\fP as
a mountpoint but it is a symbolic link that resolves to a pathname
referencing a mount point outside of 
.I /tmp_mnt 
(or the mount point set with the
.I \-M 
option).
The automounter refuses to do this mount
because it could cause
problems in the host's file system, e.g. mounting on \(lq/usr\(rq rather
than in \(lq/tmp_mnt\(rq.
.KE
.KS
.IP \(bu
\&\fIhost \&\fIserver\fP not responding
.IP
The automounter attempted to contact \&\fIserver\fP but received
no response.
.KE
.KS
.IP \(bu
\&\fIMount of \&\fIserver\fP:\&\fIpathname\fP on \&\fImountpoint\fP: \&\fIreason\fP
.IP
The automounter failed to do a mount.
This may indicate a server or network problem.
.KE
.KS
.IP \(bu
\&\fIpathconf: \&\fIserver\fP: server not responding
.IP
The automounter is unable to contact the mount daemon on
\&\fIserver\fP that provides (\s-2POSIX\s0) pathconf information.
.KE
.KS
.IP \(bu
\&\fIpathconf: no info for \&\fIserver\fP:\&\fIpathname\fP
.IP
The automounter failed to get pathconf information for
\&\fIpathname\fP.
.KE
.KS
.IP \(bu
\&\fIhierarchical mountpoints: \&\fIpathname1\fP and \&\fIpathname2\fP
.IP
The automounter does not allow its mountpoints to have
a hierarchical relationship i.e. an automounter mountpoint
must not be contained within another automounted file system.
.KE
.KS
.IP \(bu
\&\fI\&\fImountpoint\fP: Not a directory
.IP
The automounter cannot mount itself on \&\fImountpoint\fP
because it's not a directory.
Check the spelling and pathname of the mount point.
.KE
.KS
.IP \(bu
\&\fIdir \&\fImountpoint\fP must start with '/'\fP
.IP
Automounter mount point must be given as full pathname.
Check the spelling and pathname of the mount point.
.KE
.KS
.IP \(bu
\&\fI\&\fImapname\fP: \&\fIyp_err\fP
.IP
Error in looking up an entry in an \*(YP map.
May indicate \*(YP problems.
.KE
.KS
.IP \(bu
\&\fI\&\fIhostname\fP: exports: \&\fIrpc_err\fP
.IP
Error getting export list from \&\fIhostname\fP.
This indicates a server or network problem.
.KE
.KS
.IP \(bu
\&\fInfscast: cannot send packet: \&\fIreason\fP
.IP
The automounter cannot send a query packet to a server
in a list of replicated file system locations.
.KE
.KS
.IP \(bu
\&\fInfscast: cannot receive reply: \&\fIreason\fP
.IP
The automounter cannot receive replies from any
of the servers in a list of replicated file system locations
.KE
.KS
.IP \(bu
\&\fInfscast:select: \&\fIreason\fP
.IP \(bu
\&\fICannot create socket for nfs: \&\fIrpc_err\fP
.IP
All these error messages indicate
problems attempting to 
.I ping 
servers for a replicated
file system.
This may indicate a network problem.
.KE
.KS
.IP \(bu
\&\fI\s-2NFS\s0 server (pid\&\fIn\fP@\&\fImountpoint\fP) not responding still trying\fP
.IP
An \s-2NFS\s0 request made to the automount daemon with
\s-2PID\s0 \&\fIn\fP
serving \&\fImountpoint\fP has timed out.
The automounter may be temporarily overloaded or dead.
Wait a few minutes; if the condition persists,
the easiest solution is to reboot the client.
If not, you have to exit all processes that use automounted
directories
(or, change to a non automounted directory in the case
of a shell), kill the current automount process and restart it again
from the command line.
If this does not work, you have to reboot.
.KE
..IX "debugging" "and automount" "" "and \&\fIautomount\fP" PAGE END 
..IX automount "" "\&\fIautomount\fP" "" PAGE END
