.ds YP \s-2NIS\s0
.if \n(1T .bp
.NH 1
\&The Network Information Service
.LP
..IX NIS "" "" "" PAGE START
..IX  YP  ""  ""  "" PRINT "\fIsee\fP NIS" 
.LP
.NH 2
\&What is \*(YP
.LP
The Network Information Service (\*(YP) was formerly known
as Sun Yellow Pages.  The functionality of the two remains
the same, only the name has changed.  The name Yellow Pages
is a registered trademark in the United Kingdom of British
Telecommunications plc and may not be used without permission.
.LP
There exist however some differences between previous releases of
this service and the one in Release 4.1 of the SunOS operating system.
.LP
..IX NIS "" "" "" PAGE MAJOR
\*(YP is a distributed name service designed
to meet the administrative needs of diverse and
evolving computing communities.
It is a mechanism for identifying
and locating objects and resources accessible to the
community.
It provides a uniform storage and retrieval 
method for network\-wide information in a
transport protocol\- and media\-independent fashion.
.LP
By running the \*(YP service, the system administrator
can distribute administrative databases (maps)
..IX "NIS maps" 
among a variety of machines, and update those databases
from a centralized location in an automatic and
reliable fashion, thus ensuring that all clients
share the same databases in a consistent manner throughout
the network.
Furthermore, the use of the \*(YP \(lqpublickey\(rq
..IX "publickey map"
..IX "NIS maps" "publickey map"
..IX "network security" "publickey map"
..IX security "publickey map"
map permits running secure \s-2RPC\s0 and secure \s-2NFS\s0 across
the network of machines.
.NH 3
\&The \*(YP elements
.LP
The \*(YP service is composed of the following
elements:
.IP \(bu
domains
.IP \(bu
maps
.IP \(bu
daemons: 
.RS
.IP \(bu
.I ypserv 
\(em server process
.IP \(bu
.I ypbind 
\(em binding process
.IP \(bu
.I ypxfrd 
\(em high speed map transfer daemon
.IP \(bu
.I rpc.ypupdated 
\(em server for changing map entries
.IP \(bu
.I rpc.yppasswdd 
\(em server for modifying \*(YP password file
.IP \(bu
.I in.named 
\(em optional (see 
\fIAdministering Domain Name Service\fP)
.RE
.IP \(bu
utilities:
.RS
.IP \(bu
.I ypcat 
\(em list data in a map
.IP \(bu
.I ypwhich 
\(em list name of \*(YP server and maps served
.IP \(bu
.I ypmatch 
\(em match a key to its value in a map
.IP \(bu
.I ypinit 
\(em build and install an \*(YP database.
.IP \(bu
.I yppoll 
\(em get a map's order number from a server
.RE
.IP \(bu
auxiliary utilities:
.RS
.IP \(bu
.I yppush 
\(em propagate data from master to slave \*(YP server
.IP \(bu
.I ypset 
\(em set binding to a particular server
.IP \(bu
.I ypxfr 
\(em transfer data from master to slave \*(YP server
.IP \(bu
.I makedbm 
\(em create dbm file for an \*(YP map
.RE
.LP
This chapter explains how to set up and administer the
\*(YP name service.
Information in the chapter includes:
.IP \(bu
The \*(YP environment, which explains what is an \*(YP 
domain, what are \*(YP servers and clients, and
what are the \*(YP maps.
.IP \(bu
Deploying the \*(YP service, which explains how to establish
an \*(YP domain, how to prepare files on clients and
servers, how to make the maps, how to set up servers
and clients, and how to propagate the maps.
.IP \(bu
Administering Users on an \*(YP Network, which
explains how to add new users to an \*(YP domain and
what are some of the security implications of running \*(YP.
.IP \(bu
Obtaining Map Information, which lists some methods by
which users can browse the information contained in \*(YP maps.
.IP \(bu
Advanced \*(YP Administration, which explains how to update
\*(YP maps, how to modify the Makefile, how to add maps, how
to move master maps to another server, and how to use
\*(YP together with the Domain Name Service.
.IP \(bu
Summary of \*(YP Related Commands
.IP \(bu
Fixing \*(YP Problems
.IP \(bu
Turning Off \*(YP Services
.IP \(bu
Default \*(YP Maps
.LP
.NH 2
\&The \*(YP Environment
.LP 
\*(YP service is provided by the daemons
..IX "ypserv" "" "\&\fIypserv\fP daemon"
..IX daemons "ypserv" "" "\&\fIypserv\fP"
..IX "NIS daemons" "\&\fIypserv\fP"
..IX "ypbind" "" "\&\fIypbind\fP daemon"
..IX daemons "ypbind" "" "\&\fIypbind\fP"
..IX "NIS daemons" "\&\fIypbind\fP"
..IX "ypupdated" "" "\&\fIrpc.ypupdated\fP daemon"
..IX daemons "ypupdated" "" "\&\fIrpc.ypupdated\fP"
..IX "NIS daemons" "\&\fIrpc.ypupdated\fP"
.I ypserv 
and 
.I ypbind ,
and updates are handled by the daemon
.I rpc.ypupdated .
.LP
The \*(YP service uses information contained
in \*(YP
.I maps .
..IX "NIS maps" "" "" "" PAGE MAJOR
..IX map "NIS" "" "" PAGE MAJOR
This information
usually derives from text files such as those traditionally found in the 
.I /etc 
directory.
Each \*(YP map has a
.I mapname .
On a network running \*(YP, \fIat least one\fP \*(YP server per
domain (see below) maintains
a set of \*(YP maps for other hosts in the domain to query.
.LP
.NH 3
\&The \*(YP Domain
.LP
..IX NIS "domain"  ""  ""  PAGE MAJOR
A
.I "\*(YP domain"
shares a common set of maps.
Each domain has a 
.I domainname .
Each machine belongs to a domain; 
machines belonging to the same domain share
the same maps.
.LP
No restrictions are placed on whether a
machine can belong to a given domain, as long
as there is a server (see below) for that domain's maps
in the same network.
If the machine is in a subnet (see the chapter 
\fIThe SunOS Network Environment\fP)
there must be a server within the subnet.
.LP
\s+2\fBNote\fP\s0: The domain name is case sensitive.
.LP
.LP
Assignment to a domain is done at the local level
of each machine through the command
.I domainname ,
as seen below.
.LP
..IX server master "" "" PAGE MAJOR
..IX server slave "" "" PAGE MAJOR
.NH 3
\&\*(YP Machine Types
.LP
There are three types of \*(YP machines:
.IP \(bu
master server
.IP \(bu
slave server
.IP \(bu
client 
.LP
Any machine can be an \*(YP client,
but only machines with disks should be
\*(YP servers, either master or slave.
Servers are also clients.
.LP
.NH 4
\&\*(YP servers
.LP
..IX "NIS server" "" "" "" PAGE START 
By definition, an \*(YP server is
a machine with a disk storing
a set of \*(YP maps
that it makes available to network hosts.
The \*(YP server does not have to be the same
machine as the file server,
unless, of course, it is the
only machine on the network with a disk.
Preferably, also, no \(*\s-2YP\s0 server is a gateway machine, since
this can lead to some problems under heavy load conditions.
.LP
\*(YP servers come in two varieties,
master and slave.
The machine designated as \*(YP 
.I "master server" 
..IX "NIS server" master "" "" PAGE MAJOR
contains the set of
maps that you, the \*(YP administrator, update as necessary.
If there is only one \*(YP server on the
network, designate it as the master server.
Otherwise, designate the machine that
will propagate \*(YP updates with the least
performance degradation.
In all cases, the master server should be running
release 4.x if there is a mixture of machines
running 3.x and 4.x releases in the network.
We recommend that the master server run release 4.1
because of the new 
.I ypxfrd 
daemon to speed map transfers.
.LP
You can designate additional \*(YP servers on the
network as 
.I "slave servers" .
..IX "NIS server" slave "" "" PAGE MAJOR
A slave server has a complete copy of the master's
set of \*(YP maps:
Whenever the master server's maps are updated,
it propagates the updates among the slave
servers.
The existence of slave servers allows the system
administrator to distribute evenly the load
implied in answering \*(YP requests.
It also minimizes the impact of a server becoming
unavailable.
The following diagram is a stylized representation
of the relationship between master, slaves and clients,
where the arrows represent the possible client-server
binding at any one time:
.\".# copy postscript file: figs.ps/yp.relation.ps
.\".CP figs.ps/yp.relation.ps 3.5i "" ""
.\".sp -.75i
.sp
.ne 3.5i
.ce
Figure: Master, slaves and clients
.sp 3.5i
.\".\s-2KS\s0
.\".\s-2FN\s0 "Master, slaves and clients"
.\".\".\s-2PS\s0 < ypic.a.pic
.\".\s-2LP\s0
.\".\s-2PS\s0
.\"arc at 2.434,8.331 from 2.450,8.463 to 2.563,8.363 cw
.\"arc at 2.467,7.947 from 2.550,7.963 to 2.462,7.862 cw
.\"arc at 1.775,8.363 from 1.675,8.350 to 1.762,8.463 cw
.\"arc at 1.759,7.945 from 1.775,7.862 to 1.675,7.950 cw
.\"arc at 3.850,9.463 from 3.862,9.363 to 3.750,9.450 cw
.\"arc at 3.856,9.844 from 3.750,9.850 to 3.850,9.950 cw
.\"arc at 4.494,9.496 from 4.638,9.475 to 4.550,9.363 cw
.\"arc at 4.562,9.865 from 4.537,9.950 to 4.650,9.863 cw
.\"arc at 1.809,9.408 from 1.825,9.325 to 1.725,9.412 cw
.\"arc at 1.811,9.837 from 1.725,9.813 to 1.825,9.925 cw
.\"arc at 2.500,9.425 from 2.600,9.438 to 2.513,9.325 cw
.\"arc at 2.495,9.785 from 2.500,9.925 to 2.625,9.838 cw
.\"arc at 1.594,6.406 from 1.587,6.325 to 1.512,6.400 cw
.\"arc at 1.637,6.631 from 1.512,6.662 to 1.587,6.750 cw
.\"arc at 2.040,6.407 from 2.125,6.412 to 2.063,6.325 cw
.\"arc at 2.028,6.658 from 2.063,6.750 to 2.125,6.675 cw
.\"arc at 2.781,6.416 from 2.800,6.362 to 2.725,6.425 cw
.\"arc at 2.869,6.619 from 2.725,6.688 to 2.800,6.763 cw
.\"arc at 3.275,6.425 from 3.337,6.425 to 3.275,6.362 cw
.\"arc at 3.275,6.700 from 3.275,6.763 to 3.337,6.700 cw
.\"arc at 4.438,6.700 from 4.438,6.763 to 4.500,6.700 cw
.\"arc at 4.447,6.406 from 4.487,6.425 to 4.438,6.362 cw
.\"arc at 4.031,6.619 from 3.888,6.688 to 3.962,6.763 cw
.\"arc at 3.944,6.416 from 3.962,6.362 to 3.888,6.425 cw
.\"arc at 5.520,6.385 from 5.513,6.300 to 5.438,6.362 cw
.\"arc at 5.519,6.631 from 5.438,6.625 to 5.513,6.713 cw
.\"arc at 5.994,6.350 from 6.037,6.375 to 5.987,6.300 cw
.\"arc at 5.969,6.631 from 5.975,6.713 to 6.050,6.638 cw
.\"arc at 5.994,7.697 from 5.975,7.750 to 6.050,7.700 cw
.\"arc at 5.984,7.406 from 6.037,7.425 to 5.987,7.350 cw
.\"arc at 5.501,7.687 from 5.438,7.688 to 5.513,7.750 cw
.\"arc at 5.520,7.435 from 5.513,7.350 to 5.438,7.412 cw
.\"arc at 5.450,8.438 from 5.450,8.375 to 5.388,8.438 cw
.\"arc at 5.473,8.705 from 5.388,8.700 to 5.450,8.787 cw
.\"arc at 5.902,8.457 from 5.987,8.463 to 5.925,8.375 cw
.\"arc at 5.918,8.702 from 5.912,8.787 to 6.000,8.725 cw
.\"arc at 5.967,9.640 from 5.975,9.725 to 6.050,9.662 cw
.\"arc at 5.997,9.369 from 6.037,9.387 to 5.987,9.325 cw
.\"arc at 5.519,9.644 from 5.438,9.650 to 5.513,9.725 cw
.\"arc at 5.494,9.379 from 5.513,9.325 to 5.438,9.387 cw
.\"arc at 3.969,8.094 from 3.962,8.012 to 3.888,8.088 cw
.\"arc at 4.031,8.281 from 3.888,8.350 to 3.962,8.425 cw
.\"arc at 4.434,8.069 from 4.487,8.088 to 4.438,8.012 cw
.\"arc at 4.437,8.361 from 4.438,8.425 to 4.500,8.350 cw
.\"line from 4.862,9.438 to 4.763,9.412 to 4.862,9.387
.\"line from 4.763,9.412 to 5.350,9.412
.\"line from 4.850,9.182 to 4.763,9.238 to 4.814,9.148
.\"line from 4.763,9.238 to 5.300,8.675
.\"line from 4.488,9.155 to 4.412,9.225 to 4.446,9.127
.\"line from 4.412,9.225 to 5.350,7.775
.\"line from 2.789,8.030 to 2.688,8.050 to 2.767,7.984
.\"line from 2.688,8.050 to 5.338,6.787
.\"line from 2.784,7.888 to 2.688,7.925 to 2.755,7.847
.\"line from 2.688,7.925 to 4.162,6.900
.\"line from 2.488,7.680 to 2.413,7.750 to 2.446,7.652
.\"line from 2.413,7.750 to 2.987,6.862
.\"line from 1.288,6.638 to 1.438,6.638
.\"line from 1.288,9.537 to 1.288,6.662
.\"line from 1.525,9.512 to 1.625,9.537 to 1.525,9.563
.\"line from 1.625,9.537 to 1.288,9.537
.\"line from 2.802,9.162 to 2.712,9.213 to 2.768,9.125
.\"line from 2.712,9.213 to 3.800,8.175
.\"line from 2.150,9.213 to 2.150,8.550
.\"line from 2.125,8.650 to 2.150,8.550 to 2.175,8.650
.\"line from 2.712,9.563 to 3.663,9.563
.\"line from 3.563,9.537 to 3.663,9.563 to 3.563,9.588
.\"line from 2.563,8.350 to 2.563,7.963
.\"line from 1.563,8.525 to 2.650,8.525 to 2.650,7.750 to 1.563,7.750 to 1.563,8.525
.\"line from 1.775,8.463 to 2.450,8.463
.\"line from 2.438,7.862 to 1.788,7.862
.\"line from 1.675,7.963 to 1.675,8.350
.\"line from 3.750,9.463 to 3.750,9.850
.\"line from 4.525,9.363 to 3.875,9.363
.\"line from 3.862,9.950 to 4.537,9.950
.\"line from 3.663,10.025 to 4.737,10.025 to 4.737,9.262 to 3.663,9.262 to 3.663,10.025
.\"line from 4.650,9.863 to 4.650,9.463
.\"line from 1.725,9.425 to 1.725,9.813
.\"line from 2.500,9.325 to 1.850,9.325
.\"line from 1.825,9.925 to 2.500,9.925
.\"line from 1.625,9.988 to 2.712,9.988 to 2.712,9.225 to 1.625,9.225 to 1.625,9.988
.\"line from 2.625,9.825 to 2.625,9.425
.\"line from 1.438,6.800 to 2.200,6.800 to 2.200,6.275 to 1.438,6.275 to 1.438,6.800
.\"line from 1.512,6.400 to 1.512,6.662
.\"line from 2.038,6.325 to 1.600,6.325
.\"line from 1.587,6.750 to 2.063,6.750
.\"line from 2.125,6.675 to 2.125,6.400
.\"line from 2.663,6.838 to 3.413,6.838 to 3.413,6.287 to 2.663,6.287 to 2.663,6.838
.\"line from 2.725,6.425 to 2.725,6.688
.\"line from 3.250,6.362 to 2.813,6.362
.\"line from 2.800,6.763 to 3.275,6.763
.\"line from 3.337,6.700 to 3.337,6.425
.\"line from 4.500,6.700 to 4.500,6.425
.\"line from 3.962,6.763 to 4.438,6.763
.\"line from 4.412,6.362 to 3.975,6.362
.\"line from 3.888,6.425 to 3.888,6.688
.\"line from 3.813,6.838 to 4.575,6.838 to 4.575,6.287 to 3.813,6.287 to 3.813,6.838
.\"line from 5.362,6.775 to 6.125,6.775 to 6.125,6.237 to 5.362,6.237 to 5.362,6.775
.\"line from 5.438,6.362 to 5.438,6.625
.\"line from 5.963,6.300 to 5.525,6.300
.\"line from 5.513,6.713 to 5.975,6.713
.\"line from 6.050,6.638 to 6.050,6.362
.\"line from 6.050,7.700 to 6.050,7.412
.\"line from 5.513,7.750 to 5.975,7.750
.\"line from 5.963,7.350 to 5.525,7.350
.\"line from 5.438,7.412 to 5.438,7.688
.\"line from 5.362,7.825 to 6.125,7.825 to 6.125,7.275 to 5.362,7.275 to 5.362,7.825
.\"line from 5.313,8.850 to 6.063,8.850 to 6.063,8.313 to 5.313,8.313 to 5.313,8.850
.\"line from 5.388,8.438 to 5.388,8.700
.\"line from 5.912,8.375 to 5.475,8.375
.\"line from 5.450,8.787 to 5.912,8.787
.\"line from 6.000,8.725 to 6.000,8.438
.\"line from 6.050,9.662 to 6.050,9.387
.\"line from 5.513,9.725 to 5.975,9.725
.\"line from 5.963,9.325 to 5.525,9.325
.\"line from 5.438,9.387 to 5.438,9.650
.\"line from 5.362,9.800 to 6.125,9.800 to 6.125,9.250 to 5.362,9.250 to 5.362,9.800
.\"line from 3.813,8.488 to 4.575,8.488 to 4.575,7.950 to 3.813,7.950 to 3.813,8.488
.\"line from 3.888,8.088 to 3.888,8.350
.\"line from 4.412,8.012 to 3.975,8.012
.\"line from 3.962,8.425 to 4.438,8.425
.\"line from 4.500,8.350 to 4.500,8.088
.\".ps 11
.\""\*(YP master" at 1.800,9.593 ljust
.\""\*(YP slave" at 1.762,8.081 ljust
.\""\*(YP slave" at 3.850,9.593 ljust
.\""client" at 1.563,6.518 ljust
.\""client" at 2.775,6.543 ljust
.\""client" at 3.938,6.543 ljust
.\""client" at 5.487,6.481 ljust
.\""client" at 5.487,7.531 ljust
.\""client" at 5.438,8.556 ljust
.\""client" at 5.487,9.506 ljust
.\""client" at 3.938,8.206 ljust
.\".\s-2PE\s0
.\".\s-2KE\s0
.LP
A server may be a master in regard to one map, and a slave in
..IX "NIS server" "" "" "" PAGE END 
regard to another.  However, 
randomly designating a server as master of one map
and another server as master of another map
can cause a great deal of administrative confusion. 
You are strongly urged to make a
single server the master for all the maps you create
within a single domain.
The examples in this chapter assume that one server is the
master for all maps in the domain.
.LP
.NH 4
\&\*(YP Clients
.LP
.I "\*(YP clients"
..IX "NIS client" "" "" "" PAGE MAJOR
run processes that
request data from maps on the servers.
Clients do not care which server is the master in a 
given domain, since
all \*(YP servers should have the same information. 
The distinction between master and slave server only 
applies to 
.I where
you make the updates. 
.NH 4
\&\*(YP Binding
.LP
..IX NIS binding "" "" PAGE MAJOR
..IX binding NIS "" "" PAGE MAJOR
\*(YP clients get information from the \*(YP server
through the binding process, which does the following:
.IP 1.
A program running on the client (that is,
a client process) needing
information provided by
an \*(YP map, asks
.I ypbind 
for the name of a server.
.IP 2.
..IX "ypbind" "" "\&\fIypbind\fP daemon"
..IX daemons "ypbind" "" "\&\fIypbind\fP"
..IX "NIS daemons" "\&\fIypbind\fP"
The function of
.I ypbind 
is to remember
the address at which the
.I ypserv 
process is listening for requests.
.I ypbind 
sends an \s-2RPC\s0 broadcast message for 
..IX "ypserv" "" "\&\fIypserv\fP daemon"
..IX daemons "ypserv" "" "\&\fIypserv\fP"
..IX "NIS daemons" "\&\fIypserv\fP"
.I ypserv 
processes and binds to the first one to respond.
This information is cached in the file
.I \&\fIdomainname\fP\s+1.\s0\&\fIversion\fP 
in the directory
.I /var/yp/binding\fP 
(see below, subsection 
\fIEstablishing the Domain\fP).  
.IP 3.
.I ypbind 
tells the client process to which server to talk.
The client sends the request directly to the
server.
.IP 4.
The
.I ypserv 
daemon on the \*(YP server handles the request
by consulting the appropriate map, and
.IP 5.
it sends the requested information back to the client.
.LP
The binding between a client and a server can
change in accordance with the network's load,
as the service tries to compensate for the
current activity; that is, a client may get
its information from one server at one time and
from another server at a different time.
.LP
To find out which \*(YP server is currently providing
service to a client, use the
.I ypwhich 
..IX ypwhich "" "\&\fIypwhich\fP \(em who is NIS server" 
command as follows:

.DS
.ft CW
% \&\fBypwhich\fP [\|\&\fIhostname\fP\|]
.DE

where
.I hostname
is the name of the client.
If no 
.I hostname 
is mentioned, 
.I ypwhich 
defaults to the local host (that is,
the machine on which the command is entered.)
.NH 4
\&\&\fIypbind\fP and Subnetting
..IX "ypbind" "subnet" "\&\fIypbind\fP daemon" "and subnetting"
..IX subnet ypbind "" "and \&\fIypbind\fP daemon"
..IX daemons "ypbind" "" "\&\fIypbind\fP"
..IX "NIS daemons" "\&\fIypbind\fP"
.LP
The client process, as seen above, uses an \s-2RPC\s0 broadcast to 
initiate a binding.
Since broadcasts are only local subnet events that are not
routed further, there must be at least one domain server
(master or slave) on the same subnet as the client.  
The domain servers themselves may exist throughout different subnets
since domain map propagation works across subnet boundaries.
In a subnet environment, one common method is, if possible, to make 
the subnet router an \*(YP domain server. 
This allows it to serve clients on either subnet interface.
.NH 3
\&\*(YP Maps
..IX "NIS maps" "location of"
.LP
\*(YP maps are one type of implementation of SunOS databases.
(Other types, not necessarily overlapping, 
are the files generally found in the 
.I /etc 
directory and the \s-2DNS\s0 files.)
.LP
Maps for each domain are located
in a separate, distinct directory,
.I /var/yp/\fIdomainname\fP 
on the \*(YP server.
That is, the maps for machines that belong to
the domain
.I accounting 
will be located in the directory
.I /var/yp/accounting 
on their corresponding
\*(YP server.
.LP
Information in \*(YP maps is organized in the format of
..IX NIS map "" "" "" PAGE START 
..IX  "NIS maps" "" "" "" PAGE START 
.I ndbm 
files.
.LP
\s+2\fBNote\s0\fP: Never make the maps on a slave server.
.LP
.LP
SunOS Release 4.1 supplies a Makefile
in the directory
.I "/var/yp" 
of machines designated as master servers at installation
time.
Running
.I make 
in that directory (as explained below in
\fIMaking the maps\fP) causes
.I makedbm 
to create the default \*(YP maps from the input files.
The last section of this chapter provides a
complete listing and explanation of these maps.
.LP
The
.I ypfiles (5)
and
.I ndbm (3)
man pages completely explain the
.I ndbm 
file format.
Input to
.I makedbm 
must be in the form of
.I "key/value"
pairs, where
.I key
is the first word of each line and
.I value
is whatever follows in that line.
The input can come directly from a file
or from standard input (as when modified
through a script; see below, 
\fIMaking the maps\fP).  After passing through
.I makedbm 
the data is collected in two files,
.I "mapname\&\fI.dir\fP"
and
.I "mapname\&\fI.pag\fP" ,
both in the
.I /var/yp/\&\fIdomainname\fP 
directory on the master server.
.KS
.LP
.ce
Table: A Basic Set of \*(YP Maps
.TS
tab(`);
lw(2.5i) lw(2.5i).
bootparams`netid.byname
ethers.byaddr`netmasks.byaddr
ethers.byname`networks.byaddr
group.bygid`networks.byname
group.byname`passwd.byname
hosts.byaddr`passwd.byuid
hosts.byname`protocols.byname
mail.aliases`protocols.bynumber
mail.byaddr`publickey.byname
netgroup.byhost`rpc.bynumber
netgroup.byuser`services.byname
netgroup`ypservers
.TE
.KE
You may want to use all these maps or only
specific maps.
\*(YP can also serve any number of maps you
create or add when you install other
software products.
.LP
\*(YP services make updating network databases much simpler.
You no longer have to change the administrative files in
.I /etc 
on every machine each time you
modify the network environment. 
For example, when you add a new machine to a network
without \*(YP,
you must update
.I /etc/hosts 
on every machine on the network.
With \*(YP,
you only have to update the 
input file in the master server and run
.I make .
This automatically 
updates the 
.I "hosts.byname 
and
.I "hosts.byaddr" 
maps, among others.
These maps are then transferred to other servers,
and are then available to all the clients.
Then programs that previously consulted
.I /etc/hosts 
send a remote procedure call to the \*(YP servers for the same
information.
The \*(YP server refers to the
.I "hosts.byname" 
and
.I "hosts.byaddr" 
maps, then sends the requested information to the
client.
.LP 
You can use the 
.I ypcat 
command to display the values in a map. 
Its basic format is 
 
.DS
.ft CW
ypcat \fImapname\fP 
.DE
 
where 
.I mapname 
is the name of the map you want to examine or 
its nickname. 
To obtain a list of available map nicknames,
such as 
.I passwd
for 
.I passwd.byname ,
enter
.I "ypcat -x"
or
.I "ypwhich -x"
The nicknames are hard\(hycoded, and can be
neither modified nor added to.
.L
If a map is composed only of keys, as in the case of
.I ypservers ,
use 
.I "ypcat -k"
otherwise 
.I ypcat 
will print blank lines.
The 
.I ypcat (1)
man page describes more options for   
.I ypcat .
.LP
You can use the
.I ypwhich 
command introduced earlier to find out
which server is the master of a particular map.
Type the following:

.DS
.ft CW
% \&\fBypwhich -m \fImap.name\fP
.DE

where
.I map.name
is the name or the nickname of the map whose master you want to find.
.I ypwhich 
responds by displaying the name of the server.
For complete information,
refer to the
.I ypwhich (8)
man page.
.NH 2
\&Deploying the \*(YP Service
..IX NIS "setting up" "" "" PAGE START
.LP
Deploying the \*(YP service consists of the
following steps:
.IP (1) 5
Establishing the domain(s) for your machines
.IP (2)
Preparing network databases for \*(YP service
.\".\s-2IP\s0 (3)
.\"Running the text files through makedbm to produce the maps
.IP (3)
Preparing the files on \*(YP clients
.IP (4)
Preparing network databases on the master server
.IP (5)
Making the maps
.IP (6)
Setting up the master server
.IP (7)
Setting up slave servers
.IP (8)
Setting up \*(YP clients
.IP (9)
Modifying default maps
.IP (10)
Propagating \*(YP maps
.LP
The following sections explain each of the above steps.
.LP
.NH 3
\&Establishing the Domain
..IX NIS domain 
.LP
Before you configure machines as \*(YP servers or
clients, you must prepare the \*(YP domain
by:
.IP \(bu
Giving it a name
.IP
A domain name can be up to 256 characters
long, though you should limit yourself to much shorter
names, with a practical upper limit of 32 characters.
.IP \(bu
Designating which machines will
serve or will be served by the \*(YP domain.
.IP
Once you have chosen a domain name,
make a list of network hosts
that will give or receive \*(YP service
within that domain.
.RS
.IP \(bu
Determine which machine 
should be master server (you can always change 
this at a later date.)
.IP \(bu
List which hosts on the network, if any, are to be slave servers.
.IP \(bu
Finally, list all the hosts that are to be
\*(YP clients.
.RE
.LP
You probably will want all hosts in your network's
administrative domain to
receive \*(YP services, although this
is not strictly necessary.
If this is the case, give the \*(YP domain 
a name within
the network administrative domain.
For instance, in the Internet domain
.I widget.com ,
you could call it 
.I yp.widget.com .
You can also have more than one \*(YP
domain name within the Internet domain.
Refer back to the chapter
\fIThe SunOS Network Environment\fP,
and forward to the chapter
\fIAdministering Domain Name Service\fP
for a full description
of network domain names.
.LP
Before a machine can use \*(YP services,
its correct \*(YP domain name and host name
must be set.
Except in the case of diskless machines, which receive
the appropriate information at boot time from their server,
the host name is taken from a file in
.I /etc 
called
.I hostname.\&\fIxx#\fP ,
where \&\fIxx#\fP stands for a network interface, such as
.I le0 
or
.I ie0 ,
and the domain name is taken from the file
.I /etc/defaultdomain .
.LP
SunInstall 
automatically updates these files
for every machine you have it configure.
Thereafter, when these machines boot,
their host names and
\*(YP domain names are set through
.I /etc/rc.boot 
and 
.I /etc/rc.local 
respectively, where the above mentioned files are consulted.
.LP
However, if you want to change
the \*(YP domain name
or host name on a machine,
log in as superuser,
and edit the
.I /etc/defaultdomain 
file, changing its present content with the new domain
name for the machine.
To change the host name, edit the
appropriate
.I hostname.\&\fIxx#\fP 
file (there will be more than one if the machine has
more than one network interface), and replace the
old host name with the new one.
Reboot the machine: 
After changing the domainname or the hostname you
must reboot it, because some library routines
may have cached the old domainname
and/or hostname, and it is the only way of
changing the cache.
.NH 3
\&Preparing Network Databases for \*(YP Service
.LP
Until \*(YP is deployed, each host accesses
network information through the local
.I /etc 
files.
After \*(YP is set up, hosts should obtain information
from the \*(YP maps,
rather than from the local files.
For this to happen the local administrator of each host,
or the system administrator, must
abbreviate or eliminate the files in
.I /etc 
that represent the same databases as
the \*(YP maps.
Files on the master server should also be prepared.
These files are:
.DS
.ft CW
passwd
hosts
ethers
group
networks
protocols
services
aliases
netmasks
.DE
.LP
.NH 3
\&Preparing Files on \*(YP Clients
.LP
..IX "network databases" "modifications for NIS"
Here are the changes, if any, that have to be made
to
.I /etc 
files on all \*(YP clients.
These changes should be made either by the system administrator
through the file server, or by the local administrator of each
host.
Note that
the files
.I networks ,
.I protocols ,
.I ethers ,
and
.I services 
need not be present on any \*(YP clients.
However, if a client will on occasion not run \*(YP, 
make sure that the above mentioned files do have
valid data in them.
.SH
\&Preparing \&\fIhosts.equiv\fP
.LP
The
.I hosts.equiv 
file, which is fully described in
\fIThe SunOS Network Environment\fP, 
does not have an equivalent \*(YP map.
However,
either the system administrator or the local administrator
can add escape sequences to it
that reference the \*(YP hosts database.
.LP
\s+2\fBNote\fP\s0: This is unsafe if there are untrusted hosts
in the network.
.LP
.LP
If
.I hosts.equiv 
contains a single line with only the character
.I + 
(plus) in it, then anyone listed in the password database
(whether in the local 
.I passwd 
file or, if it contains a
.I + ,
in the \*(YP map)
can access the machine from any known host.
This is the default.
.LP
Designating trusted groups allows for
more control over logins.
Trusted groups are
described in the chapter
\fIAdministering Security\fP.  
\*(YP assumes that
the trusted group name appearing after
the 
.I +@ 
or
.I -@ 
sign is a netgroup defined in the 
.I netgroups 
map.
Refer to 
\fIThe SunOS Network Environment\fP
for more information.
.LP
If a machine's
.I hosts.equiv 
does not have escape sequences, 
only by the entries
in the file determine granting remote access, 
and \*(YP maps are not consulted.
.SH
\&Preparing \&\fI.rhosts\fP
.LP
..IX rhosts NIS "\&\fIrhosts\fP file" "and NIS"
.I "\&.rhosts" 
also does not have an equivalent \*(YP map.
\fIThe SunOS Network Environment\fP
fully discusses its format and restrictions.
Make the list of trusted hosts
explicit, or use netgroup names for the same purpose.
You can not use secondary hostnames (nicknames) in your
.I .rhosts 
or
.I hosts.equiv 
files.
You can, however, use secondary hostnames
in
.I /etc/hosts .
All of the
above files are related in that they enable remote machines to access
local machines in some fashion.
.NH 4
\&Preparing \&\fIhosts\fP
.LP
Even when set up for receiving \*(YP service,
the client's
.I /etc/hosts 
..IX hosts NIS "\&\fI/etc/hosts\fP file" "and NIS"
file must contain entries for the local host's name,
and the local loopback name.  
If the client is a diskless machine, it also must
contain the address of its file server.
The
.I "/etc/hosts" 
file is accessed at boot time before
the client's
.I ypbind 
daemon starts up.
Once
.I ypbind 
is running, the local
.I /etc/hosts 
file is not accessed at all.  
Rather, information is obtained from the
.I hosts.byaddr 
and
.I hosts.byname 
maps. 
Refer to 
\fIThe SunOS Network Environment\fP
for more information on
.I "/etc/hosts" .
.NH 4
\&Preparing \&\fIpasswd\fP
..IX passwd NIS "\&\fI/etc/passwd\fP file" "and NIS"
.LP
Programs first consult an \*(YP client's local
.I "/etc/passwd" 
file to determine access permission
before consulting the \*(YP maps.
Therefore, every client's
.I "/etc/passwd" 
should contain entries for root and the primary users
of the machine.
.I "/etc/passwd" 
should also have the
.I + 
escape entry to force the use of the 
.I passwd.byname 
and
.I passwd.byuid 
\*(YP maps.
If there is no
.I + 
entry, programs will not
consult the \*(YP maps at all.
.LP
A sample \*(YP client's
.I /etc/passwd 
file looks like:

.DS L
.ft CW
root:9wxntql2t\s-2HT\s0.k:0:1:Operator:/:/bin/csh
nobody:*:65534:65534::/:
daemon:*:1:1::/:
sys:*:2:2::/:/bin/csh
bin:*:3:3::/bin:
uucp:*:4:8::/var/spool/uucppublic:
news:*:6:6::/var/spool/news:/bin/csh
ingres:*:7:7::/usr/ingres:/bin/csh
audit:*:9:9::/etc/security/audit:/bin/csh
sync::1:1::/:/bin/sync
sysdiag:*:0:1:Old System Diagnostic:/usr/diag/sysdiag:/usr/diag/sysdiag/sysdiag
sundiag:*:0:1:System Diagnostic:/usr/diag/sundiag:/usr/diag/sundiag/sundiag
stefania:7kj\s-2DXZD\s0/Hug2s:624:20:Stefania:/home/dancer/samba:/bin/csh
+:
.DE

.LP
\s+2\fBNote\s0\fP:
The +: notation is the default entry 
in the 
.I passwd 
file created at installation time.
However, the 
.I passwd 
program will change this notation to "+::0:0:::".   
Both notations are equivalent.
.LP
.LP
The last line informs the library routines to use the \*(YP maps.
If you remove that line,
you will disable \*(YP password access.
.LP
Earlier entries in 
.I "/etc/passwd" 
take precedence over, or 
.I mask ,
later entries with the same user name or same user \s-2ID\s0.
Therefore, please note the order of the entries for the daemon and
sync user names (which have the 
same user \s-2ID\s0) and make sure that order is not altered
in your own file.
.LP
.NH 4
\&Preparing \&\fIgroup\fP
..IX group NIS "\&\fI/etc/group\fP file" "and NIS"
.LP
For an \*(YP client, you can reduce
.I "/etc/group" 
to a single line:

.DS
.ft CW
+:
.DE

The
.I + 
escape sequence
forces all translation of group names and group \s-2ID\s0s to be
made via the \*(YP maps.  This is the recommended procedure.
.NH 3
\&Preparing Network Databases on the Master Server
.LP
Setting up the master server, as seen later in this chapter,
converts
the input text files on the master server
into \*(YP master server maps.
Before doing this, however,
you need to take several precautions.
.LP
The input files may be located either in the master
server's 
.I /etc 
directory or in some other directory.
Having them in
.I /etc 
may have the disadvantage that then the contents of the master server's
local files will be the same as that of the maps.
.LP
If on the other hand you choose to locate
the input files in some other directory, you will have to modify the
Makefile in 
.I /var/yp 
by changing the line that says
.DS
.ft CW
\s-2DIR\s0=/etc
.DE
to say
.DS
.ft CW
\s-2DIR\s0=/\&\fIyour_choice\fP
.DE
(see below, 
\fIModifying the Makefile\fP)
and treat the server's local files as those of a client.
.LP
Check the following input files on the master server
to make sure they reflect an up-to-date picture of your system:
.DS
.ft CW
passwd
hosts
ethers
group
networks
protocols
services 
bootparams
netgroup
.DE
An entry for the daemon user \s-2ID\s0 must be present
in the local
.I "passwd" 
file for both master and slave server.
Furthermore, that entry must precede any other
entries with the same user \s-2ID\s0, as described
previously for setting up the client's
.I /etc/passwd 
file.
.LP
Also,
make sure the
.I aliases 
input file is complete
by verifying that
it contains all the mail aliases that you
want to have available 
.I throughout
the domain.
Refer to the chapter on
\fIAdministering Electronic Mail\fP,
and the
.I aliases (5)
man page for more information.
.NH 4
\&The \&\fIpublickey\fP map
..IX "publickey map" "" "" "" PAGE MAJOR
..IX "NIS maps" "publickey map" "" "" PAGE MAJOR
..IX "network security" "publickey map" "" "" PAGE MAJOR
..IX security "publickey map"
.LP
If you are planning on running secure \s-2RPC\s0 or
secure \s-2NFS\s0
as a means of providing secure networking,
you need to prepare the 
.I publickey 
file.
.tr ~'
.LP
This file consists of three fields in the following
format:

.DS
.ft CW
user name	 user's public key : user's secret key
.DE

where
.I "user name"
may be the name of a user or of a machine,
.I "user~s public key"
is that key in hexadecimal notation, and
.I "user~s secret key"
is that key also in hexadecimal notation, encrypted
by the user~s password.
.LP
.tr ~~
Since nobody expects you to be conversant in
hexadecimal notation, the program 
.I newkey 
is provided to make things easier.
The program creates a new public/secret key pair in the
.I publickey 
file, encrypted with the login password of the given user.
.LP
Users can later on modify their own entries, or can
even create them, by using the
program 
..IX chkey "" "\&\fIchkey\fP \(em change encryption key"
.I chkey .
..IX newkey "" "\&\fInewkey\fP \(em create key in the \&\fIpublickey\fP database"
.LP
For instructions on the use of
.I newkey 
and
.I chkey ,
consult their respective man pages in the
\fISunOS Reference Manual\fP,
and the section on 
\fISecure NFS\fP
in the chapter
\fIThe Sun Network File System Service\fP.  
.LP
Note that in order for 
.I newkey 
and
.I chkey 
to be able to run properly, the daemon
.I rpc.ypupdated 
..IX daemons ypupdated "" "\&\fIypupdated\fP"
..IX "NIS daemons" ypupdated "" "\&\fIypupdated\fP"  
..IX ypupdated "" "\&\fIypupdated\fP daemon"
must be running on the master server.
If it is not running at this point, enter

.DS
.ft CW
# \&\fBrpc.ypupdated\fP
.DE

and also make sure that the master server's
.I /etc/rc.local 
file contains the lines 

.DS
.ft CW
umask 022
if [ -f /usr/etc/rpc.ypupdated -a -d /var/yp/`domainname` ]; then
	rpc.ypupdated;		echo -n ' ypupdated'
fi
.DE

.LP
The
.I ypupdated 
daemon consults the file
.I /var/yp/updaters 
for information about which maps should be updated
and how to go about it.
In the case of the 
.I publickey.byname 
map, changes to the
.I publickey 
text file affected through 
.I newkey 
or
.I chkey 
are mediated by 
.I /usr/etc/yp/udpublickey .
.KS
.LP
.I updaters 
is a 
.I make 
file, and it is installed by default with an entry
for 
.I /etc/publickey .
If you modify
.I publickey 's
directory in 
.I /var/yp/Makefile 
(that is, if you want the 
.I publickey 
file to be in a directory other than
.I /etc )
you should also modify the variable
\s-2DIR\s0 in
.I updaters 
in a manner similar to that specified below in
\fIModifying the Makefile\fP.  
.KE
.LP
.NH 4
\&Other Maps
.LP
Most maps, unlike 
.I publickey.byname ,
do not need the assistance of special
programs for their creation or modification.
For instance, if you are planning on having distributed
automounter files (for more information on the automounter,
see the chapter \fIUsing the NFS Automounter\fP) 
all you have to do is write the automounter files as they would reside
in a machine's 
.I /etc 
directory, but make sure that the notation
.I +\&\fImapname\fP 
at the beginning of a line,
as an indication to consult the corresponding \*(YP map,
is not present in the input files that you prepare for 
.I makedbm 
on the master server.
..IX NIS map "" "" PAGE END 
..IX  "NIS maps" "" "" "" PAGE END 
.LP
.NH 3
\&Making the maps
.LP
The next step, after creating the input files,
is to convert them
into the
.I dbm 
format that the \*(YP service expects.
This is done automatically for you by 
..IX ypinit "" "\&\fIypinit\fP \(em make NIS database"
.I ypinit 
when you call it on the master server, as explained
below, in 
\fISetting Up the Master Server\fP.  
.I ypinit 
(among other things) calls the program 
.I make ,
which uses the Makefile located in
.I /var/yp .
.LP
.NH 4
\&The default Makefile
.LP
..IX NIS "Makefile" "" "and \&\fIMakefile\fP"
..IX makedbm "" "\&\fImakedbm\fP"
A Makefile is provided for you in the directory
.I /var/yp .
It contains the commands needed to transform
the input files
into the desired 
.I dbm 
format.
Unless you add non-default maps, or change the value of
.I \s-2DIR\s0 
in the Makefile, as explained later, you will not need
to ever modify it.
The Makefile contains commands for 
.I make ,
and is similar to the following:

.DS L
.ft CW
#
#	@(#)make.script 1.30 89/05/09 \s-2SMI\s0
#
# Set the following variable to "-b" to have yp servers use the domain name
# resolver for hosts not in the current domain. 
#B=-b
B=
\s-2DIR\s0 =/etc
\s-2DOM\s0 = `domainname`
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
.\"\s-2NOPUSH\s0 = ""
.\"\s-2ALIASES\s0 = /etc/aliases
.\"\s-2YPDIR\s0=/usr/etc/yp
.\"\s-2YPDBDIR\s0=/var/yp
.\"\s-2YPPUSH\s0=$(\s-2YPDIR\s0)/yppush
.\"\s-2MAKEDBM\s0=$(\s-2YPDIR\s0)/makedbm
.\"\s-2REVNETGROUP\s0=$(\s-2YPDIR\s0)/revnetgroup
.\"\s-2STDETHERS\s0=$(\s-2YPDIR\s0)/stdethers
.\"\s-2STDHOSTS\s0=$(\s-2YPDIR\s0)/stdhosts
.\"\s-2MKNETID\s0=$(\s-2YPDIR\s0)/mknetid
.\"\s-2MKALIAS\s0=$(\s-2YPDIR\s0)/mkalias
.\"
.\"\s-2CHKPIPE\s0=  || (  echo "yp make terminated:" $@ 1>&2; kill -\s-2TERM\s0 0 )
.\"
.\"
.\"k:
.\"	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2MAKE\s0)  $(\s-2MFLAGS\s0) -k all; \e
.\"	else $(\s-2MAKE\s0) $(\s-2MFLAGS\s0) -k all \s-2NOPUSH\s0=$(\s-2NOPUSH\s0);fi
.\"
all: passwd group hosts ethers networks rpc services protocols \e
	netgroup bootparams aliases publickey netid netmasks c2secure
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
.\"
.\"c2secure:
.\"	-@if [ -f $(\s-2DIR\s0)/security/passwd.adjunct ]; then \e
.\"		if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2MAKE\s0)  $(\s-2MFLAGS\s0) -k \e
.\"		passwd.adjunct.time group.adjunct.time; \e
.\"		else $(\s-2MAKE\s0) $(\s-2MFLAGS\s0) -k \s-2NOPUSH\s0=$(\s-2NOPUSH\s0) \e
.\"		passwd.adjunct.time group.adjunct.time; \e
.\"		fi; \e
.\"	fi
.\"
passwd.time: $(\s-2DIR\s0)/passwd
	@(awk '\s-2BEGIN\s0 { \s-2FS\s0=":"; \s-2OFS\s0="\et"; } /^[a-zA-Z0-9_]/ { print $$1, $$0 }' $(DI
R)/passwd  $(\s-2CHKPIPE\s0))| $(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/passwd.byname; 
	@(awk '\s-2BEGIN\s0 { \s-2FS\s0=":"; \s-2OFS\s0="\et"; } /^[a-zA-Z0-9_]/ { printf("%-10d ", $$3);
 print $$0 }' $(\s-2DIR\s0)/passwd $(\s-2CHKPIPE\s0))| $(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/passwd.b
yuid; 
	@touch passwd.time; 
	@echo "updated passwd"; 
	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) -d $(\s-2DOM\s0) passwd.byname; fi
	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) -d $(\s-2DOM\s0) passwd.byuid; fi
	@if [ ! $(\s-2NOPUSH\s0) ]; then echo "pushed passwd"; fi

group.time: $(\s-2DIR\s0)/group
	@(awk '\s-2BEGIN\s0 { \s-2FS\s0=":"; \s-2OFS\s0="\et"; } { print $$1, $$0 }' $(\s-2DIR\s0)/group $(\s-2CHKPI\s0
\s-2PE\s0))| $(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/group.byname; 
	@(awk '\s-2BEGIN\s0 { \s-2FS\s0=":"; \s-2OFS\s0="\et"; } { printf("%-10d ", $$3); print $$0 }' $(
\s-2DIR\s0)/group $(\s-2CHKPIPE\s0)) | $(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/group.bygid; 
	@touch group.time; 
	@echo "updated group"; 
	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) -d $(\s-2DOM\s0) group.byname; fi
	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) -d $(\s-2DOM\s0) group.bygid; fi
	@if [ ! $(\s-2NOPUSH\s0) ]; then echo "pushed group"; fi
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
passwd: passwd.time
group: group.time
hosts: hosts.time
ethers: ethers.time
networks: networks.time
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
				\fB\&\s+1.\s0\fP
.\"rpc: rpc.time
.\"services: services.time
.\"protocols: protocols.time
.\"netgroup: netgroup.time
.\"bootparams: bootparams.time
.\"aliases: aliases.time
.\"publickey: publickey.time
.\"netid: netid.time
.\"passwd.adjunct: passwd.adjunct.time
.\"group.adjunct: group.adjunct.time
netmasks: netmasks.time
$(\s-2DIR\s0)/netid:
.DE

The function of the Makefile is to create, for each of the databases
listed under
.I all ,
the appropriate maps for \*(YP to use.
In most cases the input file must first be cleaned of comment 
and other extraneous lines through some 
.I sed 
or 
.I awk 
script.
Then the fields of the file must be ordered correctly for 
.I makedbm .
This is very clear in the case of 
.I passwd .
In order to create the map 
.I passwd.byname 
makedbm must be passed the
.I "key/value"
pair of
.I "name/entry" 
while in order to create the
.I passwd.byuid 
the pair must be
.I "uid/entry" .
This is accomplished by the 
.I awk 
script that in the first case passes to makedbm
the first field of the password file and then the whole
entry, and in the second case passes the third field
followed, again, by the whole entry.
.LP
.NH 3
\&Setting Up the Master Server
..IX "NIS server" master
..IX server master
.LP
The
.I /usr/etc/yp/ypinit 
shell script helps you establish the master and slave servers.
It also runs
.I make 
initially to create the maps, and starts their propagation.
.LP
If servers in the network are running release 3.x and 4.x of the
SunOS operating system, always choose a server running 4.x to be
your master server. 
A server running 4.1 is in fact to be preferred over one running
previous releases because of performance improvements.
..IX ypinit "" "\&\fIypinit\fP \(em make NIS database"
..IX "NIS maps" "propagating"
.LP
You use 
.I ypinit 
to build a fresh set of \*(YP maps on the master server in 
the following way:
.IP 1.
Boot the machine that is going to be your master 
server in single\(hyuser mode, 
and, as superuser:
.\".\s-2IP\s0 2.
.\"If you have added maps (that is, files in the 
.\".L /etc
.\"directory that you want converted into \*(YP maps), as 
.\"in the example above, edit 
.\".L /usr/sbin/ypinit :
.\"look for the line that says
.\".\s-2BS\s0
.\".\s-2LS\s0
.\"maps="publickey netid"
.\".\s-2LE\s0
.\".\s-2BE\s0
.\"and change it to
.\".\s-2BS\s0
.\".\s-2LS\s0
.\"maps="auto.direct auto.home auto.master publickey netid"
.\".\s-2LE\s0
.\".\s-2BE\s0
.\"(or whatever combination is appropriate for your case.)
.IP 2.
Type

.DS
.ft CW
# \&\fBcd /var/yp\fP
# \&\fB/usr/etc/yp/ypinit \|-m\fP
.DE

.IP 3.
.I ypinit 
asks whether you want the procedure
to terminate at the first non-fatal error or
continue despite non-fatal errors.
.IP
If you choose the first option,
.I ypinit 
will exit upon encountering the first problem;
you can then fix it
and restart
.I ypinit .
This is
recommended if you
are running
.I ypinit 
for the first time.
If you prefer to continue, 
you can try to fix by hand all problems that may occur,
then restart 
.I ypinit .
.IP 4. 
.I ypinit 
prompts for a list of other hosts to become \*(YP servers.
Enter the name of all other \*(YP servers.
.IP 5.
Once 
.I ypinit 
has constructed the list of servers, it start
.I make (1).
This program uses the instructions contained in the
Makefile file (either the default one or the one you modified)
located in 
.I /var/yp :
it cleans all comment lines from the files
you designated and runs
.I makedbm 
on them, creating the appropriate maps
and establishing the name of the master server for
each map.
.LP
Note that if the map or maps being pushed by the Makefile
correspond to a domain other than the one returned by
the command 
.I domainname 
on the master, you can make sure that they are pushed to the
correct domain by starting make in the 
.I ypinit 
shell script with a proper identification of the variable
.I \s-2DOM\s0 :

.DS
.ft CW
make \s-2DOM\s0=\&\fIcorrect_domain\fP passwd
.DE

will push the password map to the intended domain instead of
the domain to which the master belongs.
.LP
For security reasons,
you may want to restrict access to the master \*(YP
machine to a smaller set of users than that defined in its
.I /etc/passwd 
file.
To do this, copy the complete file and give the copy
a name and path
other than 
.I /etc/passwd .
Edit out undesired users from the
remaining 
.I /etc/passwd .
For a security-conscious system, this
smaller file should not include the \*(YP escape entry (+).
.NH 4
\&Creating the Master Server
..IX "NIS server" master
..IX server master
.LP
Now that the master maps are created,
you can create the master
server and begin \*(YP service.
To do this, you have to run
.I ypinit 
again, then start up
.I ypserv 
on the server.
When a client requests information from the server,
.I ypserv 
is the daemon that 
answers information requests from clients after looking it up
in the
\*(YP maps.
.IP 1.
From
.I /var/yp ,
type the following

.DS
.ft CW
# \&\fB/usr/etc/yp/ypinit -m\fP
.DE

to set up the master server.
.IP 2.
Next, type

.DS
.ft CW
# \&\fBypserv\fP
.DE

to start providing \*(YP services.
The next time you boot the server,
.I ypserv 
will automatically start up from 
.I /etc/rc.local .
.IP 3
Look for the following lines on the master server's 
.I /etc/rc.local 
file:

.DS
.ft CW
if [ -f /usr/etc/ypserv -a -d /var/yp/`domainname` ]; then
        ypserv;                 echo -n ' ypserv'
#
#       Master \s-2NIS\s0 server runs the \s-2XFR\s0 daemon
#
#       ypxfrd;                 echo -n ' ypxfrd'
fi
.DE

and uncomment the line that says:

.DS
.ft CW
#       ypxfrd;                 echo -n ' ypxfrd' 
.DE

.IP 4
Finally, type

.DS
.ft CW
# \&\fBypxfrd\fP
.DE

to start the high speed transfer daemon (always do this only
on the master server.)
The next time you boot the master server,
.I ypxfrd 
will automatically start up from
.I /etc/rc.local .
.LP
.NH 3
\&Setting Up Slave Servers
..IX "NIS server" slave "" "" PAGE START 
..IX server slave "" "" PAGE START 
.LP
Your network can have one or more \*(YP
slave servers.  
Having slave servers ensures the continuity of
\*(YP services in the event of the master server
being down.
Before actually running
.I ypinit 
to create the slave servers, you should
take several precautions.
.LP
The domain name for
each \*(YP slave must be the same as that
for the \*(YP master server.
Use the
.I domainname 
..IX domainname "" "\&\fIdomainname\fP \(em set/display domain name"
command
on each \*(YP slave to make
sure they are consistent with
the master server.
Make any changes to the domain 
name as necessary, as described
in the previous section,
\fIEstablishing the Domain\fP.  
Also, do not forget to set each slave server's
correct host name. 
.LP
As you did with the \*(YP master server, you must also
check that every slave server's
password database
contains an entry for the daemon user name
and that it precedes other entries with the
same user \s-2ID\s0.
.LP
Make sure that
the network is working properly before
you set up a slave \*(YP server.
In
particular, check that you can use
.I rcp 
to send files from the master \*(YP server to \*(YP slaves.
If you cannot, follow the procedures outlined
in \fIThe SunOS Network Environment\fP
to permit the use of 
.I rcp .
.LP
Now you are ready
to create a new slave server.
.IP 1.
Reboot each slave server in single user mode.
.IP 2.
Change directory
to
.I /var/yp .
.\".\s-2IP\s0 3.
.\"Modify the \(lqmaps\(rq line in ypinit as you did
.\"in the master server (see above, \(lqSetting the
.\"master server\(rq).
.\".\s-2IP\s0 3.
.\"Type the following:
.\".\s-2BS\s0 \s-2GRAY\s0
.\".\s-2LS\s0
.\"# \&\fB/usr/sbin/ypinit -c
.\".\s-2LE\s0
.\".\s-2BE\s0
.\"Enter the names of the \*(YP servers in order of preference;
.\"that is, enter first the names of the servers that are 
.\"physically closer to the machine in the network. 
.\"If the client is also a server, enter its name first.
.\"This initializes the client and establishes its servers
.\"for binding.
.IP 3.
Type the following:

.DS
.ft CW
# \&\fBypbind\fP
.DE

.IP 4.
Type the following:

.DS
.ft CW
# \&\fB/usr/etc/yp/ypinit -s \&\fImaster\fP
.DE

where
.I master
is the hostname of the existing \*(YP master server.
.\" \s-2NOT\s0 \s-2TRUE\s0 \s-2ACCORDING\s0 \s-2TO\s0 \s-2YOONKIM\s0
.\"Ideally, the named host really is the master server, but it can
.\"be any host with a stable set of \*(YP maps, such as another
.\"slave server.
.IP
.I ypinit 
will not prompt you for a list
of other servers, as it does when you create
the master server.
However, it does let you choose whether
to halt at the first non-fatal error.
.I ypinit 
then calls the program
.I ypxfr ,
which transfers a copy of the master's \*(YP map set to the
slave server's
.I /var/yp/\fIdomainname\fP 
directory.
.IP 5.
When
.I ypinit 
terminates, make backup copies of the
.I /etc/passwd 
and
.I /etc/group 
files, and edit the original files by adding 
.I +: 
to the end so they refer to the \*(YP maps.
This applies also to whatever non-default maps
you may have added to the Makefile.
For instance, if there is an
.I auto.direct 
\*(YP map, the file 
.I /etc/auto.direct 
should also be copied to another file and the original
should contain a line similar to

.DS
.ft CW
+auto.direct
.DE

Thus, whenever the automounter reads this file,
it will consult the \*(YP
.I auto.direct 
map upon reaching this line.
.IP
The above procedures ensure that processes on the
slave server also use the \*(YP services,
rather than files in the local
.I /etc .
.IP 6.
Type

.DS
.ft CW
# \&\fBypserv\fP
.DE

to begin \*(YP services on the slave server.
The next time you reboot the \*(YP slave, 
.I ypserv 
will start automatically from
.I /etc/rc.local .
.LP
Repeat the procedures above for each machine you
want configured as an \*(YP slave server.
..IX "NIS server" slave "" "" PAGE END 
..IX server slave "" "" PAGE END 
.LP
.NH 3
\&Setting Up \*(YP clients
..IX "NIS client"
.IP 1.
Edit the client's local files, as you did
for the local files in the slave servers,
so that processes consulting those files are
sent to the \*(YP maps.
.IP 2.
Type

.DS
.ft CW
# \&\fBps -aux | grep ypbind\fP
.DE

to confirm that
.I ypbind 
is running.
If it is not, enter the command from the command line,
and inspect the 
.I /etc/rc.local 
file to make sure that the following
lines are there, and are not commented out:

.DS
.ft CW
if [ -d /var/yp ]; then
	if [ -f /etc/security/passwd.adjunct ]; then
		ypbind -s;	echo -n ' ypbind'
	else
		ypbind;		echo -n ' ypbind'
	fi
fi
.DE

At this point, you must have at least one
\*(YP server configured on the network (or on the
subnet, if you are subnetting). 
Otherwise, processes on the client hang if no
\*(YP server is available while 
.I ypbind 
is running.
If the client is in C2 security mode, 
.I ypbind 
will be started with the 
.I -s 
option, and will accept bindings only to 
.I ypserv 
processes run as root.
If none such is available, the situation is the same as
having none in the network, and
.I ypbind 
will hang.
.IP 3.
Add entries for the client in the following maps:
..IX "NIS maps" "modifying"
.DS
.ft CW
ethers
hosts
bootparams
netgroup \fR(If applicable)
.DE
.IP 4.
Have users in the client use the
.I yppasswd 
command to create their new passwords
in the
.I passwd 
maps.
For this to work, the 
.I rpc.yppasswdd 
daemon must be running in the master server.
Users can also use
.I "passwd -y"
to the same effect, or
.I "passwd" 
alone if they do not have an entry
in the machines' local
.I /etc/passwd 
file.
.LP
Notice that running the
.I passwd 
command
only affects the local client's environment when the
user has an entry in the local 
.I passwd 
file.
In this case, you must run
the
..IX yppasswd "" "\&\fIyppasswd\fP \(em change login password in NIS"
.I yppasswd 
command to change the \*(YP password maps.
Its syntax is:

.DS
.ft CW
% \&\fByppasswd\fP [ \fIlogin_name\fP ]
.DE

When a user types the above command,
.I yppasswd 
prompts for the new password twice,
as does the local
.I passwd 
command.
However, when the user has successfully responded,
.I yppasswd 
(or 
.I passwd 
when acting as such)
puts the new password in the
.I passwd.byname 
and
.I passwd.byuid 
maps.
A user's \*(YP password can be different from the password on
his or her own machine.  
If the 
.I rpc.yppasswdd 
daemon is not set to make and propagate the newly
modified password database immediately, there may be
a considerable time lag between the time the user sets 
the new \*(YP password and the time it takes effect.
Even when it is, map pushing is not
instantaneous, so if it takes a while it does not mean
that the process failed.
.NH 4
\&Heterogenous Slaves
..IX server slave
..IX "NIS server" slave
.LP
A problem with the use of a 3.x \*(YP slave with a 4.x master may 
initially exist after setting up the 3.x slave.   
Because the 3.x 
.I ypinit 
program does not know of the complete set of 4.x \*(YP maps, when a 
3.x slave is initialized 
.I "ypinit -s
the 
.I ypinit 
program only runs
.I ypxfr 
for traditional 3.x maps (e.g. 
.I hosts ,
.I passwd ,
.I ethers ).
This means the \*(YP slave will not initially have the 
entire 4.x set of \*(YP maps (e.g. 
.I publickey ,
.I netid ,
.I netmasks )
and consequently the two databases will not be entirely synchronized.
For the slave to fully support the \*(YP domain,
the full set of master \*(YP maps must be transferred to the 3.x slave.
To insure that all 
maps are initially copied to the slave, a script such as the one
below can be run after the slave initialization:  

.DS
.ft CW
#! /bin/sh  
for \s-2MAP\s0 in `ypwhich -m | awk '{print $1 }'`
do
/usr/etc/yp/ypxfr -h `ypwhich -m $\s-2MAP\s0` $\s-2MAP\s0
echo "Transfered $\s-2MAP\s0 "
done
.DE

.LP
\s+2\fBNote\s0\fP: You can modify the
.I ypinit 
shell script to do this automatically.
.LP
.LP
This script assumes that 
.I ypbind 
is running on the slave and is bound to a server on the relevant domain.
This script will cause the 
slave to first inventory all the master maps and then 
.I ypxfr 
them across.
.NH 3
\&Modifying Default Maps
..IX "NIS maps" "modifying"
.LP
Use the following procedure for updating all
.I default
maps.
.IP 1.
Become superuser on the master server.
(Always modify \*(YP maps
on the master server.)
.IP 2.
Edit the input file for the map you want to change,
whether that file resides in
.I /etc 
or in some other directory of your choice.
.IP 3.
Type the following:

.DS
.ft CW
# \&\fBcd /var/yp\fP
# \&\fBmake\fP \&\fImapname\fP
.DE

The
.I make 
command will then update your map according to the
changes you made in its corresponding file.
It will also propagate it among the servers
(see below,
\fIPropagating an NIS Map\fP).    
.LP
Do not use this procedure with the publickey map.
The commands
.I newkey 
and
.I chkey 
(see above, 
\fIPreparing Network Databases on the Master Server\fP)
do it all for you.
.LP
Note that 
.I making
the map does not propagate it. 
For this you have to follow the instructions in the
following section.
.NH 3
\&Propagating an \*(YP Map
.LP
When you 
..IX "NIS maps" "propagating" "" "" PAGE START 
..IX map "propagation of"
.I propagate 
an \*(YP map,
you move it from one server to another\(emmost often from
the master to all \*(YP slave 
servers.  Initially,
.I ypinit 
propagates the maps from master to slaves, as described previously.
From then on,
you must transfer updated maps from master to
slaves by running the
..IX "NIS maps" ypxfr "" "\&\fIypxfr\fP command" PAGE START 
..IX ypxfr "" "\&\fIypxfr\fP \(em transfer NIS map" "" PAGE START
.I ypxfr 
command.
You can run
.I ypxfr 
two different ways: periodically
through the root
.I crontab 
file;
or interactively on the command line. 
.LP
.I ypxfr 
handles map transfer in tandem with the
..IX "NIS maps" yppush "" "\&\fIyppush\fP command"
.I yppush 
program.
.I yppush 
should always be run from the master server.
The Makefile in the
.I /var/yp 
directory automatically runs
.I yppush 
after you change the master set of maps.
.LP
.I yppush 's
function is to copy, or 
..IX push
.I push
a new version of an \*(YP
map from the \*(YP master to the slave(s).
After making 
a list of \*(YP servers from the 
.I ypservers 
map initially build by 
.I ypinit, 
.I yppush 
contacts each slave server in the
list
and sends it a \(lqtransfer map\(rq request.
When the request is acknowledged by the slave,
the
.I ypxfr 
program running on the slave does the actual transfer 
of the new map to the slave.
.NH 4
\&Using \&\fIcrontab\fP with \&\fIypxfr\fP
.LP
Maps have different rates of change. 
For instance, some
may not change for months at a time,
such as 
.I protocols.byname 
among the default maps and
.I auto.master 
among the non\(hydefault,
but 
.I publickey 
or
.I passwd.byname 
may change several times a day.
Scheduling map transfer through the
..IX crontab ypxfr "\&\fIcrontab\fP \(em editor" "using with \&\fIypxfr\fP"
..IX ypxfr crontab "\&\fIypxfr\fP \(em transfer NIS map" "using with \&\fIcrontab\fP"
.I crontab 
command allows setting specific propagation times for individual maps.
.LP
To periodically run
.I ypxfr 
at a rate
appropriate for the map set,
root's
.I crontab 
file on each slave server should contain the appropriate
.I ypxfr 
entries.
.I ypxfr 
contacts the master server and transfers the map only if the master's
copy is more recent than the local copy.
(Refer to the chapter on
\fIAdministering Workstations\fP
for information about creating
.I crontab 
files through the
.I crontab 
command, and see 
.I crontab (1)
in the
\fISunOS Reference Manual\fP.)
.NH 4
\&Using Shell Scripts with \&\fIypxfr\fP
..IX ypxfr shell "\&\fIypxfr\fP \(em transfer NIS map" "and shell scripts"
.LP
As an alternative to creating separate
.I crontab 
entries for each map, you may
prefer to have
root's
.I crontab 
run a shell
script
that periodically updates all maps.
There are sample map\(hyupdating shell scripts,
.I ypxfr_1perday ,
.I ypxfr_1perhour ,
and
.I ypxfr_2perday 
in the directory
.I /usr/etc/yp .
You can easily modify or replace these shell scripts
to fit your site's requirements.
Here is the default
.I ypxfr_1perday 
shell script:

.DS
.ft CW
#! /bin/sh
#
# ypxfr_1perday.sh - Do daily yp map check/updates
#

\s-2PATH\s0=/bin:/usr/bin:/usr/etc:/usr/etc/yp:$\s-2PATH\s0
export \s-2PATH\s0

# set -xv
ypxfr group.byname
ypxfr group.bygid 
ypxfr protocols.byname
ypxfr protocols.bynumber
ypxfr networks.byname
ypxfr networks.byaddr
ypxfr services.byname
ypxfr ypservers
.DE

This shell script will
update once per day the maps mentioned in it,
if root's
.I crontab 
executes it once a day (preferably at times of low
network load).
You can also have scripts to update maps once a week,
once a month, once every hour, etc., but be aware
of the performance degradation implied in
propagating the maps.
.LP
Run the same shell scripts 
through root's
.I crontab 
on each slave server configured for the \*(YP domain.
Alter the exact time of execution from one server to
another to avoid bogging down the master.
.LP
If you want to transfer the map from a particular slave server,
use the
.I "-h \fIhost\fP"
option of
.I ypxfr 
within
the shell script.
Here is the syntax of the commands you put in the script:

.DS
.ft CW
/usr/etc/yp/ypxfr -h \&\fIhost\fP [ -c ] \&\fImapname\fP
.DE

where
.I host
is the name of the server with the maps you
want to transfer, and
.I mapname 
is the name of the requested map.  If you use the
.I -h 
option without specifying
.I host ,
.I ypxfr 
will try to get the map from the master server.
If 
.I ypserv 
is not running locally at the time 
.I ypxfr 
is executed, you must use the 
.I -c 
flag.
.LP
You can use the
.I "-s \fIdomain\fP"
option 
to transfer maps from
another domain to your local domain.
These maps should be preferably the
same across domains.
For example, two \*(YP domains might share the same
.I services.byname 
and
.I services.byaddr 
maps.
Alternatively, you can use
.I rcp ,
or
.I rdist 
for more control,
to transfer files across domains too.
See
.I rdist (1)
in the
\fISunOS Reference Manual\fP.
.NH 4
\&Directly Invoking \&\fIypxfr\fP
.LP
The second method of invoking
.I ypxfr 
is to
run it
as a command.
Typically,
you do this only in exceptional situations \(em for example when
setting up a temporary \*(YP server to create a test environment,
or when trying to quickly get an \*(YP server that has been out of
service consistent with the other servers.
.LP
.NH 4
\&Logging \&\fIypxfr\fP's Activities
.LP
..IX "NIS maps" ypxfr "" "\&\fIypxfr\fP command" PAGE END 
..IX ypxfr "" "\&\fIypxfr\fP \(em transfer NIS map" "" PAGE END 
.I ypxfr 's
transfer attempts and the
results can be captured in a log file.
If a file called
.I /var/yp/ypxfr.log 
exists, results are appended to it.  No attempt to limit
the size of the log file is made. 
To prevent it from growing indefinitely,
empty it from time to time by entering

.DS
.ft CW
# \&\fBcp \|/var/yp/ypxfr.log\| /var/yp/ypxfr.log.old\fP
# \&\fBcat\| /dev/null\| >\| /var/yp/ypxfr.log\fP
.DE

You can have 
.I crontab 
execute these commands once a week.
.LP
To turn off logging, remove the log file.
..IX NIS "setting up" "" "" PAGE END 
.NH 2
\&Administering Users on an \*(YP Network
..IX NIS administering "" "" PAGE START
.LP
SunOS Release 4.1 provides a number of features
for administering \*(YP in a secure
environment.
If your site requires tight security, refer
to chapters
\fIThe Sun Network File System Service\fP
and
\fIAdministering C2 Security\fP.  
You may want to use some of the
features they discuss, such as secure
file systems and C2-like security.
If your network requires average
security, refer first to 
\fIAdministering Security\fP.  
This next section covers only \*(YP
matters; it assumes you are
familiar with the security information in 
\fIAdministering Security\fP.  
.NH 3
\&How \*(YP Maps Affect Security
.LP
..IX security "and NIS maps" "" "" PAGE START
..IX "NIS maps" "and security" "" "" PAGE START
..IX "network security" "and NIS maps" "" "" PAGE START
Security on a system running \*(YP depends on
how programs consult the files in the
.I /etc 
directory that are equivalent to the input files for the \*(YP maps.
A machine's local files are consulted first.
These include
.DS
.ft CW
/etc/passwd
/etc/group
/etc/aliases
.DE
Then the programs consult maps in the \*(YP
domain that correspond to the local files.
For example,
a machine checks its own
.I /etc/aliases 
file for mail
aliases, then checks the
.I mail.aliases 
\*(YP map.
.LP
The
.I passwd 
file is a good example of how local files
take precedence in an \*(YP environment.
When a user runs 
the 
.I passwd 
command to change his or her password,
the program first checks if the user has an
entry in the local
.I /etc/passwd 
file.
If there is no such entry, and \*(YP is running, and
there is a 
.I + 
escape line in the local file,
the program acts as
.I yppasswd 
and changes the user's password on the \*(YP master server for the
.I passwd 
map.
.LP
The following files in each machine's
.I /etc 
directory contain network information:
.DS
.ft CW
/etc/hosts
/etc/networks
/etc/ethers
/etc/services
/etc/netmasks
/etc/protocols
.DE
However, on a network with \*(YP, information is obtained
not from these local files but rather from their 
corresponding \*(YP maps instead, with the following exceptions:
.IP \(bu
When booting, each
machine needs an entry in
.I /etc/hosts 
for itself and the local loopback name.
A diskless machine also needs an entry for its file server.
.IP \(bu
Routers (that is, machines with more than one network
interface) that are also \*(YP clients need to have
.I /etc/netmasks 
for use during booting.
.NH 3
\&Changing the \*(YP Password
..IX NIS "and changing passwords"
.LP
Users must run 
.I "passwd -y"
or
.I yppasswd 
to change their passwords in the \*(YP password file
(or they can run
.I passwd 
if they do not have an entry in the local 
.I /etc/passwd 
file.)
Before they can do this, you must
start the
.I rpc.yppasswdd 
daemon
by adding an entry for it in
.I rc.local 
on the master server for the password map.
.LP
The master password file in the master server
that is used to build the password maps should not be
that server's
.I /etc/passwd 
file.
This is because this file should not contain an entry for
.I root ,
and because you may want to limit access to the master server
to a small group of people, a goal that would be defeated by
having 
.I /etc/passwd 
contain entries for all the users.
The master password file should therefore be in a 
directory like
.I /var/etc ,
or any directory of your choice, as long as the file itself
is not a link to another file.
Go to the master server, edit
.I rc.local ,
and add the following:

.DS
.ft CW
if [ \-f /usr/etc/rpc.yppasswdd \-a \-d /var/yp/`domainname` ] ; then
	/usr/etc/rpc.yppasswdd /var/etc/passwd \-m \e
	   passwd \s-2DIR\s0=/var/yp/\&\fIdomainname\fP
fi
.DE

where
.I domainname
is the name of your \*(YP domain directory.
Then reboot the master server to start up the
.I yppasswdd 
daemon.
Notice that when the 
.I \-m 
option is given, a
.I make 
is forced in 
.I /var/yp 
immediately following a modification of the file, and the arguments
that follow the
.I \-m 
are passed over to 
.I make. 
If you want to avoid having this 
.I make 
take place at any and all times, eliminate it, and control the pushing
of the password maps through 
.I crontab :

.DS
.ft CW
if [ \-f /usr/etc/rpc.yppasswdd \-a \-d /var/yp/`domainname` ] ; then
	/usr/etc/rpc.yppasswdd /var/etc/passwd
fi
.DE

The above examples would have to have the name of an adjunct file
if you are running a C2 secure network.
See the chapter
\fIAdministering C2 Security\fP
and the
reference to the adjunct file in the man page for
.I rpc.yppasswdd (8).
.LP
To actually change the \*(YP password, have the user
type:

.DS
.ft CW
% \&\fByppasswd \fIuser_name\fP
.DE

The system then prompts the user to type the old
and new passwords, as the local
.I passwd 
command does.
Refer to the
.I yppasswdd (8)
man page for more information about
the daemon and to
.I yppasswd (1)
for information about the
.I yppasswd 
command.
.NH 3
\&How Netgroups Affect Security on an \*(YP Network
.LP
On a network with \*(YP, the
.I netgroup 
input file on the master \*(YP server
is used for generating three
\*(YP maps:
.I netgroup ,
.I netgroup.byuser 
and 
.I netgroup.byhost .
.I netgroup 
contains the basic information
in the
.I netgroup 
input file.
The two other \*(YP maps contain
information in a format that speeds lookup of netgroups
given the host or user.
.LP
Various programs use the
.I netgroup 
\*(YP maps
for permission checking during login, remote mount,
remote login, and remote shell creation.
These programs include:
.I mountd ,
.I login ,
.I rlogin ,
and 
.I rsh .
.I login 
consults them for user classifications if it encounters
netgroup names in the
.I passwd 
database.
The
.I mountd 
daemon consults them
for machine classifications if it encounters netgroup names
in 
.I /etc/exports .
.I rlogin 
and 
.I rsh 
consult the
.I netgroup 
maps for both machine and user classifications if they
encounter netgroup names in the 
.I /etc/hosts.equiv 
or 
.I /.rhosts 
file.  
.LP
Refer to 
\fIThe SunOS Network Environment\fP
for more information about
.I netgroup .
.
.
..IX security "and NIS maps" "" "" PAGE END 
..IX "NIS maps" "and security" "" "" PAGE END 
..IX "network security" "and NIS maps" "" "" PAGE END 
..IX NIS administering "" "" PAGE END
.NH 3
\&Adding a New User to an \*(YP Domain
.LP
..IX NIS "adding users to" "" "" PAGE START
Adding a new user to a network already running \*(YP is
very similar to adding a new user in a non-networked 
machine, but it requires a few extra steps and it
may imply also adding a new client machine to 
the \*(YP maps.
.LP
Once the new user's workstation has been added to the
network, and the user has been given a password in it as
outlined in the chapter 
\fIAdministering Workstations\fP
and in
.I adduser (8),
the first step in adding the new user to
the \*(YP network is to update the
.I yppasswd 
file. 
Follow these procedures;
.IP 1.
Log in as 
.I root 
on the master \*(YP server.
.IP 2.
Edit the master \*(YP server's
.I passwd 
input file, whether in 
.I /etc 
or with another name or in another directory.
.IP
The following example shows an
initial entry in
the \*(YP master server's password input file:
.LP

.DS
roger::1947:10:The Boss:/home/shams/roger:/bin/csh
.DE

.IP
Note that the fields in 
the \*(YP password maps are identical to the local
.I passwd 
file.
You should also make sure that the user \s-2ID\s0
which you assign to this user is
unique within the network domain.
Failure to keep \s-2ID\s0's unique may prevent
files on different machines from being moved between directories
because the
system will respond as if the directories are owned by two different
users.  Also, file ownership may become confused when an \s-2NFS\s0
server exports a directory to an \s-2NFS\s0
client whose password file contains users with
user \s-2ID\s0s that match those
of different users on the \s-2NFS\s0 server.
.IP 3.
After you have updated the master server's
password file, 
update the password \*(YP maps as follows:

.DS
.ft CW
# \&\fBcd /var/yp\fP
# \&\fBmake passwd\fP
.DE

Note that if your site uses the
C2 secure configuration option, it will split
.I passwd 
into two files.  In a C2 secure
environment, only processes running with superuser privileges can
access the file containing the encrypted password.
.
.IP 4.
Have the user use the
.I yppasswd 
command to set his or her \*(YP password.
.NH 4
\&Making the Home Directory
.LP
After you update the \*(YP password file,
and create a password entry for the user on the local machine,
create a home directory, as shown in 
\fIAdministering Workstations\fP.  
Note that if you are working on the file server rather
than on the user's workstation, and
if the \*(YP password maps have not
yet been updated on the machine's \*(YP server, the
following error message appears when you attempt to 
change ownership of the home directory.

.DS
.ft CW
unknown user id:  username
.DE

In that case, you can use the following set of commands:

.DS
.ft CW
# \&\fBcd /home/\fIservername\fP
# \&\fBmkdir roger\fP
# \&\fBchown\fP \fIuserid#\fP \&\fBroger\fP
.DE

You use the \s-2ID\s0 number from the password file entry
instead of login name to change the ownership of 
the user's home directory.
..IX NIS "adding users to" "" "" PAGE END 
.NH 2
\&Obtaining Map Information
.LP
..IX "NIS maps" "getting info on"
Users can obtain information from and about the maps at any
time by using the commands
.I ypcat ,
.I ypwhich 
and 
.I ypmatch .
In the examples below, \&\fImapname\fP refers both to the
official name of a map and to its nickname, if any.
The examples are not exhaustive, and you should consult the
respective man pages in the
\fISunOS Reference Manual\fP.
.IP \(bu
To list all the values contained by a map, enter:

.DS
.ft CW
% ypcat \&\fImapname\fP
.DE

..IX ypcat "" "\&\fIypcat\fP \(em print values from NIS database"
.IP \(bu
To list both the keys and the values (if any) contained by a map,
enter:

.DS
.ft CW
% ypcat -k \&\fImapname\fP
.DE

.IP \(bu
To list all the map nicknames, enter any of:

.DS
.ft CW
% ypcat -x
% ypwhich -x
% ypmatch -x
.DE

.IP \(bu
To list all the available maps and their master(s), enter:
..IX ypwhich "" "\&\fIypwhich\fP \(em who is NIS server"

.DS
.ft CW
% ypwhich -m
.DE

.IP \(bu
To list the master server for a particular map, enter:

.DS
.ft CW
% ypwhich -m \&\fImapname\fP
.DE

.IP \(bu
To match a key with an entry in a map, enter

.DS
.ft CW
% ypmatch \&\fIkey mapname\fP
.DE

..IX ypmatch "" "\&\fIypmatch\fP \(em match NIS keys"
.IP \(bu
If the item you are looking for is not a key in a map, enter:

.DS
.ft CW
% ypcat \&\fImapname\fP | grep \&\fIkey\fP
.DE

.IP \(bu
To obtain information about other domains, use the
.I \-d 
options of these commands.
.NH 2
\&Advanced \*(YP Administration
.LP
..IX "NIS maps" administering
This section describes how to maintain the
maps of an existing \*(YP domain.
Subjects discussed include:
.IP \(bu
Updating \*(YP maps
.IP \(bu
Modifying the Makefile
.IP \(bu
Adding maps to an additional \*(YP server
.IP \(bu
Moving the master map set to a new server
.IP \(bu
Using \*(YP together with \s-2DNS\s0.
.NH 3
\&Updating Existing Maps
..IX "NIS maps" updating "" "" PAGE START
.LP
After you have installed \*(YP, you will discover that
some maps require frequent updating
while others never need to change.
For example, the 
.I publickey.byname 
map may change frequently on a large
company's network.
On the other hand, the 
.I auto.master 
map probably will change little, if at all.
.LP
When you need to update a map, you can use one
of two updating procedures, depending on whether
it is a default map or not.
..IX "NIS maps" "map types"
A
.I default
map is a map in the default set created by
.I ypinit 
from the network databases.
The section 
\fIModifying Default Maps\fP
above explains how to modify these maps.
.I non-default
maps may be any of the following:
.IP \(bu
Included with an application purchased from a
vendor.
.IP \(bu
Created specifically for your site.
.IP \(bu
Created from a non-text file.
.LP
The following explains how to use various updating tools. 
In practice, you probably will only use them
if you add
non-default maps or change the set of \*(YP
servers after the system is already up and running.
.LP
.NH 3
\&Modifying the Makefile
..IX "NIS maps" "Makefile modification guidelines" "" "" PAGE START
.LP
You can modify the Makefile provided by default in 
.I /var/yp 
to suit your needs.
You can delete or add entries, and you can change the 
names of some of the directories.
.LP
\fBDeleting Entries\fP: If you want the Makefile to not produce
maps for a specific database, edit it and first delete the
name of the database from the
.I all 
rule (that is the line that starts with the word
.I all: ).
Then look for the appropriate rule for that database
(that is the rule at the end of the file that, for
example for the database hosts, says 
.I "hosts: hosts.time"
and either delete the line or, just to be in the safe side for
the future, comment it out by prepending a # to the line.
.LP
\fBAdding Entries\fP:
To add an entry to the Makefile you have to 
.IP \(bu
add the name of
the database to the
.I all 
rule
.IP \(bu
add a rule for the database, and 
.IP \(bu
write the time rule.
.LP
For instance, in order for the 
.I make 
file to work on automounter input files, or any map of your own
that you wish to propagate through \*(YP, you
would have to make the following modifications to the
make file:
.IP (1)
modify the line that starts with the word
.I all: 
by adding the name of the database you want to add.
.\".\s-2BS\s0 \s-2GRAY\s0

.DS
.in -.3i
.ft CW
all: passwd group hosts ethers networks rpc services protocols \e
	netgroup bootparams aliases publickey netid netmasks c2secure\^\e
	auto.direct auto.home
.in +.3i
.DE

The order of the entries is not relevant, but please notice that
the blank space at the beginning of the 
continuation lines \fImust\fP be a
\s-2TAB\s0, not spaces.
.IP (2)
Add the following lines at the end of the make file:

.DS
.ft CW
auto.direct: auto.direct.time
auto.home: auto.home.time
.DE

.IP (3)
Add an entry for
.I auto.direct.time 
in the middle of the file.

.DS L
.ft CW 
auto.direct.time: $(\s-2DIR\s0)/auto.direct
	@(while read L; do echo $$L; done < $(\s-2DIR\s0)/auto.direct $(\s-2CHKPIPE\s0)) | \e
		(sed -e "/^#/d" -e s/#.*$$// -e "/^ *$$/d" $(\s-2CHKPIPE\s0)) | \e
		$(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/auto.direct;
	@touch auto.direct.time;
	@echo "updated auto.direct";
	@if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) auto.direct; fi
	@if [ ! $(\s-2NOPUSH\s0) ]; then echo "pushed auto.direct"; fi
.DE

.LP
The while loop at the beginning is designed to eliminate any 
backslash-extended lines in the input file.
The
.I sed 
script eliminates comment and empty lines, and feeds the output to
.I makedbm .
.LP
The same procedure should be followed for all other automounter
maps, or any other non\(hydefault maps.
.LP
\fBChanging Variables\fP: 
You can change the settings of the variables defined at the top
of the Makefile simply by changing the value at the right of
the equal sign 
.I = ).
For instance, if you don't use the files located in 
.I /etc 
as input for the maps, but rather files located in
another directory, say
.I /var/etc/\&\fIdomainname\fP ,
you should change the value of
.I \s-2DIR\s0 
from
.I \s-2DIR\s0=/etc 
to
.I \s-2DIR\s0=/var/etc/\&\fIdomainname\fP .
.NH 3
\&Creating and Modifying Non-Default Maps
.LP
To update a non-default map,
you edit its corresponding text file.
Then you rebuild the updated map using the
.I /usr/etc/yp/makedbm 
program.
(The
.I makedbm (8)
man page
fully describes this command.)
If the map has an entry in the 
.I /var/yp/Makefile ,
simply run 
.I make 
as described above.
If the map does not have an entry, try to
create one following the instructions above, in 
\fIMaking the Maps\fP.  
Using 
.I make 
is the preferred method.
Otherwise, you will have to use 
.I makedbm 
by hand.
.LP
There are two different methods for using
.I makedbm :
.IP \(bu
Redirect the program's output
to a temporary file, modify the file,
then use the modified file as input to
.I makedbm .
.IP \(bu
Have the
output of
.I makedbm 
operated on within a pipeline
that feeds into
.I makedbm .
This is appropriate
if you can update the
disassembled map with either
.I awk ,
.I sed ,
or a
.I cat 
append.
.LP
You can use either of two possible procedures
for creating new maps.
The first uses an existing text file as
input; the second uses standard input.
.LP
.NH 4
\&Updating Maps Built from Existing Text Files
.LP
Assume that a text file
.I "/var/yp/mymap.asc" 
was created with an editor or a shell script
on the \*(YP master.
You want to create an \*(YP map from this file and locate
it in the
.I "home_domain" 
subdirectory.
To do this, you type the following on the master server:

.DS
.ft CW
#  \&\fBcd /var/yp\fP
#  \&\fB/usr/etc/yp/makedbm mymap.asc home_domain/mymap\fP
.DE

The
.I mymap 
map now exists in the directory
.I home_domain .
.LP
Adding entries to 
.I mymap 
is simple.
First, you must modify the text file
.I mymap.asc .
(If you modify the actual
.I dbm 
files without modifying the corresponding text
file, the modifications are lost.)
Type the following:

.DS
.ft CW
#  \&\fBcd /var/yp\fP
#  <\fRedit\fP mymap.asc>
#  \&\fB/usr/etc/yp/makedbm mymap.asc home_domain/mymap\fP
.DE

When you finish updating the map,
propagate it to the slave servers, as described in
the section 
\fIPropagating an NIS Map\fP.  
.LP
.NH 4
\&Updating Maps Built from Standard Input
.LP
When no original text file exists, create the \*(YP map
from the keyboard by typing input to
.I makedbm ,
as shown below:

.DS
.ft CW
ypmaster# \&\fBcd /var/yp\fP
ypmaster# \&\fB/usr/etc/yp/makedbm - home_domain/mymap\fP
key1 value1
key2 value2
key3 value3
\&\fB<ctl D>\fP
ypmaster#
.DE

If you later need to modify such a map, which is
not based in an existing file, you can use
.I "makedbm -u"
to disassemble the map and
create a temporary text intermediate file.
You type the following:

.DS
.ft CW
%  \&\fBcd /var/yp\fP
%  \&\fB/usr/etc/yp/makedbm -u home_domain/mymap > mymap.temp\fP
.DE

The resulting
temporary file
.I mymap.temp 
has one
entry per line.
You can edit it as needed,
using your preferred editing tools.
.LP
To update the map, you give the
name of the modified temporary file
to
.I makedbm 
as follows:

.DS
.ft CW
%  \&\fB/usr/etc/yp/makedbm mymap.temp home_domain/mymap\fP
%  \&\fBrm mymap.temp\fP
.DE

When 
.I makedbm 
finishes,
propagate the map to the slave servers, as described in 
the section 
\fIPropagating an NIS Map\fP.  
.LP
The preceding paragraphs explained how to use some tools, but in
reality almost everything you actually have to do can be done by
.I ypinit 
and
.I /var/yp/Makefile ,
unless you add
non-default maps to the database, or change the set of \*(YP
servers after the system is already up and running.
.LP
Whether you use the
.I Makefile 
in
.I /var/yp 
or some other procedure\(em
.I Makefile 
is one of many possibilities\(em the goal is the same: a
new pair of well-formed
.I dbm 
files must end up in the maps
directory on the master \*(YP server.
..IX "NIS maps" updating "" "" PAGE END 
..IX "NIS maps" "propagating" "" "" PAGE END 
.NH 3
\&Adding New \*(YP Maps to the \&\fIMakefile\fP
.LP
Adding a new \*(YP map entails getting copies of the 
map's 
.I dbm 
files into the 
.I /var/yp/\fIdomain_name\fP 
directory on each of the \*(YP servers in the
domain.  The actual mechanism is described above in 
\fIPropagating an NIS Map\fP.  
This section only
describes how to update the Makefile so that
propagation works correctly.
.LP
After deciding which \*(YP server is the master of the map, 
modify 
.I /var/yp/Makefile 
on the master server so that you can
conveniently rebuild the map (as indicated above,
different servers can be masters of different 
maps, but in most cases this can lead to administrative
confusion, and it is strongly recommended that you
set only one server as the master of all maps).
Actual case-by-case modification is
too varied to describe here,
but typically a human-readable text file
is filtered through 
.I awk ,
.I sed ,
and/or
.I grep 
to make it
suitable for input to 
.I makedbm .
Refer to the existing
.I /var/yp/Makefile 
for examples and the section
\fIModifying the Makefile\fP
above.
.LP
Use the mechanisms already in place in 
.I /var/yp/Makefile 
when deciding how to create dependencies that 
.I make 
will recognize.
Be aware that
.I make 
is very sensitive to the presence or absence of tabs
at the beginning of lines within the dependency rules,
and a missing tab can invalidate an entry that is otherwise
well formed.
.LP
To get an initial copy of the map, you can have
.I make 
run 
.I yppush 
on the \*(YP master server.  The map must be globally available
before clients begin to access it.  If the map is available from
some \*(YP servers but not all, you will encounter
unpredictable behavior from client programs.
.NH 3
\&Adding a New \*(YP Server to the Original Set
..IX "NIS server" "expanding number of"
.LP
After \*(YP is running, you may
need to create an \*(YP slave server that you did not include in the
initial set given to
.I ypinit .
If the environment at your site is such that servers are 
added or removed from the list frequently, you may want to
consider adding an entry in the Makefile for the 
.I ypservers 
map that was initially created by
.I ypinit .
After adding the 
variable
.I \s-2YPSERVERS\s0=$(\s-2DIR\s0)/ypservers 
and the word
.I ypservers 
to the 
.I all 
rule, and adding the rules
.I "ypservers: ypservers.time"
and
.I "$(\s-2DIR\s0)/ypservers:" 
you should add a rule similar to the following:

.DS L
.ft CW
ypservers.time: $(\s-2YPSERVERS\s0)
        @(awk '!/^#/ && !/^$$/ { print $$1, $$0 }' $(\s-2YPSERVERS\s0) $(\s-2CHKPIPE\s0)) | \e
                $(\s-2MAKEDBM\s0) - $(\s-2YPDBDIR\s0)/$(\s-2DOM\s0)/ypservers;
        @touch ypservers.time;
        @echo "updated ypservers";
        @if [ ! $(\s-2NOPUSH\s0) ]; then $(\s-2YPPUSH\s0) ypservers; fi
        @if [ ! $(\s-2NOPUSH\s0) ]; then echo "pushed ypservers"; fi

.DE

.LP
The above is just a suggestion, and you might find some other
method more appropriate for your site.
.LP
If, however, you do not think it would be justified to modify
the Makefile,
the following procedure explains how to proceed manually:
.IP 1.
Log in to the master server as superuser.
.IP 2.
Go to the \*(YP domain directory by typing:

.DS
.ft CW
# \&\fBcd /var/yp/\fIdomain_name\fP
.DE

.IP 3.
Disassemble
.I ypservers ,
as follows:

.DS
.ft CW
# \&\fB/usr/etc/yp/makedbm -u ypservers > /tmp/\fItemp_file\&\fI
.DE

.I makedbm 
converts
.I ypservers 
from
.I dbm 
format to the temporary text file
.I /tmp/\fItemp_file\fP .
.IP 4.
Edit
.I /tmp/\fItemp_file\fR 
using your preferred text editor.
Add the new slave server's name to the list of servers.
Then save and close the file.
.IP 5.
Run the 
.I makedbm 
command with
.I temp_file
as the input file and 
.I ypservers 
as the output
file.

.DS
.ft CW
# \&\fB/usr/etc/yp/makedbm /tmp/\fItemp_file\fP ypservers
.DE

This converts 
.I ypservers 
back into 
.I dbm 
format.
.IP 6.
Verify that the 
.I ypservers 
map is correct (since there is no 
text file for 
.I ypservers )
by typing the following:

.DS
.ft CW
# \&\fB/usr/etc/yp/makedbm -u ypservers\fP
.DE

.IP
Each entry in
.I ypservers 
will be displayed on your screen.
.IP
\s+2\fBNote: \s0\fP If a 
host name is not in \fIypservers\fP it will not be warned of
updates to the \*(YP map files.
.IP 7.
Set up the
new slave server's \*(YP domain directory
by copying
the \*(YP map set from the master server.
To do this, log in to
the new \*(YP slave as superuser, and run the 
.I ypinit 
command:

.DS
.ft CW
\&\fIypslave\fP# \&\fBcd /var/yp\fP
.\"ypslave# \&\fBypinit -c\fP
.\"\&\fI< enter the list of servers > \fP
\&\fIypslave\fP# \&\fBypbind\fP
\&\fIypslave\fP# \&\fB/usr/etc/yp/ypinit -s\fP \&\fIypmaster\fP
.DE

When you are finished,
complete steps 6 through 9 of the section 
\fISetting Up Slave Servers\fP.  
..IX "NIS maps" "Makefile modification guidelines" "" "" PAGE END 
.NH 3
\&Changing a Map's Master Server
.LP
..IX "NIS maps" "changing a master server"
..IX server master
..IX "NIS server" master
To change a map's master,
you first have to build it on the new \*(YP master.
The old master's name occurs as a key-value pair in
the existing map (this pair is inserted automatically by
.I makedbm ).
Therefore, using the existing copy at the
new master or transferring a copy to the new master with 
.I ypxfr 
is insufficient.
You have to reassociate the key
with the new master's name.
If the map has a text
source file, you should copy it in its current version to the new
master.
.LP
Here are instructions for
remaking a sample \*(YP map called 
.I "jokes.bypunchline" .
.IP 1.
Log in to the new master as superuser, and type the following:

.DS
.ft CW
newmaster# \&\fBcd /var/yp\fP
.DE

.IP 2.
.I /var/yp/Makefile 
must 
have an entry for
the new map before you specify the map to
.I make .
If
this isn't the case, edit the
Makefile now (see above, 
\fIMaking the maps\fP).  
.IP 3.
Type the following:

.DS
.ft CW
newmaster# \&\fBmake jokes.bypunchline\fP
.DE

.IP 4.
If the old master
will remain an \*(YP server,
.I rlogin 
in to it, and
edit 
.I /var/yp/Makefile .
Comment out the section of
.I "/var/yp/Makefile" 
that made 
.I "jokes.bypunchline" 
so that
it is no longer made there.
.IP 5.
If 
.I jokes.bypunchline 
only exists as a 
.I dbm 
file, remake it on
the new master by disassembling a copy from any \*(YP
server, then running the disassembled version through
.I makedbm :

.DS
.ft CW
newmaster# \&\fBcd /var/yp\fP
newmaster# \&\fBypcat -k jokes.bypunchline |\e \fP
\&\fB/usr/etc/yp/makedbm - mydomain/jokes.bypunchline\fP
.DE

.LP
After making the map on the new master, you must send a copy of
it to the other slave servers.
However, do not use
.I yppush \(em
the other slaves will try to get new copies from the
old master, rather than the new one.
A typical method for circumventing this
(you may find others) is to transfer a copy of the
map from the new master back to the old master.
Become superuser on the
old master server and type:

.DS
oldmaster# \&\fB/usr/etc/yp/ypxfr -h newmaster jokes.bypunchline\fP
.DE

Now it is safe to run
..IX yppush "" "\&\fIyppush\fP \(em force propagation of modified NIS map"
.I yppush .
The remaining slave servers still believe that the old
master is the current master.
They will attempt to get the current
version of the map from the old master.  When they do so, they will get
the new map, which names the new master as the current master. 
.LP
If this method fails, you can try this
cumbersome but sure-fire option.
Log in as superuser
on each \*(YP server and
execute the 
.I ypxfr 
command
shown above.  This will certainly work, but you
should consider it
the worst case solution.
.\" The following section has not been indexed at all
.NH 3
\&Using \*(YP in conjunction with \s-2DNS\s0
..IX NIS "and Domain Name Service"
..IX DNS NIS "" "and NIS"
.LP
Host lookups may be configured in one of the following
ways:
.IP \(bu
Through \*(YP exclusively, through the
.I hosts.byname 
and
.I hosts.byaddr 
maps as outlined above; this is effective only
within a given domain.
.IP \(bu
The Domain Name Service (\s-2DNS\s0) can be used for all hostname and
address lookups if \*(YP is not running, or
.IP \(bu
\*(YP can be used to look up hostnames and addresses initially,
followed by \s-2DNS\s0 lookup if the \*(YP lookup fails.
.LP
To configure hostname and address lookups to occur exclusively
through \s-2DNS\s0, please refer to the chapter
\fIAdministering Domain Name Service\fP.  
.LP
To configure hostname and address lookup to occur through
\*(YP and then through \s-2DNS\s0 you should follow the following steps:
.IP 1.
The two maps
.I hosts.byname 
and
.I hosts.byaddr 
must have the
.I \s-2YP_INTERDOMAIN\s0 
key set in them; to obtain this you must edit the file
.I /var/yp/Makefile 
and modify the lines (at the top of the file) that say

.DS
.ft CW
#B=-b
B=
.DE

to say

.DS
.ft CW
B=-b
#B=
.DE

Thus 
.I makedbm 
will be started with the
.I -b 
flag when making the maps, and the 
.I \s-2YP_INTERDOMAIN\s0 
key will be inserted in them.
.\".\s-2IP\s0 2.
.\"Make sure that the master server for these maps is a machine running
.\"Release 4.x, so the 
.\".L -b 
.\"flag is preserved.
.\".\s-2IP\s0 3.
.\"Make sure that if there are slave servers in the network that are running
.\"Release 3.x of the SunOS operating system, their
.\".L ypserv 
.\"is called with the
.\".L -i
.\"flag set.
.IP 2.
All \*(YP servers should have an
.I /etc/resolv.conf 
file that points to a valid nameserver (see 
\fIAdministering Domain Name Service\fP
for instructions
on how to write this file).
.NH 4
\&Problems in Heterogeneous \*(YP Domains
..IX "NIS domains" "resolving problems with"
.LP
The above assumes that both master and slave servers in the \*(YP domain
are running Release 4.x of the SunOS operating system.
If that is not the case, problems may arise.
The following is a list of possible problems, and some possible 
workarounds.
.IP \(bu
If an \*(YP server, either master or slave, is running release
3.x, interdomain operations are not recognized by its 
.I ypserv .
.IP
\fBWorkaround\fP: Start 
.I ypserv 
on that server with the (undocumented) option 
.I \-i .
.IP \(bu
If the master server is running 3.x and the slave server is
running 4.x, the
.I \s-2YP_INTERDOMAIN\s0 
key will not be present in the maps.
.IP
\fBWorkaround\fP: Start 
.I ypxfr 
with the 
.I \-b 
option on the slave, if the slave is running 4.0.3 or a
later release.
If the slave is running 4.0 or 4.0.1, upgrade it to 4.0.3
or a later release.
.IP \(bu
If the master server is running 4.x prior to 4.0.3
and the slave server is
running 4.x, the 
.I \s-2YP_INTERDOMAIN\s0 
key will be stripped from the maps
when a transfer is done.
.IP
\fBWorkaround\fP: Start 
.I ypxfr 
with the 
.I \-b 
option on the slave, if the slave is running 4.0.3 or a
later release.
If the slave is running 4.0 or 4.0.1, upgrade to 4.0.3
or a later release.
.LP
The following table summarizes the above information.
The notation \(lq4.0.3-\(rq means \(lqrelease of the
SunOS operating system earlier than 4.0.3\(rq \(en that is, 4.0 
or 4.0.1\(rq.
The notation \(lq4.0.3+\(rq means \(lqrelease 4.0.3 of the
SunOS operating system or later\(rq.
The command 
.I "makedbm \-b"
is a reference to the
.I B 
variable in the Makefile, as explained in the previous section.
.ne 10
.LP
.ce
Table: \*(YP/\s-2DNS\s0 in Heterogeneous \*(YP Domains
.TS
expand doublebox tab(~);
lfB ||  l lfB l
l || l |  l |  l 
l || l |  l |  l.
.sp .5v
slave~~master~
~_~_~_~
~3.x~4.0.3-~4.0.3+
.sp .3v
_
.sp .3v
3.x~on master: \&\fIypserv -i\fP~on master: \&\fImakedbm -b\fP~on master: \&\fImakedbm -b\fP
~on slave: \&\fIypserv -i\fP~on slave: \&\fIypserv -i\fP~on slave: \&\fIypserv -i\fP
.sp .3v
_
.sp .3v
4.0.3-~T{
upgrade slave
T}~T{
upgrade slave
T}~T{
upgrade slave
T}
.\"on master: \&\fIypserv -i\fP~on master: \&\fImakedbm -b\fP~on master: \&\fImakedbm -b\fP
~\&~\&~\&~
.sp .3v
_
.sp .3v
4.0.3+~ypserv -i on master~makedbm -b on master~makedbm -b on master
~ypxfr -b on slave~ypxfr -b on slave~ypxfr on slave
.sp .5v
.TE
.NH 2
\&Summary of \*(YP Related Commands
.LP
..IX "NIS commands" "summary"
In addition to maps, \*(YP service also includes
specialized daemons, system programs, and commands, 
which are summarized below.
Some of them have been introduced in detail before, some
of them have not.
In all cases, refer to their man pages.
.LP
.IP "\&\fIypserv\fP" 1i
Looks up requested
information in a map.
.I ypserv 
is a daemon that runs on \*(YP servers with a complete set of maps.
At least one
.I ypserv 
daemon must be present on the network for \*(YP service to function.
.IP "\&\fIypbind\fP" 1i 
Provides \*(YP server binding information to clients.
It provides binding by finding a
.I ypserv 
process that serves maps within the domain of the requesting
client.
.I ypbind 
must run on all
servers and clients.
.IP "\&\fIypinit\fP" 1i
Automatically creates maps for an \*(YP server
from the input files.
It also constructs the initial maps that are not built
from files,
such as
.I ypservers .
Use
.I ypinit 
to set
up the master \*(YP server and the slave \*(YP servers for the
first time.
.IP "\&\fImake\fP" 1i
Updates \*(YP maps by reading
the Makefile in
.I /var/yp .
You can use
.I make 
to update all maps based on the input files
or to update individual maps.
The man page
.I ypmake (8)
describes
.I make 's
functionality for \*(YP.
.IP "\&\fImakedbm\fP" 1i
.I makedbm 
takes an input file and converts it into
.I dbm 
.I ".dir" 
and
.I ".pag" 
files\(emvalid 
.I dbm 
files that \*(YP can use as maps.  
You can also use 
.I "makedbm -u"
to \(lqdisassemble\(rq a map,
so that you can see the key-value pairs that comprise it. 
.IP "\&\fIypxfr\fP" 1i
Moves an \*(YP map from one server to
another, using \*(YP itself as the transport medium.  
You can run 
.I ypxfr 
interactively, or periodically from a 
.I crontab 
file. 
It is also called by
.I ypserv 
to initiate a transfer.
.IP "\&\fIypxfrd\fP" 1i
Provides faster map transfers for 4.1 slave servers.
It is run only on the master server.
.IP "\&\fIyppush\fP" 1i
Copies a new version of an \*(YP map
from the \*(YP master server to its slaves.
You run it on the master \*(YP server.
.IP "\&\fIypset\fP" 1i
Tells a
.I ypbind 
process
to bind to a named \*(YP server.
This is not for casual use and its use is discouraged
because of security implications. 
See the man page for
.I ypset (8)
and
.I ypserv (8)
in the
\fISunOS Reference Manual\fP, 
particularly in reference to the 
.I -ypset 
and 
.I -ypsetme 
options to the latter.
.IP "\&\fIyppoll\fP" 1i
Tells which version of an \*(YP map
is running on a server that you specify.
It also lists the master server for the map.
.IP "\&\fIypcat\fP" 1i
Displays the contents of an \*(YP map.
.IP "\&\fIypmatch\fP" 1i
Prints the value for one or more specified keys
in an \*(YP map.  You cannot specify which \*(YP server's
version of the map you are seeing.
.IP "\&\fIypwhich\fP" 1i
Shows which 
\*(YP server a client is using
at the moment for \*(YP services, or, if invoked
with the 
.I "-m \&\fImapname\fP"
option, which \*(YP 
server is master of each of the maps.
If only
.I -m 
is used, it displays the names of all the
maps available and their respective master servers.
.IP "\&\fIypupdated\fP" 1i
Facilitates the updating of \*(YP information.
.NH 2
\&Fixing \*(YP Problems
..IX maintenance "fixing NIS problems" "" "" PAGE START
..IX NIS troubleshooting "" "" PAGE START
..IX troubleshooting "NIS problems" "" "" PAGE START 
.LP
This section explains how to clear problems
encountered on networks running \*(YP.
It has two parts, covering problems
seen on an \*(YP client and those seen on
an \*(YP server.
.LP
.NH 3
\&Debugging an \*(YP Client
.LP
Before trying to debug an \*(YP client, review the first part
of the chapter, which explains the \*(YP environment.
Then look for the subheading in this section that best
describes your problem.
.
.NH 4
\&Hanging Commands on the Client
.LP
The most common problem of \*(YP clients is for a command
to hang and generate console messages such as:

.DS
.ft CW
\*(YP: server not responding for domain <\fIdomainname\fP>.  Still trying
.DE

Sometimes many commands begin to hang, even though the system as
a whole seems fine and you can run new commands.
.LP
The message above indicates that 
.I ypbind 
on the local machine is
unable to communicate with 
.I ypserv 
in the domain 
.I domainname .
This
happens when a machine running 
.I ypserv 
has crashed and there is not other \*(YP server 
available on your subnet (otherwise
.I ypbind 
would broadcast for another server and obtain it.)
It
may also occur if the network or \*(YP server is so
overloaded that
.I ypserv 
cannot get a response back to the client's 
.I ypbind 
within the
timeout period.
.LP
Under these circumstances, every client on the
network will experience the same or similar problems.
The condition is temporary in most cases.
The messages will usually
go away when the \*(YP server reboots and restarts
.I ypserv ,
or when the load on the \*(YP servers or network itself
decreases.
.LP
However, commands may hang and
require direct
action to clear them.
The following list describes
the causes of such
problems and gives suggestions for fixing them:
.IP \(bu
The \*(YP client has not set, or has incorrectly set,
.I domainname 
on the machine.  Clients must use a domain name
that the \*(YP servers know.
.IP
On the client type
.I domainname 
to see which domain name is set.
Compare that with the actual domain name in 
.I /var/yp 
on the
\*(YP master server.
If a machine's
.I domainname 
is not the same as the server's,
the machine's
.I domainname 
entry in 
.I /etc/defaultdomain 
is incorrect.
Log in as superuser and correct the client's
.I defaultdomain 
file.
This assures domain name is correct every time the machine boots.
Reboot the machine. 
.\"Then set
.\".L domainname
.\"manually by typing:
.\".\s-2BS\s0 \s-2GRAY\s0
.\".\s-2LS\s0 
.\"# \&\fBdomainname\fP \fIgood_domain_name\fP
.\".\s-2LE\s0
.\".\s-2BE\s0
.IP \(bu
If your domain name is correct and commands still hang,
make sure the subnet has at
least one \*(YP server machine.  
Some networks consist of two or more
subnets joined by routers.
A client can automatically
bind only to a 
.I ypserv 
process on its subnet, not on another accessible network or subnet.
At least one \*(YP server for a client's domain must be running on
the client's subnet.
Two or more \*(YP servers improve availability
and response characteristics for \*(YP services.
.IP
In extreme cases where local server binding is not possible,
use of the 
.I ypset 
command may temporarily allow binding to another server, if available,
on another network or subnet.
However, if 
.I ypbind 
has not been started with either of the
.I -ypset 
or 
.I -ypsetme 
options, this kind of binding is not possible.
Notice that for security reasons the use of
.I -ypset 
should be limited only to debugging purposes under controlled
circumstances, and that the use of 
.I -ypsetme 
can also result in serious security breaches.
If you must start 
.I ypbind 
with the 
.I -ypsetme 
option, once you have fixed the problem you should kill
.I ypbind 
and restart it again without the option.
.IP \(bu
If your local network has an \*(YP server and commands still hang,
make sure the server is up and
running.
Check other machines on your local network.
If several
clients also have problems, suspect a server problem.
Try to find a client machine behaving normally, and type the 
.I ypwhich 
command on it.  If 
.I ypwhich 
does not respond, kill it and go to
a terminal on the \*(YP server.  Type:

.DS
.ft CW
# \&\fBps ax | grep yp\fP
.DE

Look for 
.I ypserv 
and 
.I ypbind 
processes.  If the server's
.I ypbind 
daemon is not running, start it up by typing:

.DS
.ft CW
# \&\fBypbind\fP
.DE

If a 
.I ypserv 
process is running, 
type

.DS
.ft CW
# \&\fBypwhich\fP
.DE

on the \*(YP server.
If 
.I ypwhich 
does not respond,
.I ypserv 
has probably hung, and you should restart it.
While logged in as superuser, type the following:

.DS
.ft CW
# \&\fBps axu | grep ypserv\fP
# \&\fBkill -9\fP [pid # from ps]
# \&\fBypserv\fP
.DE

If 
.I ps 
shows no 
.I ypserv 
process running, start one up.
.
.NH 4
\&\*(YP Service is Unavailable
.LP
When most machines on the network appear to be fine, but
one client cannot receive \*(YP service, that client may
experience many 
different symptoms.
For example, some commands appear to
operate correctly while others terminate with an error message
about the unavailability of \*(YP.
Other commands limp along in a
backup-strategy mode particular to the program involved. 
Still other commands or daemons crash with 
obscure messages or no message at all.
Here are messages a client in this situation may receive:

.DS
.ft CW
samba% \&\fBypcat myfile\fP
ypcat: can't bind to \*(YP server for domain <\fIdomainname\fP>.
	Reason: can't communicate with ypbind.
.DE


.DS
.ft CW
% \&\fB/usr/etc/yp/yppoll myfile\fP
Sorry, I can't make use of the \*(YP.  I give up.
.DE

.LP
On the problem client,
run
.I "ls -l"
on a directory containing
files owned by many users, including some not in the
client's
.I /etc/passwd 
file\(emfor example
.I /usr .
If the resulting display
lists file owners not in the local
.I /etc/passwd 
as numbers, rather than names, this also means
that \*(YP service is not working.
.LP
These symptoms usually indicate that 
the client's
.I ypbind 
process is not
running.  
Run
.I "ps ax"
and check for 
.I ypbind .
If it you do not
find it, log in as superuser and start it as follows:

.DS
.ft CW
# \&\fBypbind\fP
.DE

\*(YP problems should disappear.
.
.NH 4
\&\&\fIypbind\fP Crashes
.LP
If 
.I ypbind 
crashes almost immediately each time it is started,
look for a problem in some other part of the system.
Check for the presence of the 
.I portmap 
daemon by typing:

.DS
.ft CW
%  \&\fBps ax | grep portmap\fP
.DE

If it is not running, reboot.
.LP
If 
.I portmap 
..IX portmap "" "\&\fIportmap\fP daemon"
..IX daemons portmap "" "\&\fIportmap\fP"
itself will
not stay up or behaves strangely, look for more fundamental problems.
Check the network software in the ways suggested in
the section on Ethernet debugging in the chapter
\fIThe SunOS Network Environment\fP.  
.LP
You may be able to communicate with 
.I portmap 
on the problematic client from a
machine operating normally.  From the functioning machine,
type:

.DS
.ft CW
% \&\fBrpcinfo -p client\fP
.DE

If 
.I portmap 
on the problematic machine is fine, 
.I rpcinfo 
produces the following
output:
 
.DS
.ft CW
   program vers proto   port
    100007    2   tcp   1024  ypbind
    100007    2   udp   1028  ypbind
    100007    1   tcp   1024  ypbind
    100007    1   udp   1028  ypbind
    100021    1   tcp   1026  nlockmgr
    100024    1   udp   1052  status
        .
        .
        .
.DE

Your machine will have
different port numbers.
The four entries for the 
.I ypbind 
process are:

.DS
.ft CW
    100007    2   tcp   1024  ypbind
    100007    2   udp   1028  ypbind
    100007    1   tcp   1024  ypbind
    100007    1   udp   1028  ypbind
.DE

If they are not displayed, 
.I ypbind 
has been unable to register its
services.  Reboot the machine and run
.I rpcinfo 
again. If 
the
.I ypbind 
processes are there and they change each
time you try to restart 
.I /usr/etc/ypbind ,
reboot the system, even if the 
.I portmap 
daemon is running.
If the situation persists after reboot, call Sun
customer support for help.
.NH 4
\&\&\fIypwhich\fP Displays are Inconsistent
..IX ypwhich "resolving problems with" "\&\fIypwhich\fP i\(em who is NIS server"
.LP
When you use 
.I ypwhich 
several times on the same client, the
resulting display varies because the \*(YP server changes.
This is normal.  The binding of \*(YP client to \*(YP server
changes over time when the network or the \*(YP servers are
busy.
Whenever possible, the network stabilizes at a point where all
clients get acceptable response time from the \*(YP servers.
As long as your client machine gets \*(YP service, it does not
matter where the service comes from.  
For example, an \*(YP server
machine may get its own \*(YP services from another
\*(YP server on the network.
.
.NH 3
\&Debugging an \*(YP Server
..IX "NIS server" debugging
.LP
Before trying to debug your \*(YP server, read the beginning
part of this chapter about the \*(YP environment.
Then look in this subsection for the heading
that most closely describes the server's problem.
.
.NH 4
\&Servers Have Different Versions of an \*(YP Map
.LP
Because \*(YP propagates maps among servers, occasionally
you may find different versions of the same map 
on various \*(YP servers on the network.
This version discrepancy is normal if transient, but abnormal otherwise.
.LP
Most commonly, normal map propagation
is prevented if it occurs when an \*(YP server or
router between \*(YP servers is down. 
When all \*(YP
servers and the routers between them are running,
.I ypxfr 
should succeed.
.LP
If a particular slave server has problems updating maps,
log in to that
server and run 
.I ypxfr 
interactively.  If 
.I ypxfr 
fails, it
will tell you why it failed, and you can fix the
problem.
If 
.I ypxfr 
succeeds, but you suspect it has occasionally failed,
create a log file to enable logging of messages.  
As superuser type:

.DS
.ft CW
\&\fIypslave\fP# \&\fBcd /var/yp\fP
\&\fIypslave\fP# \&\fBtouch ypxfr.log\fP
.DE

This saves all output from 
.I ypxfr .
The output resembles
the output
.I ypxfr 
displays when run interactively, but each
line in the log file is timestamped.
(You may see unusual orderings in
the timestamps.
That is okay\(em the timestamp tells you when 
.I ypxfr 
started to run.
If copies of 
.I ypxfr 
ran simultaneously but their
work took differing amounts of time, they may actually write their
summary status line to the log files in an order different from that
which they were invoked.)
Any pattern of intermittent failure shows
up in the log.
When you have fixed the problem, turn off logging by
removing the log file.  If you forget to remove it, it will grow
without limit.
.LP
While still logged in to the problem \*(YP slave server, inspect
.I root 's
.I crontab 
file on that machine,
and check the 
.I ypxfr* 
shell scripts it invokes.
Typos in these files cause propagation problems, as do failures
to refer to a shell script within 
.I /var/spool/cron/crontabs/root ,
or failures to refer to a map within any shell script.
.LP
Also, make sure that the \*(YP slave server is in the map
.I ypservers 
within the domain.
If it is not, it still operates
perfectly as a server,
but 
.I yppush 
will not tell it when a new copy of
a map exists.
.LP
If the \*(YP slave server's 
problem is not obvious, you can work around it while you debug
using 
.I rcp 
or 
.I tftp 
to copy a recent version of the inconsistent map
from any healthy \*(YP server.
Be sure not do this remote copy as
root, but you can probably do it 
while logged in as  
.I daemon .
For instance, here is how you might
transfer the map \(lqbusted:\(rq
.LP

.DS
.ft CW
\&\fIypslave\fP# \&\fBchmod go+w /var/yp/mydomain\fP
\&\fIypslave\fP# \&\fBsu daemon\fP
$ \&\fBrcp\fP \&\fIypmaster\fP:/var/yp/mydomain/busted.\e* /var/yp/mydomain\fP
$ \&\fB^D\fP
\&\fIypslave\fP# \&\fBchown root /var/yp/mydomain/busted.*\fP
\&\fIypslave\fP# \&\fBchmod go-w /var/yp/mydomain\fP
.DE

Here the
.I * 
character has been escaped in the command line, so
that it will be expanded on \&\fIypmaster\fP, 
instead of locally on \&\fIypslave\fP.
Notice that the map files should be owned
by root, so you must change ownership of them after the transfer.
.
.NH 4
\&\&\fIypserv\fP Crashes
..IX ypserv "fixing crashes of" "\&\fIypserv\fP daemon"
..IX daemons ypserv "" "\&\fIypserv\fP"
..IX "NIS daemons" ypserv "" "\&\fIypserv\fP"
.LP
When the 
.I ypserv 
process crashes almost immediately, and does not
stay up even with repeated activations, the debug process is virtually
identical to that previously described in the subsection 
.I ypbind ""
Crashes.\(rq  Check for the existence of the
.I portmap 
daemon as follows:

.DS
.ft CW
ypserver% \&\fBps ax | grep portmap\fP
.DE

Reboot the server if you do not find the daemon.  If it is there, type:

.DS
.ft CW
% \&\fBrpcinfo -p \fIyp_server\fP
.DE

and look for output such as:

.DS
.ft CW
   program vers proto   port
    100004    2   udp   1027  ypserv
    100004    2   tcp   1024  ypserv
    100004    1   udp   1027  ypserv
    100004    1   tcp   1024  ypserv
    100007    2   tcp   1025  ypbind
    100007    2   udp   1035  ypbind
    100007    1   tcp   1025  ypbind
    100007    1   udp   1035  ypbind
    100009    1   udp   1023  yppasswdd
    100003    2   udp   2049  nfs
    100024    1   udp   1074  status
    100024    1   tcp   1031  status
    100021    1   tcp   1032  nlockmgr
    100021    1   udp   1079  nlockmgr
    100020    1   udp   1082  llockmgr
    100020    1   tcp   1033  llockmgr
    100021    2   tcp   1034  nlockmgr
    100012    1   udp   1104  sprayd
    100011    1   udp   1106  rquotad
    100005    1   udp   1108  mountd
    100008    1   udp   1110  walld
    100002    1   udp   1112  rusersd
    100002    2   udp   1112  rusersd
    100001    1   udp   1115  rstatd
    100001    2   udp   1115  rstatd
    100001    3   udp   1115  rstatd
.DE

Your machine will have different
port numbers.  The four entries
representing the
.I ypserv 
process are:

.DS
.ft CW
    100004    2   udp   1027  ypserv
    100004    2   tcp   1024  ypserv
    100004    1   udp   1027  ypserv
    100004    1   tcp   1024  ypserv
.DE

If they are not present,
.I ypserv 
has been unable to register its
services.  Reboot the machine.
If the
.I ypserv 
processes are there, and they change each
time you try to restart 
.I /usr/etc/ypserv ,
reboot the machine.
If the situation persists after reboot, call Sun
for assistance.
.
..IX maintenance "fixing NIS problems" "" "" PAGE END 
..IX NIS troubleshooting "" "" PAGE END 
..IX troubleshooting "NIS problems" "" "" PAGE END 
.NH 2
\&Turning Off \*(YP Services
..IX NIS "turning off"
.LP
If 
.I ypserv 
on the master is disabled, you can no longer update any
the \*(YP maps.  
If you choose to turn off \*(YP on a
network currently running it, you can disable it by
simply renaming the 
.I /usr/etc/ypbind\fP 
file to 
.I /usr/etc/ypbind.orig .
SunInstall does this automatically if you tell it you do not want to run \*(YP.
Type the following:

.DS
.ft CW
% \&\fBcd /etc\fP
% \&\fBmv /usr/etc/ypbind /usr/etc/ypbind.orig\fP
.DE

.LP
To disable \*(YP on a particular \*(YP slave
or master, type the following on the server in question: 

.DS
.ft CW
% \&\fBmv /usr/etc/ypserv /usr/etc/ypserv.orig.\fP
.DE
  
Again,
SunInstall
does this automatically if you do not select \*(YP.
.LP
Refer back to the chapter on
\fIThe Sun Network File System Service\fP 
for information about the
files you need to maintain for a server should you decide
to disable \*(YP.
..IX  NIS "" "" ""  PAGE END
.
.
.NH 2
\&Default \*(YP Maps
..IX "NIS maps" listing
.LP
The following table describes the default \*(YP maps,
information they contain, and whether SunOS 
consults the corresponding administrative files when
\*(YP is running.
.LP
.LP
.ce
Table: \*(YP Map Descriptions
.TS H
box tab(`);
l 2 | lw(1i) 2 | lw(2.5i)
l 2 | lw(1i) 2 | lw(2.5i)
l lw(1i) lw(2.5i).
   `Corresponding` 
Map Name`Admin File?`Description 
_
.sp .5v
.TH
bootparams`bootparams`T{
Contains pathnames of files clients need during booting:
\&\fIroot\fP, \&\fIswap\fP, possibly others.  With \*(YP,
.I bootparamd 
does not consult \&\fI/etc/bootparams\fP after map is created.
T}

ethers.byaddr`ethers`T{
Contains machine names and Ethernet addresses.
The Ethernet address is the key in the map.
\&\fI/etc/ethers\fP is not consulted after map is created.
T}

ethers.byname`ethers`T{
Same as \&\fIethers.byaddr\fP, except key is machine name instead
of Ethernet address.
T}

group.bygid`group`T{
Contains group security information with group \s-2ID\s0 as key.  With \*(YP,
local \&\fI/etc/group\fP is consulted first, then map.
T}

group.byname`group`T{
Contains group security information with group name as key.  With \*(YP,
local \&\fI/etc/group\fP is consulted first, then map.
T}

hosts.byaddr`hosts`T{
Contains host name, and \s-2IP\s0 address, with \s-2IP\s0 address as key.
With \*(YP, the map is always used except at boot time, when
\&\fI/etc/hosts\fP is consulted.
T}

hosts.byname`hosts`T{
Contains hostname and \s-2IP\s0 address, with hostname as key.
With \*(YP,
map is always used, except at boot time, when it
\&\fI/etc/hosts\fP is consulted.
T}

mail.aliases`aliases`T{
Contains aliases and mail addresses, with aliases as key.
With \*(YP,
local \&\fI/etc/aliases\fP is consulted first, then map.
T}

mail.byaddr`aliases`T{
Contains mail address and alias, with mail address as key.  
With \*(YP,
local \&\fI/etc/aliases\fP is consulted first, then map.
T}

netgroup.byhost`netgroup`T{
Contains group name, user name and host name, with host name
as key.  
\&\fI/etc/netgroup\fP is never consulted.
T}

netgroup.byuser`netgroup`Same as \&\fInetgroup.byhost\fP, except that key is user name.

netgroup`netgroup`T{
Same as netgroup.byhost, except that key is group name.
T}

netid.byname`T{
passwd, hosts, group
T}`T{
Used for \s-2UNIX\s0\(hystyle authentication.
Contains machine name and mail address (including
domain name).
If there is a 
.I netid 
file available it is consulted in addition to the data
available through the other files.
T}

netmasks.byaddr`netmasks`T{
Contains network mask to be used with \s-2IP\s0 subnetting, with
mask as key.
\&\fI/etc/netmasks\fP is never consulted after the map is created.
T}

networks.byaddr`networks`T{
Contains names of networks known to your system and their \s-2IP\s0
addresses, with the address as the key.
\&\fI/etc/networks\fP is never consulted after map is created.
T}

networks.byname`networks`Same as \&\fInetworks.byaddr\fP, except key is name of network.

passwd.byname`password`T{
Contains password information with user name as key.  With \*(YP,
local \&\fI/etc/passwd\fP is consulted first, then map.
T}

passwd.byuid`password`T{
Same as 
.I passwd.byname ,
except that key is user \s-2ID\s0.
T}

protocols.byname`protocols`T{
Contains network protocols known to your network,
with protocol name as key.
\&\fI/etc/protocols\fP is never consulted after map is created.
T}

protocols.bynumber`protocols`T{
Same as
.I protocols.byname ,
except that key is protocol number.
T}

publickey.byname`publickey`T{
Contains public and secret keys.
\&\fI/etc/publickey\fP is never consulted after map is created.
T}

rpc.bynumber`rpc`T{
Contains program number and name of \s-2RPC\s0s known to your system.
Key is \s-2RPC\s0 program number.
\&\fI/etc/rpc\fP is never consulted after map is created.
T}

services.byname`services`T{
Lists Internet services known to your network. 
Key is service name.
\&\fI/etc/services\fP is never consulted after map is created.
T}

ypservers`None`Lists \*(YP servers known to your network.

.TE
