#
#	@(#)rc.boot	1.2 90/07/23 4.1NFSSRC; from 1.24 88/02/07 SMI
#
# Executed once at boot time
#
# Note that all "echo" commands are in parentheses.  This is done
# because all commands that redirect the output to "/dev/console"
# must be done in a child of the main shell, so that the main shell
# does not open a terminal and get its process group set.  Since
# "echo" is a builtin command, redirection for it will be done
# in the main shell unless the command is run in a subshell.
#
PATH=/bin:/etc:/usr/bin:/usr/etc; export PATH
HOME=/; export HOME
hostname=unknown
#
# It is important to fsck the root filesystem here to prevent
# spurious panics after system crashes.
#
error=0
hostname $hostname
ifconfig ec0 $hostname -trailers up
ifconfig ie0 $hostname -trailers up
ifconfig le0 $hostname -trailers up
mount -n /usr >/dev/console
if [ $1x = singleuserx ]
then
	(echo "checking / and /usr filesystems")		>/dev/console
	fsck -p -w / /usr >/dev/console 2>&1
else
	if [ -r /fastboot ]
	then
		(echo "Fast boot ... skipping disk checks")	>/dev/console
	else
		(echo "checking filesystems")			>/dev/console
		fsck -p -w >/dev/console 2>&1
		case $? in
		0)
			;;
		4)
			(echo "Mounted FS fixed - rebooting.")	>/dev/console
			reboot -q -n
			;;
		8)
			(echo "Reboot failed...help!")		>/dev/console
			error=1
			;;
		12)
			(echo "Reboot interrupted.")		>/dev/console
			error=1
			;;
		*)
			(echo "Unknown error in reboot fsck.")	>/dev/console
			error=1
			;;
		esac
	fi
fi
mount -o remount,rw / >/dev/console
umount -at nfs
> /etc/mtab
mount -f / > /dev/console 2>&1
mount -f /usr > /dev/console 2>&1
sync
#
# exit with error status if there were any fsck errors above
#
exit $error
