/*	@(#)vfs_conf.c	2.2 88/06/13 4.0NFSSRC SMI;  from SMI 1.6 87/01/27	*/

#include "param.h"
#include "vfs.h"
#include "bootconf.h"

extern	struct vfsops ufs_vfsops;	/* XXX Should be ifdefed */

#ifdef NFSCLIENT
extern	struct vfsops nfs_vfsops;
#endif

#ifdef PCFS
extern	struct vfsops pcfs_vfsops;
#endif

#ifdef LOFS
extern	struct vfsops lo_vfsops;
#endif

#ifdef RFS
extern	struct vfsops rfs_vfsops;
#endif

extern	struct vfsops spec_vfsops;

/* 
 * WARNING: THE POSITIONS OF FILESYSTEM TYPES IN THIS TABLE SHOULD NOT
 * BE CHANGED. These positions are used in generating fsids and fhandles.
 * Thus, changing positions will cause a server to change the fhandle it
 * gives out for a file.
 */

struct vfssw vfssw[] = {
	"spec", &spec_vfsops,		/* SPEC */
	"4.3", &ufs_vfsops,		/* UFS */
#ifdef NFSCLIENT
	"nfs", &nfs_vfsops,		/* NFS */
#else
	(char *)0, (struct vfsops *)0,
#endif
#ifdef PCFS
	"pc", &pcfs_vfsops,		/* PC */
#else
	(char *)0, (struct vfsops *)0,
#endif
#ifdef LOFS
	"lo", &lo_vfsops,		/* LOopback */
#else
	(char *)0, (struct vfsops *)0,
#endif
#ifdef RFS
	"rfs", &rfs_vfsops,		/* RFS */
#else
	(char *)0, (struct vfsops *)0,
#endif
};

#define	NVFS	(sizeof vfssw / sizeof vfssw[0])

struct vfssw *vfsNVFS = &vfssw[NVFS];

struct bootobj rootfs = {
	{ "ufs",           "",     0, 0, (struct vnode *)0 },
};
struct bootobj dumpfile = {
	{ "",           "",     0, 0, (struct vnode *)0 },
};
