/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 */
/*	@(#)mount.h	2.3 89/03/20 4.0NFSSRC SMI;	from UCB 7.1 6/4/86	*/
/*				@(#) from SUN 2.10	*/

/*
 * Mount structure.
 * One allocated on every ufs mount.
 * Used to find the super block.
 */
struct	mount {
	struct mount	*m_nxt;		/* linked list of all mounts */
	struct vfs	*m_vfsp;	/* vfs structure for this filesystem */
	struct vnode	*m_devvp;	/* vnode for block device mounted */
	struct buf	*m_bufp;	/* pointer to superblock */
	dev_t		m_dev;		/* device mounted */
	u_short		m_qflags;	/* QUOTA: filesystem flags */
	struct inode	*m_qinod;	/* QUOTA: pointer to quota file */
	u_long		m_btimelimit;	/* QUOTA: block time limit */
	u_long		m_ftimelimit;	/* QUOTA: file time limit */
};
#ifdef KERNEL
extern struct	mount *mounttab;
/*
 * Convert vfs ptr to mount ptr.
 */
#define VFSTOM(VFSP)	((struct mount *)((VFSP)->vfs_data))

/*
 * Operations
 */
struct mount *getmp();
#endif
