/*	@(#)swapgeneric.c	2.1 88/05/18 4.0NFSSRC SMI;	from UCB 7.1 6/5/86	
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)swapgeneric.c	7.1 (Berkeley) 6/6/86
 */

#include "mba.h"

#include "pte.h"

#include "param.h"
#include "conf.h"
#include "buf.h"
#include "time.h"
#include "vm.h"
#include "systm.h"
#undef NFS
#include "mount.h"
#include "reboot.h"
#include "vfs.h"
#include "vnode.h"
#include "cons.h"
#include "mtpr.h"
#include "../vaxmba/mbareg.h"
#include "../vaxmba/mbavar.h"
#include "../vaxuba/ubareg.h"
#include "../vaxuba/ubavar.h"

/*
 * Generic configuration;  all in one
 */
struct vnode *argvp;
struct vnode *rootvp;



int	nswap;
long	dumplo;
int	dmmin, dmmax, dmtext;

struct	genericconf {
	caddr_t	gc_driver;
	char	*gc_name;
	dev_t	gc_root;
};
#ifdef GENERIC_CONF
extern	struct mba_driver hpdriver;
extern	struct uba_driver scdriver;
extern	struct uba_driver hkdriver;
extern	struct uba_driver idcdriver;
extern	struct uba_driver hldriver;
extern	struct uba_driver udadriver;
struct genericconf  genericconf[] = {
	{ (caddr_t)&hpdriver,	"hp",	makedev(0, 0),	},
	{ (caddr_t)&scdriver,	"up",	makedev(2, 0),	},
	{ (caddr_t)&udadriver,	"ra",	makedev(9, 0),	},
	{ (caddr_t)&idcdriver,	"rb",	makedev(11, 0),	},
	{ (caddr_t)&hldriver,	"rl",	makedev(14, 0),	},
	{ (caddr_t)&hkdriver,	"hk",	makedev(3, 0),	},
	{ (caddr_t)&hkdriver,	"rk",	makedev(3, 0),	},
	{ 0 },
};
#else
extern	struct mba_driver hpdriver;
struct genericconf  genericconf[] = {
	{ (caddr_t)&hpdriver,	"hp",	makedev(0, 0),	},
	{ 0 },
};
#endif
struct vfssw *
setconf()
{
	register struct mba_device *mi;
	register struct uba_device *ui;
	register struct genericconf *gc;
	int unit, swaponroot = 0;

	if (rootdev != NODEV)
		goto doswap;
	if (boothowto & RB_ASKNAME) {
		char name[128];
retry:
		printf("root device? ");
		gets(name);
		for (gc = genericconf; gc->gc_driver; gc++)
			if (gc->gc_name[0] == name[0] &&
			    gc->gc_name[1] == name[1])
				goto gotit;
		goto bad;
gotit:
		if (name[3] == '*') {
			name[3] = name[4];
			swaponroot++;
		}
		if (name[2] >= '0' && name[2] <= '7' && name[3] == 0) {
			unit = name[2] - '0';
			goto found;
		}
		printf("bad/missing unit number\n");
bad:
		printf("use hp%%d, up%%d, ra%%d, rb%%d, rl%%d or hk%%d\n");
		goto retry;
	}
	unit = 0;
	for (gc = genericconf; gc->gc_driver; gc++) {
		for (mi = mbdinit; mi->mi_driver; mi++) {
			if (mi->mi_alive == 0)
				continue;
			if (mi->mi_unit == 0 && mi->mi_driver ==
			    (struct mba_driver *)gc->gc_driver) {
				printf("root on %s0\n",
				    mi->mi_driver->md_dname);
				goto found;
			}
		}
		for (ui = ubdinit; ui->ui_driver; ui++) {
			if (ui->ui_alive == 0)
				continue;
			if (ui->ui_unit == 0 && ui->ui_driver ==
			    (struct uba_driver *)gc->gc_driver) {
				printf("root on %s0\n",
				    ui->ui_driver->ud_dname);
				goto found;
			}
		}
	}
	printf("no suitable root\n");
	asm("halt");
found:
	gc->gc_root = makedev(major(gc->gc_root), unit*8);
	rootdev = gc->gc_root;
doswap:
	swdevt[0].sw_dev = argdev = dumpdev =
	    makedev(major(rootdev), minor(rootdev)+1);
	/* swap size and dumplo set during autoconfigure */
	if (swaponroot)
		rootdev = dumpdev;
}

getchar()
{
	register c;

	while ((mfpr(RXCS)&RXCS_DONE) == 0)
		;
	c = mfpr(RXDB)&0177;
	if (c == '\r')
		c = '\n';
	cnputc(c);
	return (c);
}

gets(cp)
	char *cp;
{
	register char *lp;
	register c;

	lp = cp;
	for (;;) {
		c = getchar() & 0177;
		switch (c) {
		case '\n':
		case '\r':
			*lp++ = '\0';
			return;
		case '\b':
		case '#':
		case '\177':
			lp--;
			if (lp < cp)
				lp = cp;
			continue;
		case '@':
		case 'u'&037:
			lp = cp;
			cnputc('\n');
			continue;
		default:
			*lp++ = c;
		}
	}
}

/*
 * If booted with ASKNAME, prompt on the console for a filesystem
 * name and return it.
 */
getfsname(askfor, name)
	char *askfor;
	char *name;
{

	if (boothowto & RB_ASKNAME) {
		printf("%s name: ", askfor);
		gets(name);
	}
}

/*
 * Return the device number and name of the first
 * block device in the bdevlist that can be opened.
 * If booted with the -a flag, ask user for device name.
 * Name must be at least 128 bytes long.
 * askfor is one of "root" or "swap".
 */
dev_t
getblockdev(askfor, name)
	char *askfor;
	char *name;
{
#ifdef sun
	register struct bdevlist *bl;
	int unit;
	int part;

	if (boothowto & RB_ASKNAME) {
		for (unit = -1; unit == -1; ) {
			printf("%s device ( ", askfor);
			for (bl = bdevlist; bl->bl_name; bl++)
				printf("%s%%d[a-h] ", bl->bl_name);
			printf("): ");
			gets(name);
			if (*name == '\0') {
				bl = bdevlist;
				unit = 0;
				part = 0;
				break;
			}
			for (bl = bdevlist; bl->bl_name; bl++) {
				if (bl->bl_name[0] == name[0] &&
				    bl->bl_name[1] == name[1])
					break;
			}
			if (!bl->bl_name) {
				printf("unknown device name %c%c\n",
				    name[0], name[1]);
				continue;





			}
			if (name[2] < '0' || name[2] > '7') {
				printf("bad/missing unit number\n");
				continue;
			}
			unit = name[2] - '0';
			if (name[3] == '\0') {
				part = 0;
			} else if (name[3] >= 'a' && name[3] <= 'h') {
				part = name[3] - 'a';
			} else {
				printf("bad partition (use a-h)\n");
				unit = -1;
			}
		}
	} else {
		unit = 0;
		part = 0;
		/*
		 * If a name was given, find that block device
		 */
		if (*name != '\0') {
			for (bl = bdevlist; bl->bl_name; bl++) {
				if (bl->bl_name[0] == name[0] &&
				    bl->bl_name[1] == name[1]) {
					if (chkroot(bl)) {
						unit = name[2] - '0';
						part = name[3] - 'a';
						goto found;
					}
				}
			}
			return ((dev_t)0);
		}
		/*
		 * Look for device we booted from
		 */
		for (bl = bdevlist; bl->bl_name; bl++) {
			register struct bootparam *bp = (*romp->v_bootparam);

			if (!((*bl->bl_name == bp->bp_dev[0]) &&
				(*(bl->bl_name+1) == bp->bp_dev[1])))
				continue;
			if (chkroot(bl)) {



				goto found;
			} 
		} 

		/*
		 * Use first device that can be opened
		 */
		for (bl = bdevlist; bl->bl_name; bl++) {
			if (chkroot(bl)) {
				goto found;
			} 
		}
		return ((dev_t)0);
	}


found:
	name[0] = bl->bl_name[0];
	name[1] = bl->bl_name[1];
	name[2] = '0' + unit;
	name[3] = 'a' + part;
	name[4] = '\0';
	return (makedev(major(bl->bl_root), unit*8+part));


#endif sun
}

#ifdef sun

chkroot(bl)
	register struct bdevlist *bl;
{       
	register struct mb_device *md;
	dev_t try;
	
	for (md = mbdinit; md->md_driver; md++) {
		if (md->md_alive == 0)
			continue;
		if (md->md_unit == 0 && md->md_driver == bl->bl_driver) {
			try = makedev(major(bl->bl_root), 0);
			if ((*bdevsw[major(try)].d_open)(try, FREAD) == 0) {
				(void)(*bdevsw[major(try)].d_close)(try, FREAD);
				return (1);
			}
		}
	}
	return (0);
} 

#endif

struct vfssw *
getfstype(askfor, fsname)
	char *askfor;
	char *fsname;
{
	int fstype;
	extern char *strcpy();


	if (boothowto & RB_ASKNAME) {

		for (fsname[0] = '\0'; fsname[0] == '\0'; ) {
			printf("%s filesystem type ( ", askfor);
			for (fstype = 0; fstype < MOUNT_MAXTYPE; fstype++) {
				if (vfssw[fstype].vsw_name)
					printf("%s ", vfssw[fstype].vsw_name);
			}
			printf(" ): ");
			gets(fsname);
			for (fstype = 0; fstype < MOUNT_MAXTYPE; fstype++) {
				if (vfssw[fstype].vsw_name == 0) {
					continue;
				}
				if (*fsname == '\0') {
					(void) strcpy(fsname, vfssw[fstype].vsw_name);
					return (&vfssw[fstype]);
				}
				if (strcmp(vfssw[fstype].vsw_name, fsname)==0) {
					return (&vfssw[fstype]);
				}
			}
			printf("Unknown filesystem type '%s'\n", fsname);
			*fsname = '\0';
		}
	} else if (*fsname) {
		for (fstype = 0; fstype < MOUNT_MAXTYPE; fstype++) {
			if (vfssw[fstype].vsw_name == 0) {
				continue;
			}
			if (strcmp(vfssw[fstype].vsw_name, fsname) == 0) {
				return (&vfssw[fstype]);
			}
		}




	}
	return ((struct vfssw *)0);
}
