#ifndef lint
static char sccsid[] = "@(#)opt_software.c	1.10 88/03/08 Copyr 1987 Sun Micro";
#endif

/*
 * @(#)opt_software.c	1.4 92/04/23 4.1NFSSRC; from 1.10 88/03/08 D/NFS
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */

/*
 * Create the extractlist for given architecture
 *
 * Usage: opt_software arch tapedev tapehost
 */

#include "mktp.h"
#include <errno.h>
extern int errno;

#undef ALWAYS_GET_REQUIRED
#define EXTFILE "/tmp/EXTRACTLIST."
#define STRSZ 256
char *Prog;
static char *gtypnam();

main(argc,argv)
        int argc;
        char *argv[];
{
	char *arch, *tapedev, *tapehost;
	char filename[STRSZ], ans[STRSZ];
	char *swtype;
        FILE *ip = NULL, *popen();
        toc_entry *eptr;
        Information *infoptr;
        tapeaddress *tapeptr;
        int nentries, foundone, read_xdr_toc();
        u_int software_size;
	int status;

	Prog = argv[0];
	if (argc !=3 && argc != 4)
		usage();

	arch = argv[1];
	tapedev = argv[2];
	if (argc == 4) {
		tapehost = argv[3];
		if (*tapehost == '\0')
			tapehost = NULL;
		if (tapehost && strncmp("/dev/", tapedev, 5)) {
			fprintf(stderr, "\
tapedev must start with \"/dev/\" if tapehost if given.\n");
			usage();
		}
	} else
		tapehost = NULL;

	/*
         * Set up toc entry table
         */
	printf("Reading the table of contents for %s architecture...\n", arch);
	do {
	    tryagain:
		if (ip) {
			fclose(ip);
			ip = NULL;
		}
		if (strncmp("/dev/", tapedev, 5) == 0)
		    for (;;) {
			printf("\n\
Mount a %s release tape%s%s and hit RETURN, or enter \"exit\" : ",
				arch, tapehost? " on " : "",
				tapehost? tapehost : "");
			if (gets(ans) == NULL || !strcmp(ans, "exit")) {
				printf("\n%s: terminating\n", Prog);
				exit(1);
			}
			if (tapehost) {
				int pfd[2], pid, wpid, cnt;

				sprintf(filename, "\
rsh %s -n \"mt -f %s rew && mt -f %s fsf 1\"", tapehost, tapedev, tapedev);
				if (pipe(pfd) < 0) {
					fprintf(stderr, "%s: ", Prog);
					perror("pipe");
					exit(1);
				}
				/*
				 * We fork here so we can look at the output
				 * of the remote mt commands.  If there is
				 * any output, then there was an error.
				 */
				switch(pid = fork()) {
				    case -1:
					fprintf(stderr, "%s: ", Prog);
					perror("can't fork");
					exit(1);
					break;
				    case 0:
					/* child */
					dup2(pfd[1], 1);
					dup2(pfd[1], 2);
					close(pfd[0]);
					close(pfd[1]);
					_exit(system(filename));
					break;
				    default:
					/* parent */
					close(pfd[1]);
					for (;;) {
					    if ((wpid = wait(0)) == -1) {
						if (errno == EINTR)
							continue;
						fprintf(stderr, "%s: ", Prog);
						perror("wait");
						exit(1);
					    } else if (wpid == pid)
						break;
					}
					status = 0;
					while((cnt=read(pfd[0],ans,STRSZ)) > 0){
						write(1, ans, cnt);
						status += cnt;
					}
					close(pfd[0]);
					break;
				}
			} else {
				sprintf(filename, "\
mt -f %s rew && mt -f %s fsf 1", tapedev, tapedev);
				status = system(filename);
			}
			if (status == 0)
				break;
			printf("\
Unable to position tape; command sent:\n    %s)\n", filename);
		    }
        	if (tapehost) {
                	sprintf(filename,"rsh %s -n dd if=%s 2>/dev/null",
                        	tapehost,tapedev);
                	if((ip = popen(filename,"r")) == NULL) {
				fprintf(stderr, "%s: Unable to popen `%s'\n",
					Prog, filename);
				exit(1);
                	}
        	} else { 
			if ((ip = fopen(tapedev, "r")) == NULL) {
				fprintf(stderr, "%s: Unable to open %s\n",
					Prog, tapedev);
				exit(1);
			}
        	}
	} while (!(nentries = read_xdr_toc(ip,&dinfo,&vinfo,entries,NENTRIES)));
	fclose(ip);
	/*
       	 * Start select software for the specified architecture
       	 */
	sprintf(filename, "%s%s", EXTFILE, arch);
	unlink(filename);
	if ((ip = fopen(filename, "w")) == NULL) {
		fprintf(stderr, "%s: Can't create %s for writing\n",
			Prog, filename);
		exit(1);
	}

	/*
	 * This won't do since someone decided to put change the
	 * Title entry from "SunOS" to "SunOS 4.0.3", and the Version
	 * entry from "4.0" to "700-2159-10".  Not a pretty sight.
	 * The new structure parses in later script work as two
	 * args in "INSTALL", and causes even more problems later in
	 * "extracting", so we'll just delete it here.  RTHU, 89/11/3
	 */

	sscanf(dinfo.Title, "%[^ 	]", filename);
	if( strlen( dinfo.Title ) != strlen( filename ) ) {
	    fprintf(ip, "IDENT %s", filename);
	    sscanf(dinfo.Title, "%*[^ \t]%*[ \t]%s", filename);
	    fprintf(ip, " %s\n", filename);
	}
	else
	    fprintf(ip, "IDENT %s %s\n", dinfo.Title, dinfo.Version);

	for(eptr=entries, foundone = 0; eptr <= entries+nentries; eptr++) {
		infoptr = &eptr->Info;
		tapeptr = &eptr->Where.Address_u.tape;
		/*
		 *  Skip over files which are not installable or are
		 *  of the wrong architecture.
		 */
		if ( infoptr->kind != INSTALLABLE ||
		      !cmp_strlist(&infoptr->Information_u.Install.arch_for,
				   arch)
                      ) {
			continue;
                }
		/*
		 *  If this is the root entry, just write it out to
		 *  the extractlist.
		 *
		 *  Add record type to extract list, RTHU 90/12/11
		 */
		if (strcmp(eptr->Name, "root") == 0) {
			fprintf(ip,
				"ENTRY root %d %d %s / required not_movable %d\n",
				tapeptr->volno,
				tapeptr->file_number,
				gtypnam(eptr->Type),
				tapeptr->size);
			continue;
		}
		if (foundone++ == 0)
			printf("\
\nSelect optional software for the %s architecture:\n", arch);
		software_size = infoptr->Information_u.Install.size;
		if (infoptr->Information_u.Install.required)
			swtype = "required";
		else if (infoptr->Information_u.Install.desirable)
			swtype = "desirable";
		else if (infoptr->Information_u.Install.common)
			swtype = "common";
		else
			swtype = "optional";
		for (;;) {
			printf("Install \"%s\" [%d bytes; %s] ? [y/n]: ",
				eptr->LongName, software_size, swtype);
#ifdef ALWAYS_GET_REQUIRED
			if (infoptr->Information_u.Install.required) {
				printf("y\n");
				strcpy(ans, "y\n");
				break;
			}
#endif
			gets(ans);
			if (*ans == 'y' || *ans == 'n')
				break;
			printf("  Please answer \"yes\" or \"no\"\n");
		}
		if (*ans == 'y') {
			/*
			 * Add record type to extract list, RTHU 90/12/11
			 */
			fprintf(ip, "ENTRY %s %d %d %s %s %s %s %d\n",
				eptr->Name,
				tapeptr->volno,
				tapeptr->file_number,
				gtypnam(eptr->Type),
				infoptr->Information_u.Install.loadpoint,
				swtype,
				infoptr->Information_u.Install.moveable == TRUE?
					"movable" : "not_movable",
				tapeptr->size);
		}
	}
	fclose(ip);
	if (!foundone) {
		printf("\nRelease tape is not for %s architecture.\n", arch);
		if (strncmp("/dev/", tapedev, 5) != 0)
			exit(1);
		goto tryagain;
	}
	exit(0);
}

static
char *gtypnam(type)
file_type type;
{
	switch(type)
	{
	default:
	case UNKNOWN :
		return "unknown";
	case TOC:
		return "toc";
	case IMAGE:
		return "image";
	case TAR:
		return "tar";
	case CPIO:
		return "cpio";
	case BAR:
		return "bar";
	case TARZ:
		return "tarZ";
	}
}

/*
 *  search the string_list looking for a match of s.  Returns
 *  1 if match, 0 if no match.
 */
cmp_strlist(list, s)
register string_list *list;
register char *s;
{
	register int x;
	register char **p;

	if (list == NULL)
		return 0;

	for (x = 0, p = list->string_list_val;
	     x < list->string_list_len; x++, p++) {
		if (!strcmp(*p, s))
			return 1;		/* found a match */
	}
	return 0;
}

usage()
{
	fprintf(stderr, "Usage: %s arch tapedev [tapehost]\n", Prog);
	exit(1);
}
