
%/*
% * Copyright (c) 1987, 1990 by Sun Microsystems, Inc.
% */
%
%/* from @(#)rnusers.x	1.3 90/05/24 TIRPC 1.0 */

/*
 * Find out about remote users
 */

#ifdef RPC_HDR
%#ifndef _rpcsvc_rnusers_h
%#define _rpcsvc_rnusers_h
%/*
% * This is a utmp entry that does not correspond to a genuine user
% */
%#ifndef nonuser
%#define nonuser(ut) ((ut).ut_host[0] == 0 && \
%      strncmp((ut).ut_line, "tty", 3) == 0 && ((ut).ut_line[3] == 'p' \
%                                            || (ut).ut_line[3] == 'q' \
%                                            || (ut).ut_line[3] == 'r' \
%                                            || (ut).ut_line[3] == 's'))
%#endif /* !def nonuser */
#endif

const MAXUSERS = 100;
const MAXUTLEN = 256;

/*
 * the structure (data object) passed between the rusers program and
 * rpc.rusersd. For historical reasons it is similar to the utmp structure
 * for the bsd sytems. It is the data object that is included in the stuctures
 * passed between the client and the rusers service.
 */

struct ru_utmp {
	string ut_line<MAXUTLEN>;       /* tty name */
	string ut_name<MAXUTLEN>;       /* user id */
	string ut_host<MAXUTLEN>;       /* host name, if remote */
	int ut_time;                    /* time on */
};


struct utmpidle {
	ru_utmp ui_utmp;
	unsigned int ui_idle;
};

typedef ru_utmp utmparr<MAXUSERS>;

typedef utmpidle utmpidlearr<MAXUSERS>;

program RUSERSPROG {
	/*
	 * Old version does not include idle information
	 */
	version RUSERSVERS_ORIG {
		int
		RUSERSPROC_NUM(void) = 1;

		utmparr
		RUSERSPROC_NAMES(void) = 2;

		utmparr
		RUSERSPROC_ALLNAMES(void) = 3;
	} = 1;

	/*
	 * Includes idle information
	 */
	version RUSERSVERS_IDLE {
		int
		RUSERSPROC_NUM(void) = 1;

		utmpidlearr
		RUSERSPROC_NAMES(void) = 2;

		utmpidlearr
		RUSERSPROC_ALLNAMES(void) = 3;
	} = 2;
} = 100002;
	
#ifdef RPC_HDR
%#endif /*!_rpcsvc_rnusers_h*/
#endif
