/*      @(#)nettype.h 1.18 91/01/15 SMI      */

/*
 * nettype.h, Nettype definitions.
 * All for the topmost layer of rpc
 *
 * Copyright (C) 1988, Sun Microsystems, Inc.
 */

#ifndef _RPC_NETTYPE_H
#define _RPC_NETTYPE_H

#include <netconfig.h>

#define _RPC_NONE	0
#define _RPC_NETPATH	1
#define _RPC_VISIBLE	2
#define _RPC_CIRCUIT_V	3
#define _RPC_DATAGRAM_V	4
#define _RPC_CIRCUIT_N	5
#define _RPC_DATAGRAM_N	6
#define _RPC_TCP	7
#define _RPC_UDP	8

#ifdef __cplusplus
extern "C" void *_rpc_setconf (char *);
extern "C" void _rpc_endconf (struct handle *);
extern "C" struct netconfig *_rpc_getconf (struct handle *);
extern "C" struct netconfig *_rpc_getconfip (char *);
#elif (__STDC__ || c_plusplus)
extern void *_rpc_setconf (char *);
extern void _rpc_endconf (struct handle *);
extern struct netconfig *_rpc_getconf (struct handle *);
extern struct netconfig *_rpc_getconfip (char *);
#else
extern void *_rpc_setconf ();
extern void _rpc_endconf ();
extern struct netconfig *_rpc_getconf ();
extern struct netconfig *_rpc_getconfip ();
#endif
#endif /* !_RPC_NETTYPE_H */
