/*	@(#)pmap_clnt.h 1.24 91/01/15 SMI	*/

/*
 * pmap_clnt.h
 * Supplies C routines to get to portmap services.
 *
 * Copyright (C) 1984, Sun Microsystems, Inc.
 */

/*
 * Usage:
 *	success = pmap_set(program, version, protocol, port);
 *	success = pmap_unset(program, version);
 *	port = pmap_getport(address, program, version, protocol);
 *	head = pmap_getmaps(address);
 *	clnt_stat = pmap_rmtcall(address, program, version, procedure,
 *		xdrargs, argsp, xdrres, resp, tout, port_ptr)
 *		(works for udp only.) 
 * 	clnt_stat = clnt_broadcast(program, version, procedure,
 *		xdrargs, argsp,	xdrres, resp, eachresult)
 *		(like pmap_rmtcall, except the call is broadcasted to all
 *		locally connected nets.  For each valid response received,
 *		the procedure eachresult is called.  Its form is:
 *	done = eachresult(resp, raddr)
 *		bool_t done;
 *		caddr_t resp;
 *		struct sockaddr_in raddr;
 *		where resp points to the results of the call and raddr is the
 *		address if the responder to the broadcast.
 */

#ifndef _RPC_PMAPCLNT_H
#define _RPC_PMAPCLNT_H

#ifdef __cplusplus
extern "C" bool_t pmap_set (u_long, u_long, int, u_short);
extern "C" bool_t pmap_unset (u_long, u_long);
extern "C" struct pmaplist *pmap_getmaps (struct sockaddr_in *);
extern "C" enum clnt_stat pmap_rmtcall (struct sockaddr_in *, u_long, u_long, u_long, xdrproc_t, caddr_t, xdrproc_t, caddr_t, struct timeval, u_long *);
extern "C" enum clnt_stat clnt_broadcast (u_long, u_long, u_long, xdrproc_t, char *, xdrproc_t, char *, resultproc_t);
extern "C" u_short pmap_getport (struct sockaddr_in *, u_long, u_long, u_int);
#elif (__STDC__ || c_plusplus)
extern bool_t pmap_set (u_long, u_long, int, u_short);
extern bool_t pmap_unset (u_long, u_long);
extern struct pmaplist *pmap_getmaps (struct sockaddr_in *);
enum clnt_stat pmap_rmtcall (struct sockaddr_in *, u_long, u_long, u_long, xdrproc_t, caddr_t, xdrproc_t, caddr_t, struct timeval, u_long *);
enum clnt_stat clnt_broadcast (u_long, u_long, u_long, xdrproc_t, char *, xdrproc_t, char *, resultproc_t);
extern u_short pmap_getport (struct sockaddr_in *, u_long, u_long, u_int);
#else
extern bool_t pmap_set ();
extern bool_t pmap_unset ();
extern struct pmaplist *pmap_getmaps ();
enum clnt_stat pmap_rmtcall ();
enum clnt_stat clnt_broadcast ();
extern u_short pmap_getport ();
#endif

#endif /*!_RPC_PMAPCLNT_H*/
