/* @(#)Pod.h 1.1 91/05/14 SMI */
/*
 * Copyright (c) 1988, Sun Microsystems, Inc.  All Rights Reserved. Sun
 * considers its source code as an unpublished, proprietary trade secret, and
 * it is available only under strict license provisions.  This copyright
 * notice is placed here only to protect Sun in the event the source is
 * deemed a published work.  Dissassembly, decompilation, or other means of
 * reducing the object code to human readable form is prohibited by the
 * license agreement under which this code is provided to the user or company
 * in possession of this copy.
 * 
 * RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the Government
 * is subject to restrictions as set forth in subparagraph (c)(1)(ii) of the
 * Rights in Technical Data and Computer Software clause at DFARS 52.227-7013
 * and in similar clauses in the FAR and NASA FAR Supplement.
 * 
 * (C) Copyright 1987 Sun Microsystems, Inc. All rights reserved. This material
 * contains trade secret information of Sun Microsystems, Inc. Use,
 * reproduction, or disclosure is prohibited, except under a written license
 * by Sun Microsystems, Inc. Use of copyright notice is precautionary only
 * and does not imply publication or disclosure.
 */

/*
 * This module (class) contains the code and data for the Pod. The Pod (there
 * is only one) is at the root of the shared/global memory data hierarchy.
 * 
 * It contains information on the associated semaphore, shared memory, and all
 * of the Threads.
 */

#ifndef Pod_h
#define Pod_h

typedef struct Pod
{
    Thread          threads[XTI_MAX_THREADS];	/* array of Thread structures */
}               Pod;

#define LOCK_POD	1
#define UNLOCK_POD	0
#define LOCKED		1
#define UNLOCKED	0

#ifdef FORWARD
#undef FORWARD
#endif

#ifdef Pod_c
#define FORWARD
#else
#define FORWARD extern
extern int      xti_debug_enabled;

#endif

#define GET_ADDR	0
#define FREE_ADDR	1

FORWARD Pod    *addr_Pod();
FORWARD int	lock_Pod();

#endif
