/*
 * TEP.h -- Include file for TEP definitions
 */
#ifndef TEP_h
#define TEP_h
typedef struct sockaddr_in sockaddr_in;

typedef struct TEP
{
    u_char          socket_type;/* socket type, i.e., SOCK_STREAM */
    u_char          state;	/* TEP state, i.e., T_UNBND */
    u_char          event;	/* TEP event, i.e., T_DATA */
    u_char          qlen;	/* qlen specified in t_listen() */
    u_char          fd;		/* socket file desc */
    u_char          clnt_fd;	/* file desc returned from accept() */
    u_char          unused[2];	/* padding */
}               TEP;

#ifdef FORWARD
#undef FORWARD
#endif

#ifdef TEP_c
#define FORWARD
#else
#define FORWARD extern
#endif

FORWARD TEP    *get_tep();
FORWARD TEP    *init_TEP();
FORWARD int     accept_TEP();
FORWARD int     bind_TEP();
FORWARD int     close_TEP();
FORWARD int     connect_TEP();
FORWARD int     getinfo_TEP();
FORWARD int     getprotadd_TEP();
FORWARD int     getstate_TEP();
FORWARD int     listen_TEP();
FORWARD int     look_TEP();
FORWARD int     optmgmt_TEP();
FORWARD int     rcv_TEP();
FORWARD int     snd_TEP();
FORWARD int     rcvconnect_TEP();
FORWARD int     rcvudata_TEP();
FORWARD int     sndudata_TEP();
FORWARD int     rcvuderr_TEP();
FORWARD int     sync_TEP();
FORWARD int     unbind_TEP();
FORWARD int     rcvrel_TEP();
FORWARD int     sndrel_TEP();
FORWARD int     snddis_TEP();
FORWARD int     rcvdis_TEP();

#endif
