#include <stdio.h>

#ifdef sun
#include <stropts.h>
#endif

#include "tcp.h"

int
accept_call(listenfd, callptr, name, rwflag)
    int             listenfd;
    struct t_call  *callptr;
    char           *name;
    int             rwflag;
{
    int             newfd;

    if ((newfd = t_open(name, O_RDWR, (struct t_info *) 0)) < 0)
    {
	fprintf(stderr, "t_open error\n");
	exit(1);
    }
    if (t_bind(newfd, (struct t_bind *) 0, (struct t_bind *) 0) < 0)
    {
	fprintf(stderr, "t_bind error\n");
	exit(1);
    }
    if (t_accept(listenfd, newfd, callptr) < 0)
    {
	if ((int) t_errno == TLOOK)
	{
	    if (t_rcvdis(listenfd, (struct t_discon *) 0) < 0)
	    {
		fprintf(stderr, "t_rcvdis error\n");
		exit(1);
	    }
	    if (t_close(newfd) < 0)
	    {
		fprintf(stderr, "t_close error\n");
		exit(1);
	    }
	}
	fprintf(stderr, "t_accept error\n");
	fprintf(stderr, "\terrno: ");
	perror("\t");
	fprintf(stderr, "\tt_errno: %s\n", t_strerror(t_errno));
	exit(1);
    }
    return (newfd);
}
