#include "tcp.h"
#include <errno.h>

extern int      doit();

main(argc, argv)
    int             argc;
    char           *argv[];
{
    int             tfd;
    struct sockaddr_in serv_addr;
    struct t_call  *callptr;

    extern char    *sys_errlist[];

    pname = argv[0];

    if ((tfd = t_open(DEV_TCP, O_RDWR, (struct t_info *) 0)) < 0)
    {
	fprintf(stderr, "client: can't open %s.\n", DEV_TCP);
	exit(1);
    }
    if (t_bind(tfd, (struct t_bind *) 0, (struct t_bind *) 0) < 0)
    {
	fprintf(stderr, "client: can't bind local address.\n");
	exit(1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(SERV_TCP_PORT);

    if ((callptr = (struct t_call *) t_alloc(tfd, T_CALL, T_ADDR)) ==
	    (struct t_call *) 0)
    {
	fprintf(stderr, "client: can't alloc t_call.\n");
	exit(1);
    }
    callptr->addr.maxlen = sizeof(serv_addr);
    callptr->addr.len = sizeof(serv_addr);
    callptr->addr.buf = (char *) &serv_addr;
    callptr->opt.len = 0;
    callptr->udata.len = 0;

    if (t_connect(tfd, callptr, (struct t_call *) 0) < 0)
    {
	fprintf(stderr, "client: can't do connect.\n");
	exit(1);
    }
    doit(stdin, tfd);
    t_close(tfd);
    exit(0);
}

int
doit(fd, tfd)
    FILE           *fd;
    int             tfd;
{
    int             n, flags;
    char            sendline[MAXLINE], recvline[MAXLINE + 1];

    while (fgets(sendline, MAXLINE, fd) != NULL)
    {
	n = strlen(sendline);
	if (t_snd(tfd, sendline, n, 0) != n)
	{
	    fprintf(stderr, "client: can't do t_snd.\n");
	    exit(1);
	}
	n = t_rcv(tfd, recvline, MAXLINE, &flags);
	if (n < 0)
	{
	    fprintf(stderr, "client: can't do rcv.\n");
	    fprintf(stderr, "errno: ");
	    perror("");
	    fprintf(stderr, "t_errno: %s\n", t_strerror(t_errno));
	    exit(1);
	}
	recvline[n] = 0;
	fputs(recvline, stdout);
    }
    if (ferror(fd))
    {
	fprintf(stderr, "client: reading file.\n");
	exit(1);
    }
    return(0);
}
