#include "tcp.h"
#include <errno.h>

extern int      accept_call();
extern int      str_echo();

main(argc, argv)
    int             argc;
    char           *argv[];
{
    int             tfd, newtfd, childpid;
    struct sockaddr_in serv_addr;
    struct t_bind   req;
    struct t_call  *callptr;

    extern char    *sys_errlist[];

    pname = argv[0];

    if ((tfd = t_open(DEV_TCP, O_RDWR, (struct t_info *) 0)) < 0)
    {
	fprintf(stderr, "server: can't open %s.\n", DEV_TCP);
	exit(1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(SERV_TCP_PORT);
    /* serv_addr.sin_port = htons(0); */

    req.addr.maxlen = sizeof(serv_addr);
    req.addr.len = sizeof(serv_addr);
    req.addr.buf = (char *) &serv_addr;
    req.qlen = 5;

    if (t_bind(tfd, &req, (struct t_bind *) 0) < 0)
    {
	fprintf(stderr, "server: can't bind local address.\n");
	exit(1);
    }
    if ((callptr = (struct t_call *) t_alloc(tfd, T_CALL, T_ADDR)) ==
	    (struct t_call *) 0)
    {
	fprintf(stderr, "server: can't alloc t_call.\n");
	exit(1);
    }
    for (;;)
    {
	if (t_listen(tfd, callptr) < 0)
	{
	    fprintf(stderr, "server: t_listen() error.\n");
	    fprintf(stderr, "errno: ");
	    perror("");
	    fprintf(stderr, "t_errno: %s\n", t_strerror(t_errno));
	    exit(1);
	}
	/* close tfd and open newtfd for communication with the client */
	if ((newtfd = accept_call(tfd, callptr, DEV_TCP, 1)) < 0)
	{
	    fprintf(stderr, "server: accept_call() error.\n");
	    exit(1);
	}

/*
 * the following lines are to test with the system fork
 * remove them to test with the xti fork */
#ifdef fork
#undef fork
#endif

	if ((childpid = fork()) < 0)
	{
	    fprintf(stderr, "server: fork() error.\n");
	    exit(1);
	} else if (childpid == 0)
	{
#ifdef XTI_DEBUG
	    fprintf(stderr, "in child pid: %d tfd: %d newtfd: %d\n",
		    getpid(), tfd, newtfd);
#endif
	    t_close(tfd);
	    str_echo(newtfd);
	    t_close(newtfd);
	    exit(0);
	}
#ifdef XTI_DEBUG
        fprintf(stderr, "in parent pid: %d tfd: %d newtfd: %d\n",
	        getpid(), tfd, newtfd);
        fprintf(stderr, "parent: close newfd = %d and exit\n", newtfd);
#endif
	t_close(newtfd);	/* this fd is used by the child, not the
				 * server */
	exit(0);
    }
}
