#include <stdio.h>

#ifdef sun
#include <stropts.h>
#endif

#include "tcp.h"


int
writen(fd, ptr, nbytes)
    int             fd;
    char           *ptr;
    int             nbytes;
{
    int             nleft, nwritten;

    nleft = nbytes;
    while (nleft > 0)
    {
	nwritten = write(fd, ptr, nleft);
	if (nwritten <= 0)
	    return (nwritten);
	nleft -= nwritten;
	ptr += nwritten;
    }
    return (nbytes - nleft);
}

int
readline(fd, ptr, maxlen)
    int             fd;
    char           *ptr;
    int             maxlen;
{
    int             n, rc;
    char            c;

    for (n = 1; n < maxlen; n++)
    {
	if ((rc = read(fd, &c, 1)) == 1)
	{
	    *ptr++ = c;
	    if (c == '\n')
	    {
		break;
	    }
	} else if (rc == 0)
	{
	    if (n == 1)
	    {
		return (0);
	    } else
	    {
		break;
	    }
	} else
	{
	    return (-1);
	}
    }
    *ptr = 0;
    return (n);
}

int
str_echo(sockfd)
    int             sockfd;
{
    int             n;
    char            line[MAXLINE];

    for (;;)
    {
	n = readline(sockfd, line, MAXLINE);
	if (n == 0)
	{
	    return (n);
	} else if (n < 0)
	{
	    exit(1);
	}
	if (writen(sockfd, line, n) != n)
	{
	    exit(1);
	}
    }
}
