#include "udp.h"
#include <string.h>
#include <sys/param.h>
#include <sys/types.h>

#ifdef sun
#include <sys/fcntl.h>
#endif

#include <stdio.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/ioctl.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <rpc/rpc.h>
#include <sys/syslog.h>

extern int      doit();

main(argc, argv)
    int             argc;
    char           *argv[];
{
    int             tfd;
    struct sockaddr_in serv_addr;
    struct t_unitdata unitdata;
    char            hostname[100];
    struct hostent *host_entry;
    struct in_addr *inet_address;
    int             gethostnameReturn;

    extern char    *sys_errlist[];

    pname = argv[0];

    if ((tfd = t_open(DEV_UDP, O_RDWR, (struct t_info *) 0)) < 0)
    {
	fprintf(stderr, "client: can't open %s.\n", DEV_UDP);
	exit(1);
    }
    if (t_bind(tfd, (struct t_bind *) 0, (struct t_bind *) 0) < 0)
    {
	fprintf(stderr, "client: can't bind local address.\n");
	exit(1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_port = htons(SERV_UDP_PORT);

    /*
     * get the inet address from the hostname.
     */
    gethostnameReturn = gethostname(&(hostname[0]), sizeof(hostname));
    if (gethostnameReturn == 0 &&
	    (host_entry = (struct hostent *) gethostbyname(&(hostname[0]))) >
	    (struct hostent *) 0)
    {
	inet_address = (struct in_addr *) host_entry->h_addr_list[0];
	serv_addr.sin_addr = *inet_address;
    } else
    {
	serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
    }

    unitdata.addr.maxlen = sizeof(serv_addr);
    unitdata.addr.len = sizeof(serv_addr);
    unitdata.addr.buf = (char *) &serv_addr;
    unitdata.opt.maxlen = 0;
    unitdata.opt.len = 0;
    unitdata.opt.buf = (char *) 0;

    doit(tfd, &unitdata, stdin);
    t_close(tfd);
    exit(0);
}

int
doit(tfd, sudataptr, fd)
    int             tfd;
    struct t_unitdata *sudataptr;
    FILE           *fd;
{
    int             n, flags;
    char            sendline[MAXLINE], recvline[MAXLINE + 1];
    struct t_unitdata *rudataptr;

    if ((rudataptr = (struct t_unitdata *) t_alloc(tfd, T_UNITDATA, T_ADDR)) ==
	    (struct t_unitdata *) 0)
    {
	fprintf(stderr, "server: can't alloc t_unitdata.\n");
	exit(1);
    }
    while (fgets(sendline, MAXLINE, fd) != NULL)
    {
	n = strlen(sendline);
	sudataptr->udata.len = n;
	sudataptr->udata.buf = sendline;
	if (t_sndudata(tfd, sudataptr) < 0)
	{
	    perror("client: can't do t_sndudata.");
	    exit(1);
	}
	rudataptr->opt.maxlen = 0;
	rudataptr->udata.maxlen = MAXLINE;
	rudataptr->udata.buf = recvline;
	n = t_rcvudata(tfd, rudataptr, &flags);
	if (n < 0)
	{
	    fprintf(stderr, "client: can't do rcvudata().\n");
	    fprintf(stderr, "errno: ");
	    perror("");
	    fprintf(stderr, "t_errno: %s\n", t_strerror(t_errno));
	    exit(1);
	}
	recvline[n] = '\0';
	fprintf(stdout, "%s", recvline);
    }

    /* send a datagram with one delete character to terminate the server */
    sudataptr->udata.len = 1;
    *(sudataptr->udata.buf) = 0x7F;
    if (t_sndudata(tfd, sudataptr) < 0)
    {
	fprintf(stderr, "client: can't do t_sndudata.\n");
	exit(1);
    }
    if (ferror(fd))
    {
	fprintf(stderr, "client: reading file.\n");
	exit(1);
    }
    return(0);
}
