#include "udp.h"
#include <errno.h>

extern int      accept_call();
extern int      str_echo();

main(argc, argv)
    int             argc;
    char           *argv[];
{
    int             tfd;
    struct sockaddr_in serv_addr;
    struct t_bind   req;

    extern char    *sys_errlist[];

    pname = argv[0];

    if ((tfd = t_open(DEV_UDP, O_RDWR, (struct t_info *) 0)) < 0)
    {
	fprintf(stderr, "server: can't open %s.\n", DEV_UDP);
	exit(1);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
    serv_addr.sin_port = htons(SERV_UDP_PORT);
    /* serv_addr.sin_port = htons(0); */

    req.addr.maxlen = sizeof(serv_addr);
    req.addr.len = sizeof(serv_addr);
    req.addr.buf = (char *) &serv_addr;
    req.qlen = 5;

    if (t_bind(tfd, &req, (struct t_bind *) 0) < 0)
    {
	fprintf(stderr, "server: can't bind local address.\n");
	exit(1);
    }
    echo(tfd);
}

echo(tfd)
    int             tfd;
{
    int             flags;
    char            line[MAXLINE];
    struct t_unitdata *udataptr;

    if ((udataptr = (struct t_unitdata *) t_alloc(tfd, T_UNITDATA, T_ADDR)) ==
	    (struct t_unitdata *) 0)
    {
	fprintf(stderr, "server: can't alloc t_unitdata.\n");
	exit(1);
    }
    for (;;)
    {
	udataptr->opt.maxlen = 0;
	udataptr->opt.len = 0;
	udataptr->udata.maxlen = MAXLINE;
	udataptr->udata.len = MAXLINE;
	udataptr->udata.buf = line;
	line[0] = '\0';

	if (t_rcvudata(tfd, udataptr, &flags) < 0)
	{
	    fprintf(stderr, "server: t_rcvudata() error.\n");
	    fprintf(stderr, "errno: ");
	    perror("");
	    fprintf(stderr, "t_errno: %s\n", t_strerror(t_errno));
	    exit(1);
	}
	/* a datagram with one delete character terminates the server */
	if (*(udataptr->udata.buf) == 0x7F && udataptr->udata.len == 1)
	{
	    t_close(tfd);
	    exit(0);
	}
	if (t_sndudata(tfd, udataptr) < 0)
	{
	    fprintf(stderr, "server: t_sndudata() error.\n");
	    fprintf(stderr, "errno: ");
	    perror("");
	    fprintf(stderr, "t_errno: %s\n", t_strerror(t_errno));
	    exit(1);
	}
    }
}
