#include <sys/file.h>
#include "cons.h"

/*
 * Test program for apa8 display driver
 */

#define	DELAY(x) {int i;  for(i=0; i<x; i++);}
#define	STDIN_TEST
main()
{
	int fd;
	int col, i;
	char buf[80];

	if ((fd=open("/dev/bus", O_RDONLY) < 0)) {
		perror("error opening /dev/bus");
		exit(0);
	}
	if (!apa8_probe()) {
	    printf("You don't have an apa8 installed!\n");
	    exit(0);
	}
	apa8_init();

#ifdef	STDIN_TEST
	printf("Reading stdin and sending to apa8\n");
	while((i=getchar()) > 0)
	    apa8_putchar(i&0xff);
#else
	apa8_putchar(ADM3A_CLEAR);
	for (i=0x00; i<256; i++)
		apa8_putchar(i);
	sprintf(buf,"%c=%c%c", 0x1b, ' '+20, ' '+30);
	apa8_puts(buf);
	sprintf(buf,"X  This is row 20 column 30!");
	apa8_puts(buf);

#ifdef	SCROLL_TEST
	sprintf(buf,"%c=%c%c", 0x1b, ' '+31, ' '+30);
	apa8_puts(buf);
	sprintf(buf,"X  This is row 31 column 30!");
	apa8_puts(buf);

	apa8_cursor_off();
	apa8_scroll_up(1);
	apa8_cursor_on();
	sprintf(buf,"%c=%c%c", 0x1b, ' '+21, ' '+30);
	apa8_puts(buf);
	sprintf(buf,"X  This is row 21 column 30!");
	apa8_puts(buf);
exit();
#endif
	apa8_putchar(ADM3A_HOME);
	for (col=0; col<90; col++) {
	    apa8_putchar(ADM3A_RIGHT);
	    DELAY(250000);
	}
	for (col=0; col<90; col++) {
	    apa8_putchar(ADM3A_LEFT);
	    DELAY(250000);
	}

	apa8_putchar(ADM3A_HOME);
	for (col=0; col<30; col++) {
	    apa8_putchar(ADM3A_DOWN);
	    apa8_putchar(ADM3A_RIGHT);
	    DELAY(250000);
	}
	for (col=0; col<30; col++) {
	    apa8_putchar(ADM3A_UP);
	    apa8_putchar(ADM3A_RIGHT);
	    DELAY(250000);
	}
	for (col=0; col<30; col++) {
	    apa8_putchar(ADM3A_DOWN);
	    apa8_putchar(ADM3A_LEFT);
	    DELAY(250000);
	}
	for (col=0; col<30; col++) {
	    apa8_putchar(ADM3A_UP);
	    apa8_putchar(ADM3A_LEFT);
	    DELAY(250000);
	}
#endif
}

apa8_puts(s)
char *s;
{
	while (*s)
	    apa8_putchar(*s++);
}
