/*
 * 5799-WZQ (C) COPYRIGHT IBM CORPORATION  1986,1987,1988
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */
/* $Header: /sys/rt/include/RCS/io.h,v 1.3 1994/05/22 12:40:07 roger Exp md $ */
/* $ACIS:io.h 12.0$ */
/* $Source: /sys/rt/include/RCS/io.h,v $ */

#if !defined(lint) && !defined(LOCORE) && defined(RCS_HDRS)
static char volatile *rcsidio = "$Header: /sys/rt/include/RCS/io.h,v 1.3 1994/05/22 12:40:07 roger Exp md $";
#endif

#define Adr_8259A	0xF0008880	/* first 8259 address (CPU IRPT 3) */
#define Adr_8259B	0XF00088A0	/* second 8259 address (CPU IRPT 4) */
#define CRRA		0x8c40
#define CRRB		0x8c60
#define INIT_8259(adr)	* (char volatile *) adr = 0x12; \
	* (char volatile *) (adr+1) = 0x00	/* send init sequence */

#define INIT_INTR() INIT_8259(Adr_8259A);	\
		INIT_8259(Adr_8259B)	/* initialize both 8259's */

#define POLL_CMD	0x0c		/* poll interrupts */
#define GET_IMR		0x00		/* get interrupt mask register */
#define SET_IMR		0x00		/* set interrupt mask register */
#define GET_ISR		0x0b		/* get In Service Register */
#define GET_IRR		0x0a		/* get Int Request Register */
#define NSEOI_CMD 	0x20	/* non specific end of interrupt */
#define SEOI_CMD 	0x60	/* specific end of interrupt */
#define DISPLAY(value)	display(value)	/* put into front panel display */

/* Enable/Disable Interrupts from a Bus I/O level */
#define ENABLE	1
#define DISABLE	0

#define IOSPACE		0xf0000000	/* PC/AT IO map */
#define IOSPACE2	0xf4000000	/* PC/AT memory map */
#define IOSPACEMASK	0xff000000	/* mask for IOSPACEs */
#define FPASPACE	0xff000000	/* where FPA lives */
#define IOSPACESHIFT	24		/* number of bits to shift right */
#define IOPAGESHIFT	(IOSPACESHIFT-PGSHIFT)	/* number of bits to shift vpage right */


/*
 ********************************************************************
 *
 *                   This section of sa.h defines
 *    		     various macros and constants
 *		     that ONLY APPLY TO THE IBMRTPC
 *		     version of the kernel.
 *
 ********************************************************************
 */


#define PUT_PC1B(x,v) x = v 
#define PUT_PC2B(x,v) x = v 
#define PUT_PC4B(x,v) x = v 
		
#define GET_PC1B(x) x 
#define GET_PC2B(x) x 
#define GET_PC4B(x) x

#define GET_PC(x)  x
#define PUT_PC(x,v) x = v


#define IOOUT(port, d) (*((char volatile *)(port)) =  d)
#define IOIN(port) ( (char) (*((char volatile *)(port))))  
#define IOOUTW(port, d) (*((short volatile *)(port)) = (int) d)
#define IOINW(port) ( (short) (*((short volatile *)(port)) ))  

#define OUT(port, d) IOOUT((int)(port)+IO_BASE, d)
#define IN(port) IOIN((int)(port)+IO_BASE)
#define OUTW(port, d) IOOUTW((int)(port)+IO_BASE, d)
#define INW(port) IOINW((int)(port)+IO_BASE) 

#define MM_IN(p) (*((char volatile *) (p)))
#define MM_OUT(p, d) (*((char volatile *) (p)) = ((char) (d)))
#define MM_INW(p) (*((short volatile *) (p)))
#define MM_OUTW(p, d) (*((short volatile *) (p)) = ((short) (d)))

#define set_128_window(x) (x)	/* dummy */
#define set_512_window(x) (x)	/* dummy */

#define IO_BASE 0xf0000000	       /* I/O base address */
#define MEM_BASE 0xf4000000	       /* PC Memory base address */

#ifdef DEBUG
#define LOCAL			       /* make it external */
#else
#define LOCAL	static		       /* make it local */
#endif DEBUG
