/*
 * Copyright (c) 1988 University of Utah.
 * Copyright (c) 1982, 1986, 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * the Systems Programming Group of the University of Utah Computer
 * Science Department.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * from: Utah $Hdr: pcb.h 1.14 91/03/25$
 *
 *	@(#)pcb.h	8.1 (Berkeley) 6/10/93
 */

/*
 * IBM RT process control block
 */
struct pcb
{
	int	pcb_ksp;	/* kernel stack pointer */
	int	pcb_afpalen;	/* afpa length register */
	int	pcb_sr08;	/* segment 8 */
	int	pcb_r0;
	int	pcb_r1;
	int	pcb_r2;
	int	pcb_r3;
	int	pcb_r4;
	int	pcb_r5;
	int	pcb_r6;
	int	pcb_r7;
	int	pcb_r8;
	int	pcb_r9;
	int	pcb_r10;
	int	pcb_r11;
	int	pcb_r12;
	int	pcb_r13;
	int	pcb_r14;
	int	pcb_r15;
	int	pcb_iar;	/* instruction address */
	int	pcb_icscs;	/* program status longword */
	struct	pte *pcb_p0br;	/* seg 0 base register */
	int	pcb_p0lr;	/* seg 0 length register and astlevel */
	struct	pte *pcb_p1br;	/* seg 1 base register */
	int	pcb_p1lr;       /* seg 1 length register and pme */
/*
 * Software pcb (extension)
 */
	int	pcb_szpt;	/* number of pages of user page table */
	int	pcb_cmap2;
	int	*pcb_sswap;
	int	pcb_sigc[2];
	int	pcb_fpastatus;	/* fpa status value when owned an exception */
	char	pcb_ccr;	/* value for CCR for this process */
	char	pcb_consdev;	/* which console devices are open for access */
	char	pcb_fill[2];	/* filler */
};

#define pcb_usp pcb_r1		/* user stack pointer */

#define AST_USER 0x80000000    /* VAX AST simulation - changed WEW*/

#define aston() (u.u_pcb.pcb_icscs |= AST_USER)

#define astoff() (u.u_pcb.pcb_icscs &= ~AST_USER)

/*
 * The pcb is augmented with machine-dependent additional data for
 * core dumps. For the IBM RT we don't need anything for now.
 */
struct md_coredump {
};
