/*
 * Copyright (c) 1988 University of Utah.
 * Copyright (c) 1982, 1986, 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * the Systems Programming Group of the University of Utah Computer
 * Science Department.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * from: Utah $Hdr: reg.h 1.1 90/07/09$
 *
 *	@(#)reg.h	8.3 (Berkeley) 1/27/94
 */

/*
 * Location of the users' stored
 * registers relative to D0.
 * Usage is u.u_ar0[XX].
 */
#define MCSPCS (-3)
#define INFO (-2)
#define ICSCS (-1)
#define R0 (0)
#define R1 (1)
#define SP (1)
#define R2 (2)
#define R3 (3)
#define R4 (4)
#define R5 (5)
#define R6 (6)
#define R7 (7)
#define R8 (8)
#define R9 (9)
#define R10 (10)
#define R11 (11)
#define R12 (12)
#define R13 (13)
#define R14 (14)
#define R15 (15)
#define IAR (16)
#define MQ  (17)
#define ECR_COUNT (18)
#define EX1_CTL (19)
#define EX1_ADDR (20)
#define EX1_DATA (21)
#define EX1_RSV (22)
#define EX2_CTL (23)
#define EX2_ADDR (24)
#define EX2_DATA (25)
#define EX2_RSV (26)
#define EX_GSR1	(27)
#define EX_REP1	(28)
#define EX_GSR2	(29)
#define EX_REP2	(30)
/*
 * NOTE: please be sure to change MAXSIGREGS (in h/signal.h) if the number
 * of registers restored by sigcleanup/sigreturn changes.
 */

#ifdef IPCREG
#define	NIPCREG 18
int ipcreg[NIPCREG] =   /* allow modification of only these u area variables */
        {R0,R1,R2,R3,R4,R5,R6,R7,R8,R9,R10,R11,R12,R13,R14,R15,IAR,MQ};
#endif

/*
 * Register set accessible via /proc/$pid/reg
 */
struct reg {
        int     r_regs[16];	/* numbered as above */
	int	r_pc;
	int	r_sr;
};

/*
 * Register set accessible via /proc/$pid/fpreg
 */
struct fpreg {
	int	fpr_xxx;	/* not implemented */
};
