#include <machine/cpu.h>

#define SYS_ADDRTAG ROMP_SID_SYSTEM<<ROMP_VPAGE_BITS

#ifndef	eye_profil	/* XXX should be in locore.h */
#define eye_catcher(name) .ascii "<name>";.align 2; name
#endif

	.globl	.oVncs
	.set	.oVncs, 0

	.text
	.align	2

	.globl	_.mmu_init
	.globl	_mmu_init
	
_mmu_init:	.long _.mmu_init
eye_catcher(mmu_init):
_.mmu_init:	
	stm	r14,-44(sp)
	cal	sp,-44(sp)

 #  Loop through HATIPT mapping system page i to real page i.

	get	r0,$(0x01ffffff)	# Protection bits:
			# spare(7),write(1)=1,tid(8)=ff,lockbits(16)=ffff	
	get	r12,$(SYS_ADDRTAG)	# part of addrtag for seg id
	lis	r9,0			# page number
	load	r11,_rose_page_shift	# which page size are we using?
#ifdef	SIMULATOR
	load	r3,_ROMP_HATIPT		# point to HATIPT at end of memory
#else
	load	r3,hatipt		# point to HATIPT at end of memory
#endif
	load	r4,_ROMP_HASHMASK	# hashing significant bits
	ai	r2,r4,1			# r2 = number of HATIPT entries
	nilz	r4,r4,ROMP_SID_SYSTEM	# partial result for hash calculations
	cal16	r5,ROMP_UNDEF_PTR(r0)	# Invalid IPTPTR value for debug
	load	r7,_physmem		# pointer to end of valid memory
	get	r8,$-1			# invalid HATPTR

hatiptloop:
	mr	r10,r9			# copy of page number
	cis	r11,0xc			# 4K pages?
	jne	0f
	sli	r10,1			# double page # for addrtag
0:
	o	r10,r12			# add in segid part
	oiu	r10,r10,0x4000		# use key 01->user read, kernel write
	sts	r10,IPTADDRTAG(r3)	# set ADDRTAG field to sys seg addr
	sths	r8,IPTHATPTR(r3)	# in case the hatptr is invalid here
	mr	r6,r9			# copy page number for mungeing
	x	r6,r4			# "unhash" to get page pointer
	c	r6,r7			# beyond end of installed memory?
	jnl	hatinvalid		# yes, leave hat ptr invalid

	sths	r6,IPTHATPTR(r3)	# set HATPTR field to this page
hatinvalid:
	sths	r5,IPTIPTPTR(r3)	# invalid IPTPTR
	sts	r0,IPTLOCK(r3)		# set lock bits and flags
	inc	r9,1			# next page
	sis	r2,1			# decrement counter
	bnzx	hatiptloop		# loop if not zero
	ai	r3,r3,HATIPTSIZE	# ...while pointing to next entry

return:
	lm	r14,0(sp)
	brx	r15
	cal	sp,44(sp)
