/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)trap.h	0.0 () xx/xx/xx
 */

#ifndef _RT_TRAP_H_

#define ICSCS_ASTON     0x80000000  /* simulated, unpredictable in hardware */
#define ICSCS_RESERVED  0x70000000
#define ICSCS_STGPROT   0x08000000
#define ICSCS_PROBSTATE 0x04000000
#define ICSCS_TRANSLATE 0x02000000
#define ICSCS_INTERRUPT 0x01000000
#define ICSCS_CHECKSTOP 0x00800000
#define ICSCS_REGSETNO  0x00700000
#define ICSCS_INSTSTEP  0x00080000  /* simulated, unpredictable in hardware */
#define ICSCS_PRIORITY  0x00070000
#define ICSCS_HOKEY 0x00000070  /* ad hoc convention used by wait and execve */
#define ICSCS_TESTBIT 0x00000001

#define ICSCS_USERSET 0x0E870000  /* user ICSCS must have these bits set */
#define ICSCS_USERCLR 0xF1780000  /* user ICSCS must have thsts bits cleared */

/* format for printing ics_cs */
#define ICSFMT "\20\20INST-STEP\30CHKSTOP-MASK\31INTR-MASK\32XLATE\33USER\34STG-PROT\35PERIE"
/* format for printing cs also in ics_cs */
#define ICSFMT2 "\20\1TB\2OV\4C-ZERO\5GT\6EQ\7LT\10P-ZERO\20INST-STEP\30CHECK-STOP-MASK\31INTR-MASK\32XLATE\33PROB-STATE\34STG-PROT\35PERIE";	/* full blown-version */

#endif /* !_RT_TRAP_H_ */
