#include <sys/param.h>
#include <sys/systm.h>

#include <vm/vm.h>
#include <vm/vm_kern.h>
#include <vm/vm_page.h>

#include <machine/cpu.h>

dump_pmap(pmap)
struct pmap *pmap;
{
	int i;
	queue_head_t *list;
	struct pmap_list_entry *lentry;
	struct pmap_cache_entry *centry;
	pmap_list_entry_t next_lentry;
	pmap_cache_entry_t next_centry;

	printf("pmap addr = 0x%08x\n", pmap);
	for (i=0; i<NUSR_SEGS; i++)
	    printf("sidtab[%02d]=0x%03x\n", i, pmap->sidtab[i]);
	printf("ref_count=%d\n", pmap->ref_count);
	printf("ppage_list:(next=0x%08x  prev=0x%08x) ppage_count=%d\n",
		pmap->ppage_list.next, pmap->ppage_list.prev,
		pmap->ppage_count);

	list = &pmap->ppage_list;
	lentry = (struct pmap_list_entry *) queue_first(list);
	while (!queue_end(list,(queue_entry_t) lentry)) {
	    next_lentry = (pmap_list_entry_t) queue_next(&lentry->pmap_pages);
	    printf("v->p: 0x%08x -> 0x%08x\n", lentry->vaddr, lentry->paddr);
	    lentry = next_lentry;
	}

	printf("cache_entries:(next=0x%08x  prev=0x%08x) cache_count=%d\n",
		pmap->cache_entries.next, pmap->cache_entries.prev,
		pmap->cache_count);
	list = &pmap->cache_entries;
	centry = (struct pmap_cache_entry *) queue_first(list);
	while (!queue_end(list,(queue_entry_t) centry)) {
	    next_centry = (pmap_cache_entry_t) queue_next(&centry->cache_entries);
	    printf("seg/v->p: 0x%03x/0x%04x -> 0x%08x\n",
	    (centry->addrtag>>17)&0xfff, centry->addrtag&0x1ffff,
	    centry->ppage);
	    centry = next_centry;
	}
}
