#	from: @(#)Makefile	8.1 (Berkeley) 6/10/93
#	     $Id: Makefile,v 1.1 1994/11/01 18:51:37 roger Exp $

# XXX: for old make.
MACHINE_ARCH=${MACHINE}

.if !exists(machine) || !exists(${MACHINE_ARCH})
machine-links:
	-rm -f machine && \
	    ln -s ${.CURDIR}/../../arch/${MACHINE}/include machine
	-rm -f ${MACHINE_ARCH} && \
	    ln -s ${.CURDIR}/../../arch/${MACHINE_ARCH}/include ${MACHINE_ARCH}
.else
machine-links:
.endif

#RELOC=180000
RELOC=200000
#RELOC=220000

CONS= -DAPA8CONSOLE # -DAPA16CONSOLE -DAPA8CONSOLE -DMPELCONSOLE
DEFS= -DJUSTASK -DSTANDALONE -DCOMPAT_NOLABEL ${CONS}  -DDEBUGIT
CFLAGS=	-O ${INCPATH} ${DEFS} -fvolatile
LDFLAGS= -N -x -e start -M

SRCS=   autoconf.c apa8_driver.c cons.c devopen.c wd.c # fd.c 
SRCS+=	conf.c prf.c tgets.c machdep.c
SRCS+=	kbd.c kbd_keymap.c hdcompat.c

S=	${.CURDIR}/../..

.PATH: ${S}/arch/${MACHINE_ARCH}/${MACHINE_ARCH}
.PATH: ${S}/stand ${S}/lib/libsa

INCPATH=-I${.CURDIR} -I${.CURDIR}/../.. -I${S} -I${S}/lib/libsa -Imachine/.. -I. 

### find out what to use for libkern
.include "$S/lib/libkern/Makefile.inc"
LIBKERN=	${KERNLIB}

.include "$S/lib/libsa/Makefile.inc"
LIBSA=	${SA_LIB}

LIBS=	${LIBSA} libdrive.a \
	${LIBSA} ${LIBKERN}

BOOTS=	dboot cat #ls
ALL=	${BOOTS} installboot

all: machine-links ${ALL}

${BOOTS}: ${LIBS}

OBJS=	${SRCS:N*.h:R:S/$/.o/g}
libdrive.a: ${OBJS}
	rm -f $@
	${AR} cq $@ ${OBJS}
	${RANLIB} $@

# depend on DEFS

devopen.o machdep.o srt0.o: Makefile
cons.o dca.o hil.o: Makefile
ite.o ite_subr.o ite_dv.o ite_gb.o ite_hy.o ite_rb.o ite_tc.o: Makefile

# startups

relsrt0.o: srt0.s
	$(CPP) -E $(INCPATH) ${DEFS} -DRELOC=0x${RELOC} -DREL $(.CURDIR)/srt0.s >$*.S
	$(AS) -o $*.o $*.S
	rm -f $*.S

# new boot
pboot:	pboot.o relsrt0.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin relsrt0.o pboot.o ${LIBS} -o $@
	@size pboot
	@echo pboot total size should not exceed 1044480 bytes

ls:	ls.o relsrt0.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin relsrt0.o ls.o ${LIBS} -o $@
	@size ls
	@echo ls total size should not exceed 1044480 bytes

cat:	cat.o relsrt0.o ${LIBS}
	${LD} ${LDFLAGS} -T ${RELOC} relsrt0.o cat.o ${LIBS} -o $@
	@size cat
	@echo cat total size should not exceed 1044480 bytes

# bootable from tape

tboot:	tboot.o srt0.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin srt0.o tboot.o ${LIBS} -o $@
	@size tboot
	@echo tboot total size should not exceed 1044480 bytes

tboot.o: boot.c
	cp ${.CURDIR}/boot.c tboot.c; chmod +w tboot.c
	${CC} -c ${CFLAGS} -DJUSTASK tboot.c
	rm -f tboot.c

tcopy:	copy.o tpsrt0.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin tpsrt0.o copy.o ${LIBS} -o $@
	@size tcopy
	@echo tcopy total size should not exceed 1044480 bytes

# bootable from floppy or real disks

dboot:	boot.o relsrt0.o bootconf.o ${LIBS}
	${LD} ${LDFLAGS} -T ${RELOC} relsrt0.o boot.o bootconf.o ${LIBS} -o $@ 
	@size dboot
	@echo dboot text+data size should not exceed 57344 bytes
	@echo dboot total size should not exceed 1044480 bytes

bootconf.o: ${.CURDIR}/conf.c
	rm -f bootconf.c
	ln -s ${.CURDIR}/conf.c bootconf.c
	${CC} -c ${CFLAGS} -DBOOT bootconf.c
	rm -f bootconf.c

# non-secure boot (allows booting non-root owned or world writable kernels)

nboot:	nboot.o srt0.o bootconf.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin -o nboot srt0.o nboot.o bootconf.o ${LIBS}
	@size nboot
	@echo nboot text+data size should not exceed 57344 bytes
	@echo nboot total size should not exceed 1044480 bytes

nboot.o: ${.CURDIR}/boot.c
	rm -f nboot.c
	ln -s ${.CURDIR}/boot.c nboot.c
	${CC} -c ${CFLAGS} -DINSECURE nboot.c
	rm -f nboot.c

dcopy:	copy.o srt0.o conf.o ${LIBS}
	${LD} -N -T ${RELOC} -e begin -o dcopy srt0.o copy.o conf.o ${LIBS}

mkboot: ${.CURDIR}/mkboot.c
	${CC} ${CFLAGS} -o mkboot ${.CURDIR}/mkboot.c

installboot: ${.CURDIR}/installboot.sh
	@rm -f installboot
	cp -p ${.CURDIR}/installboot.sh installboot

# utilities

clean cleandir:
	rm -f *.o *.exe *.i errs make.out
	rm -f a.out pboot cat ls tboot tcopy
	rm -f boot[a-z]? boot[a-wyz][a-z].c conf[a-wyz][a-z].c
	rm -f core sboot bootconf.c nboot.c
	rm -f libdrive.a mkboot dboot dcopy nboot installboot *.lif

install: mkboot installboot ${ALL}
	./mkboot pboot netbsdboot.lif
	./mkboot dboot diskboot.lif
	./mkboot nboot ndiskboot.lif
	./mkboot tboot tcopy tapeboot.lif
	install -c -o bin -g bin -m 555 installboot ${DESTDIR}/usr/mdec
	install -c -o bin -g bin -m 444 netbsdboot.lif ${DESTDIR}/usr/mdec/rdboot
	rm -f ${DESTDIR}/usr/mdec/bootrd
	ln ${DESTDIR}/usr/mdec/rdboot ${DESTDIR}/usr/mdec/bootrd
	rm -f ${DESTDIR}/usr/mdec/sdboot
	ln ${DESTDIR}/usr/mdec/rdboot ${DESTDIR}/usr/mdec/sdboot
	rm -f ${DESTDIR}/usr/mdec/bootsd
	ln ${DESTDIR}/usr/mdec/sdboot ${DESTDIR}/usr/mdec/bootsd
	install -c -o bin -g bin -m 644 tapeboot.lif ${DESTDIR}/usr/mdec/bootct
#	install -o bin -g bin -m 755 -d ${DESTDIR}/sys/hpdist/tp
#	install -o bin -g bin -m 444 netbsdboot.lif ${DESTDIR}/sys/hpdist/tp
#	install -o bin -g bin -m 444 tapeboot.lif ${DESTDIR}/sys/hpdist/tp
#	install -o bin -g bin -m 444 diskboot.lif ${DESTDIR}/sys/hpdist/tp
#	install -o bin -g bin -m 444 ndiskboot.lif ${DESTDIR}/sys/hpdist/tp

#.include <bsd.dep.mk>
#.include <bsd.obj.mk>
# XXX This should not be necessary.
.include <bsd.subdir.mk>

FRC:
