
#include "asm.h"
#include "cpu.h"

	.text

	 # stupid sh*t for old ld.  It sets the New Calling Sequence flag.
         .globl .oVncs
         .set .oVncs , 0

	.globl	_edata
	.globl	start

	#
	# FYI: tech ref, pg 7-13:
	# r2 = POST control block
	# r3 = ROM entry table
	# r4 = boot record area (0x1800)
	#
	# (Maybe we care about these registers/values in the future?)
	#
start:
	j	_.start			# skip over ENTRY
ENTRY(start)

	cas	r0,r15,r0		# save off return address

#ifdef REL
	bali	r15, 1f			# determine where we are running
1:					
	ai	r15, r15, start-1b	# adjust for the bali
	get	r5,$start		# get address of start
	.using  start,r15

	c	r15,r5			# same ?
	beq	noreloc			# yes, no need to relocate

	cas	r4,r15,r0		# current (load) address.
	get	r6, $_edata		# end of copy.
	cas	r15,r5,r0		# address to restart at.

        # copy address range r4..r6 to r5, 8 bytes at a time
        bx      0f
        dec     r5,4
        .align  2
0:      ls      r7,0(r4)
        ls      r8,4(r4)
        inc     r4,8
        sts     r7,4(r5)
        inc     r5,8
        sts     r8,0(r5)
        cl      r5,r6
        jl      0b

	brx	r15			# restart at real address, and...
        lis     r15,0			# tell the code we cant return to
					# the caller, b/c we destroyed too
					# many registers.

noreloc:

#endif	/* REL */

	mfs	scr_iar,r15 		# get address of next instruction
0:	.using	0b,r15			# base register for the following saves

	# save non-volatile registers in so that we can return to the caller
	st	r0,_save_r15		# return address
	st	r1,_save_r1
	st	r6,_save_r6
	st	r7,_save_r7
	st	r8,_save_r8
	st	r9,_save_r9
	st	r10,_save_r10
	st	r11,_save_r11
	st	r12,_save_r12
	st	r13,_save_r13
	st	r14,_save_r14
#ifdef DEBUGSRT0
	st	r2,_save_r2		# arg0
	st	r3,_save_r3		# arg1
	st	r4,_save_r4		# arg2
	st	r5,_save_r5		# arg3
#endif

	# first 2 arguments may be howto, bootdev.
	# set them, if they aren't already set.
	load	r14,_bootdev
	cis	r14,0
	jne	bootdev_isset
	st	r2,_howto
	st	r3,_bootdev
bootdev_isset:

	mfs	scr_iar,r14 		# get address of next instruction
0:	.using	0b,r14			# base register for the rest...

	# put our stack at start.  NOTE: stack grows DOWN.
	get	r1,$start

	# Disable interrupt handling.
	cal	r4,0x180(r0)		# set interrupt & checkstop mask
	mts	scr_ics,r4		# set ICS.

	# clear bss
        lis     r4,0
        lda     r5,_edata
        lda     r6,_end
bss_loop:
        sts     r4,0(r5)
        inc     r5,4
        cl      r5,r6
        jl      bss_loop

	# now initialize the hardware.
	get 	r0,$_init_hdwr;
	bali	r15,_.init_hdwr;

	get 	r0,$_configure;
	bali	r15,_.configure;

	# done with low-stuff, now to C-code
main_loop:
	lis	r2,0			# XXX (fixme?): dummy arg for main.
	lis	r3,0			# XXX (fixme?): dummy arg for main.
	get 	r0,$_main;
	bali	r15,_.main;		# call main(0,0)
	b	main_loop		# do it again upon return

#
# for gcc2
#
ENTRY(__main)
        br      r15

ENTRY(init_hdwr)

	# determine what processor we are running on.
	# 3 choices, original RT ROMP, APC, and EAPC -- aka mod135.
	# NOTE: the original RT ROMP processor is not supported.

	# XXX:  TODO (?) 
	#	do a read from 0xf0008c80 (memory configuration register).
	#	Check bit 7.  If set to 1, original processor, so DIE.
	#	Else if 0, its APC or EAPC.
	# XXX:  ASSUME we are on an APC-stype processor.
	#	Besides, I have no way to test this code.
#	get	r4,$0xf0008c80		# memory configuration register
#	lcs	r4,0(r4)		# read it.
#	nilz	r4,r4,0x40		# if 0 then OLD cpu, if 1 then *APC
#	jeq	cpu_is_apc_type
#	wait				# OLD cpu, just die.
#cpu_is_apc_type:

	#
	# initialize IOIM 1
	# tech ref, appendix B-12.
	#
	get	r4,$0x800400	# address of IOIM1_BASE
	cal16	r5,0xa090(r0)	# reset default values.
        iow	r5,0(r4)	# write it.
	#
	# disable parity (tech ref appendix B says to do so!)
	#
	get	r4,$0x900008	# address of IOIM1+IOIM_GCR
        ior     r5,0(r4)	# read it.
	oil	r6,r5,0x8	# OR in IOIM_NOPARITY
        iow	r6,0(r4)	# write it.

	# Now that IOIM 1 is initialized, continue determining which
	# CPU we are running on.
	# Definitely on an APC style processor, so check if its an EAPC.
	# check bit 20 in misc chip control register.  If 1, this
	# is an APC, if 0 then EAPC.

	get	r4,$0x900000		# get base of IOIM1
	ior	r4,0xd(r4)		# get chip configuration register
	nilz	r4,r4,0x800		# if 1 then APC, if 0 then EAPC
	jeq	cpu_is_mod_eapc		# branch if EAPC
	lis	r0,CPU_APC
	st	r0,_cpu			# store cpu model information
	j	cpu_check_done		# done with CPU model checks
cpu_is_mod_eapc:
	lis	r0,CPU_EAPC		# else its a EAPC
	st	r0,_cpu			# store cpu model number

	# definitely on an EAPC processor.  Read General Status Register
	# twice to see if we need to set a bit in General Control Register.
	# Hardware ref appendix C.

	get	r6,$0x900000		# get base of IOIM1
	ior	r4,0xb(r6)		# get GSR to clear it
	ior	r4,0xb(r6)		# get GSR to see if bit 20 stuck at 1
	nilz	r4,r4,0x800		# is bit 20 set?
	jeq	cpu_check_done		# no, new ZIC
	ior	r4,0x8(r6)		# yes bit 20 set, old ZIC, apply fix
	setbl	r4,6			# turn on bit 22
	iow	r4,0x8(r6)		# write to GCR
cpu_check_done:

	#
	# Do a POR to all boards via CRRA and CRRB
	# tech ref p5-59
	#
	cal	r4,0xff(r0)		# 0xff -- reset all bits
	get     r5,$0xf0008c40		# component reset register A
	stcs    r4,0(r5)		# issue POR
	get     r5,$0xf0008c60		# component reset register B
	stcs    r4,0(r5)		# issue POR
	#
	# initialize IOIM 2 (NOT present on EAPC card)
	#
	load	r2,_cpu
	cis	r2,CPU_EAPC
	jeq	ioim2_skip
	get	r4,$0x800100	# address of IOIM2_base
	cal16	r5,0xb091(r0)	# make it different from IOIM1
        iow	r5,0(r4)	# write it.

ioim2_skip:
        br      r15		# return to caller

# simple led display routine.
ENTRY(led_display)
        get     r3,$0x800000            # get base address of ROM
	lcs	r0,0(r3)		# enable LED's with a read
        get     r3,$0x811000            # get the address base for LED's
        mc33    r3,r2                   # get the complete address
        ior     r0,0(r3)                # read from it
        iow     r0,0(r3)                # write it (lock it)
	br	r15                     # and return to caller

# simple delay routine.
ENTRY(delay)
	cal	r0,0xff(r0)		# put 0xff into r0.
	get	r3,$0xf00080e0		# address of IOCC delay register.
delay_loop:
	stcs	r0,0(r3)		# write 0xff to IOCC delay register.
	sis	r2,1			# subtract 1 and compare
	jh	delay_loop		# loop again
	br	r15			# return to caller

# attempt to return to the program that called us.
ENTRY(_rtt)
	# if save_r15 is non-zero, then we can return to the caller.
	load	r15,_save_r15
	cis	r15,0
	jeq	restart_this_program

	# return non-volatile registers to their value upon entry.
	load	r1,_save_r1
	load	r6,_save_r6
	load	r7,_save_r7
	load	r8,_save_r8
	load	r9,_save_r9
	load	r10,_save_r10
	load	r11,_save_r11
	load	r12,_save_r12
	load	r13,_save_r13
	load	r14,_save_r14
	balr	r15,r15			# return to the caller

restart_this_program:
	load	r2,_howto		# setup for the restart
	load	r3,_bootdev
	get 	r0,$start;
	balix	r15,_.start;		# restart
	lis	r15,0			# DONT allow a return to HERE !!!

	.align	2

#define VAR(x)	.globl x; x: .long 0

VAR(_cpu)
VAR(_howto)
VAR(_bootdev)

# registers we must save in order to return to our caller
VAR(_save_r1)
VAR(_save_r6)
VAR(_save_r7)
VAR(_save_r8)
VAR(_save_r9)
VAR(_save_r10)
VAR(_save_r11)
VAR(_save_r12)
VAR(_save_r13)
VAR(_save_r14)
VAR(_save_r15)

#ifdef DEBUGSRT0
VAR(_save_r2)
VAR(_save_r3)
VAR(_save_r4)
VAR(_save_r5)
#endif
