/*
** Institutional File System Project
** University of Michigan
**
** $Log:	asy.c,v $
 * Revision 1.2.1.8  91/12/11  08:30:46  honey
 * more!
 * 
 * Revision 1.2.1.7  91/11/27  23:46:13  honey
 * massive changes to try to increase performance.
 * 
 * Revision 1.2.1.6  91/11/26  15:57:19  honey
 * CTS signalling.  RTS is yet to come ...
 * 
 * Revision 1.2.1.5  91/11/26  15:24:04  lhuston
 * Added a counter for lost interupts.
 * 
 * Revision 1.2.1.4  91/09/30  23:42:21  honey
 * 38400
 * 
 * Revision 1.2.1.3  91/08/30  10:52:17  lhuston
 * Added a hack to check for lost interupts, and get the flow 
 * going again if one was lost.
 * 
 * Revision 1.2.1.2  90/05/29  11:54:39  eal
 * New IFS Development Branch
 * Added IFS Header
 * 
*/
/*
 * 5799-WZQ (C) COPYRIGHT IBM CORPORATION 1987,1988
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */
/* $Header: /afs/citi.umich.edu/usr/machdep/rt_aos4/sys/caio/RCS/asy.c,v 1.2.1.8 91/12/11 08:30:46 honey Exp $ */
/* $ACIS:asy.c 12.0$ */
/* $Source: /afs/citi.umich.edu/usr/machdep/rt_aos4/sys/caio/RCS/asy.c,v $ */

#if !defined(lint) && !defined(NO_RCS_HDRS)
static char *rcsid = "$Header: /afs/citi.umich.edu/usr/machdep/rt_aos4/sys/caio/RCS/asy.c,v 1.2.1.8 91/12/11 08:30:46 honey Exp $";
#endif
/*
 * Multiport asynchronous driver
 */
#include "asy.h"
#if NASY > 0

#include "../h/param.h"
#include "../h/conf.h"
#include "../h/dir.h"
#include "../h/user.h"
#include "../h/proc.h"
#include "../h/ioctl.h"
#include "../h/tty.h"
#include "../h/systm.h"
#include "../h/uio.h"
#include "../h/file.h"
#include "../machine/debug.h"
#include <syslog.h>

#ifdef ATR
extern int cold;		/* if 1, we're still in startup */
#define ASY_ADDR(addr) ((struct asydevice *)((addr) + pcif_io_b));
#else
#define ASY_ADDR(addr) ((struct asydevice *)((addr)));
#endif ATR

#include "../machineio/asyreg.h"
#include "../machine/io.h"
#include "../h/buf.h"
#include "../machineio/ioccvar.h"
#include "kernel.h"
#ifdef ATR
#include "../ca_atr/pcif.h"	/* need to get at pcvec_map[] */
#endif ATR

#include "ap.h"
#if NAP > 0
#include "../machineio/apdefs.h"
#endif

#include "../machine/softint.h"

#define ASY_SETBAUD(addr, baud) { \
	    IOOUT( &(addr)->lcr, (IOIN( &(addr)->lcr ) | LCR_DLAB) );\
	    IOOUT( &(addr)->dllsb, asybaudtbl[(baud)].lsb);\
	    IOOUT( &(addr)->dlmsb, asybaudtbl[(baud)].msb);\
	    IOOUT( &(addr)->lcr, (IOIN( &(addr)->lcr ) & ~LCR_DLAB) );}

static struct asybaudtbl {
	unsigned char msb;
	unsigned char lsb;
} asybaudtbl[NSPEEDS] = {
	 /* B0     */ 	0x00, 0x00,
	 /* B50    */ 	0x00, 0x02, /* 57600 (was 0x09, 0x00) */
	 /* B75    */ 	0x00, 0x01, /* 115200 (was 0x06, 0x00) */
	 /* B110   */ 	0x04, 0x17,
	 /* B134   */ 	0x03, 0x5b,
	 /* B150   */ 	0x03, 0x00,
	 /* B200   */ 	0x02, 0x40,
	 /* B300   */ 	0x01, 0x80,
	 /* B600   */ 	0x00, 0xc0,
	 /* B1200  */ 	0x00, 0x60,
	 /* B1800  */ 	0x00, 0x40,
	 /* B2400  */ 	0x00, 0x30,
	 /* B4800  */ 	0x00, 0x18,
	 /* B9600  */ 	0x00, 0x0c,
	 /* B19200 */ 	0x00, 0x06,
	 /* EXTB   */ 	0x00, 0x03	/* 38,400 */
};

/* output rate at various speeds; division by 10 is to convert baud to 
 * characters per second */
static int asyoutputrate[] = {
	10/10, 57600/10, 115200/10, 110/10, 134/10, 150/10, 200/10, 300/10,
	600/10, 1200/10, 1800/10, 2400/10, 4800/10, 9600/10, 19200/10, 38400/10
	};
#define ISPEED B9600		/* default input and output speed */

 /*
  * Encoding of the minor device number.
  * Numbering from the right to left:
  * 	Bits 0 & 1 encode the port number (0-3) on the multiport adapter
  * 	Bits 2, 3 & 4 encode the adapter number as follows:
  *			(0-3) for the multiport adapters
  *			(4-5) for the COM adapters
  *
  *			 4 3 2 1 0
  *			___________
  *			|     |   |
  *			-----------
  */
#define NPORTS	4		/* number of serial port per multiport card */
#define MAXUNIT (NASY * NPORTS)	/* total number of ports configured */
struct cbuf asycbuf[MAXUNIT];
 /*
  * Terminology:
  *
  *	ctlr    -- refers to the card number and can have a value from 0 to NASY
  *	port    -- always has a value from 0 to 3 to indicate slot A, B, C, 
  *		   or D	on a given ctlr
  *	unit    -- refers to the index into the tty struct array for a port
  *	           on any ctlr.
  */

 /*
  * Encoding of index into tty structure array:  
  *		2 2 2 2 | 1 1 1 1 | 1 1 1 1 | 1 1
  *	unit    3 2 1 0 | 9 8 7 6 | 5 4 3 2 | 1 0 9 8 | 7 6 5 4 | 3 2 1 0
  *		________|_________|_________|_________|_________|________
  *	port	      0 |       0 | 3 2 1 0 | 3 2 1 0 | 3 2 1 0 | 3 2 1 0
  *	        --------|---------|---------|---------|---------|--------
  *	ctlr       5         4	       3         2	   1         0
  *
  * Note that 17-19 and 21-23 are not used since there is only one port on
  * each of the COM cards.
  *
  * To calculate the index number:
  *			UNIT = (ctlr# * NPORTS ) + port#
  */
#define UNIT(ctlr, port)	(((ctlr) << 2) + (port))
#define CTLR(unit)		((unit) >> 2)
#define PORT(unit)		((unit) & 0x03)
#define PORTMASK(port)		((1 << (port)) & 0x0f) 

#define	ASY_XPEND	0x01
#define ASY_XTARDY	0x04

int	intr_flag[MAXUNIT];
int	to_is_running = 0;
int	lost_intrs = 0;

int	check_intr();

struct tty asy[MAXUNIT];
int asytimerset[MAXUNIT];
int asyinbufcount[17];
int asyoutbufcount[17];
int asystartloopcount[17];
int asylocts;
int asyhicts;
int asyrintchars;

#if NAP > 0
int asyoutc();
#endif
int asystart(), ttrstrt(), asyattach(), asyprobe(), asyint();

/* following is a hokey test for a quad card */
#ifdef IBMRTPC
#define isquad(addr) (0x0000f000 & (int) (addr) )
#endif IBMRTPC

#ifdef ATR
/* this will eliminate all the COM addresses */
#define isquad(addr) ( (0x0000f000 & (int)(addr)) && (0x00000010 &(int)(addr)) )
#endif ATR

/* define standard addresses for autoconf */
caddr_t asystd[] = {
#ifdef ATR
	(caddr_t)0x00001230,	       /* Multiport adaptor 1 */
	(caddr_t)0x00002230,	       /* Multiport adaptor 2 */
	(caddr_t)0x00003230,	       /* Multiport adaptor 3 */
	(caddr_t)0x00004230,	       /* Multiport adaptor 4 */
	(caddr_t)0x000003f8,	       /* PC/PS asynch adaptor COM1 */
	(caddr_t)0x000002f8,	       /* PC/PS asynch adaptor COM2 */
	(caddr_t)0x00003220,	       /* PC/PS asynch adaptor COM3 */
	(caddr_t)0x00003228,	       /* PC/PS asynch adaptor COM4 */
	(caddr_t)0x00004220,	       /* PC/PS asynch adaptor COM5 */
	(caddr_t)0x00004228,	       /* PC/PS asynch adaptor COM6 */
	(caddr_t)0x00005220,	       /* PC/PS asynch adaptor COM7 */
	(caddr_t)0x00005228,	       /* PC/PS asynch adaptor COM8 */
#endif ATR
#ifdef IBMRTPC
	(caddr_t)0xf0001230,	       /* Multiport adapter 1 */
	(caddr_t)0xf0002230,	       /* Multiport adapter 2 */
	(caddr_t)0xf0003230,	       /* Multiport adapter 3 */
	(caddr_t)0xf0004230,	       /* Multiport adapter 4 */
/* we do not define the COM cards here for an RT because this screws up the 
 * the ctlr number in autoconf if there are no multiport cards present
 */
#endif IBMRTPC
	0
};

#ifdef ATR
#define	COM1_ADDR	0x000003f8
#define	COM2_ADDR	0x000002f8
#define	COM3_ADDR	0x00003220
#define	COM4_ADDR	0x00003228
#define	COM5_ADDR	0x00004220
#define	COM6_ADDR	0x00004228
#define	COM7_ADDR	0x00005220
#define	COM8_ADDR	0x00005228
#endif ATR

#ifdef IBMRTPC
#define BADD_ADDR (caddr_t) 0xeeeeeeee /* to catch bad IRQ number */

caddr_t asyreset[16] = {
	BADD_ADDR, BADD_ADDR, BADD_ADDR, BADD_ADDR, /* 0 - 3 */
	BADD_ADDR, BADD_ADDR, BADD_ADDR, BADD_ADDR, /* 4 - 7 */
	BADD_ADDR, (caddr_t)0xf00002f2,	
	  (caddr_t)0xf00006f2, (caddr_t)0xf00006f3, /* 8 - 11 */
	BADD_ADDR, BADD_ADDR, BADD_ADDR, BADD_ADDR, /* 12 - 15 */
};
#endif IBMRTPC

char asysoftCAR[NASY];	    		/*  software carrier detect  */
unsigned char asysoftFIFO[MAXUNIT];	/*  software - FIFO mode */





struct iocc_device *asydinfo[NASY];
struct iocc_driver asydriver = {
	/* probe, slave, attach, dgo, addr, dname, dinfo, mname, csr, intr */
	   asyprobe, 0, asyattach, 0, asystd, "asy", asydinfo, 0, 0, asyint
};

/*   asyprobe will try to generate an interrupt so that the system can
 *   determine whether or not the async ctlrs specified in the config
 *   file are truly present.  It will also try to determine the ctlrs
 *   interrupt request level (IRQ).  The interrupts are generated using 
 *   the loopback feature provided by the INS8250.
 */

asyprobe(addr)
	register caddr_t addr;
{
	register struct asydevice *asyp = ASY_ADDR(addr);
	char savemsr;

	DEBUGF(ttydebug, printf("asyprobe(%x):\n", addr));
	

	if (isquad(asyp)) {
#ifdef ATR
		return(PROBE_BAD);  /* no quad card support in ATR version */
#endif ATR
#ifdef IBMRTPC
		IOOUT( &asyp->ppir, 0xff); /* initialize ppir - ONLY ONCE */
		DEBUGF(ttydebug, 
		printf("ppir=%x, iir=%x\n",IOIN(&asyp->ppir),IOIN(&asyp->iir)));

		/* reset all shared interrupts */
		IOOUT(asyreset[9], 0);
		IOOUT(asyreset[10], 0);
		IOOUT(asyreset[11], 0);
#endif IBMRTPC
	}
	
#ifdef ATR
	DEBUGF(ttydebug, printf("asyprobe: pcif_io_b = 0x%x\n", pcif_io_b));

	if ((int)addr == COM1_ADDR) 
		pcvec_map[4] = 1;	/* forward IRQ4 interrupts from PS/2 */
	else
		pcvec_map[3] = 1;	/* forward IRQ3 interrupts from PS/2 */
#endif ATR

	DEBUGF(ttydebug, printf(" lsr=%x,", IOIN( &asyp->lsr ) ) );
	DEBUGF(ttydebug, printf(" msr=%x\n", IOIN( &asyp->msr ) ) );
	IOOUT(&asyp->ier, IER_MSR);     	/* enable modem status int. */
	IOOUT(&asyp->mcr, MCR_IEN);		/* enable modem ints (only */
	DELAY(1);				/* for COM card; does not */
						/* affect Multiport card) */
	IOOUT(&asyp->mcr, MCR_IEN | MCR_LOOP) ; /* enable LOOP mode */
	DELAY(1);
	IOOUT(&asyp->mcr, MCR_IEN); 		/* disable LOOP mode */
	PROBE_DELAY(10000);
	DEBUGF(ttydebug, printf(" iir=%x", IOIN( &asyp->iir )));
	IOOUT(&asyp->ier,0);	        	/* disable all interrupts */
	savemsr = IOIN(&asyp->msr);		/* reset modem interrupts */
	DEBUGF(ttydebug, printf(" msr=%x\n", savemsr));

#ifdef IBMRTPC
	/* reset all shared interrupts */
	if (isquad(addr)) {
		IOOUT(asyreset[9], 0);
		IOOUT(asyreset[10], 0);
		IOOUT(asyreset[11], 0);
		PROBE_DELAY(10000);
	}
#endif IBMRTPC
	return (PROBE_OK);
}




asyattach(iod)
	register struct iocc_device *iod;
{
	register struct tty *tp;
	register int ctlr = iod->iod_unit;
	register int port;  /* line number on this ctlr */
	register int saveiir;
	register struct asydevice *addr = ASY_ADDR(iod->iod_addr);

	DEBUGF(ttydebug & SHOW_INIT, printf("asyattach: ctlr=%d addr=%x\n", ctlr,addr));
	
	/* initializes the tty struct for each port on this ctlr */
	for (port = 0, tp = &asy[UNIT(ctlr,port)]; port < NPORTS; port++, addr++, tp++) {
		DEBUGF(ttydebug & SHOW_INIT, 
		printf("port = %d, tp = %x, addr = %x\n", port, tp, addr ));
		tp->t_addr = (caddr_t)addr;
		tp->t_cbufp = &asycbuf[UNIT(ctlr,port)];
		tp->t_state = 0;
		/* these instructions have no effect on non-FIFO card */
		/* clear fifos */
		IOOUT(&addr->fcr, FCR_FCR1|FCR_FCR2);
 		/* enable 14 char FIFO mode */
 		IOOUT(&addr->fcr,
			FCR_FCR0/* |FCR_FCR6 /* |FCR_FCR7 */);
		saveiir=IOIN(&addr->iir) ;
		/* supports FIFO?  (i.e., is NS16550, not NS16540) */
 		if (saveiir & (IIR_FIFO1 | IIR_FIFO2)) {
 			++asysoftFIFO[UNIT(ctlr,port)];	
		}
		else
			asysoftFIFO[UNIT(ctlr,port)] = 0;
				
		asysoftCAR[iod->iod_unit] = iod->iod_flags; /* carrier detect */
		if (!isquad(addr))
			break;	       /* only one port per PC card */
	}
}

/*ARGSUSED*/
asyopen(dev, flag)
	dev_t dev;
{
	register struct tty *tp;
	register int unit = minor(dev);
	register int s, msrbits, error;
	register struct asydevice *asyaddr;
	register struct iocc_device *iod;
	int ctlr = CTLR(unit);

	DEBUGF(ttydebug & SHOW_OPEN, printf("asyopen%x: \n", unit));
	
	s = spl_asy();
	if (unit >=MAXUNIT || (iod=asydinfo[ctlr])==0 || iod->iod_alive==0) {
		(void) splx(s);
		return (ENXIO);
	}

	tp = &asy[unit];
	if (tp->t_state & TS_XCLUDE && u.u_uid != 0) {
		(void) splx(s);
		return (EBUSY);
	}

	asyaddr = (struct asydevice *)tp->t_addr;
	tp->t_state |= TS_WOPEN;

	if (tp->t_state & TS_CLOSE) {
		ttywait(tp);			/* wait til complete */
	}
	/* if this is first open, initialize tty state to defaults */
	if ((tp->t_state & TS_ISOPEN) == 0) {
		asytimerset[unit] = 0;
		ttychars(tp);
		tp->t_oproc = asystart;
		tp->t_ospeed = tp->t_ispeed = ISPEED;
		tp->t_flags = ODDP | EVENP | ECHO;
 
		asyparam(unit);

      	    	if (asysoftFIFO[unit]) {
			/* flush FIFO */
			IOOUT(&asyaddr->fcr, FCR_FCR1|FCR_FCR2);
 			/* enable 14 char FIFO mode */
 			IOOUT(&asyaddr->fcr, FCR_FCR0/*|FCR_FCR6/* |FCR_FCR7 */);
		}
		/* enable receive, line, modem and transmit interrupts */
		IOOUT(&asyaddr->ier, IER_DR | IER_LSR | IER_MSR | IER_THRE);
		/* turn DTR RTS on */
     		if (isquad(asyaddr))
			IOOUT(&asyaddr->mcr, MCR_DTR | MCR_RTS);
		else
			IOOUT(&asyaddr->mcr, MCR_IEN | MCR_DTR | MCR_RTS);
		(void) splx(s);
	} 
	s = spl_asy();
	/* check if carrier is or up modem is on */
	msrbits = IOIN(&asyaddr->msr);
	if ((msrbits & MSR_DCD) || 
 	     ( asysoftCAR[ctlr] & PORTMASK(PORT(unit)) ) ) 
 		tp->t_state |= TS_CARR_ON;
	/* wait for carrier to come up */
	while ( (tp->t_state & TS_CARR_ON) == 0 ) {
		tp->t_state |= TS_WOPEN;
		sleep((caddr_t) &tp->t_rawq, TTIPRI);
	}
	(void) splx(s);

	DEBUGF(ttydebug & SHOW_OPEN, printf("asyopen%d: ier=%x, mcr=%x", 
		unit, IOIN(&asyaddr->ier), IOIN(&asyaddr->mcr) ));
	if ( error = (*linesw[tp->t_line].l_open)(dev, tp) ) 
		asyclose(dev);
	DEBUGF(ttydebug & SHOW_OPEN, printf(" ldisc=%x, flags=%x, state=%x\n",
		tp->t_line, tp->t_flags, tp->t_state ));
	return ( error );
}


/*ARGSUSED*/
asyclose(dev)
	dev_t dev;
{
	register int unit = minor(dev);
	register struct tty *tp = &asy[unit];
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	register int s = spl_asy();
	int asycls(), asyminttimer();

	DEBUGF(ttydebug & SHOW_OPEN, printf("In asyclose ..."));

	tp->t_state |= TS_CLOSE;		/* close in progress */

	timeout(asycls, tp, asyouttime(tp));	/* set timeout for close */

	(*linesw[tp->t_line].l_close)(tp);
	IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) & ~LCR_SETB);  /* clr break */
	if ((tp->t_state&(TS_WOPEN|TS_HUPCLS))||(tp->t_state&TS_ISOPEN)==0) {
		IOOUT(&asyaddr->ier, ~(IER_DR | IER_LSR | IER_MSR) );
     		if (isquad(asyaddr))
			IOOUT(&asyaddr->mcr, 0);
		else
			IOOUT(&asyaddr->mcr, MCR_IEN);
 		IOOUT(&asyaddr->fcr, ~(FCR_FCR0));	/* flush */
		DEBUGF(ttydebug & SHOW_OPEN, 
			printf("turning off DTR, RTS...disabling ints..."));
	}
close1:
	if (tp->t_state & TS_CLOSE) {		/* close in progress */
		untimeout(asycls, tp);		/* cancel the timeout */
		untimeout(asyminttimer, tp);
	}
	ttyclose(tp);
	DEBUGF(ttydebug & SHOW_OPEN, printf("asyclose end\n"));
	(void) splx(s);
}

/*
 * return an overestimate of the number of clock ticks it will take
 * to output the remaining output after close has started
 * the multiplcation by 3 and division by 2 give a 50% overestimate 
 * plus hz gives an additional second just in case.
 */

asyouttime(tp)
register struct tty *tp;
{
	return (hz + 3 * hz * tp->t_outq.c_cc / (2 * asyoutputrate[tp->t_ospeed]));

}

/*
 * routine called when close takes longer than it should to flush output
 * and get things going again
 */
asycls(tp)
register struct tty *tp;
{
	register int s = spl_asy();

	DEBUGF(ttydebug & SHOW_OPEN, printf("asycls called\n"));
	if (tp->t_state & TS_CLOSE) {		/* if close in progress */
		ttyflush(tp, FREAD|FWRITE);
		tp->t_state = 0;
	}
	(void) splx(s);
}


/*ARGSUSED*/
asyread(dev, uio)
	register dev_t dev;
	register struct uio *uio;
{
	register struct tty *tp = &asy[minor(dev)];
	DEBUGF(ttydebug & SHOW_RDWR, {
	    register struct asydevice *asyaddr=(struct asydevice *)tp->t_addr;
	    printf("In asyread: asyaddr=(%x) lcr=(%x) ier=(%x)\n", 
		    asyaddr, IOIN(&asyaddr->lcr), IOIN(&asyaddr->ier) ); 
	} );
	return ((*linesw[tp->t_line].l_read)(tp, uio));
}


/*ARGSUSED*/
asywrite(dev, uio)
	dev_t dev;
	struct uio *uio;
{
	register struct tty *tp = &asy[minor(dev)];

	DEBUGF(ttydebug & SHOW_RDWR, printf("In asywrite\n"));
	return ((*linesw[tp->t_line].l_write)(tp, uio));
}



/*ARGSUSED*/
/* modeled after dh-11 */
asyioctl(dev, cmd, addr, flag)
	dev_t dev;
	caddr_t addr;
{
	register int unit = minor(dev);
	register struct tty *tp = &asy[unit];
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	register int error, s;
 	int trigger_level;
 	char trigger_bits;

	DEBUGF(ttydebug, printf("asyioctl%d: cmd=%x, flag=%x\n",unit,cmd,flag));
	error = (*linesw[tp->t_line].l_ioctl)(tp, cmd, addr, flag);
#if NAP > 0
	if ( cmd == TIOCSETD )
		if ( *(int *)addr == APLDISC )
			tp->t_oproc = asyoutc;
		else 
			tp->t_oproc = asystart;
#endif NAP
	if (error >= 0)
		return (error);
	error = ttioctl(tp, cmd, addr, flag);
	if (error >= 0) {
		if (cmd == TIOCSETP || cmd == TIOCSETN || cmd == TIOCLBIS ||
		    cmd == TIOCLBIC || cmd == TIOCLSET ) {
			asyparam(unit);
		}
		return (error);
	}
	s = spl_asy();
	switch (cmd) {
	case TIOCSBRK:		       /* Set break */
		IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) | LCR_SETB);
		break;
	case TIOCCBRK:		       /* Clear break */
		IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) & ~LCR_SETB);
		break;
	case TIOCSDTR:		       /* Set DTR and RTS */
     		if (isquad(asyaddr))
			IOOUT(&asyaddr->mcr, MCR_DTR | MCR_RTS);
		else
			IOOUT(&asyaddr->mcr, MCR_IEN | MCR_DTR | MCR_RTS);
		break;
	case TIOCCDTR:		       /* Clear DTR and RTS */
     		if (isquad(asyaddr))
			IOOUT(&asyaddr->mcr, 0);
		else
			IOOUT(&asyaddr->mcr, MCR_IEN);
		break;
 	case TIOCSETT:		       /* Set trigger level */
 		trigger_level = *(int *)addr;
 		if (trigger_level < 4)  
  			trigger_bits = 0;
 		else
 			if (trigger_level < 8)
 				trigger_bits = FCR_FCR6;
 			else
 	       		 	if (trigger_level < 14)
 					trigger_bits = FCR_FCR7;
 				else 
  					trigger_bits = (FCR_FCR7 | FCR_FCR6);
 		IOOUT(&asyaddr->fcr, (FCR_FCR0 | trigger_bits));
 		break;	
	default:
		(void) splx(s);
		return (ENOTTY);
	}
	(void) splx(s);
	return (0);
}

asyparam(unit)
	register int unit;
{
	register struct tty *tp = &asy[unit];
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	register char bits;
	register int s;

	DEBUGF(ttydebug & SHOW_IO, 
 	    printf("asyparam%d: tp->t_flags=(%x)", unit, tp->t_flags));

	s = spl_asy();
	if (tp->t_ispeed == B0) {
		tp->t_state |= TS_HUPCLS;
		IOOUT(&asyaddr->mcr, MCR_IEN); /* hang up line (DTR,RTS =0) */
		(void) splx(s);
		return;
	}

	/* Set the baud rate and initial asy settings */
	ASY_SETBAUD(asyaddr, tp->t_ispeed);
	if (tp->t_flags & (RAW | LITOUT | PASS8))
		bits = LCR_8BIT;
	else
		bits = (LCR_7BIT | LCR_PEN);
	if (tp->t_flags & EVENP)
		bits |= LCR_EPS;
	if (tp->t_ispeed == B110)
		bits |= LCR_STB;
	IOOUT(&asyaddr->lcr, bits);

	DEBUGF(ttydebug & SHOW_REGS, printf("lcr=(%x)\n", IOIN(&asyaddr->lcr)));
	DEBUGF(ttydebug & SHOW_IO, printf(" asyparam end\n"));
	(void) splx(s);
}


/*
 * unit indicates which port on a 4 line ctlr caused the interrupt
 */
asyint(ctlr)
	register int ctlr;
{
	register int unit = UNIT(ctlr,0);
	register struct asydevice *asyaddr = ASY_ADDR(asydinfo[ctlr]->iod_addr);
	register struct tty *tp;
	register unsigned char saveiir;
	register unsigned char port = 0;

#ifdef ATR
	/*
	 * Since we can share interrupts, we can be called during
	 * startup when probing ports that share the same IRQ level.
	 * Return with an error in this case.
	 */
	if (cold)
		return(-1);
#endif ATR
	DEBUGF(ttydebug & SHOW_INTR,printf("asyint%d: addr=%x ",unit,asyaddr));
#ifdef IBMRTPC
     	if (isquad(asyaddr)) {
    		port = IOIN(&asyaddr->ppir);
    		port &= 0x0F;
		DEBUGF(ttydebug & SHOW_INTR, printf("port=%x ",port));
		if (0 == port) {
			saveiir = IOIN(&asyaddr->iir);
			if ((0xC0 & saveiir)||(0x01 == saveiir))
				;
			else {
				log(LOG_WARNING,
			     "asyint: no ppir, saveiir = %x\n",
					saveiir);
			}
			return(0);
		}
portselect:
		if (port & PORT_A) {
	    		unit = UNIT(ctlr,0);
			port &= ~PORT_A;
		}
		else if (port & PORT_B) {
	    		unit = UNIT(ctlr,1);
			port &= ~PORT_B;
		}
		else if (port & PORT_C) {
	    		unit = UNIT(ctlr,2);
			port &= ~PORT_C;
		}
		else if (port & PORT_D) {
	    		unit = UNIT(ctlr,3);
			port &= ~PORT_D;
		}
		else {
	    		unit = UNIT(ctlr,0);
			printf("asyint: Bogus port = %x\n", port);
		}
	}
#endif IBMRTPC
	tp = &asy[unit];
	asyaddr = (struct asydevice *)tp->t_addr;
	saveiir = IOIN(&asyaddr->iir);
	if (IIR_PEND & saveiir) { 
		printf("asyint: phantom interrupt\n");
		return 0;
	}
	do {
		char buf[16];
		register int i, j;

		switch (saveiir & IIR_MASK) {
		   case IIR_RXB:
			for (i = 0; i < 16 && (IOIN(&asyaddr->lsr) & LSR_DR); )
				buf[i++] = IOIN(&asyaddr->rxb);
			asyinbufcount[i]++;
			IOOUT(&asyaddr->mcr, MCR_DTR);	/* clear RTS */
			for (j = 0; j < i; j++)
				(*linesw[tp->t_line].l_rint)(buf[j],tp);
			IOOUT(&asyaddr->mcr, MCR_DTR | MCR_RTS);	/* set RTS */
			/* disable RTS */
     			break;
     		   case IIR_CTI:
     		   case IIR_LSR:
     			asyrint(unit, tp, asyaddr);
     			break;
     		   case IIR_TXB:
     			asyxint(unit, tp, asyaddr);
     			break;
     		   case IIR_MSR:
     			asymint(unit, tp, asyaddr);
     			break;
		   default:
			printf("asy%d:iir=%x\n",unit,saveiir);
			break;
		}
	} while (((saveiir=IOIN(&asyaddr->iir))&IIR_PEND)==0);
#ifdef IBMRTPC
	if ((port) && isquad(asyaddr))
		goto portselect; /*more than one port pending*/
#endif
	return(0);
}

/*ARGSUSED*/
int
asyrint(unit, tp, asyaddr)
	register int unit;
	register struct tty *tp;
	register struct asydevice *asyaddr;
{
	register int c;
	register char savelsr;
	register int txwanted = 0;
	register int charcount = 0;

	DEBUGF(ttydebug & SHOW_INTR, printf("asyrint%d: \n", unit));
	savelsr = IOIN(&asyaddr->lsr);

	do {
		/* read available data */
		if (savelsr & LSR_DR)
			c = IOIN(&asyaddr->rxb);
		/* check error conditions */
		if ((savelsr & LSR_PE) && 
		    ((tp->t_flags & (EVENP|ODDP)) != (EVENP|ODDP)) &&
		    ((tp->t_flags & (EVENP|ODDP)) != 0) ) {
			DEBUGF(ttydebug,
				printf("asy%d: parity error\n",unit));
	    		continue;
		}
		/*
		 * A framing error (break) generates
		 * a null (in raw mode, for getty), or
		 * an interrupt (in cooked/cbreak modes).
		 */
		if (savelsr & (LSR_FE | LSR_BI))
			if (tp->t_flags & RAW)
				c = 0;
			else
				c = tp->t_intrc;

		if (savelsr & LSR_OR)
			log(LOG_WARNING, "asy%d: input overrun\n", unit);
#if NAP > 0
		if (tp->t_line == APLDISC) {
			if (savelsr & LSR_BI)
				c = APBREAK;
			else if (savelsr & LSR_FE)
				c = APERROR;
			DEBUGF(ttydebug & SHOW_CHARS, 
				printf("AP GOT -> (%x)\n", (char)c));
		}
#endif NAP

		/* check i/o conditions */
		if (savelsr & (LSR_THRE | LSR_TSRE))
			txwanted++;
		if (savelsr & LSR_DR) {
			(*linesw[tp->t_line].l_rint)(c, tp);
			charcount++;
			DEBUGF(ttydebug & SHOW_CHARS, 
				printf("GOT -> (%c) (%x)\n", c, c));
		} else
			break;
		if (charcount > 32) {
			log(LOG_WARNING, "asy%d: lsr loop > 32\n", unit);
			break;
		}
	} while ((savelsr = IOIN(&asyaddr->lsr)) & LSR_DR);
	DEBUGF(ttydebug & SHOW_INTR, 
		printf("asy%d: charcount=%d\n",unit,charcount));
	asyrintchars += charcount;
	if (txwanted)
		asystart(tp);
	return(charcount);
}

/*ARGSUSED*/
asyxint(unit, tp, asyaddr)
	register int unit;
	register struct tty *tp;
	register struct asydevice *asyaddr;
{
	DEBUGF(ttydebug & SHOW_INTR, printf("asyxint%d: ", unit));
#if NAP > 0
	if (tp->t_line == APLDISC) {
		DEBUGF(ttydebug & SHOW_INTR, printf("calling AP xint \n"));
		(*linesw[tp->t_line].l_start)(tp);
	} else 
#endif NAP
	{
		tp->t_state &= ~TS_BUSY;
		intr_flag[unit] = 0;	

		if (tp->t_line)
			(*linesw[tp->t_line].l_start)(tp);
		else
			asystart(tp);
	}
	DEBUGF(ttydebug & SHOW_INTR, printf("asyxint end\n"));
}

asystart(tp)
	register struct tty *tp;
{
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
 	register int i, s;
 	register int c = 0, count = 0, loopcount = 0;

	DEBUGF(ttydebug & SHOW_IO, printf("asystart addr=%x\n", asyaddr));
	/*
	 * Must hold interrupts to prevent state of the tp
	 * from changing
	 */
	s = spl_asy();
	/* are we Clear To Send? */
	if (!asycheckmsr(tp, asyaddr)) { /* this will set */
		goto out2;		 /*tp->t_state appropriately */
	}		

	/*
	 * if it's currently active, or delaying, no need to do anything.
	 */

	if (tp->t_state & (TS_TIMEOUT | TS_BUSY | TS_TTSTOP)) {
		goto out2;
	}

 	if (IOIN(&asyaddr->lsr) & LSR_THRE) {
	    /* silo is empty ... fill 'er up */
      	    /* unit = tp - asy */
      	    if ((asysoftFIFO[tp - asy]) &&
       		(tp->t_flags & (RAW | LITOUT))) {
      		for (i = 0; i < 9; i++) {
       			if (tp->t_outq.c_cc <= 0 || (c = getc(&tp->t_outq)) == -1)
       				goto out1;
			IOOUT(&asyaddr->txb, c);	/* away she goes ... */
			count++;
      	    	}
	    }

	    /* room for one more */
 	    do {
		if ((tp->t_outq.c_cc <= 0) || (c = getc(&tp->t_outq)) == -1)
                 	goto out1;
                 DEBUGF(ttydebug & SHOW_CHARS,
                 	printf("put (%c) (%x)\n", (char)(c), (char)(c) ));
                 if ( tp->t_flags & (RAW | LITOUT) || (c <= 0177) ) {
                     IOOUT(&asyaddr->txb, c);
		     loopcount++;
                 } else {
                     timeout(ttrstrt, (caddr_t)tp, (c & 0177));
                     tp->t_state |= TS_TIMEOUT;
                     DEBUGF(ttydebug & SHOW_CHARS,
				printf("asystart timeout\n"));
                     goto out1;
	        }
	    } while ((IOIN(&asyaddr->msr) & MSR_CTS) && \
			(IOIN(&asyaddr->lsr) & LSR_THRE));
	}
	tp->t_state |= TS_BUSY;
	DEBUGF(ttydebug & SHOW_REGS, printf("asystart: enable TX int\n"));
	/* we did all we could; now wait for xmit interrupt */
	if (count) {
		IOOUT(&asyaddr->ier, IOIN(&asyaddr->ier) | (IER_THRE));
		if(!(to_is_running))
			init_timeout_check();
		intr_flag[find_unit(tp)] |= ASY_XPEND;
	}
	goto out2;

out1:
	tp->t_state &= ~TS_BUSY;

	/*
	 * if there are sleepers, and output has drained below low
	 * water mark, wake up sleepers.
	 */

	if (tp->t_outq.c_cc <= TTLOWAT(tp)) { 
		if (tp->t_state & TS_ASLEEP) {
			tp->t_state &= ~TS_ASLEEP;
			wakeup((caddr_t) & tp->t_outq);
		}
		if (tp->t_wsel) {
			selwakeup(tp->t_wsel, tp->t_state & TS_WCOLL);
			tp->t_wsel = 0;
			tp->t_state &= ~TS_WCOLL;
		}
	}  
out2:
	(void) splx(s);

	if (count > 16)
		count = 16;
	asyoutbufcount[count]++;
	if (loopcount > 16)
		loopcount = 16;
	asystartloopcount[loopcount]++;

	DEBUGF(ttydebug & SHOW_IO, printf(" asystart: done\n" ));
}


asymint(unit, tp, asyaddr)
	register int unit;
	register struct tty *tp;
	register struct asydevice *asyaddr;
{
/*
	register int s;
*/

	DEBUGF(ttydebug & SHOW_INTR, 
		printf("asymint%d\n", unit) );
#if NAP > 0
	if (tp->t_line == APLDISC)
		return (0);
#endif

/*
	s = spl_asy();
	if (asycheckmsr(tp, asyaddr))
*/
		asystart(tp);
/*
	DEBUGF(ttydebug & SHOW_INTR, printf("asymint end\n"));
	splx(s);
*/
}

/*
**	This routine is called if CTS has been off for five seconds.
**	Double check CTS by calling asycheckmsr().  If CTS is set, we
**	probably just lost an interrupt.  Otherwise, send the modem
**	a break.
*/

asyminttimer(tp)
register struct tty *tp;
{
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	int unit = find_unit(tp);
	int s;
	int asyminttimer2();

	printf("asy%d: CTS timeout check...",unit);

	s = spl_asy();


	if (asycheckmsr(tp, asyaddr)) {
		asytimerset[unit] = 0;
		printf("missed CTS going high\n");
		asystart(tp);
	}
	else {
		printf("modem not responding\n");
		IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) ^ LCR_SETB);
     		if (isquad(asyaddr)) {
			IOOUT(&asyaddr->mcr, MCR_DTR | MCR_RTS);
		}
		else {
			IOOUT(&asyaddr->mcr, MCR_IEN | MCR_DTR | MCR_RTS);
		}
		timeout(asyminttimer2, tp, hz);
		timeout(asyminttimer, tp, 5 * hz);
	}
	splx(s);
}

/* Remove the break signal; bring the modem back on-line */
asyminttimer2(tp)
register struct tty *tp;
{
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	int s;

	s = spl_asy();
	IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) & ~LCR_SETB);
	splx(s);
}

/*
 * this mucks with tp state, so it must be called at spl_asy().
 * it returns 1 if output is appropriate at this time, 0 o.w.
 */

asycheckmsr(tp, asyaddr)
	register struct tty *tp;
	register struct asydevice *asyaddr;
{
	register int rval;
	register char savemsr;
	int unit = find_unit(tp);


	savemsr = IOIN(&asyaddr->msr);

	DEBUGF(ttydebug & SHOW_INTR, 
		printf("asycheckmsr: savemsr=%x\n", savemsr ) );
	if (rval = (savemsr & MSR_CTS)) {
/*
**	CTS is set.  If we had a timer set, it's no longer needed.
*/
		if (asytimerset[unit]) {
			untimeout(asyminttimer,tp);
			asytimerset[unit] = 0;
		}
		tp->t_state &= ~TS_TTSTOP;

		asyhicts++;
	} else {
/*
**	Make sure we don't lose the interrupt for CTS coming back on
*/
		if (!asytimerset[unit]) {
			asytimerset[unit]++;
			timeout(asyminttimer, tp, 5 * hz);
		}
		tp->t_state |= TS_TTSTOP;
		asylocts++;
	}

	if (savemsr & MSR_DDCD) {     /* if carrier transition */
		if (savemsr & MSR_DCD) { /* carrier on */
			DEBUGF( ttydebug & SHOW_INTR,printf("Carrier detect "));
			if ((tp->t_state & TS_CARR_ON) == 0) {
				wakeup((caddr_t) &tp->t_rawq);
			        (*linesw[tp->t_line].l_modem)(tp, 1);
				tp->t_state |= TS_CARR_ON;
			}
		} else {  		  /* carrier dropped */
			DEBUGF( ttydebug & SHOW_INTR,printf("Carrier lost "));	
			if (tp->t_state & TS_CARR_ON) {
				gsignal(tp->t_pgrp, SIGHUP);
				gsignal(tp->t_pgrp, SIGCONT);
				ttyflush(tp, FREAD | FWRITE);
			}
			(*linesw[tp->t_line].l_modem)(tp, 0);
			tp->t_state &= ~TS_CARR_ON;
		}
	}
	return rval;
}

asyselect(dev, rw)
	dev_t dev;
	int rw;
{
	register struct tty *tp = &asy[minor(dev)];

	return ((*linesw[tp->t_line].l_select)(dev, rw));
}


/* 
 * This routine is for the support of the 3812 printer. It will perform one
 * of three functions:
 *	    1) set the break bit 
 *	    2) clear the break bit  
 *	or  3) output one character.
 */
#if NAP > 0
asyoutc(tp, c)
	register struct tty *tp;
	register int c;
{
	register struct asydevice *asyaddr = (struct asydevice *)tp->t_addr;
	register int s = spl_asy();

	DEBUGF(ttydebug & SHOW_CHARS, printf("asyoutc: PUT (%x)\n", (char) c));
	if (c >= 0)
		IOOUT(&asyaddr->txb, c);
	else {
		switch (c) {
		case APBREAKON:
			IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) | LCR_SETB);
			break;
		case APBREAKOFF:
			IOOUT(&asyaddr->lcr, IOIN(&asyaddr->lcr) & ~LCR_SETB);
			break;
		case APINTMASK:
			IOOUT(&asyaddr->ier, (IER_LSR | IER_THRE | IER_DR));
			break;
		}
	}
	(void) splx(s);
}
#endif

int	find_unit(tp)
	register struct tty *tp;
{
	int i;

	for (i = 0; i < MAXUNIT; i++)
		if(tp->t_cbufp == &asycbuf[i])
			return i;
	return -1;
}



init_timeout_check()
{
	int	i;

	if(!to_is_running) { 
		for (i = 0; i < MAXUNIT; i++)
			intr_flag[i] = 0;
		timeout(check_intr, (caddr_t) 0, hz);
		to_is_running = 1;
	}
}

/*
 * at high speed (19.2 and above) it seems that xmit done interrupts
 * are sometimes waylaid.  this addresses the symptom.
 */
check_intr(addr)
	register	caddr_t	addr;
{
	register int i, s;
	register struct	tty *tp;

	s = spl_asy();
	to_is_running = 0;
	for (i = 0; i < MAXUNIT; i++) {
		/* an x interrupt was tardy.  did it arrive? */
		if (intr_flag[i] & ASY_XTARDY) {
			lost_intrs++;			/* musta got lost */
			tp = &asy[i];
     			asyxint(i, tp, (struct asydevice *) tp->t_addr);
		}
		/* an x interrupt was pending.  did it arrive? */
		if (intr_flag[i] & ASY_XPEND) {
			intr_flag[i] |= ASY_XTARDY;	/* it's tardy */
			if (to_is_running++ == 0)
				timeout(check_intr, (caddr_t) 0, hz);
		}
	}
	splx(s);
}

#endif NASY
