#include <sys/types.h>           /* for caddr_t */

#define PAGESIZE      4096	 /* same value as returned by getpagesize() */
#define SHLIB_MAGIC   0x6772944a /* magic number of sharable library        */

union _ShareLibHeader {
	struct {
	    unsigned long magic;	/* must be SHLIB_MAGIC   */
	    unsigned long version;	/* current version       */
	    unsigned long text_size;    /* multiple of PAGESIZE  */
	    unsigned long data_size;    /* multiple of PAGESIZE  */
	    caddr_t       text_addr;    /* PAGESIZE aligned      */
	    caddr_t       data_addr;    /* PAGESIZE aligned      */
	} header;
	unsigned char array[PAGESIZE];
};

typedef union _ShareLibHeader ShareLibHeader;

struct SharedLibraryTable {
				const char *name;
				int version;
};
