/*
 * 5799-WZQ (C) COPYRIGHT IBM CORPORATION  1986,1987,1988
 * LICENSED MATERIALS - PROPERTY OF IBM
 * REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083
 */
/* $Header: /usr/src/sys/rt/RCS/autoconf.c,v 1.6 91/02/06 12:25:41 rayan Exp $ */
/* $ACIS:autoconf.c 12.1$ */
/* $Source: /usr/src/sys/rt/RCS/autoconf.c,v $ */

#if !defined(lint) && !defined(NO_RCS_HDRS)
static char *rcsid = "$Header: /usr/src/sys/rt/RCS/autoconf.c,v 1.6 91/02/06 12:25:41 rayan Exp $";
#endif

#include <syslog.h>
#include "reg.h"
#include "pte.h"
#include "mmu.h"
#include "scr.h"

#include "param.h"
#include "systm.h"
#include "user.h"
#include "kernel.h"
#include "map.h"
#include "vm.h"
#include "proc.h"
#include "buf.h"
#include "reboot.h"
#include "conf.h"
#include "file.h"
#include "text.h"
#include "clist.h"
#include "callout.h"
#include "cmap.h"
#include "mbuf.h"
#include "io.h"
#include "../rtio/ioccvar.h"
#include "aha.h"
#ifdef IHA
#include "iha.h"
#endif IHA
#if (NIHA + NAHA) > 0
#include "../machineio/scsi.h"
#include "../machineio/xhavar.h"
#endif
#if NIHA > 0
#include "../machineio/ihareg.h"
extern struct iocc_driver ihadriver;
extern int numiha;
#endif
#if NAHA > 0
#define	DEBUGF(A, B)
#include "../machineio/ahareg.h"
extern struct iocc_driver ahadriver;
extern int numaha;
#endif
 /* #include "dmap.h"		/* already included in user.h */
#include "cpu.h"
#include "dkstat.h"
#ifdef ROMPC
#include "ioim.h"
#endif ROMPC

#ifdef ATR
#include "../ca_atr/pcif.h"
#include "vga.h"
#include "ibmvbarmmmdxiv.h"
#include "ms.h"
#if	NVGA > 0
#include "../machinecons/vgaio.h"
#endif
int sv_pc_cb;				/* PS/2 address */
/*
 * MMU lock bits to control access to io space in the 64k windows
 */
struct io_locks {
	char	write_bit;
	unsigned short lock_bits;
} io_locks[] = {
	/*  Read/Write access to 0x03b0-0x03df */
#if NVGA > 0
	{1,0x0500},		/* page 0  0x0000-0x07ff */
#else !VGA
#ifdef NIBMVBARMMMDXIV > 0
	{1,0x0400},		/* page 0  0x0000-0x07ff */
#else !IBM8514
	{0,0x0000},		/* page 0  0x0000-0x07ff */
#endif !IBM8514
#endif !VGA
#ifdef NIBMVBARMMMDXIV > 0
	{0,0x0404},		/* page 1  0x0800-0x0fff */
	{0,0x0404},		/* page 2  0x1000-0x17ff */
	{0,0x0404},		/* page 3  0x1800-0x1fff */
	{1,0x0400},		/* page 4  0x2000-0x27ff */
#else
	{0,0x0000},		/* page 1  0x0800-0x0fff */
	{0,0x0000},		/* page 2  0x1000-0x17ff */
	{0,0x0000},		/* page 3  0x1800-0x1fff */
	{0,0x0000},		/* page 4  0x2000-0x27ff */
#endif
	{0,0x0000},		/* page 5  0x2800-0x2fff */
	{0,0x0000},		/* page 6  0x3000-0x37ff */
	{0,0x0000},		/* page 7  0x3800-0x3fff */
#ifdef NIBMVBARMMMDXIV > 0
	{1,0x0404},		/* page 8  0x4000-0x47ff */
	{1,0x0404},		/* page 9  0x4800-0x4fff */
#else
	{0,0x0000},		/* page 8  0x4000-0x47ff */
	{0,0x0000},		/* page 9  0x4800-0x4fff */
#endif
	{0,0x0000},		/* page a  0x5000-0x57ff */
	{0,0x0000},		/* page b  0x5800-0x5fff */
	{0,0x0000},		/* page c  0x6000-0x67ff */
	{0,0x0000},		/* page d  0x6800-0x6fff */
	{0,0x0000},		/* page e  0x7000-0x77ff */
	{0,0x0000},		/* page f  0x7800-0x7fff */
#ifdef NIBMVBARMMMDXIV > 0
	{1,0x0404},		/* page 10 0x8000-0x87ff */
	{1,0x0404},		/* page 11 0x8800-0x8fff */
	{1,0x0404},		/* page 12 0x9000-0x97ff */
	{1,0x0404},		/* page 13 0x9800-0x9fff */
	{1,0x0404},		/* page 14 0xa000-0xa7ff */
	{1,0x0404},		/* page 15 0xa800-0xafff */
	{1,0x0404},		/* page 16 0xb000-0xb7ff */
	{1,0x0404},		/* page 17 0xb800-0xbfff */
	{1,0x0404},		/* page 18 0xc000-0xc7ff */
	{1,0x0404},		/* page 19 0xc800-0xcfff */
	{1,0x0404},		/* page 1a 0xd000-0xd7ff */
	{1,0x0404},		/* page 1b 0xd800-0xdfff */
	{1,0x0404},		/* page 1c 0xe000-0xe7ff */
	{1,0x0404},		/* page 1d 0xe800-0xefff */
	{1,0x0404},		/* page 1e 0xf000-0xf7ff */
	{1,0x0404}		/* page 1f 0xf800-0xffff */
#else
	{0,0x0000},		/* page 10 0x8000-0x87ff */
	{0,0x0000},		/* page 11 0x8800-0x8fff */
	{0,0x0000},		/* page 12 0x9000-0x97ff */
	{0,0x0000},		/* page 13 0x9800-0x9fff */
	{0,0x0000},		/* page 14 0xa000-0xa7ff */
	{0,0x0000},		/* page 15 0xa800-0xafff */
	{0,0x0000},		/* page 16 0xb000-0xb7ff */
	{0,0x0000},		/* page 17 0xb800-0xbfff */
	{0,0x0000},		/* page 18 0xc000-0xc7ff */
	{0,0x0000},		/* page 19 0xc800-0xcfff */
	{0,0x0000},		/* page 1a 0xd000-0xd7ff */
	{0,0x0000},		/* page 1b 0xd800-0xdfff */
	{0,0x0000},		/* page 1c 0xe000-0xe7ff */
	{0,0x0000},		/* page 1d 0xe800-0xefff */
	{0,0x0000},		/* page 1e 0xf000-0xf7ff */
	{0,0x0000}		/* page 1f 0xf800-0xffff */
#endif
};
extern int current_512_w; 		/* The active windows */
extern int current_128_w;
extern int pcif_io_b;

int cbcb_wait = 50000;
struct cbcb *cbcb;			/* Pointer to cbcb in PC memory */
char *pcvec_map;
struct pcif_reg *pcif_reg;		/* Pointer to pcif register set  */

ushort *pcdebugptr = (ushort *)0;
#endif /* ATR */

/*
 * Setup the system to run on the current machine.
 *
 * Configure() is called at boot time and initializes the
 * device tables and the memory controller monitoring.  Available
 * devices are determined (from possibilities mentioned in ioconf.c),
 * and the drivers are initialized.
 *
 */

int cold = 1;				  /* if 1, still working on cold-start */
int dkn;				  /* number of iostat dk numbers assigned so far 
					  */
int nulldev();				  /* a null routine */
int int_irq;				  /* the irq level of an interrupt (autoconf) */
int int_level;				  /* the CPU level of an interrupt (autoconf) */
int (*int_rtn)() = nulldev;		/* int rtn for EARLY_INT driver being probed */
int int_ctlr;

extern int iodebug;

configure()
{
	cold = 1;			  /* doing startup */

	float_init();		/* init FPA if present */
#ifdef IBMRTPC
	dma_init();		/* init dma now, so it doesn't mess up lan */
#endif

	iow(MMUBASE + MMU_SER, 0);	  /* clear the SER! */

	autoconf();
	if ((boothowto & RB_ASKNAME) == 0)
		setroot();
#if GENERIC
	setconf();
#endif
	swapconf();
	cold = 0;
	printf("configure end\n");
}


/*
 * print out warning for stray interrupts.
 */

devunk(info, icscs, iar)
	register int info, icscs, iar;
{
	register int s = spl7();	  /* inhibit interrupts */

	if (cold) {
		int_level = s & 0x07;
	} else {
		log(LOG_WARNING, "Stray Interrupt! level=%d info=%x", s & 07, info);
	}
	splx(s);			  /* return to previous interrupt level */
	return (0);			  /* last entry in list - must terminate search 
					  */
}


#define MAX_8259_LEVELS 8		  /* max number of levels on a 8259 */
#define MAX_SLIH	24		  /* max number of SLIHs */
#define MAX_8259	2		  /* max number of 8259s */

/*
 * following is for "vmstat" display in systat(1)
 */
#define OTHER_INTS	2		/* other ints (clock+soft) */
long intrcnt[MAX_SLIH+OTHER_INTS];	/* the I/O counts (+OTHER) */
long eintrcnt;			/* the end of the counts */
#ifdef IBMRTPC
char intrnames[MAX_SLIH*6] =
"clock\0soft\0DMA\0IRQ10\0IRQ9 \0IRQ3 \0IRQ4 \0KLS\0IRQ2 \0IRQ7 \0IRQ8 \0IRQ11\0IRQ14\0IRQ12\0IRQ6 \0IRQ5 \0IRQ15\0IRQ13\0     \0     \0     \0     \0     \0     \0";
#endif IBMRTPC
#ifdef ATR
char intrnames[MAX_SLIH*6] = 
"clock\0soft\0IRQ0 \0IRQ1 \0IRQ2 \0IRQ3 \0IRQ4 \0IRQ5 \0IRQ6 \0IRQ7 \0IRQ8 \0IRQ9 \0IRQ10\0IRQ11\0IRQ12\0IRQ13\0IRQ14\0IRQ15";
#endif ATR
char eintrnames[] = "";
/* end of additions for vmstat display of systat(1) */

int devunk();
#ifdef IBMRTPC
int dma_int();
#endif IBMRTPC
int klsint();

struct slihtab slih_table[MAX_SLIH] =
{
/* rtn info irq flags */
#ifdef ATR		
    0, 0, 0, 0, 0,		/* 0 IRQ 0   */
    klsint, 0, 0, 1, FIXED,	/* 1 IRQ 1   */
    0, 0, 0, 2, 0,		/* 2 IRQ 2   */
    0, 0, 0, 3, 0,		/* 3 IRQ 3   */
    0, 0, 0, 4, 0,		/* 4 IRQ 4   */
    0, 0, 0, 5, 0,		/* 5 IRQ 5   */
    0, 0, 0, 6, 0,		/* 6 IRQ 6   */
    0, 0, 0, 7, 0,		/* 7 IRQ 7   */

    0, 0, 0, 8, 0,		/* 8 IRQ 8   */
    0, 0, 0, 9, 0,		/* 9 IRQ 9   */
    0, 0, 0, 10, 0,		/* 10 IRQ 10 */
    0, 0, 0, 11, 0,		/* 11 IRQ 11 */
    0, 0, 0, 12, 0,		/* 12 IRQ 12 */
    0, 0, 0, 13, 0,		/* 13 IRQ 13 */
    0, 0, 0, 14, 0,		/* 14 IRQ 14 */
    0, 0, 0, 15, 0,		/* 15 IRQ 15 */
#endif ATR
#ifdef IBMRTPC
/*	rtn	info irq flags */
	dma_int, 0, 0, 0, FIXED,	  /* 0 (Planar) 8237 terminal count */
	0, 0, 0, 10, 0,			  /* 1 IRQ 10 */
	0, 0, 0, 9, 0,			  /* 2 IRQ 9 */
	0, 0, 0, 3, 0,			  /* 3 IRQ 3 */
	0, 0, 0, 4, 0,			  /* 4 IRQ 4 */
	klsint, 0, 0, 1, FIXED,		  /* 5 (planar) keyboard */
	0, 0, 0, 2, 0,			  /* 6 8530 serial port */
	0, 0, 0, 7, 0,			  /* 7 IO BUS IRQ 7 */

	0, 0, 0, 8, 0,			  /* 8 (planar) reserved */
	0, 0, 0, 11, 0,			  /* 9 IRQ 11 */
	0, 0, 0, 14, 0,			  /* 10 IRQ 14 */
	0, 0, 0, 12, 0,			  /* 11 IRQ 12 */
	0, 0, 0, 6, 0,			  /* 12 IRQ 6 */
	0, 0, 0, 5, 0,			  /* 13 IRQ 5 */
	0, 0, 0, 15, 0,			  /* 14 IRQ 15 */
	0, 0, 0, 13, 0,			  /* 15 (planar) serial port */
#endif IBMRTPC
};

/*
 * last_slih indicates where there is spare space for duplicate
 * (chain) entries.
 */
struct slihtab *last_slih = slih_table + (MAX_8259_LEVELS * MAX_8259);

/*
 * in "int_table" is passed to the 8259 interrupt controller service
 * routine for level 3 and level 4 interrupts.
 * it specifies the address of the 8259 and the SLIH table for the
 * 8 8259 levels. Each level is a linked list of driver interrupt service
 * routines that are called in turn. when one claims an interrupt the
 * list is terminated.
 * if none claim the interrupt then 'devunk' will be called.
 */


#define MAX_IRQ 16
char irq_map[MAX_IRQ];

char shr_dummy;
#ifdef IBMRTPC
char volatile * shr_int_reset[MAX_IRQ] = {
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	(char *)0xf00002f3,	(char *)0xf00002f4,	(char *)0xf00002f5,
	(char *)0xf00002f6,	(char *)0xf00002f7,	&shr_dummy,
	(char *)0xf00002f2,	(char *)0xf00006f2,	(char *)0xf00006f3,
	(char *)0xf00006f4,	&shr_dummy,		(char *)0xf00006f6,
	(char *)(char *)0xf00006f7
};
#endif IBMRTPC

#ifdef ATR
char volatile * shr_int_reset[MAX_IRQ] = {
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	&shr_dummy,		&shr_dummy,		&shr_dummy,
	&shr_dummy
};

#endif ATR


struct int_table int3table =
{
#ifdef IBMRTPC
	(char *)Adr_8259A,		  /* the first 8259A */
#endif IBMRTPC
#ifdef ATR
	(char *)0,
#endif ATR
	slih_table
};

struct int_table int4table = {
#ifdef IBMRTPC
	(char *)Adr_8259B,		  /* the second 8259A */
#endif IBMRTPC
#ifdef ATR
	(char *)0,
#endif ATR
	slih_table + MAX_8259_LEVELS
};

int ign_devunk = 0;		/* can be patched to ignore some devunks */

#ifdef ATR
#define INT8259RETURN(value,p,r) {int8259return(p,r,eoipending); return(value);}

/*
 * handle end of interrupt processing:
 * 1. send an EOI to the pc if it is expecting one
 * 2. clear shared memory location in cbcb that indicates we
 *	are busy processing an interrupt.
 * 3. clear the interrupt request bit in the pcif.
 */
int8259return(p,r,eoipending)
char *p;
int r;
int eoipending;
{
	set_512_window (cbcb_addr);	/* point to the cbcb */
	if (eoipending&QEOIPENDING)
		pc_req(r == R_INT3 ? CB_EOI3 : CB_EOI4, (char *) ((int) *p & 0x07), SVENT);
	*p = 0;				/* clear cbcb->rompint3 or rompint4 */
	RSETBIT(&pcif_reg->romp_intr,r);
}

#endif ATR

#ifdef IBMRTPC
#define INT8259RETURN(v,p,r) return(v)
#endif IBMRTPC
/*
 * int_8259 services an interrupt generated by an 8259A.
 * it determines which 8259 line caused the interrupt and then
 * calls the appropriate SLIH to service it.
 * if that SLIH does not claim the interrupt then the next SLIH
 * in the chain is called until either there are no more left or
 * one claims it.
 * the SLIH is called with the info field from the table which is
 * the controller number from autoconfig.
 */


int_8259(table, icscs, iar)
	register struct int_table *table;
	register int iar, icscs;
{
	register char volatile *adr_8259 = table->addr_8259;
	register struct slihtab *s;
	register int i;
	register int irq;

#ifdef ATR
	register int j;
	register int pcifreset;
	int eoipending;
/*
 * The SLIH for the ATR version of the system looks into the cbcb
 * to figure out what hardware interrupt occured. The PC code 
 * writes values into the cbcb in the same manner the 8259
 * chip would respond in poll mode .
 */

	set_512_window (cbcb_addr);	/* point to the cbcb */
#endif



	cnt.v_intr++;		/* count device interrupts */

#ifdef IBMRTPC
poll_loop:
	*adr_8259 = POLL_CMD;
/*	DELAY(1);			  /* just in case */
	i = *adr_8259;			  /* pick up the active device */
#endif

#ifdef ATR
/*
 * Interrupts on the first 8259 are passed to us via romp level 3, 
 * while interupts on the second 8259 come by way of romp level 4.
 * For either case we need to look at the cbcb to figure out what
 * IRQ level has occured. 
 */

	if ((table == &int3table)) {
	    adr_8259 = (char *)&cbcb->romp_int3;
	    pcifreset = R_INT3; 
	}
	else {
	    adr_8259 = (char *)&cbcb->romp_int4;
	    pcifreset = R_INT4; 
	}

	j = 0;
	while(((i = *adr_8259) == 0) && (j++ < 10)); 	/* XXXX GRL */
	/*
	 * Interrupts fowarded from the PS/2 can be from hardware
	 * (PS/2 needs to send an EOI, see rompint.c) or from software
	 * (PS/2 does not need to send an EOI).
	 *
	 * When devices are at the same IRQ level it is possible for
	 * one device to take anothers interrupt. Ordinarily this would
	 * be OK since the next interrupt would go the the next device.
	 * However when a driver that gets an interrupt directly from
	 * hardware take a interrupt from a software generated driver,
	 * (or the inverse) we have problems.
	 *
	 * To get around this the PS/2 code sets a bit (EOIPENDING) in
	 * the cbcb->rompint? field to tell us if this interrupt is
	 * software generated or hardware generated. We then set a flag
	 * that each driver looks at. If that driver expects only software
	 * interupts then he does not service the request if the flag is set.
	 *
	 */
	eoipending = i & (EOIPENDING | QEOIPENDING);
#endif ATR



	if ((i & 0x80) == 0) {
			if (ign_devunk) 
				INT8259RETURN(0,adr_8259,pcifreset);

		printf("8259 @ %x (%x): ", adr_8259, i);
			i = devunk((int)table, iar, icscs);
			INT8259RETURN(i,adr_8259,pcifreset); /* complain */
		}

#ifdef IBMRTPC
	*adr_8259 = SEOI_CMD + (i& 0x7);  /* specific EOI */
#endif IBMRTPC

	s = table->slihtab + (i & 0x7);	  /* get the appropriate slih table */
	irq = s->slih_irq;		  /* get its IRQ number */
	if (cold) {
		register int called_int_rtn = 0;

		for (;;) {
			if (s->slih_rtn == 0)
				break;
			if (s->slih_rtn == int_rtn)
				called_int_rtn = 1;
			if ((*s->slih_rtn)(s->slih_info, irq, i) == 0 ||
			    (s = s->slih_next) == 0)
				break;
		}
		if (s && s->slih_rtn) {	/* interrupt accepted by a driver? */
			INT8259RETURN(0,adr_8259,pcifreset);
		} else if (int_rtn != nulldev) {	/* EARLY_INT set? */
			if (!called_int_rtn)
				(void)(*int_rtn)(int_ctlr, irq, i); /* it'll clear int */
			*shr_int_reset[irq] = 0xff;
		} /* else driver's probe rtn clears int, & does share int
		   * reset too if it is needed */
		if (int_irq != -1 && int_irq != irq)
			printf("autoconf: help - interrupt at irq %d and irq %d!\n",
			    int_irq, irq);
		int_irq = irq;
	} else {	/* keep this path optimal! */
		for (;;) {
			if (s->slih_rtn == 0) {
				*shr_int_reset[irq] = 0xff;
				break;
			}
			if ((*s->slih_rtn)(s->slih_info, irq, i) == 0) {
				*shr_int_reset[irq] = 0xff;
				intrcnt[s-slih_table+OTHER_INTS]++;  /* count interrupts */
				INT8259RETURN(0,adr_8259,pcifreset);
			}
			if ((s = s->slih_next) == 0) {
				*shr_int_reset[irq] = 0xff;
				break;
			}
		}
		if((irq<9)||(irq>11)||(iodebug & 0x10))
			log(LOG_WARNING, "8259 (%x) IRQ %d: %s ", i, irq, s ? "no SLIH" : "unclaimed");
		else
			INT8259RETURN(i,adr_8259,pcifreset);
	}
	i = devunk((int)table, iar, icscs);
	INT8259RETURN(i,adr_8259,pcifreset);
}




/* following table is MAX_SLIH long on the assumption that if that limit
 * is reasonable for slih_table it is also reasonable for the number
 * of device addresses.
 */
caddr_t probe_addrs[MAX_SLIH];		  /* table to remember used device addresses */
int trap();



/* following table is MAX_SLIH long on the assumption that if that limit
 * is reasonable for slih_table it is also reasonable for the number
 * of device addresses.
 */
caddr_t probe_addrs[MAX_SLIH];		  /* table to remember used device addresses */
int trap();
int (*_trap)();
int autotrap();

autoconf()
{
/*
 * go thru the iocc_device structure and configure each existing device
 * into the system.
 */
	register struct iocc_ctlr *ic;
	register struct iocc_driver *id, *idr;
	register struct iocc_device *iod;
	register caddr_t * addrp;
	register caddr_t addr;		  /* address of adapter register */
	extern struct iocc_ctlr iocccinit[];
	extern struct iocc_device ioccdinit[];
	int s;

	_trap = autotrap;		  /* intercept traps due to autoconfig */
	printf("autoconf");
	s = spl1();			  /* allow interrupts (but keep as system ) */
	klswait();
	printf("\n");
	dkn = 0;
	init_slih();			  /* initialize slih_table */
/*
 * scan thru the data structures resetting values
 * in case this is a restart of the kernel while in
 * memory.
 */
	for (ic = iocccinit; id = ic->ic_driver; ++ic) {
		ic->ic_alive = 0;
	}
	for (iod = ioccdinit; id = iod->iod_driver; ++iod) {
		iod->iod_alive = 0;
		iod->iod_forw = 0;
		iod->iod_mi = 0;
	}
/*
 * loop thru the controller structures
 * for each on which is potentially present check to see if it is
 * realy there.
 * if no address is given then check the standard list given in
 * the driver.
 */
	for (ic = iocccinit; id = ic->ic_driver; ++ic) {
		if (id->idr_flags & EARLY_INT) {
			int_rtn = id->idr_intr;	/* enable early interrupt(s) */
			int_ctlr = ic->ic_ctlr;
		} else
			int_rtn = nulldev;
		addr = ic->ic_addr;	  /* address from ctlr structure */
		for (addrp = id->idr_addr; addr || (addrp && (addr = *addrp++)); addr = 0)
			if (ctlr_probe(ic, addr, id))
				break;
		if (addr == 0)
			continue;	  /* this one is not here */
		id->idr_minfo[ic->ic_ctlr] = ic; /* remember controler */
		ic->ic_alive++;			 /* remember it's alive */
#if NIHA > 0 || NAHA > 0
		if(  0   /* <- This is a dummy zero to make the #if's work */
#if NIHA > 0
			|| id == &ihadriver 
#endif NIHA
#if NAHA > 0
			|| id == &ahadriver
#endif NAHA
						)
		{
			xha_hd[ic->ic_ctlr].xh_active=1;
#if NIHA > 0
			if(id == &ihadriver)
			{
				    xha_hd[ic->ic_ctlr].xh_hatype=HATYPE_IBM;
				    xha_hd[ic->ic_ctlr].xh_haname="iha";
				    numiha++;
			}
#endif NIHA
#if NAHA > 0
			if (id == &ahadriver)
			{
				    xha_hd[ic->ic_ctlr].xh_hatype=HATYPE_AHA;
				    xha_hd[ic->ic_ctlr].xh_haname="aha";
				    numaha++;
			}
#endif NAHA
			xha_hd[ic->ic_ctlr].xh_xha= addr;
			xha_hd[ic->ic_ctlr].xh_driver=id;
			xha_hd[ic->ic_ctlr].xh_iocc=ic;
			xhac_attach(ic,id);
		}
#endif NIHA || NAHA
/*
 * loop thru the device structures looking for mass storage
 * peripherals attached to this adapter.
 */
		for (iod = ioccdinit; idr = iod->iod_driver; ++iod) {
			if (id != idr || iod->iod_alive ||
			    (ic->ic_ctlr != iod->iod_ctlr && iod->iod_ctlr != '?'))
				continue; /* not us */
			if (slave(id, iod, addr)) {
				iod->iod_alive = 1;
				iod->iod_ctlr = ic->ic_ctlr;
				iod->iod_addr = addr;
				if (iod->iod_dk && dkn < DK_NDRIVE)
					iod->iod_dk = dkn++;
				else
					iod->iod_dk = -1;
				iod->iod_mi = ic;
				printf("%s%d at %s%d slave %d\n",
				    id->idr_dname, iod->iod_unit,
				    id->idr_mname, ic->ic_ctlr, iod->iod_slave);
				attach(iod, id);
			}
		}
	}
/*
 * now look for non-mass storage peripherals.
 */
	for (iod = ioccdinit; id = iod->iod_driver; ++iod) {
		if (id->idr_flags & EARLY_INT) {
			int_rtn = id->idr_intr;	/* enable early interrupt(s) */
			int_ctlr = iod->iod_unit;
		} else
			int_rtn = nulldev;
		if (iod->iod_alive || iod->iod_slave != -1)
			continue;	  /* already done, or not present */
		addr = iod->iod_addr;	  /* address from device structure */
		for (addrp = id->idr_addr; addr || (addrp && (addr = *addrp++)); addr = 0) {
			if (!device_probe(iod, addr, id))
				continue;
			iod->iod_alive = 1;
			iod->iod_addr = addr;
			attach(iod, id);
			break;
		}
	}
#if NIHA > 0 || NAHA > 0
/*
 * now look for units on xha controller
 */
    if(numiha + numaha)
    {
	register struct iocc_driver *id;
	register struct  xha_driver *xdr;
	register struct  xha_device *xi;
	register struct  xha_driver *xsr;
	register struct  xha_slave  *xs;
	register int a;
	struct		 xha_device	saved_xi;
	struct		 xha_hd		saved_xh;
/*
 * loop through the xha device structures looking for SCSI targets
 * attached to the adapters.
 */
	for(a=0;a < numiha+numaha; a++)
	{
	    if(!xha_hd[a].xh_active)
		continue;
	    xha_hd[a].xh_active=0; /* Clear the bit, don't need it anymore */
	    addr = xha_hd[a].xh_xha;
	    id=xha_hd[a].xh_driver;
	    DEBUGF(autodebug,printf("Checking %s%d at 0x%X\n",id->idr_mname,a,addr););
	    /* Loop through the drive init structure */
	    for (xi = xhdinit; xdr = xi->xi_driver; xi++) 
	    {
		if (xdr->xd_flags & EARLY_INT) {
			int_rtn = id->idr_intr;	/* enable early interrupt(s) */
			int_ctlr = a;
		} else
			int_rtn = nulldev;

		DEBUGF(autodebug,printf("Checking target %s%d\n",xdr->xd_dname,xi->xi_unit);); 
		if (xi->xi_alive || (a != xi->xi_ctlr && xi->xi_ctlr != '?') || (xha_hd[a].xh_hatype != xi->xi_hatype))
		{
		    DEBUGF(autodebug,printf("skipped, alive=%d, ctlr=%d\n",
			xi->xi_alive,xi->xi_ctlr); );
		    continue;
		}

		/* 
		 * Fill in the hadriver variable so that the target probe 
		 * routine can call back a probe routine in the ha driver.
		 */
#if NAHA > 0
		if(xha_hd[a].xh_hatype == HATYPE_AHA)
		{
		    extern struct xhac_driver ahacdriver;
		    xi->xi_hadriver= &ahacdriver;
		}
#endif NAHA
#if NIHA>0
		if(xha_hd[a].xh_hatype == HATYPE_IBM)
		{
		    extern struct xhac_driver ihacdriver;
		    xi->xi_hadriver= &ihacdriver;
		}
#endif NIHA

/* In order to make it possible to use the xha_slave structures at probe
   time, we fill them in with what we expect */

		for(xs=xhsinit; xs->xs_driver;xs++)
		{
			if(xs->xs_target==xi->xi_target &&
			   xs->xs_ctlr==xi->xi_ctlr)
			if(xs->xs_lun >= 0 && xs->xs_lun <= 8 && 
		           xi->xi_slaves[xs->xs_lun] == 0)
			{
			   xi->xi_slaves[xs->xs_lun]=xs;
			   /* xs->xs_xi=xi; Must be done in the device driver
				probe routine, and be restoerd if probe fails */
			}
		}

	        /* Save structures in case probe fails */
		bcopy((char *)xi,(char *)&saved_xi,sizeof saved_xi);
		bcopy((char *)&xha_hd[a],(char *)&saved_xh, sizeof saved_xh);
		/* First, pretend that it works */
		xi->xi_ctlr=a;
		xha_hd[a].xh_ndrive++;		/* Yet another drive */
		xi->xi_hd = &xha_hd[a];
		xi->xi_xha = addr;
		if (xhatarget_probe(xdr,xi,addr))
		{
		    xi->xi_alive=1;
		    /*  
		     *  The xh_xhip array is during autoconfig only used
		     *  in the xha_probe routine to determine if the target
		     *  already has been configured, If so, ant wildcard specs
		     *  will not be tested against that target.
		     *  The above means that we cannot pretend that is works
		     *  b4 we have probed the target because then wildcarding 
		     *	won't ever work.
		     */
		    xha_hd[a].xh_xhip[xi->xi_target]=xi; /* Make a link */
		    printf("%s%d at %s%d target %d \n", 
			xdr->xd_dname, xi->xi_unit, 
			xha_hd[a].xh_haname, xi->xi_ctlr, 
			xi->xi_target);

		    /* Now loop through the slave init structure */
		    for(xs=xhsinit; xsr = xs->xs_driver; xs++)
		    {
			DEBUGF(autodebug,printf("Checking slave %s%d\n",xsr->xd_sname,xs->xs_unit);); 
			struct xha_device *savedxi;

			if(xs->xs_alive || 
			   (xs->xs_ctlr != xi->xi_ctlr && xs->xs_ctlr != '?') ||
		           (xs->xs_target != xi->xi_target && xs->xs_target != '?') ||
			   (xsr != xi->xi_driver)
			)
			{
			    DEBUGF(autodebug,printf("skipped, xs_alive=%d, xi_unit=%d xs_ctlr=%d\n",
				xs->xs_alive,xi->xi_unit,xs->xs_ctlr);); 
			    continue;
			}
			savedxi = xs->xs_xi;
			xs->xs_xi = xi;
			if (xha_slave(xsr, xs, addr)) 
			{
		
			    xs->xs_alive = 1;
			    xs->xs_ctlr = xi->xi_ctlr;
			    /* Link together the device and slave structures */
			    xi->xi_slaves[xs->xs_lun]=xs;
			    if (xs->xs_dk && dkn < DK_NDRIVE)
				xs->xs_dk = dkn++;
			    else
				xs->xs_dk = -1;
			    printf("%s%d at %s%d lun %d\n",
				xdr->xd_sname, xs->xs_unit,
				xdr->xd_dname, xi->xi_unit, xs->xs_lun);
			    xha_attach(xs, xsr);
			}
			else
			    xs->xs_xi = savedxi;
  		    }
		}
		else
		{
		    /* revert to saved status */
			DEBUGF(autodebug,printf("%s%d at %s%d target %d: Probe failed\n",
			xdr->xd_dname, xi->xi_unit, 
			xha_hd[a].xh_haname, xi->xi_ctlr, 
			xi->xi_target); );
		    bcopy((char *)&saved_xi,(char *)xi,sizeof (struct xha_device));  
		    bcopy((char *)&saved_xh,(char *)&xha_hd[a],sizeof (struct xha_hd));
		}
	    }
	}
    }
#endif NIHA || NAHA
	int_rtn = nulldev;
	splx(s);			  /* restore interrupt state */
	_trap = trap;
}

#if NIHA > 0 || NAHA > 0
xha_slave(xhd, xs, addr)
	register struct xha_driver *xhd;
	register struct xha_slave *xs;
	register int addr;
{
	register int result;
	if (xhd->xd_slave == 0) 
	{
		DEBUGF(autodebug, printf("%s%d: no slave routine present - ignored\n",
		    xhd->xd_dname, xs->xs_unit));
		return (0);		  /* not there if no slave routine */
	}
	DEBUGF(autodebug, printf("calling slave at 0x%x (0x%x,0x%x)\n", xs->xs_lun, xs, addr));
	result = (*xhd->xd_slave)(xs, (caddr_t) addr);
	return (result);
}
  
xhac_attach(ic, id)
	register struct iocc_ctlr *ic;
	register struct iocc_driver *id;
{
	register int result;
  
	if (id->idr_attach == 0) 
	{
		printf("%s: no attach routine - ignored\n", id->idr_mname);
		return (0);  /* assume that it doesn't exist if no attach rtn */
	}
	DEBUGF(autodebug, printf("calling attach at 0x%x(0x%x)\n", id->idr_attach, ic));
	result = (*id->idr_attach)(ic);
	return (result);
}
xha_attach(xs, xhd)
	register struct xha_slave *xs;
	register struct xha_driver *xhd;
{
	register struct xha_device *xi;
	register int result;

	if (xhd->xd_sinfo)
		xhd->xd_sinfo[xs->xs_unit] = xs; /* link together */
	else
		printf("%s: sinfo pointer is null\n", xhd->xd_dname);

	xi = xs->xs_xi;
	if(xi)
	{
		if(xhd->xd_dinfo)
			xhd->xd_dinfo[xi->xi_unit] = xi;
		else
			printf("%s: dinfo pointer is null\n",xhd->xd_dname);
	}
	else
		printf("%s: device pointer is null\n",xhd->xd_dname);

	if (xhd->xd_attach == 0) {
		printf("%s: no attach routine - ignored\n", xhd->xd_dname);
		return (0);  /* assume that it doesn't exist if no attach rtn */
	}
	/* printf("calling attach at 0x%x(0x%x)\n", xhd->xd_attach, xs); */
	DEBUGF(autodebug, printf("calling attach at 0x%x(0x%x)\n", xhd->xd_attach, xs));
	result = (*xhd->xd_attach)(xs);
	return (result);
}

xhatarget_probe(xdr, xi, addr)
	register struct  xha_driver *xdr;
	register struct  xha_device *xi;
	register caddr_t addr;
{
	register int result;
	DEBUGF(autodebug,printf("testing target %s%d at SCSI target %d\n",
	    xdr->xd_dname, xi->xi_unit, xi->xi_target); );
	if ((result = xha_probe(addr, xdr, xi)) != PROBE_BAD) {
		if (result == PROBE_BAD_INT) { return (PROBE_BAD); } 
		DEBUGF(autodebug, 
		    printf("%s%d target 0x%x\n", xdr->xd_dname, 
			xi->xi_unit, xi->xi_target); );
		return (PROBE_OK);
	}
	return (PROBE_BAD);
}
xha_probe(addr, xdr, xi)
	register struct xha_driver *xdr;
	register caddr_t addr;
	register struct xha_device *xi;
{
	register int result;

	if (xdr->xd_probe == 0) {
		printf("Xhaprobe: no probe routine - ignored\n");
		DEBUGF(autodebug, printf("no probe routine - ignored\n"));
		return (PROBE_BAD);	  /* assume that it exist if no probe rtn */
	}
	DEBUGF(autodebug, printf("calling probe routine at 0x%x(0x%x)\n", xdr->xd_probe, addr));
	if(xi->xi_target == '?')
	{
	    /* Probe all possible targets */
	    for(xi->xi_target=0;xi->xi_target < 8;xi->xi_target++)
	    {
		/* Have we used this target b4 ? */
		if(xi->xi_hd && xi->xi_hd->xh_xhip[xi->xi_target])
		{
			DEBUGF(autodebug,printf("xha_probe: target %d already configured, skipped\n",xi->xi_target););
			continue;
		}
		DEBUGF(autodebug,printf("xha_probe: probing target %d with routine at %X\n",
			xi->xi_target,xdr->xd_probe););
		result = (*xdr->xd_probe)(addr,xi);
		switch (result) 
		{
		    case PROBE_OK:			  
		    case PROBE_NOINT:
			/* Xi->xi_target now has the correct value */
			return(result);
		    case PROBE_BAD:
			continue;
		    default:
			/* Restore the wildcard */
			xi->xi_target = '?';
			return(PROBE_BAD);
		}
	    }
	    /* Restore the wildcard */
	    xi->xi_target = '?';
	    return(PROBE_BAD);
	}
	else
	{
	    DEBUGF(autodebug,printf("xha_probe: probing target %d with routine at %X\n",
			xi->xi_target,xdr->xd_probe););
	    result = (*xdr->xd_probe)(addr,xi);
	    switch (result) 
	    {
		case PROBE_OK:			  
		case PROBE_NOINT:
		case PROBE_BAD:
		    return(result);
		default:
		    return(PROBE_BAD);
	    }
	}
}
#endif NIHA || NAHA

ctlr_probe(ic, addr, id)
	register struct iocc_ctlr *ic;
	register caddr_t addr;
	register struct iocc_driver *id;
{
	register int result;
	if (present(addr + id->idr_csr) && (result = probe(addr, id, (caddr_t) ic)) != PROBE_BAD) {
		printf("%s%d adapter %x ", id->idr_mname, ic->ic_ctlr, addr);
		if (result == PROBE_BAD_INT) {
			printf("didn't interrupt\n");
			return (PROBE_BAD);
		}
		ic->ic_addr = addr;
		if (result == PROBE_OK)
			ic->ic_irq = int_irq; /* use actual */
		set_vector(ic->ic_irq, id->idr_intr, ic->ic_ctlr, id->idr_mname, ic->ic_ctlr); /* set up IRQ */
		printf("\n");
		return (PROBE_OK);
	}
	return (PROBE_BAD);
}


device_probe(iod, addr, id)
	register struct iocc_device *iod;
	register caddr_t addr;
	register struct iocc_driver *id;
{
	register int result;

	if (present(addr + id->idr_csr) && (result = probe(addr, id, (caddr_t)id)) != PROBE_BAD) {
		printf("%s%d adapter %x ", id->idr_dname, iod->iod_unit, addr);
		if (result == PROBE_BAD_INT) {
			printf("didn't interrupt\n");
			return (PROBE_BAD);
		}
		iod->iod_alive = 1;
		if (result == PROBE_OK)
			iod->iod_irq = int_irq;	/* use actual interrupt level */
		set_vector(iod->iod_irq, id->idr_intr, iod->iod_unit, id->idr_dname, iod->iod_unit); /* set up IRQ */
		printf("\n");
		return (1);
	} else {
		return (0);
	}
}

#define PROBE_NULL	0xffffffff

/*
 * first check to see if the address is already used - if so then don't
 * regard it as present.
 * if probe succeedes then enter it in used address table.
 */
probe(addr, id, ic)
	register struct iocc_driver *id;
	register caddr_t addr;
	register caddr_t ic;
{
	register int result;
	register caddr_t * t;

	int_irq = -1;			  /* set up for interrupt determination */
	int_level = -1;
	for (t = probe_addrs; *t; ++t)
		if (*t == addr && addr != (caddr_t) PROBE_NULL)
			return (PROBE_BAD); /* oops, already in use */
	if (id->idr_probe == 0) {
		return (PROBE_BAD);	  /* assume that it exist if no probe rtn */
	}
	result = (*id->idr_probe)(addr,ic);
	switch (result) {
	case PROBE_OK:			  /* device thinks it caused an interrupt */
		if (int_irq == -1 || int_level == -1) {
			result = PROBE_BAD_INT;	/* too bad */
			break;
		}
/* fall thru */
	case PROBE_NOINT:
		*t = addr;		  /* device found - remember it's address */
		break;
	default:
		result = PROBE_BAD;
	case PROBE_BAD:
		break;
	}
	return (result);
}


slave(id, iod, addr)
	register struct iocc_driver *id;
	register struct iocc_device *iod;
	register int addr;
{
	register int result;
	if (id->idr_slave == 0) {
		return (0);		  /* not there if no slave routine */
	}
	result = (*id->idr_slave)(iod, addr);
	return (result);
}


attach(iod, id)
	register struct iocc_device *iod;
	register struct iocc_driver *id;
{
	register int result;

	if (id->idr_dinfo)
		id->idr_dinfo[iod->iod_unit] = iod; /* link together */
	else
		printf("%s: dinfo pointer is null\n", id->idr_dname);
	if (id->idr_attach == 0) {
		printf("%s: no attach routine - ignored\n", id->idr_dname);
		return (0);		  /* assume that it doesn't exist if no attach
					     rtn */
	}
	result = (*id->idr_attach)(iod);
	return (result);
}


/*
 * store new interrupt service routine into slih_table.
 * scan thru slih_table until we find an entry with no slih_rtn
 * specified (better be the first one!)
 * or one with slih_next == NULL.
 */
set_vector(irq, rtn, info, name, unit)
	int (*rtn)();
	char *name;
{
	register struct slihtab *s = &slih_table[irq_map[irq]], *p = 0;

	printf("IRQ %d ", irq);
	if (rtn == 0) {
		printf("null interrupt service routine for irq %d\n", irq);
		rtn = nulldev;
	}
	if (int_level >= 0)
		printf("CPU level %d ", int_level);
	/* printf("locating entry in slih_table\n"); */
	for (; s && s->slih_rtn; s = s->slih_next)
		p = s;
	if (s == 0) {
		/* printf("allocating entry in slih_table\n"); */
		s = last_slih++;	  /* allocate new slih entry */
		s->slih_irq = irq;	  /* remember the irq number */
		s->slih_next = 0;	  /* terminate chain */
		s->slih_flags = 0;	  /* clear flags */
		p->slih_next = s;	  /* link it into the chain */
	}
	/* printf("inserting entry in slih_table\n"); */
	s->slih_rtn = rtn;
	s->slih_info = info;
	/* printf("calling set_int_name\n"); */
	set_int_name(s, name, unit);
	/* printf("returning from set_vector\n"); */
	int_irq = -1;			  /* reset the interrupt info */
	int_level = -1;
}

/*
 * locate the proper place in interrupt name table 
 * and store controller name and unit number.
 */
set_int_name(s, name, unit)
char *name;
struct slihtab *s;
{
	int index = s - slih_table + OTHER_INTS;
	char *p;

/*
	printf("in set_int_name (name=%s unit=%d index=%d)\n", name, unit, index);
*/
	for (p=intrnames; --index >= 0; )
		p += strlen(p) + 1;
	/*
	 * p now points to the proper place for this entry
	 * we may need to add some blanks at the end of the table
	 */
	if (*p == 0)
		strcpy(p, "      ");	/* put in some blanks */
	while (*p && *name)
		*p++ = *name++;		/* copy the name */
	if (*p)
		*p++ = unit + '0';
	while (*p)
		*p++ = ' ';
}


/*
 * we assume that a non-existant location will always return the same
 * value. We also assume that UNDEFINED_ADDR is just such an undefined
 * location. It appears that usually 0xff is returned but we have seen
 * cases where 0x1f came back.
 * the following should even work if the value returned is zero but in
 * that case we will write a non-zero (0xff) value into the register
 * to see if we get a zero back out again. If all this fails it is up
 * to the driver probe routine to figure out if the device is there.
 */
present(addr)
	register char volatile *addr;
{
#ifdef IBMRTPC
#define UNDEFINED_ADDR	0xf0000000	  /* assume nothing at this address */
	register char *p = (char *)UNDEFINED_ADDR;

	addr[0] = 0;
	if (addr[0] == *p && addr[1] == *p) {
		addr[0] = ~*p;		  /* invert it just in case */
		return (addr[0] != *p);
	}
#endif IBMRTPC
#ifdef ATR
#ifdef AT
#define MIN_IO	0x0000			/* minimum address we can look at */
#define UNDEFINED_ADDR	0x00ff		/* assume nothing at this address */
#else
#define UNDEFINED_ADDR	0x0000		/* assume nothing at this address */
#define MIN_IO	0x0100			/* minimum address we can look at */
#endif
#define MAX_IO	0x10000
	/*
	 * if the address given looks like an I/O address then
	 * we test to see if anything is present at that address
	 */
	if ((int) addr >= MIN_IO && (int) addr < MAX_IO) {
		register int undef = IN(UNDEFINED_ADDR);
		if (config.cpu != 0)
			return(0);	/* give real hardware to master only */
		OUT(addr, 0);		/* set it to zero */
		if (IN(addr) == undef) {
			OUT(addr, ~undef);	/* invert it just in case */
			return(IN(addr) != undef);
		}
	}
#endif ATR
	return (1);
}


init_slih()
{
/*
 * scan thru slih_table and build the reverse mapping from IRQ number
 * to index into slih_tab.
 */
	register struct slihtab *s;
	register int i;
	register char *p;

	for (i = 0, s = slih_table; i < MAX_8259_LEVELS * MAX_8259; ++i, ++s) {
		if ((s->slih_flags & FIXED) == 0) {
			s->slih_rtn = 0;  /* reset the pointer */
			s->slih_info = 0;
		}
		irq_map[s->slih_irq] = i; /* remember the mapping */
	}
	last_slih = s;			  /* first available spot */
	for (; i < MAX_SLIH; ++i, ++s) {
		s->slih_rtn = 0;
		s->slih_next = 0;
	}
}


autotrap(mcs_pcs, info, ics_cs, regs)
        register mcs_pcs, info;
        int ics_cs;			  /* must not be a register variable */
        int regs;			  /* must not be a register variable */
{

	prstate("trap", mcs_pcs, info, (&regs)[IAR], ics_cs, &regs);
	panic("trap during autoconfig");
}


/*
 * Configure swap space and related parameters.
 */

swapconf()
{
        register struct swdevt *swp;
        register int nblks;
	register int nswap = 0;

        for (swp = swdevt; swp->sw_dev; swp++)
                if (bdevsw[major(swp->sw_dev)].d_psize) {
                        nblks =
                          (*bdevsw[major(swp->sw_dev)].d_psize)(swp->sw_dev);
                        if (nblks != -1 &&
                            (swp->sw_nblks == 0 || swp->sw_nblks > nblks)) {
                                swp->sw_nblks = nblks;
				nswap += nblks;
			}
                }
	if (nswap <= 0)
		panic("swap blocks <= 0");
        dumpconf();
}

init_intr()
{
#ifdef ATR
	register int i;
	register int rctrl;
	int	frame,vpage;
	struct pte tmp_pte;

	struct	hatipt_entry	*ipte;
	struct	io_locks *io;

	/*
	 * map the pcif into MMU_IO_SEG (segment D)
	 */
	frame = btoc(pcif_addr);
	vpage = btop(MMU_IO_SEG << 28);

	/*
	 * map in the all of pcif NOTE the kernel may have the "key"
	 * bit on, so we have to pretend the pages are user read/write.
	 * user access is controlled by the "cpu" bit (no access at all
	 * or the "special" bit (making the lock bits active))
	 */
	for (ipte = &MMU_HATIPT[frame], i=0; i < btoc(PCIF_SIZE); ipte++,i++) {
		/* fix up the ipte to make map in happy */
		ipte->key_addrtag = (MMU_SID_IO) << MMU_VPAGE_BITS;
		ipte->ipt_ptr = MMU_UNDEF_PTR;
#ifdef SIM_CHG_BIT
		mapin(&tmp_pte, vpage++, PG_UW|PG_M|frame++, 1);
#else
		mapin(&tmp_pte, vpage++, PG_UW|frame++, 1);
#endif SIM_CHG_BIT
	}

	/*
	 * now set up the lockbits. The 512K window is no access,
	 * the 128k windows are full access, and the 64K windows
	 * are limited access.
	 */
	frame = btoc(pcif_addr);
	for (ipte = &MMU_HATIPT[frame], i=0; i < btoc(PCIF_512K_SIZE); 
								ipte++,i++) {
		ipte->w = 0;
		ipte->lockbits = 0;
	}
	/*
	 * 128k windows
	 */
	for (i=0; i < btoc(PCIF_128K_SIZE*PCIF_NUMBER_128K); ipte++,i++) {
		ipte->w = 1;
		ipte->lockbits = -1;
	}
	/*
	 * first 64k window (half word access), io_locks is the desired access
	 */
	for (i=0,io=io_locks; i < btoc(PCIF_64K_SIZE); ipte++,i++,io++) {
		ipte->w = io->write_bit;
		ipte->lockbits = io->lock_bits;
	}
	/*
	 * first 64k window (byte access), io_locks is the desired access
	 * NOTE: the access is identical to the half word window.
	 */
	for (i=0,io=io_locks; i < btoc(PCIF_64K_SIZE); ipte++,i++,io++) {
		ipte->w = io->write_bit;
		ipte->lockbits = io->lock_bits;
	}

	/*
	 * initialize the pcif window pointers
	 */
	pcif_addr = MMU_IO_SEG << 28;	/* the virtual address of the pcif */
	pcif_512_fw = pcif_addr;
	pcif_128_fw = pcif_512_fw + PCIF_512K_SIZE;
	pcif_128_hw = pcif_128_fw + PCIF_128K_SIZE;
	pcif_128_b = pcif_128_hw + PCIF_128K_SIZE;
	pcif_io_hw = pcif_128_b + PCIF_128K_SIZE;
	pcif_io_b =  pcif_io_hw + PCIF_64K_SIZE;
	u.u_pcb.pcb_io = MMU_IO_DISABLE; /* make sure the IO seg is defined */
	iow(MMU_TID_ADDR,u.u_pcb.pcb_io);

	pcif_reg = (struct pcif_reg *)(pcif_base + pcif_io_b); 
	rctrl = (int)&pcif_reg->romp_ctrl;

#if NVGA > 0
	/*
	 * If the VGA is enabled, the user may get access to the 128K window.
	 * Be sure this window is initialized to a VGA address (not just 
	 * random memory).
	 */
	set_128_window(VGA_SCREEN_MIN);
	u.u_pcb.pcb_win = current_128_w;
#endif

/* 
 * Next we compute the address of the cbcb (in the PC's memory)
 * and set up a pointer to it.
 */

	cbcb = (struct cbcb *)(set_512_window(cbcb_addr)+pcif_512_fw);
	sv_pc_cb =  cbcb->cbcb_ent[SVENT].pc_cb;
	pcvec_map = (char *)(set_512_window(sv_pc_cb) + pcif_512_fw);

	SETBIT(rctrl,R_IENAB);			/* Enable ROMP to PC interrupts */
	pc_req(CB_QEOI, (char *) 0, SVENT);	/* we are queing EOI's */
#endif

#ifdef IBMRTPC
	INIT_INTR();		/* setup 8259 interrupt controllers */
	shr_int_init();		/* reset shared interrupts */

	* (char *) CCR = u.u_pcb.pcb_ccr = ccr_default;	/* set up default user access */
#endif

#ifdef ROMPC
#ifdef SGP
#ifdef MOD135
	if (cpu_model == CPU_ROMPC || cpu_model == CPU_MOD135)
#else
	if (cpu_model == CPU_ROMPC)
#endif
#endif
		init_ioims(cpu_model);
#endif ROMPC
}

#ifdef ROMPC

int ioim1_config;		/* IOIM 1 configuration */
int ioim2_config;		/* IOIM 2 configuration */
int ioim2;			/* non-zero if IOIM2 present */
label_t ioim_label;

#define MEM_2_CYCLE 0x80	/* On if 2 Cycle Memory */
/*
 * initialize both IOIM1 and IOIM2 (IOIM2 requires complete setup
 * IOIM1 has already been initialized by the ROS)
 */
init_ioims(cpu_model)
int cpu_model;
{
#ifdef IBMRTPC
	extern int memconfig;	/* memory configuration register (locore) */
	int mem_cycle = (memconfig & MEM_2_CYCLE) != 0 ? 0 : IOIM_2_CYCLE;

	iow(IOIM1_BASE, (BUS1 << 8) + (IOIM1 >> 16));
	ioim1_config = ior(IOIM1 + IOIM_MCC);	/* get configuration */
	/* for now disable parity (chips don't work at 100ns) */
	iow(IOIM1+IOIM_GCR, ior(IOIM1+IOIM_GCR) | IOIM_NOPARITY | mem_cycle);
	/* Turn off user access to FPA's, but leave IOCC controlled alone */
	iow(IOIM1+IOIM_SUB_PROB, SEG_0+SEG_4);
#endif

#ifdef MOD135
	if (cpu_model != CPU_MOD135)
#endif
	{
		extern int (*_trap)();
		extern int ioim_trap();
		register int (*oldtrap)() = _trap;
		_trap = ioim_trap;
		if (setjmp(&ioim_label)) {
			_trap = oldtrap;
			return;
		}
		/* initialize IOIM2 for 68881 operation */
		iow(IOIM2_BASE, (BUS2 << 8) + (IOIM2 >> 16));
		ioim2_config = ior(IOIM2 + IOIM_MCC);	/* get configuration */
		iow(IOIM2+IOIM_MCC, IOIM2_MCC);		/* set TAG and ARB */
		iow(IOIM2+IOIM_GCR, IOIM_NOPARITY | IOIM_LOOPMODE);
		iow(IOIM2+IOIM_MISC_0, IOIM2_MISC_0);	/* XXX obsolete hardware */
		iow(IOIM2+IOIM_MISC_1, IOIM2_MISC_1);
		iow(IOIM2+IOIM_SUB_SEG_1, IOIM2_VALUE1);
		iow(IOIM2+IOIM_SUB_PROB, IOIM2_PROB_DISABLE);	/* */
/*		iow(IOIM2+IOIM_SUB_PROB, IOIM2_PROB_ENABLE);	/* for testing */
		iow(IOIM2+IOIM_SUB_SEG_3, IOIM2_VALUE3);
		iow(IOIM2+IOIM_SUB_SEG_4, IOIM2_VALUE4);
		iow(IOIM2+IOIM_SUB_SEG_5, IOIM2_VALUE5);
		_trap = oldtrap;
		ioim2 = IOIM2;
	}
}

ioim_trap()
{
	longjmp(&ioim_label);
}

check_mem_config()
{
#ifndef ATR
	extern int memconfig;	/* memory configuration register (locore) */
	int mem_cycle = (memconfig & MEM_2_CYCLE);
	int x;
#ifdef SGP
	if (cpu_model == CPU_ROMPC)
#endif
		{
		if (mem_cycle) {
			printf("Warning: slow memory cards are not supported on APC\n");
			printf("	machine checks are likely\n");
		}
		/* following tests if APC has an 8meg card in first slot - which 
		 * means that either the cards should be swapped so that the 8meg
		 * card is in the second slot, or that the two 8meg cards are present
		 * which is wasteful as the first could be replaced by a 4meg card.
		 */
		if ((memconfig & 0xf07) == 0x804)
			printf("Warning: 4MB of 8MB memory card unusable - %s\n",
				((memconfig & 0x070) == 0x040) ? "4MB card recommended" : "exchange card order");
	/*
	 * test to see if the reply register exists
	 * if it does then the value will change when the
	 * base register is read.
	 */
		if ((ioim1_config & 0x0f00) != 0x0900)
			printf("IOIM1 EC level different than expected\n");
		x = ior(IOIM1+IOIM_REPLY);
		(void) ior(IOIM1+IOIM_BASE);
		if (ior(IOIM1+IOIM_REPLY) == x)
			printf("Warning: back-level IOIM - no reply register\n");
		}
#endif /* ATR */
}
#endif /* ROMPC */

shr_int_init()
{	/* reset all shared interrupts before we probe */
	register int irq;

	for(irq = 0; irq < MAX_IRQ; irq++) {
		*shr_int_reset[irq] = 0xff;
	}
}

#ifdef ATR
/*
 * Establish addressability to variables passed to us from the pc code.
 */

/*
 *  Functions for controlling the mapping of addresses from the ROMP
 *  address space to the PC address space.
 */


set_512_window(pc_addr)
{
	register int ioaddr = (int)&pcif_reg->pc_wind512;
	register int boundary,offset;

	boundary = (pc_addr & 0xFFF80000) >> PCIF_R5_SHIFT;
	current_512_w = boundary;
	offset = (pc_addr & 0x0007FFFF);
	IOOUT(ioaddr, boundary); 
	return(offset);
}

set_128_window(pc_addr)
{
	register int ioaddr = (int)&pcif_reg->pc_wind128;
	register int boundary,offset;

	boundary = (pc_addr & 0xFFFE0000) >> PCIF_R4_SHIFT;
	current_128_w = boundary;
	offset = (pc_addr & 0x0001FFFF);
	IOOUT(ioaddr,boundary);
	return(offset);
}

pc_req(op,unix_cb,cb_ent)	
register u_short op;
register char *unix_cb;
register u_short cb_ent;
{
        register int pcintr = (int)&pcif_reg->romp_ctrl;
	register int old_window,i = 0;      
	register int s;


	old_window = get_512_window(); 		/* Save the current window */
	set_512_window(cbcb_addr);		/* Address the cbcb        */

	s = _spl2();					
	while((cbcb->op_code & 0x00ff) != 0) {  /* wait for the op_code */
	     delay(5);				/* field to clear */
	     if(i++ > cbcb_wait) {
		set_512_window(old_window);
	  	printf("PC REQUEST TIMEOUT. (%x)\n,",cbcb->op_code & 0x00ff);
		splx(s);
		return(-1);
		}
	}


	PUT_PC(cbcb->cbcb_ent[cb_ent].unix_cb,(u_long)unix_cb); /* load the unix_cb */

	PUT_PC(cbcb->op_code,op);	/* load the op_code */
	
	SETBIT(pcintr,R_IREQ);		/* ROMP -> PC Inter */

	set_512_window(old_window);	/* restore the 512K window */

	splx(s);
	return(0);
}

#define swaph(value) (((value>>8)&0xff)|((value&0xff)<<8))

/*
 * make a request on another cpu. Of course the cpu must exist
 * for this to make sense. We don't allow our cpu as a recipient
 * of the request.
 */
pc_req_alt(op,unix_cb,cb_ent,cpu)
register u_short op;
register char *unix_cb;
register u_short cb_ent;
int cpu;
{
	register int old_window,i = 0;      
	register int s;
	struct cbcb *cbcb;
	int alt_cbcb_addr;


	if ((unsigned) cpu >= config.maxcpu)
		return(ENODEV);			/* invalid cpu number */

	if (cpu == config.cpu)
		return(EINVAL);			/* invalid cpu number */

	old_window = get_512_window(); 		/* Save the current window */
	cbcb = (struct cbcb *)(set_512_window(cbcb_addr)+pcif_512_fw);
	if ((alt_cbcb_addr = cbcb->cbcb[cpu]) == 0)	/* get that cbcb addr */
		return(EINVAL);			/* not possible */
	cbcb = (struct cbcb *)(set_512_window(alt_cbcb_addr)+pcif_512_fw);
	if (cbcb->state == swaph(STATE_RUNNING))
		return(EBUSY);			/* still running */

	s = _spl2();					
	while((cbcb->op_code & 0x00ff) != 0) {  /* wait for the op_code */
	     delay(5);				/* field to clear */
	     if(i++ > cbcb_wait) {
		set_512_window(old_window);
	  	printf("ALT CPU %d PC REQUEST TIMEOUT. (%x)\n", cpu, cbcb->op_code & 0x00ff);
		splx(s);
		return(-1);
		}
	}

	PUT_PC(cbcb->cbcb_ent[cb_ent].unix_cb,(u_long)unix_cb); /* load the unix_cb */

	PUT_PC(cbcb->op_code,op);	/* load the op_code */
	
	SETBIT(swaph(cbcb->port)+R_INTR,R_IREQ);	/* ROMP -> PC Inter */

	set_512_window(old_window);	/* restore the 512K window */

	splx(s);
	return(0);
}


/*
 * if mask is non-zero then we mask off those interrupts on the 
 * PS2 side that are being forwarded to us. This will hold those
 * interrupts pending in the 8259 on the PS2 side until we re-enable
 * the interrupts. If mask is zero then we restore the 8259 mask to
 * its normal state.
 */
maskints(mask)
u_short mask;
{

	struct mask_int mask_int;
	struct mask_int *pcptr;
	int old_window = get_512_window();

	set_512_window(cbcb_addr);		/* Address the cbcb */
	pcptr = (struct mask_int *)(cbcb->cbcb_ent[MASKENT].pc_cb+pcif_512_fw);

	if(mask) {	/* if we are masking anything */
		mask_int.master = (char)((mask & 0xff00) >> 8);
		mask_int.slave =(char)(mask & 0x00ff);
	} else {	/* we are restoring the original */
		mask_int.master = (char) pcptr -> master; 
		mask_int.slave = (char) pcptr -> slave;
	}

	pc_req(CB_MASKREQ,&mask_int,MASKENT);
	set_512_window(old_window);	

}  

/*
 * function to set pcvec_map observing the window protocols 
 * we return the old value in case anyone wants it.
 */

set_pcvec_map(index,value)
{
	int	old_window = get_512_window();
	int	result;
	
	set_512_window(sv_pc_cb);
	result = pcvec_map[index];
	pcvec_map[index] = value;
	set_512_window(old_window);
	return(result);
}

/*
 * get the control block address observing the window protocols
 */
get_pc_cb(index)
{
	int		old_window = get_512_window();
	int		result;

	(void) set_512_window(cbcb_addr);
	result =  cbcb->cbcb_ent[index].pc_cb;
	set_512_window(old_window);
	return(result);
}


int sudebug = 0;		/* suspend debug flag */
#define SUSPEND_TIMEOUT 60
int suspend_timeout = SUSPEND_TIMEOUT;	/* how long to wait for timeout */

/*
 * we suspend unix by sending a pc request and then waiting until 
 * the pc side processes it.
 * then we wait until the suspension is over
 * we call the screen save routines in order to save the screen state
 * and later restore the state (restore state routines must pick up
 * new pointers in case the pc data moved).
 */
suspend_screens()
{
	int i = suspend_timeout;		/* allow 1 minute for the save */
	int n;
	while ((n = screen_all_save()) && --i > 0)
		sleep((caddr_t)&lbolt,PZERO+1);
	if (n)
		printf("suspend: %d screen(s) didn't complete save\n",n);
}

suspend()
{
	extern struct restart restart_block;
	int	old_window = get_512_window();
	char	old_vecmap[16];
	int	i;
	int	n;
	extern struct kbdata  *kbdata;		/* ptr to keyboard data area in PS/2 memory */
	extern int		kb_pc_cb;	/* actual PS/2 address of keyboard data */
	extern int		ms_pc_cb;	/* actual PS/2 address of mouse data */
	extern int		sp_pc_cb;	/* actual PS/2 address of mouse data */
	
	set_512_window(sv_pc_cb);
	bcopy(pcvec_map, old_vecmap, 16);	/* save pc_vecmap */

	(void) _spl5();				/* allow device interrupts again */

	suspend_devices(SUSPEND_START);

	(void) _spl2();			/* allow only clock interrupts */

	screen_all_save();		/* redundant, but shouldn't harm anyone */

	pc_req(CB_SUSPEND,0,0);		/* tell PC to suspend  */

	for (i=0; i<1000; ++i) {
		if (restart_block.magic == RESTART_MAGIC)
			break;
		delay(10);		/* wait 10 seconds for pc to do its part */
	}

	if (restart_block.magic != RESTART_MAGIC) {
		(void) spl0();
		u.u_error = EINVAL;
		return;
	}

	while (restart_block.magic == RESTART_MAGIC)
		++restart_block.counter;	/* bump it */
/*
 * pick up new copies of various pc pointers in case they moved
 */
	cbcb = (struct cbcb *)(set_512_window(cbcb_addr)+pcif_512_fw);
	sv_pc_cb =  cbcb->cbcb_ent[SVENT].pc_cb;
	kb_pc_cb = cbcb->cbcb_ent[KBENT].pc_cb;
	ms_pc_cb = cbcb->cbcb_ent[MSENT].pc_cb;
	sp_pc_cb = cbcb->cbcb_ent[SPKENT].pc_cb;
	set_512_window(sv_pc_cb);
	pcvec_map = (char *)(set_512_window(sv_pc_cb) + pcif_512_fw);

	bcopy(old_vecmap, pcvec_map, 16);	/* restore pc_vecmap */

	kbdata = (struct kbdata *) (set_512_window(kb_pc_cb) + pcif_512_fw);

	kbdata->fwd_int = 1;		/* turn on kbd interrupt forwarding from PC */
#if NMS > 0
	{
		extern struct msdata *msdata;
		/* set mouse data ptr also */
		msdata = (struct msdata *) (set_512_window(ms_pc_cb) + pcif_512_fw);
	}
#endif NMS
	{
		extern struct spkdata *spkdata;
		spkdata = (struct spkdata *) (set_512_window(sp_pc_cb) + pcif_512_fw);
	}

	init_ps2_clock();		/* pick up new clock pointers */

	(void) _spl5();				/* allow devices interrupts */
	suspend_devices(SUSPEND_DONE);

	i = suspend_timeout;
	while ((n=screen_all_restore()) && --i > 0)
		sleep((caddr_t)&lbolt,PZERO+1);	/* restore screens */

	set_512_window(old_window);
	(void) spl0();				/* allow all interrupts again */
}

suspend_devices(how)
{
	register struct iocc_driver *id;
	register struct iocc_device *iod;

	for (iod = ioccdinit; id = iod->iod_driver; ++iod) {
		if (iod->iod_alive == 0 || (id->idr_flags & DRIVER_SUSPEND) == 0)
			continue;
	}
#if NMS > 0
	mssuspend(how);				/* handle mouse specially */
#endif
}
#endif ATR

#define	DOSWAP			/* change swdevt, argdev, and dumpdev too */
u_long	bootdev;		/* should be dev_t, but not until 32 bits */

static	char devname[][2] = {
	'f','d',	/* 0 = fd */
	'h','d',	/* 1 = hd */
#ifdef ATR
	'o','p',	/* 2 = op */
#endif ATR
};

#define	PARTITIONMASK	0x7
#define	PARTITIONSHIFT	3

/*
 * Attempt to find the device from which we were booted.
 * If we can do so, and not instructed not to do so,
 * change rootdev to correspond to the load device.
 */
setroot()
{
	int  majdev, mindev, unit, part, controller, adaptor;
	dev_t temp, orootdev;
	struct swdevt *swp;

	if (boothowto & RB_DFLTROOT ||
	    (bootdev & B_MAGICMASK) != (u_long)B_DEVMAGIC)
		return;
	majdev = B_TYPE(bootdev);
	if (majdev >= sizeof(devname) / sizeof(devname[0]))
		return;
	adaptor = B_ADAPTOR(bootdev);
	controller = B_CONTROLLER(bootdev);
	part = B_PARTITION(bootdev);
	unit = B_UNIT(bootdev);
	/*
	 * Search iocc devices.
	 *
	 */
	{
		register struct iocc_device *iod;

		for (iod = ioccdinit; iod->iod_driver; iod++)
			if (iod->iod_alive && iod->iod_slave == unit &&
			   iod->iod_ctlr == controller &&
/*			   iod->iod_vbanum == adaptor && /* not used */
			   iod->iod_driver->idr_dname[0] == devname[majdev][0] &&
			   iod->iod_driver->idr_dname[1] == devname[majdev][1])
				break;
		if (iod->iod_driver == 0)
			return;
		mindev = iod->iod_unit;
	}
	mindev = (mindev << PARTITIONSHIFT) + part;
	orootdev = rootdev;
	rootdev = makedev(majdev, mindev);
	/*
	 * If the original rootdev is the same as the one
	 * just calculated, don't need to adjust the swap configuration.
	 */
	if (rootdev == orootdev)
		return;
	printf("changing root device to %c%c%d%c\n",
		devname[majdev][0], devname[majdev][1],
		mindev >> PARTITIONSHIFT, part + 'a');
#ifdef DOSWAP
	mindev &= ~PARTITIONMASK;
	for (swp = swdevt; swp->sw_dev; swp++) {
		if (majdev == major(swp->sw_dev) &&
		    mindev == (minor(swp->sw_dev) & ~PARTITIONMASK)) {
			temp = swdevt[0].sw_dev;
			swdevt[0].sw_dev = swp->sw_dev;
			swp->sw_dev = temp;
			break;
		}
	}
	if (swp->sw_dev == 0)
		return;
	/*
	 * If argdev and dumpdev were the same as the old primary swap
	 * device, move them to the new primary swap device.
	 */
	if (temp == dumpdev)
		dumpdev = swdevt[0].sw_dev;
	if (temp == argdev)
		argdev = swdevt[0].sw_dev;
#endif
}
