#ifndef lint
char yysccsid[] = "@(#)yaccpar	1.4 (Berkeley) 02/25/90";
#endif
#line 2 "tcpgram.y"
/*
 * Copyright (c) 1988-1990 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * Grammar for tcpdump.
 */
#ifndef lint
static char rcsid[] =
    "@(#) $Header: tcpgram.y,v 1.22 90/10/25 13:14:16 mccanne Exp $ (LBL)";
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>

#include "interface.h"

#include <sys/time.h>
#include <net/bpf.h>

#include "gencode.h"

static struct qual qualifier;
static struct qual default_qual = { 0, 0, 0 };

int n_errors = 0;

static void
yyerror()
{
	++n_errors;
}

#line 56 "tcpgram.y"
typedef union {
	int i;
	enum bpf_code c;
	u_long h;
	u_char *e;
	char *s;
	struct stmt *stmt;
	struct block *blk;
	struct arth *a;
} YYSTYPE;
#line 69 "y.tab.c"
#define DST 257
#define SRC 258
#define HOST 259
#define GATEWAY 260
#define NET 261
#define PORT 262
#define LESS 263
#define GREATER 264
#define PROTO 265
#define BYTE 266
#define ARP 267
#define RARP 268
#define IP 269
#define TCP 270
#define UDP 271
#define BROADCAST 272
#define NUM 273
#define ETHER 274
#define GEQ 275
#define LEQ 276
#define NEQ 277
#define ID 278
#define EID 279
#define HID 280
#define LSH 281
#define RSH 282
#define LEN 283
#define OR 284
#define AND 285
#define UMINUS 286
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    2,    2,    2,
    3,    3,    3,    3,    4,    4,    4,    8,    8,    5,
    5,   16,   16,   16,   16,   16,    6,    6,    6,    6,
    6,    6,   17,   17,   18,   18,   18,   18,   18,   18,
   19,   19,   19,   20,   12,   12,   12,   12,   12,   12,
    7,    7,    7,    7,   14,   14,   14,   15,   15,   15,
    9,    9,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   11,   11,   11,   11,   11,
   13,   13,
};
short yylen[] = {                                         2,
    1,    0,    1,    3,    3,    3,    3,    1,    1,    3,
    1,    1,    1,    2,    1,    3,    3,    1,    1,    1,
    2,    3,    2,    2,    2,    2,    2,    3,    1,    3,
    3,    1,    1,    0,    1,    1,    3,    3,    3,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    4,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    6,    3,    3,    3,    3,    3,    3,
    3,    3,    2,    3,    1,    1,    1,    1,    1,    1,
    1,    3,
};
short yydefred[] = {                                      0,
    0,    0,    0,   47,   48,   46,   49,   50,   51,   81,
   45,   75,    0,    0,    0,    0,    0,    3,   20,   32,
    0,   62,    0,   61,    0,    0,   52,   53,    0,   21,
    0,   73,    0,    0,    0,    0,    0,    0,   56,   58,
   60,    0,    0,    0,    0,    0,    0,    0,    0,   55,
   57,   59,    0,    0,    0,   11,   13,   12,    0,    0,
   27,    8,    9,    0,    0,   41,   44,   42,   43,   25,
    0,   24,   26,   77,   76,   79,   80,   78,    0,    0,
   28,   74,   82,    0,    0,    7,    5,    0,    6,    4,
    0,    0,    0,    0,    0,    0,   67,   68,    0,    0,
    0,   14,    0,   15,    0,    0,    0,    0,    0,    0,
    0,   22,   54,    0,   63,    0,    0,   10,    0,    0,
   38,   40,   37,   39,    0,   17,   16,   64,
};
short yydgoto[] = {                                      16,
   34,  102,   62,  105,   18,   19,   20,  106,   21,   22,
   79,   33,   24,   53,   54,   25,   26,   71,   72,   73,
};
short yysindex[] = {                                    -13,
 -266, -255, -249,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -13,  239,  -13,    0, -280,    0,    0,    0,
  406,    0,  -63,    0,  159,  -48,    0,    0,   95,    0,
  239,    0,  -63,  -10,  -11,   -6,  -31,  -31,    0,    0,
    0,  239,  239,  239,  239,  239,  239,  239,  239,    0,
    0,    0,  239,  239,  239,    0,    0,    0,  159,  163,
    0,    0,    0, -274, -262,    0,    0,    0,    0,    0,
 -168,    0,    0,    0,    0,    0,    0,    0, -232,   -9,
    0,    0,    0,  -31,  109,    0,    0,    0,    0,    0,
  -26,  -26,  126,  173,  -39,  -39,    0,    0,   -9,   -9,
  441,    0,  -27,    0,    4, -225,   -6, -209, -206, -203,
 -192,    0,    0,   -6,    0, -197,   -6,    0,  159,  159,
    0,    0,    0,    0,  -25,    0,    0,    0,
};
short yyrindex[] = {                                    106,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -36,    0,  -36,    0,   90,    0,    0,    0,
    0,    0,    6,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  414,  435,  -36,  -36,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  151,  155,    0,    0,    0,    0,    0,
  167,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -36,  -36,    0,    0,    1,    0,    0,
   37,   51,   77,   66,   12,   26,    0,    0,   15,   40,
    0,    0,    0,    0, -205,    0, -184,    0,    0,    0,
    0,    0,    0,  120,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   96,   85,  -60,    0,   45,    0,    0,    0,  530,  101,
    0,  385,  486,    0,    0,    0,    0,    0,   14,    0,
};
#define YYTABLESIZE 723
short yytable[] = {                                     104,
    9,   84,   48,   37,   38,   29,   27,   49,   85,  108,
  109,   65,  103,   14,   30,   48,   46,   28,   47,   13,
   49,  110,  111,   29,  104,   66,   15,   55,   45,   82,
   81,   14,   48,   46,   83,   47,   71,   49,   61,   31,
  113,    9,   61,   61,  118,   61,   29,   61,  121,   65,
   72,  122,   65,  123,   65,   30,   65,   30,  119,  120,
   61,   61,   61,   66,  124,   69,   66,  128,   66,   65,
   66,   65,   65,   65,   71,  125,   70,   71,   19,   19,
   31,   87,   90,   66,  112,   66,   66,   66,   72,    1,
   66,   72,   68,   69,   71,   17,   71,   71,   71,   18,
   18,    0,    0,   69,   65,    2,   69,    0,   72,   61,
   72,   72,   72,    0,   44,   35,    0,   70,   66,    0,
    0,   86,   89,   69,   61,   69,   69,   69,   30,   71,
    0,   35,   75,    0,   70,   65,   70,   70,   70,    0,
    0,   84,    0,   72,    0,    0,    0,    0,   15,   66,
    0,    0,    0,   14,   78,   77,   76,   61,   69,    0,
   71,   61,   61,   45,   61,    0,   61,   48,   46,   70,
   47,    0,   49,    0,   72,    0,    0,    0,    0,   61,
   61,   61,    0,   36,    0,   35,    0,   35,    0,   69,
   36,   59,    0,    0,   35,   59,    0,    0,   60,   23,
   70,    0,  103,  126,  127,    0,   23,    0,   64,   65,
   66,   67,   68,   69,   48,   46,   70,   47,   74,   49,
   34,   34,   34,   34,   34,   34,    0,    0,   34,    0,
    0,    1,    2,    0,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   61,    0,   10,   56,   57,   58,    1,
    2,   12,    3,    4,    5,    6,    7,    8,    9,   10,
   11,    0,   33,   33,   33,   33,   33,   33,    0,   12,
   33,   42,   43,   37,   38,   61,   61,   61,   31,    0,
    0,   61,   61,   14,    9,    9,   65,   65,   65,   29,
   29,    0,   65,   65,    0,   65,   65,    0,   30,   30,
   66,   66,   66,    0,    0,    0,   66,   66,    0,   66,
   66,   71,   71,   71,    0,    0,    0,   71,   71,    0,
   71,   71,    0,   31,   31,   72,   72,   72,    0,    0,
    0,   72,   72,    0,   72,   72,    0,    0,    0,    0,
   69,   69,   69,    0,    0,    0,    0,    0,    0,   69,
   69,   70,   70,   70,    0,    0,    0,    0,    0,    0,
   70,   70,   34,   34,   34,   34,   34,   34,    0,    0,
   34,    1,    2,    0,    3,    4,    5,    6,    7,    8,
    9,   10,   11,    0,   23,    0,   56,   57,   58,    0,
    0,   12,    0,    0,   61,   61,   61,   23,    0,   23,
   61,   61,    0,   18,   18,    0,   42,   43,    0,   36,
    0,   36,   36,   35,    0,   35,   35,    0,    0,    0,
    0,   23,   23,   36,    0,    0,    0,   35,   36,   36,
   36,   10,   35,   35,   35,   10,   56,   57,   58,   23,
   56,   57,   58,   45,   23,   23,   23,   48,   46,    0,
   47,   62,   49,   42,   43,   62,   62,    0,   62,    0,
   62,    0,    0,    0,    0,   52,   51,   50,   23,   23,
    0,    0,   61,   62,   62,   62,   61,   61,   45,   61,
    0,   61,   48,   46,    0,   47,    0,   49,    0,    0,
    0,    0,    0,    0,   61,   61,   61,    0,  116,    0,
   36,    0,    0,    0,    0,    4,    5,    6,    7,    8,
   63,   10,   11,    0,    0,    0,   36,    0,    0,    0,
    0,   12,   88,   88,    0,    0,    0,    0,    0,   44,
    0,    0,    0,  115,    0,    0,    0,   62,    0,    0,
    0,    0,    0,   32,   63,  107,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   61,    0,
   80,    0,    0,    0,   44,    0,    0,    0,    0,   88,
  114,   91,   92,   93,   94,   95,   96,   97,   98,    0,
    0,    0,   99,  100,  101,    0,    0,    0,  117,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   63,   63,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   39,   40,   41,    0,    0,    0,   42,   43,   62,   62,
   62,    0,    0,    0,   62,   62,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   61,
   61,   61,    0,    0,    0,   61,   61,    0,    0,    0,
    0,   42,   43,
};
short yycheck[] = {                                      60,
    0,   33,   42,  284,  285,    0,  273,   47,   40,  284,
  285,    0,   40,   45,    0,   42,   43,  273,   45,   33,
   47,  284,  285,  273,   85,    0,   40,   91,   38,   41,
   41,   45,   42,   43,   41,   45,    0,   47,   38,    0,
  273,   41,   42,   43,   41,   45,   41,   47,  258,   38,
    0,  258,   41,  257,   43,   41,   45,   13,  284,  285,
   60,   61,   62,   38,  257,    0,   41,   93,   43,   58,
   45,   60,   61,   62,   38,  273,    0,   41,  284,  285,
   41,   37,   38,   58,   71,   60,   61,   62,   38,    0,
  259,   41,  261,  262,   58,    0,   60,   61,   62,  284,
  285,   -1,   -1,   38,   93,    0,   41,   -1,   58,   25,
   60,   61,   62,   -1,  124,   15,   -1,   41,   93,   -1,
   -1,   37,   38,   58,  124,   60,   61,   62,   84,   93,
   -1,   31,   38,   -1,   58,  124,   60,   61,   62,   -1,
   -1,   33,   -1,   93,   -1,   -1,   -1,   -1,   40,  124,
   -1,   -1,   -1,   45,   60,   61,   62,   38,   93,   -1,
  124,   42,   43,   38,   45,   -1,   47,   42,   43,   93,
   45,   -1,   47,   -1,  124,   -1,   -1,   -1,   -1,   60,
   61,   62,   -1,   33,   -1,   85,   -1,   33,   -1,  124,
   40,   33,   -1,   -1,   40,   33,   -1,   -1,   40,   33,
  124,   -1,   40,  119,  120,   -1,   40,   -1,  257,  258,
  259,  260,  261,  262,   42,   43,  265,   45,  124,   47,
  257,  258,  259,  260,  261,  262,   -1,   -1,  265,   -1,
   -1,  263,  264,   -1,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  124,   -1,  273,  278,  279,  280,  263,
  264,  283,  266,  267,  268,  269,  270,  271,  272,  273,
  274,   -1,  257,  258,  259,  260,  261,  262,   -1,  283,
  265,  281,  282,  284,  285,  275,  276,  277,   40,   -1,
   -1,  281,  282,   45,  284,  285,  275,  276,  277,  284,
  285,   -1,  281,  282,   -1,  284,  285,   -1,  284,  285,
  275,  276,  277,   -1,   -1,   -1,  281,  282,   -1,  284,
  285,  275,  276,  277,   -1,   -1,   -1,  281,  282,   -1,
  284,  285,   -1,  284,  285,  275,  276,  277,   -1,   -1,
   -1,  281,  282,   -1,  284,  285,   -1,   -1,   -1,   -1,
  275,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,  284,
  285,  275,  276,  277,   -1,   -1,   -1,   -1,   -1,   -1,
  284,  285,  257,  258,  259,  260,  261,  262,   -1,   -1,
  265,  263,  264,   -1,  266,  267,  268,  269,  270,  271,
  272,  273,  274,   -1,    0,   -1,  278,  279,  280,   -1,
   -1,  283,   -1,   -1,  275,  276,  277,   13,   -1,   15,
  281,  282,   -1,  284,  285,   -1,  281,  282,   -1,  259,
   -1,  261,  262,  259,   -1,  261,  262,   -1,   -1,   -1,
   -1,   37,   38,  273,   -1,   -1,   -1,  273,  278,  279,
  280,  273,  278,  279,  280,  273,  278,  279,  280,  273,
  278,  279,  280,   38,  278,  279,  280,   42,   43,   -1,
   45,   38,   47,  281,  282,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   60,   61,   62,   84,   85,
   -1,   -1,   38,   60,   61,   62,   42,   43,   38,   45,
   -1,   47,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   60,   61,   62,   -1,   58,   -1,
   15,   -1,   -1,   -1,   -1,  267,  268,  269,  270,  271,
   25,  273,  274,   -1,   -1,   -1,   31,   -1,   -1,   -1,
   -1,  283,   37,   38,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   93,   -1,   -1,   -1,  124,   -1,   -1,
   -1,   -1,   -1,   14,   59,   60,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,   -1,
   31,   -1,   -1,   -1,  124,   -1,   -1,   -1,   -1,   84,
   85,   42,   43,   44,   45,   46,   47,   48,   49,   -1,
   -1,   -1,   53,   54,   55,   -1,   -1,   -1,  103,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  119,  120,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  275,  276,  277,   -1,   -1,   -1,  281,  282,  275,  276,
  277,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  275,
  276,  277,   -1,   -1,   -1,  281,  282,   -1,   -1,   -1,
   -1,  281,  282,
};
#define YYFINAL 16
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 286
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,0,"'&'",0,"'('","')'","'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,0,0,
0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'|'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"DST","SRC","HOST","GATEWAY","NET","PORT","LESS",
"GREATER","PROTO","BYTE","ARP","RARP","IP","TCP","UDP","BROADCAST","NUM",
"ETHER","GEQ","LEQ","NEQ","ID","EID","HID","LSH","RSH","LEN","OR","AND",
"UMINUS",
};
char *yyrule[] = {
"$accept : prog",
"prog : expr",
"prog :",
"expr : term",
"expr : expr AND term",
"expr : expr OR term",
"expr : expr AND id",
"expr : expr OR id",
"id : nid",
"id : pnum",
"id : '(' pid ')'",
"nid : ID",
"nid : HID",
"nid : EID",
"nid : '!' id",
"pid : nid",
"pid : qid AND id",
"pid : qid OR id",
"qid : pnum",
"qid : pid",
"term : rterm",
"term : '!' term",
"head : pqual dqual aqual",
"head : pqual dqual",
"head : pqual aqual",
"head : pqual PROTO",
"head : pqual ndaqual",
"rterm : head id",
"rterm : '(' expr ')'",
"rterm : pname",
"rterm : arth relop arth",
"rterm : arth irelop arth",
"rterm : other",
"pqual : pname",
"pqual :",
"dqual : SRC",
"dqual : DST",
"dqual : SRC OR DST",
"dqual : DST OR SRC",
"dqual : SRC AND DST",
"dqual : DST AND SRC",
"aqual : HOST",
"aqual : NET",
"aqual : PORT",
"ndaqual : GATEWAY",
"pname : ETHER",
"pname : IP",
"pname : ARP",
"pname : RARP",
"pname : TCP",
"pname : UDP",
"other : BROADCAST",
"other : LESS NUM",
"other : GREATER NUM",
"other : BYTE NUM byteop NUM",
"relop : '>'",
"relop : GEQ",
"relop : '='",
"irelop : LEQ",
"irelop : '<'",
"irelop : NEQ",
"arth : pnum",
"arth : narth",
"narth : pname '[' arth ']'",
"narth : pname '[' arth ':' NUM ']'",
"narth : arth '+' arth",
"narth : arth '-' arth",
"narth : arth '*' arth",
"narth : arth '/' arth",
"narth : arth '&' arth",
"narth : arth '|' arth",
"narth : arth LSH arth",
"narth : arth RSH arth",
"narth : '-' arth",
"narth : '(' narth ')'",
"narth : LEN",
"byteop : '&'",
"byteop : '|'",
"byteop : '<'",
"byteop : '>'",
"byteop : '='",
"pnum : NUM",
"pnum : '(' pnum ')'",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifndef YYSTACKSIZE
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 300
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
#define yystacksize YYSTACKSIZE
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 98 "tcpgram.y"
{ 
	finish_parse(yyvsp[0].blk );
}
break;
case 4:
#line 104 "tcpgram.y"
{ gen_and(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 5:
#line 105 "tcpgram.y"
{ gen_or(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 6:
#line 106 "tcpgram.y"
{ gen_and(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 7:
#line 107 "tcpgram.y"
{ gen_or(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 9:
#line 110 "tcpgram.y"
{ yyval.blk  = gen_ncode((u_long)yyvsp[0].i , qualifier); }
break;
case 10:
#line 111 "tcpgram.y"
{ yyval.blk  = yyvsp[-1].blk ; }
break;
case 11:
#line 113 "tcpgram.y"
{ yyval.blk  = gen_scode(yyvsp[0].s , qualifier); }
break;
case 12:
#line 114 "tcpgram.y"
{ yyval.blk  = gen_ncode(yyvsp[0].h , qualifier); }
break;
case 13:
#line 115 "tcpgram.y"
{ yyval.blk  = gen_ecode(yyvsp[0].e , qualifier); }
break;
case 14:
#line 116 "tcpgram.y"
{ gen_not(yyvsp[0].blk ); yyval.blk  = yyvsp[0].blk ; }
break;
case 16:
#line 119 "tcpgram.y"
{ gen_and(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 17:
#line 120 "tcpgram.y"
{ gen_or(yyvsp[-2].blk , yyval.blk  = yyvsp[0].blk ); }
break;
case 18:
#line 122 "tcpgram.y"
{ yyval.blk  = gen_ncode((u_long)yyvsp[0].i , qualifier); }
break;
case 21:
#line 126 "tcpgram.y"
{ gen_not(yyvsp[0].blk ); yyval.blk  = yyvsp[0].blk ; }
break;
case 25:
#line 131 "tcpgram.y"
{ qualifier.primary = Q_PROTO; }
break;
case 27:
#line 134 "tcpgram.y"
{ yyval.blk  = yyvsp[0].blk ; }
break;
case 28:
#line 135 "tcpgram.y"
{ yyval.blk  = yyvsp[-1].blk ; qualifier = default_qual; }
break;
case 29:
#line 136 "tcpgram.y"
{ yyval.blk  = gen_proto_abbrev(yyvsp[0].i ); 
				  qualifier = default_qual; }
break;
case 30:
#line 138 "tcpgram.y"
{ yyval.blk  = gen_relation(yyvsp[-1].c , yyvsp[-2].a , yyvsp[0].a , 0);
				  qualifier = default_qual; }
break;
case 31:
#line 140 "tcpgram.y"
{ yyval.blk  = gen_relation(yyvsp[-1].c , yyvsp[-2].a , yyvsp[0].a , 1);
				  qualifier = default_qual; }
break;
case 33:
#line 145 "tcpgram.y"
{ qualifier.protocol = yyvsp[0].i ; }
break;
case 34:
#line 146 "tcpgram.y"
{ qualifier.protocol = 0; }
break;
case 35:
#line 149 "tcpgram.y"
{ qualifier.dir = Q_SRC; }
break;
case 36:
#line 150 "tcpgram.y"
{ qualifier.dir = Q_DST; }
break;
case 37:
#line 151 "tcpgram.y"
{ qualifier.dir = Q_OR; }
break;
case 38:
#line 152 "tcpgram.y"
{ qualifier.dir = Q_OR; }
break;
case 39:
#line 153 "tcpgram.y"
{ qualifier.dir = Q_AND; }
break;
case 40:
#line 154 "tcpgram.y"
{ qualifier.dir = Q_AND; }
break;
case 41:
#line 157 "tcpgram.y"
{ qualifier.primary = Q_HOST; }
break;
case 42:
#line 158 "tcpgram.y"
{ qualifier.primary = Q_NET; }
break;
case 43:
#line 159 "tcpgram.y"
{ qualifier.primary = Q_PORT; }
break;
case 44:
#line 162 "tcpgram.y"
{ qualifier.primary = Q_GATEWAY; }
break;
case 45:
#line 164 "tcpgram.y"
{ yyval.i  = Q_ETHER; }
break;
case 46:
#line 165 "tcpgram.y"
{ yyval.i  = Q_IP; }
break;
case 47:
#line 166 "tcpgram.y"
{ yyval.i  = Q_ARP; }
break;
case 48:
#line 167 "tcpgram.y"
{ yyval.i  = Q_RARP; }
break;
case 49:
#line 168 "tcpgram.y"
{ yyval.i  = Q_TCP; }
break;
case 50:
#line 169 "tcpgram.y"
{ yyval.i  = Q_UDP; }
break;
case 51:
#line 171 "tcpgram.y"
{ yyval.blk  = gen_broadcast(); }
break;
case 52:
#line 172 "tcpgram.y"
{ yyval.blk  = gen_less(yyvsp[0].i ); }
break;
case 53:
#line 173 "tcpgram.y"
{ yyval.blk  = gen_greater(yyvsp[0].i ); }
break;
case 54:
#line 174 "tcpgram.y"
{ yyval.blk  = gen_byteop(yyvsp[-1].i , yyvsp[-2].i , yyvsp[0].i ); }
break;
case 55:
#line 176 "tcpgram.y"
{ yyval.c  = GTOp; }
break;
case 56:
#line 177 "tcpgram.y"
{ yyval.c  = GEOp; }
break;
case 57:
#line 178 "tcpgram.y"
{ yyval.c  = EQOp; }
break;
case 58:
#line 180 "tcpgram.y"
{ yyval.c  = GTOp; }
break;
case 59:
#line 181 "tcpgram.y"
{ yyval.c  = GEOp; }
break;
case 60:
#line 182 "tcpgram.y"
{ yyval.c  = EQOp; }
break;
case 61:
#line 184 "tcpgram.y"
{ yyval.a  = gen_loadi(yyvsp[0].i ); }
break;
case 63:
#line 187 "tcpgram.y"
{ yyval.a  = gen_load(yyvsp[-3].i , yyvsp[-1].a , 1); }
break;
case 64:
#line 188 "tcpgram.y"
{ yyval.a  = gen_load(yyvsp[-5].i , yyvsp[-3].a , yyvsp[-1].i ); }
break;
case 65:
#line 189 "tcpgram.y"
{ yyval.a  = gen_arth(AddXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 66:
#line 190 "tcpgram.y"
{ yyval.a  = gen_arth(SubXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 67:
#line 191 "tcpgram.y"
{ yyval.a  = gen_arth(MulXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 68:
#line 192 "tcpgram.y"
{ yyval.a  = gen_arth(DivXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 69:
#line 193 "tcpgram.y"
{ yyval.a  = gen_arth(AndXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 70:
#line 194 "tcpgram.y"
{ yyval.a  = gen_arth(OrXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 71:
#line 195 "tcpgram.y"
{ yyval.a  = gen_arth(LshXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 72:
#line 196 "tcpgram.y"
{ yyval.a  = gen_arth(RshXOp, yyvsp[-2].a , yyvsp[0].a ); }
break;
case 73:
#line 197 "tcpgram.y"
{ yyval.a  = gen_neg(yyvsp[0].a ); }
break;
case 74:
#line 198 "tcpgram.y"
{ yyval.a  = yyvsp[-1].a ; }
break;
case 75:
#line 199 "tcpgram.y"
{ yyval.a  = gen_loadlen(); }
break;
case 76:
#line 201 "tcpgram.y"
{ yyval.i  = '&'; }
break;
case 77:
#line 202 "tcpgram.y"
{ yyval.i  = '|'; }
break;
case 78:
#line 203 "tcpgram.y"
{ yyval.i  = '<'; }
break;
case 79:
#line 204 "tcpgram.y"
{ yyval.i  = '>'; }
break;
case 80:
#line 205 "tcpgram.y"
{ yyval.i  = '='; }
break;
case 82:
#line 208 "tcpgram.y"
{ yyval.i  = yyvsp[-1].i ; }
break;
#line 872 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#ifdef YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#ifdef YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
